﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        BUTTON_MENU             : 16,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    } 
    else if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
var cr = {};
cr.plugins_ = {};
cr.behaviors = {};
if (typeof Object.getPrototypeOf !== "function")
{
	if (typeof "test".__proto__ === "object")
	{
		Object.getPrototypeOf = function(object) {
			return object.__proto__;
		};
	}
	else
	{
		Object.getPrototypeOf = function(object) {
			return object.constructor.prototype;
		};
	}
}
(function(){
	cr.logexport = function (msg)
	{
		if (window.console && window.console.log)
			window.console.log(msg);
	};
	cr.seal = function(x)
	{
		return x;
	};
	cr.freeze = function(x)
	{
		return x;
	};
	cr.is_undefined = function (x)
	{
		return typeof x === "undefined";
	};
	cr.is_number = function (x)
	{
		return typeof x === "number";
	};
	cr.is_string = function (x)
	{
		return typeof x === "string";
	};
	cr.isPOT = function (x)
	{
		return x > 0 && ((x - 1) & x) === 0;
	};
	cr.nextHighestPowerOfTwo = function(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	cr.abs = function (x)
	{
		return (x < 0 ? -x : x);
	};
	cr.max = function (a, b)
	{
		return (a > b ? a : b);
	};
	cr.min = function (a, b)
	{
		return (a < b ? a : b);
	};
	cr.PI = Math.PI;
	cr.round = function (x)
	{
		return (x + 0.5) | 0;
	};
	cr.floor = function (x)
	{
		if (x >= 0)
			return x | 0;
		else
			return (x | 0) - 1;		// correctly round down when negative
	};
	cr.ceil = function (x)
	{
		var f = x | 0;
		return (f === x ? f : f + 1);
	};
	function Vector2(x, y)
	{
		this.x = x;
		this.y = y;
		cr.seal(this);
	};
	Vector2.prototype.offset = function (px, py)
	{
		this.x += px;
		this.y += py;
		return this;
	};
	Vector2.prototype.mul = function (px, py)
	{
		this.x *= px;
		this.y *= py;
		return this;
	};
	cr.vector2 = Vector2;
	cr.segments_intersect = function(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y)
	{
		var max_ax, min_ax, max_ay, min_ay, max_bx, min_bx, max_by, min_by;
		if (a1x < a2x)
		{
			min_ax = a1x;
			max_ax = a2x;
		}
		else
		{
			min_ax = a2x;
			max_ax = a1x;
		}
		if (b1x < b2x)
		{
			min_bx = b1x;
			max_bx = b2x;
		}
		else
		{
			min_bx = b2x;
			max_bx = b1x;
		}
		if (max_ax < min_bx || min_ax > max_bx)
			return false;
		if (a1y < a2y)
		{
			min_ay = a1y;
			max_ay = a2y;
		}
		else
		{
			min_ay = a2y;
			max_ay = a1y;
		}
		if (b1y < b2y)
		{
			min_by = b1y;
			max_by = b2y;
		}
		else
		{
			min_by = b2y;
			max_by = b1y;
		}
		if (max_ay < min_by || min_ay > max_by)
			return false;
		var dpx = b1x - a1x + b2x - a2x;
		var dpy = b1y - a1y + b2y - a2y;
		var qax = a2x - a1x;
		var qay = a2y - a1y;
		var qbx = b2x - b1x;
		var qby = b2y - b1y;
		var d = cr.abs(qay * qbx - qby * qax);
		var la = qbx * dpy - qby * dpx;
		if (cr.abs(la) > d)
			return false;
		var lb = qax * dpy - qay * dpx;
		return cr.abs(lb) <= d;
	};
	function Rect(left, top, right, bottom)
	{
		this.set(left, top, right, bottom);
		cr.seal(this);
	};
	Rect.prototype.set = function (left, top, right, bottom)
	{
		this.left = left;
		this.top = top;
		this.right = right;
		this.bottom = bottom;
	};
	Rect.prototype.copy = function (r)
	{
		this.left = r.left;
		this.top = r.top;
		this.right = r.right;
		this.bottom = r.bottom;
	};
	Rect.prototype.width = function ()
	{
		return this.right - this.left;
	};
	Rect.prototype.height = function ()
	{
		return this.bottom - this.top;
	};
	Rect.prototype.offset = function (px, py)
	{
		this.left += px;
		this.top += py;
		this.right += px;
		this.bottom += py;
		return this;
	};
	Rect.prototype.normalize = function ()
	{
		var temp = 0;
		if (this.left > this.right)
		{
			temp = this.left;
			this.left = this.right;
			this.right = temp;
		}
		if (this.top > this.bottom)
		{
			temp = this.top;
			this.top = this.bottom;
			this.bottom = temp;
		}
	};
	Rect.prototype.intersects_rect = function (rc)
	{
		return !(rc.right < this.left || rc.bottom < this.top || rc.left > this.right || rc.top > this.bottom);
	};
	Rect.prototype.intersects_rect_off = function (rc, ox, oy)
	{
		return !(rc.right + ox < this.left || rc.bottom + oy < this.top || rc.left + ox > this.right || rc.top + oy > this.bottom);
	};
	Rect.prototype.contains_pt = function (x, y)
	{
		return (x >= this.left && x <= this.right) && (y >= this.top && y <= this.bottom);
	};
	Rect.prototype.equals = function (r)
	{
		return this.left === r.left && this.top === r.top && this.right === r.right && this.bottom === r.bottom;
	};
	cr.rect = Rect;
	function Quad()
	{
		this.tlx = 0;
		this.tly = 0;
		this.trx = 0;
		this.try_ = 0;	// is a keyword otherwise!
		this.brx = 0;
		this.bry = 0;
		this.blx = 0;
		this.bly = 0;
		cr.seal(this);
	};
	Quad.prototype.set_from_rect = function (rc)
	{
		this.tlx = rc.left;
		this.tly = rc.top;
		this.trx = rc.right;
		this.try_ = rc.top;
		this.brx = rc.right;
		this.bry = rc.bottom;
		this.blx = rc.left;
		this.bly = rc.bottom;
	};
	Quad.prototype.set_from_rotated_rect = function (rc, a)
	{
		if (a === 0)
		{
			this.set_from_rect(rc);
		}
		else
		{
			var sin_a = Math.sin(a);
			var cos_a = Math.cos(a);
			var left_sin_a = rc.left * sin_a;
			var top_sin_a = rc.top * sin_a;
			var right_sin_a = rc.right * sin_a;
			var bottom_sin_a = rc.bottom * sin_a;
			var left_cos_a = rc.left * cos_a;
			var top_cos_a = rc.top * cos_a;
			var right_cos_a = rc.right * cos_a;
			var bottom_cos_a = rc.bottom * cos_a;
			this.tlx = left_cos_a - top_sin_a;
			this.tly = top_cos_a + left_sin_a;
			this.trx = right_cos_a - top_sin_a;
			this.try_ = top_cos_a + right_sin_a;
			this.brx = right_cos_a - bottom_sin_a;
			this.bry = bottom_cos_a + right_sin_a;
			this.blx = left_cos_a - bottom_sin_a;
			this.bly = bottom_cos_a + left_sin_a;
		}
	};
	Quad.prototype.offset = function (px, py)
	{
		this.tlx += px;
		this.tly += py;
		this.trx += px;
		this.try_ += py;
		this.brx += px;
		this.bry += py;
		this.blx += px;
		this.bly += py;
		return this;
	};
	var minresult = 0;
	var maxresult = 0;
	function minmax4(a, b, c, d)
	{
		if (a < b)
		{
			if (c < d)
			{
				if (a < c)
					minresult = a;
				else
					minresult = c;
				if (b > d)
					maxresult = b;
				else
					maxresult = d;
			}
			else
			{
				if (a < d)
					minresult = a;
				else
					minresult = d;
				if (b > c)
					maxresult = b;
				else
					maxresult = c;
			}
		}
		else
		{
			if (c < d)
			{
				if (b < c)
					minresult = b;
				else
					minresult = c;
				if (a > d)
					maxresult = a;
				else
					maxresult = d;
			}
			else
			{
				if (b < d)
					minresult = b;
				else
					minresult = d;
				if (a > c)
					maxresult = a;
				else
					maxresult = c;
			}
		}
	};
	Quad.prototype.bounding_box = function (rc)
	{
		minmax4(this.tlx, this.trx, this.brx, this.blx);
		rc.left = minresult;
		rc.right = maxresult;
		minmax4(this.tly, this.try_, this.bry, this.bly);
		rc.top = minresult;
		rc.bottom = maxresult;
	};
	Quad.prototype.contains_pt = function (x, y)
	{
		var v0x = this.trx - this.tlx;
		var v0y = this.try_ - this.tly;
		var v1x = this.brx - this.tlx;
		var v1y = this.bry - this.tly;
		var v2x = x - this.tlx;
		var v2y = y - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		var dot11 = v1x * v1x + v1y * v1y
		var dot12 = v1x * v2x + v1y * v2y
		var invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		var u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		var v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		if ((u >= 0.0) && (v > 0.0) && (u + v < 1))
			return true;
		v0x = this.blx - this.tlx;
		v0y = this.bly - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		return (u >= 0.0) && (v > 0.0) && (u + v < 1);
	};
	Quad.prototype.at = function (i, xory)
	{
		if (xory)
		{
			switch (i)
			{
				case 0: return this.tlx;
				case 1: return this.trx;
				case 2: return this.brx;
				case 3: return this.blx;
				case 4: return this.tlx;
				default: return this.tlx;
			}
		}
		else
		{
			switch (i)
			{
				case 0: return this.tly;
				case 1: return this.try_;
				case 2: return this.bry;
				case 3: return this.bly;
				case 4: return this.tly;
				default: return this.tly;
			}
		}
	};
	Quad.prototype.midX = function ()
	{
		return (this.tlx + this.trx  + this.brx + this.blx) / 4;
	};
	Quad.prototype.midY = function ()
	{
		return (this.tly + this.try_ + this.bry + this.bly) / 4;
	};
	Quad.prototype.intersects_segment = function (x1, y1, x2, y2)
	{
		if (this.contains_pt(x1, y1) || this.contains_pt(x2, y2))
			return true;
		var a1x, a1y, a2x, a2y;
		var i;
		for (i = 0; i < 4; i++)
		{
			a1x = this.at(i, true);
			a1y = this.at(i, false);
			a2x = this.at(i + 1, true);
			a2y = this.at(i + 1, false);
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	Quad.prototype.intersects_quad = function (rhs)
	{
		var midx = rhs.midX();
		var midy = rhs.midY();
		if (this.contains_pt(midx, midy))
			return true;
		midx = this.midX();
		midy = this.midY();
		if (rhs.contains_pt(midx, midy))
			return true;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		var i, j;
		for (i = 0; i < 4; i++)
		{
			for (j = 0; j < 4; j++)
			{
				a1x = this.at(i, true);
				a1y = this.at(i, false);
				a2x = this.at(i + 1, true);
				a2y = this.at(i + 1, false);
				b1x = rhs.at(j, true);
				b1y = rhs.at(j, false);
				b2x = rhs.at(j + 1, true);
				b2y = rhs.at(j + 1, false);
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	cr.quad = Quad;
	cr.RGB = function (red, green, blue)
	{
		return Math.max(Math.min(red, 255), 0)
			 | (Math.max(Math.min(green, 255), 0) << 8)
			 | (Math.max(Math.min(blue, 255), 0) << 16);
	};
	cr.GetRValue = function (rgb)
	{
		return rgb & 0xFF;
	};
	cr.GetGValue = function (rgb)
	{
		return (rgb & 0xFF00) >> 8;
	};
	cr.GetBValue = function (rgb)
	{
		return (rgb & 0xFF0000) >> 16;
	};
	cr.shallowCopy = function (a, b, allowOverwrite)
	{
		var attr;
		for (attr in b)
		{
			if (b.hasOwnProperty(attr))
			{
;
				a[attr] = b[attr];
			}
		}
		return a;
	};
	cr.arrayRemove = function (arr, index)
	{
		var i, len;
		index = cr.floor(index);
		if (index < 0 || index >= arr.length)
			return;							// index out of bounds
		if (index === 0)					// removing first item
			arr.shift();
		else if (index === arr.length - 1)	// removing last item
			arr.pop();
		else
		{
			for (i = index, len = arr.length - 1; i < len; i++)
				arr[i] = arr[i + 1];
			arr.length = len;
		}
	};
	cr.shallowAssignArray = function (dest, src)
	{
		dest.length = src.length;
		var i, len;
		for (i = 0, len = src.length; i < len; i++)
			dest[i] = src[i];
	};
	cr.appendArray = function (a, b)
	{
		a.push.apply(a, b);
	};
	cr.arrayFindRemove = function (arr, item)
	{
		var index = arr.indexOf(item);
		if (index !== -1)
			cr.arrayRemove(arr, index);
	};
	cr.clamp = function(x, a, b)
	{
		if (x < a)
			return a;
		else if (x > b)
			return b;
		else
			return x;
	};
	cr.to_radians = function(x)
	{
		return x / (180.0 / cr.PI);
	};
	cr.to_degrees = function(x)
	{
		return x * (180.0 / cr.PI);
	};
	cr.clamp_angle_degrees = function (a)
	{
		a %= 360;       // now in (-360, 360) range
		if (a < 0)
			a += 360;   // now in [0, 360) range
		return a;
	};
	cr.clamp_angle = function (a)
	{
		a %= 2 * cr.PI;       // now in (-2pi, 2pi) range
		if (a < 0)
			a += 2 * cr.PI;   // now in [0, 2pi) range
		return a;
	};
	cr.to_clamped_degrees = function (x)
	{
		return cr.clamp_angle_degrees(cr.to_degrees(x));
	};
	cr.to_clamped_radians = function (x)
	{
		return cr.clamp_angle(cr.to_radians(x));
	};
	cr.angleTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.atan2(dy, dx);
	};
	cr.angleDiff = function (a1, a2)
	{
		if (a1 === a2)
			return 0;
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		var n = s1 * s2 + c1 * c2;
		if (n >= 1)
			return 0;
		if (n <= -1)
			return cr.PI;
		return Math.acos(n);
	};
	cr.angleRotate = function (start, end, step)
	{
		var ss = Math.sin(start);
		var cs = Math.cos(start);
		var se = Math.sin(end);
		var ce = Math.cos(end);
		if (Math.acos(ss * se + cs * ce) > step)
		{
			if (cs * se - ss * ce > 0)
				return cr.clamp_angle(start + step);
			else
				return cr.clamp_angle(start - step);
		}
		else
			return cr.clamp_angle(end);
	};
	cr.angleClockwise = function (a1, a2)
	{
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		return c1 * s2 - s1 * c2 <= 0;
	};
	cr.rotatePtAround = function (px, py, a, ox, oy, getx)
	{
		if (a === 0)
			return getx ? px : py;
		var sin_a = Math.sin(a);
		var cos_a = Math.cos(a);
		px -= ox;
		py -= oy;
		var left_sin_a = px * sin_a;
		var top_sin_a = py * sin_a;
		var left_cos_a = px * cos_a;
		var top_cos_a = py * cos_a;
		px = left_cos_a - top_sin_a;
		py = top_cos_a + left_sin_a;
		px += ox;
		py += oy;
		return getx ? px : py;
	}
	cr.distanceTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.sqrt(dx*dx + dy*dy);
	};
	cr.xor = function (x, y)
	{
		return !x !== !y;
	};
	cr.lerp = function (a, b, x)
	{
		return a + (b - a) * x;
	};
	cr.unlerp = function (a, b, c)
	{
		if (a === b)
			return 0;		// avoid divide by 0
		return (c - a) / (b - a);
	};
	cr.anglelerp = function (a, b, x)
	{
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			return a + diff * x;
		}
		else
		{
			return a - diff * x;
		}
	};
	cr.hasAnyOwnProperty = function (o)
	{
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
				return true;
		}
		return false;
	};
	cr.wipe = function (obj)
	{
		var p;
		for (p in obj)
		{
			if (obj.hasOwnProperty(p))
				delete obj[p];
		}
	};
	var startup_time = +(new Date());
	cr.performance_now = function()
	{
		if (typeof window["performance"] !== "undefined")
		{
			var winperf = window["performance"];
			if (typeof winperf.now !== "undefined")
				return winperf.now();
			else if (typeof winperf["webkitNow"] !== "undefined")
				return winperf["webkitNow"]();
			else if (typeof winperf["mozNow"] !== "undefined")
				return winperf["mozNow"]();
			else if (typeof winperf["msNow"] !== "undefined")
				return winperf["msNow"]();
		}
		return Date.now() - startup_time;
	};
	var supports_set = (typeof Set !== "undefined" && typeof Set.prototype["forEach"] !== "undefined");
	function ObjectSet_()
	{
		this.s = null;
		this.items = null;
		this.item_count = 0;
		if (supports_set)
		{
			this.s = new Set();
		}
		else
		{
			this.items = {};
		}
		this.values_cache = [];
		this.cache_valid = true;
		cr.seal(this);
	};
	ObjectSet_.prototype.contains = function (x)
	{
		if (supports_set)
			return this.s["has"](x);
		else
			return this.items.hasOwnProperty(x.toString());
	};
	ObjectSet_.prototype.add = function (x)
	{
		if (supports_set)
		{
			if (!this.s["has"](x))
			{
				this.s["add"](x);
				this.cache_valid = false;
			}
		}
		else
		{
			var str = x.toString();
			if (!this.items.hasOwnProperty(str))
			{
				this.items[str] = x;
				this.item_count++;
				this.cache_valid = false;
			}
		}
		return this;
	};
	ObjectSet_.prototype.remove = function (x)
	{
		if (supports_set)
		{
			if (this.s["has"](x))
			{
				this.s["delete"](x);
				this.cache_valid = false;
			}
		}
		else
		{
			var str = x.toString();
			if (this.items.hasOwnProperty(str))
			{
				delete this.items[str];
				this.item_count--;
				this.cache_valid = false;
			}
		}
		return this;
	};
	ObjectSet_.prototype.clear = function ()
	{
		if (supports_set)
		{
			this.s["clear"]();
		}
		else
		{
			this.items = {};
			this.item_count = 0;
		}
		this.values_cache.length = 0;
		this.cache_valid = true;
		return this;
	};
	ObjectSet_.prototype.isEmpty = function ()
	{
		if (supports_set)
			return this.s["size"] === 0;
		else
			return this.item_count === 0;
	};
	ObjectSet_.prototype.count = function ()
	{
		if (supports_set)
			return this.s["size"];
		else
			return this.item_count;
	};
	var current_arr = null;
	var current_index = 0;
	function set_append_to_arr(x)
	{
		current_arr[current_index++] = x;
	};
	ObjectSet_.prototype.update_cache = function ()
	{
		if (this.cache_valid)
			return;
		if (supports_set)
		{
			this.values_cache.length = this.s["size"];
			current_arr = this.values_cache;
			current_index = 0;
			this.s["forEach"](set_append_to_arr);
;
			current_arr = null;
			current_index = 0;
		}
		else
		{
			this.values_cache.length = this.item_count;
			var p, n = 0;
			for (p in this.items)
			{
				if (this.items.hasOwnProperty(p))
					this.values_cache[n++] = this.items[p];
			}
;
		}
		this.cache_valid = true;
	};
	ObjectSet_.prototype.values = function ()
	{
		this.update_cache();
		return this.values_cache.slice(0);
	};
	ObjectSet_.prototype.valuesRef = function ()
	{
		this.update_cache();
		return this.values_cache;
	};
	cr.ObjectSet = ObjectSet_;
	function KahanAdder_()
	{
		this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
		cr.seal(this);
	};
	KahanAdder_.prototype.add = function (v)
	{
		this.y = v - this.c;
	    this.t = this.sum + this.y;
	    this.c = (this.t - this.sum) - this.y;
	    this.sum = this.t;
	};
    KahanAdder_.prototype.reset = function ()
    {
        this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
    };
	cr.KahanAdder = KahanAdder_;
	cr.regexp_escape = function(text)
	{
		return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
	};
	function CollisionPoly_(pts_array_)
	{
		this.pts_cache = [];
		this.bboxLeft = 0;
		this.bboxTop = 0;
		this.bboxRight = 0;
		this.bboxBottom = 0;
		this.convexpolys = null;		// for physics behavior to cache separated polys
		this.set_pts(pts_array_);
		cr.seal(this);
	};
	CollisionPoly_.prototype.set_pts = function(pts_array_)
	{
		this.pts_array = pts_array_;
		this.pts_count = pts_array_.length / 2;			// x, y, x, y... in array
		this.pts_cache.length = pts_array_.length;
		this.cache_width = -1;
		this.cache_height = -1;
		this.cache_angle = 0;
	};
	CollisionPoly_.prototype.is_empty = function()
	{
		return !this.pts_array.length;
	};
	CollisionPoly_.prototype.update_bbox = function ()
	{
		var myptscache = this.pts_cache;
		var bboxLeft_ = myptscache[0];
		var bboxRight_ = bboxLeft_;
		var bboxTop_ = myptscache[1];
		var bboxBottom_ = bboxTop_;
		var x, y, i = 1, i2, len = this.pts_count;
		for ( ; i < len; ++i)
		{
			i2 = i*2;
			x = myptscache[i2];
			y = myptscache[i2+1];
			if (x < bboxLeft_)
				bboxLeft_ = x;
			if (x > bboxRight_)
				bboxRight_ = x;
			if (y < bboxTop_)
				bboxTop_ = y;
			if (y > bboxBottom_)
				bboxBottom_ = y;
		}
		this.bboxLeft = bboxLeft_;
		this.bboxRight = bboxRight_;
		this.bboxTop = bboxTop_;
		this.bboxBottom = bboxBottom_;
	};
	CollisionPoly_.prototype.set_from_rect = function(rc, offx, offy)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = rc.left - offx;
		myptscache[1] = rc.top - offy;
		myptscache[2] = rc.right - offx;
		myptscache[3] = rc.top - offy;
		myptscache[4] = rc.right - offx;
		myptscache[5] = rc.bottom - offy;
		myptscache[6] = rc.left - offx;
		myptscache[7] = rc.bottom - offy;
		this.cache_width = rc.right - rc.left;
		this.cache_height = rc.bottom - rc.top;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_quad = function(q, offx, offy, w, h)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = q.tlx - offx;
		myptscache[1] = q.tly - offy;
		myptscache[2] = q.trx - offx;
		myptscache[3] = q.try_ - offy;
		myptscache[4] = q.brx - offx;
		myptscache[5] = q.bry - offy;
		myptscache[6] = q.blx - offx;
		myptscache[7] = q.bly - offy;
		this.cache_width = w;
		this.cache_height = h;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_poly = function (r)
	{
		this.pts_count = r.pts_count;
		cr.shallowAssignArray(this.pts_cache, r.pts_cache);
		this.bboxLeft = r.bboxLeft;
		this.bboxTop - r.bboxTop;
		this.bboxRight = r.bboxRight;
		this.bboxBottom = r.bboxBottom;
	};
	CollisionPoly_.prototype.cache_poly = function(w, h, a)
	{
		if (this.cache_width === w && this.cache_height === h && this.cache_angle === a)
			return;		// cache up-to-date
		this.cache_width = w;
		this.cache_height = h;
		this.cache_angle = a;
		var i, i2, i21, len, x, y;
		var sina = 0;
		var cosa = 1;
		var myptsarray = this.pts_array;
		var myptscache = this.pts_cache;
		if (a !== 0)
		{
			sina = Math.sin(a);
			cosa = Math.cos(a);
		}
		for (i = 0, len = this.pts_count; i < len; i++)
		{
			i2 = i*2;
			i21 = i2+1;
			x = myptsarray[i2] * w;
			y = myptsarray[i21] * h;
			myptscache[i2] = (x * cosa) - (y * sina);
			myptscache[i21] = (y * cosa) + (x * sina);
		}
		this.update_bbox();
	};
	CollisionPoly_.prototype.contains_pt = function (a2x, a2y)
	{
		var myptscache = this.pts_cache;
		if (a2x === myptscache[0] && a2y === myptscache[1])
			return true;
		var i, i2, imod, len = this.pts_count;
		var a1x = this.bboxLeft - 110;
		var a1y = this.bboxTop - 101;
		var a3x = this.bboxRight + 131
		var a3y = this.bboxBottom + 120;
		var b1x, b1y, b2x, b2y;
		var count1 = 0, count2 = 0;
		for (i = 0; i < len; i++)
		{
			i2 = i*2;
			imod = ((i+1)%len)*2;
			b1x = myptscache[i2];
			b1y = myptscache[i2+1];
			b2x = myptscache[imod];
			b2y = myptscache[imod+1];
			if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
				count1++;
			if (cr.segments_intersect(a3x, a3y, a2x, a2y, b1x, b1y, b2x, b2y))
				count2++;
		}
		return (count1 % 2 === 1) || (count2 % 2 === 1);
	};
	CollisionPoly_.prototype.intersects_poly = function (rhs, offx, offy)
	{
		var rhspts = rhs.pts_cache;
		var mypts = this.pts_cache;
		if (this.contains_pt(rhspts[0] + offx, rhspts[1] + offy))
			return true;
		if (rhs.contains_pt(mypts[0] - offx, mypts[1] - offy))
			return true;
		var i, i2, imod, leni, j, j2, jmod, lenj;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2];
			a1y = mypts[i2+1];
			a2x = mypts[imod];
			a2y = mypts[imod+1];
			for (j = 0, lenj = rhs.pts_count; j < lenj; j++)
			{
				j2 = j*2;
				jmod = ((j+1)%lenj)*2;
				b1x = rhspts[j2] + offx;
				b1y = rhspts[j2+1] + offy;
				b2x = rhspts[jmod] + offx;
				b2y = rhspts[jmod+1] + offy;
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	CollisionPoly_.prototype.intersects_segment = function (offx, offy, x1, y1, x2, y2)
	{
		var mypts = this.pts_cache;
		if (this.contains_pt(x1 - offx, y1 - offy))
			return true;
		var i, leni, i2, imod;
		var a1x, a1y, a2x, a2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2] + offx;
			a1y = mypts[i2+1] + offy;
			a2x = mypts[imod] + offx;
			a2y = mypts[imod+1] + offy;
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	CollisionPoly_.prototype.mirror = function (px)
	{
		var i, leni, i2;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			this.pts_cache[i2] = px * 2 - this.pts_cache[i2];
		}
	};
	CollisionPoly_.prototype.flip = function (py)
	{
		var i, leni, i21;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i21 = i*2+1;
			this.pts_cache[i21] = py * 2 - this.pts_cache[i21];
		}
	};
	CollisionPoly_.prototype.diag = function ()
	{
		var i, leni, i2, i21, temp;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			i21 = i2+1;
			temp = this.pts_cache[i2];
			this.pts_cache[i2] = this.pts_cache[i21];
			this.pts_cache[i21] = temp;
		}
	};
	cr.CollisionPoly = CollisionPoly_;
	function SparseGrid_(cellwidth_, cellheight_)
	{
		this.cellwidth = cellwidth_;
		this.cellheight = cellheight_;
		this.cells = {};
	};
	SparseGrid_.prototype.totalCellCount = 0;
	SparseGrid_.prototype.getCell = function (x_, y_, create_if_missing)
	{
		var ret;
		var col = this.cells[x_];
		if (!col)
		{
			if (create_if_missing)
			{
				ret = allocGridCell(this, x_, y_);
				this.cells[x_] = {};
				this.cells[x_][y_] = ret;
				return ret;
			}
			else
				return null;
		}
		ret = col[y_];
		if (ret)
			return ret;
		else if (create_if_missing)
		{
			ret = allocGridCell(this, x_, y_);
			this.cells[x_][y_] = ret;
			return ret;
		}
		else
			return null;
	};
	SparseGrid_.prototype.XToCell = function (x_)
	{
		return cr.floor(x_ / this.cellwidth);
	};
	SparseGrid_.prototype.YToCell = function (y_)
	{
		return cr.floor(y_ / this.cellheight);
	};
	SparseGrid_.prototype.update = function (inst, oldrange, newrange)
	{
		var x, lenx, y, leny, cell;
		if (oldrange)
		{
			for (x = oldrange.left, lenx = oldrange.right; x <= lenx; ++x)
			{
				for (y = oldrange.top, leny = oldrange.bottom; y <= leny; ++y)
				{
					if (newrange && newrange.contains_pt(x, y))
						continue;	// is still in this cell
					cell = this.getCell(x, y, false);	// don't create if missing
					if (!cell)
						continue;	// cell does not exist yet
					cell.remove(inst);
					if (cell.isEmpty())
					{
						freeGridCell(cell);
						this.cells[x][y] = null;
					}
				}
			}
		}
		if (newrange)
		{
			for (x = newrange.left, lenx = newrange.right; x <= lenx; ++x)
			{
				for (y = newrange.top, leny = newrange.bottom; y <= leny; ++y)
				{
					if (oldrange && oldrange.contains_pt(x, y))
						continue;	// is still in this cell
					this.getCell(x, y, true).insert(inst);
				}
			}
		}
	};
	SparseGrid_.prototype.queryRange = function (rc, result)
	{
		var x, lenx, ystart, y, leny, cell;
		x = this.XToCell(rc.left);
		ystart = this.YToCell(rc.top);
		lenx = this.XToCell(rc.right);
		leny = this.YToCell(rc.bottom);
		for ( ; x <= lenx; ++x)
		{
			for (y = ystart; y <= leny; ++y)
			{
				cell = this.getCell(x, y, false);
				if (!cell)
					continue;
				cell.dump(result);
			}
		}
	};
	cr.SparseGrid = SparseGrid_;
	var gridcellcache = [];
	function allocGridCell(grid_, x_, y_)
	{
		var ret;
		SparseGrid_.prototype.totalCellCount++;
		if (gridcellcache.length)
		{
			ret = gridcellcache.pop();
			ret.grid = grid_;
			ret.x = x_;
			ret.y = y_;
			return ret;
		}
		else
			return new cr.GridCell(grid_, x_, y_);
	};
	function freeGridCell(c)
	{
		SparseGrid_.prototype.totalCellCount--;
		c.objects.clear();
		if (gridcellcache.length < 1000)
			gridcellcache.push(c);
	};
	function GridCell_(grid_, x_, y_)
	{
		this.grid = grid_;
		this.x = x_;
		this.y = y_;
		this.objects = new cr.ObjectSet();
	};
	GridCell_.prototype.isEmpty = function ()
	{
		return this.objects.isEmpty();
	};
	GridCell_.prototype.insert = function (inst)
	{
		this.objects.add(inst);
	};
	GridCell_.prototype.remove = function (inst)
	{
		this.objects.remove(inst);
	};
	GridCell_.prototype.dump = function (result)
	{
		cr.appendArray(result, this.objects.valuesRef());
	};
	cr.GridCell = GridCell_;
	var fxNames = [ "lighter",
					"xor",
					"copy",
					"destination-over",
					"source-in",
					"destination-in",
					"source-out",
					"destination-out",
					"source-atop",
					"destination-atop"];
	cr.effectToCompositeOp = function(effect)
	{
		if (effect <= 0 || effect >= 11)
			return "source-over";
		return fxNames[effect - 1];	// not including "none" so offset by 1
	};
	cr.setGLBlend = function(this_, effect, gl)
	{
		if (!gl)
			return;
		this_.srcBlend = gl.ONE;
		this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
		switch (effect) {
		case 1:		// lighter (additive)
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ONE;
			break;
		case 2:		// xor
			break;	// todo
		case 3:		// copy
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ZERO;
			break;
		case 4:		// destination-over
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ONE;
			break;
		case 5:		// source-in
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 6:		// destination-in
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		case 7:		// source-out
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 8:		// destination-out
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 9:		// source-atop
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 10:	// destination-atop
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		}
	};
	cr.round6dp = function (x)
	{
		return cr.round(x * 1000000) / 1000000;
	};
	/*
	var localeCompare_options = {
		"usage": "search",
		"sensitivity": "accent"
	};
	var has_localeCompare = !!"a".localeCompare;
	var localeCompare_works1 = (has_localeCompare && "a".localeCompare("A", undefined, localeCompare_options) === 0);
	var localeCompare_works2 = (has_localeCompare && "a".localeCompare("á", undefined, localeCompare_options) !== 0);
	var supports_localeCompare = (has_localeCompare && localeCompare_works1 && localeCompare_works2);
	*/
	cr.equals_nocase = function (a, b)
	{
		if (typeof a !== "string" || typeof b !== "string")
			return false;
		if (a.length !== b.length)
			return false;
		if (a === b)
			return true;
		/*
		if (supports_localeCompare)
		{
			return (a.localeCompare(b, undefined, localeCompare_options) === 0);
		}
		else
		{
		*/
			return a.toLowerCase() === b.toLowerCase();
	};
}());
var MatrixArray=typeof Float32Array!=="undefined"?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var b=new MatrixArray(3);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2]);return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};vec3.add=function(a,b,c){if(!c||a===c)return a[0]+=b[0],a[1]+=b[1],a[2]+=b[2],a;c[0]=a[0]+b[0];c[1]=a[1]+b[1];c[2]=a[2]+b[2];return c};
vec3.subtract=function(a,b,c){if(!c||a===c)return a[0]-=b[0],a[1]-=b[1],a[2]-=b[2],a;c[0]=a[0]-b[0];c[1]=a[1]-b[1];c[2]=a[2]-b[2];return c};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,c){if(!c||a===c)return a[0]*=b,a[1]*=b,a[2]*=b,a;c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;return c};
vec3.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=Math.sqrt(c*c+d*d+e*e);if(g){if(g===1)return b[0]=c,b[1]=d,b[2]=e,b}else return b[0]=0,b[1]=0,b[2]=0,b;g=1/g;b[0]=c*g;b[1]=d*g;b[2]=e*g;return b};vec3.cross=function(a,b,c){c||(c=a);var d=a[0],e=a[1],a=a[2],g=b[0],f=b[1],b=b[2];c[0]=e*b-a*f;c[1]=a*g-d*b;c[2]=d*f-e*g;return c};vec3.length=function(a){var b=a[0],c=a[1],a=a[2];return Math.sqrt(b*b+c*c+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
vec3.direction=function(a,b,c){c||(c=a);var d=a[0]-b[0],e=a[1]-b[1],a=a[2]-b[2],b=Math.sqrt(d*d+e*e+a*a);if(!b)return c[0]=0,c[1]=0,c[2]=0,c;b=1/b;c[0]=d*b;c[1]=e*b;c[2]=a*b;return c};vec3.lerp=function(a,b,c,d){d||(d=a);d[0]=a[0]+c*(b[0]-a[0]);d[1]=a[1]+c*(b[1]-a[1]);d[2]=a[2]+c*(b[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var b=new MatrixArray(9);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8]);return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[5];a[1]=a[3];a[2]=a[6];a[3]=c;a[5]=a[7];a[6]=d;a[7]=e;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[15]=1;b[14]=0;b[13]=0;b[12]=0;b[11]=0;b[10]=a[8];b[9]=a[7];b[8]=a[6];b[7]=0;b[6]=a[5];b[5]=a[4];b[4]=a[3];b[3]=0;b[2]=a[2];b[1]=a[1];b[0]=a[0];return b};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var b=new MatrixArray(16);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]);return b};
mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[3],g=a[6],f=a[7],h=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=c;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=g;a[11]=a[14];a[12]=e;a[13]=f;a[14]=h;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
mat4.determinant=function(a){var b=a[0],c=a[1],d=a[2],e=a[3],g=a[4],f=a[5],h=a[6],i=a[7],j=a[8],k=a[9],l=a[10],n=a[11],o=a[12],m=a[13],p=a[14],a=a[15];return o*k*h*e-j*m*h*e-o*f*l*e+g*m*l*e+j*f*p*e-g*k*p*e-o*k*d*i+j*m*d*i+o*c*l*i-b*m*l*i-j*c*p*i+b*k*p*i+o*f*d*n-g*m*d*n-o*c*h*n+b*m*h*n+g*c*p*n-b*f*p*n-j*f*d*a+g*k*d*a+j*c*h*a-b*k*h*a-g*c*l*a+b*f*l*a};
mat4.inverse=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=a[4],h=a[5],i=a[6],j=a[7],k=a[8],l=a[9],n=a[10],o=a[11],m=a[12],p=a[13],r=a[14],s=a[15],A=c*h-d*f,B=c*i-e*f,t=c*j-g*f,u=d*i-e*h,v=d*j-g*h,w=e*j-g*i,x=k*p-l*m,y=k*r-n*m,z=k*s-o*m,C=l*r-n*p,D=l*s-o*p,E=n*s-o*r,q=1/(A*E-B*D+t*C+u*z-v*y+w*x);b[0]=(h*E-i*D+j*C)*q;b[1]=(-d*E+e*D-g*C)*q;b[2]=(p*w-r*v+s*u)*q;b[3]=(-l*w+n*v-o*u)*q;b[4]=(-f*E+i*z-j*y)*q;b[5]=(c*E-e*z+g*y)*q;b[6]=(-m*w+r*t-s*B)*q;b[7]=(k*w-n*t+o*B)*q;b[8]=(f*D-h*z+j*x)*q;
b[9]=(-c*D+d*z-g*x)*q;b[10]=(m*v-p*t+s*A)*q;b[11]=(-k*v+l*t-o*A)*q;b[12]=(-f*C+h*y-i*x)*q;b[13]=(c*C-d*y+e*x)*q;b[14]=(-m*u+p*B-r*A)*q;b[15]=(k*u-l*B+n*A)*q;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var c=a[0],d=a[1],e=a[2],g=a[4],f=a[5],h=a[6],i=a[8],j=a[9],k=a[10],l=k*f-h*j,n=-k*g+h*i,o=j*g-f*i,m=c*l+d*n+e*o;if(!m)return null;m=1/m;b||(b=mat3.create());b[0]=l*m;b[1]=(-k*d+e*j)*m;b[2]=(h*d-e*f)*m;b[3]=n*m;b[4]=(k*c-e*i)*m;b[5]=(-h*c+e*g)*m;b[6]=o*m;b[7]=(-j*c+d*i)*m;b[8]=(f*c-d*g)*m;return b};
mat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],f=a[3],h=a[4],i=a[5],j=a[6],k=a[7],l=a[8],n=a[9],o=a[10],m=a[11],p=a[12],r=a[13],s=a[14],a=a[15],A=b[0],B=b[1],t=b[2],u=b[3],v=b[4],w=b[5],x=b[6],y=b[7],z=b[8],C=b[9],D=b[10],E=b[11],q=b[12],F=b[13],G=b[14],b=b[15];c[0]=A*d+B*h+t*l+u*p;c[1]=A*e+B*i+t*n+u*r;c[2]=A*g+B*j+t*o+u*s;c[3]=A*f+B*k+t*m+u*a;c[4]=v*d+w*h+x*l+y*p;c[5]=v*e+w*i+x*n+y*r;c[6]=v*g+w*j+x*o+y*s;c[7]=v*f+w*k+x*m+y*a;c[8]=z*d+C*h+D*l+E*p;c[9]=z*e+C*i+D*n+E*r;c[10]=z*g+C*
j+D*o+E*s;c[11]=z*f+C*k+D*m+E*a;c[12]=q*d+F*h+G*l+b*p;c[13]=q*e+F*i+G*n+b*r;c[14]=q*g+F*j+G*o+b*s;c[15]=q*f+F*k+G*m+b*a;return c};mat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],b=b[2];c[0]=a[0]*d+a[4]*e+a[8]*b+a[12];c[1]=a[1]*d+a[5]*e+a[9]*b+a[13];c[2]=a[2]*d+a[6]*e+a[10]*b+a[14];return c};
mat4.multiplyVec4=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=b[3];c[0]=a[0]*d+a[4]*e+a[8]*g+a[12]*b;c[1]=a[1]*d+a[5]*e+a[9]*g+a[13]*b;c[2]=a[2]*d+a[6]*e+a[10]*g+a[14]*b;c[3]=a[3]*d+a[7]*e+a[11]*g+a[15]*b;return c};
mat4.translate=function(a,b,c){var d=b[0],e=b[1],b=b[2],g,f,h,i,j,k,l,n,o,m,p,r;if(!c||a===c)return a[12]=a[0]*d+a[4]*e+a[8]*b+a[12],a[13]=a[1]*d+a[5]*e+a[9]*b+a[13],a[14]=a[2]*d+a[6]*e+a[10]*b+a[14],a[15]=a[3]*d+a[7]*e+a[11]*b+a[15],a;g=a[0];f=a[1];h=a[2];i=a[3];j=a[4];k=a[5];l=a[6];n=a[7];o=a[8];m=a[9];p=a[10];r=a[11];c[0]=g;c[1]=f;c[2]=h;c[3]=i;c[4]=j;c[5]=k;c[6]=l;c[7]=n;c[8]=o;c[9]=m;c[10]=p;c[11]=r;c[12]=g*d+j*e+o*b+a[12];c[13]=f*d+k*e+m*b+a[13];c[14]=h*d+l*e+p*b+a[14];c[15]=i*d+n*e+r*b+a[15];
return c};mat4.scale=function(a,b,c){var d=b[0],e=b[1],b=b[2];if(!c||a===c)return a[0]*=d,a[1]*=d,a[2]*=d,a[3]*=d,a[4]*=e,a[5]*=e,a[6]*=e,a[7]*=e,a[8]*=b,a[9]*=b,a[10]*=b,a[11]*=b,a;c[0]=a[0]*d;c[1]=a[1]*d;c[2]=a[2]*d;c[3]=a[3]*d;c[4]=a[4]*e;c[5]=a[5]*e;c[6]=a[6]*e;c[7]=a[7]*e;c[8]=a[8]*b;c[9]=a[9]*b;c[10]=a[10]*b;c[11]=a[11]*b;c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};
mat4.rotate=function(a,b,c,d){var e=c[0],g=c[1],c=c[2],f=Math.sqrt(e*e+g*g+c*c),h,i,j,k,l,n,o,m,p,r,s,A,B,t,u,v,w,x,y,z;if(!f)return null;f!==1&&(f=1/f,e*=f,g*=f,c*=f);h=Math.sin(b);i=Math.cos(b);j=1-i;b=a[0];f=a[1];k=a[2];l=a[3];n=a[4];o=a[5];m=a[6];p=a[7];r=a[8];s=a[9];A=a[10];B=a[11];t=e*e*j+i;u=g*e*j+c*h;v=c*e*j-g*h;w=e*g*j-c*h;x=g*g*j+i;y=c*g*j+e*h;z=e*c*j+g*h;e=g*c*j-e*h;g=c*c*j+i;d?a!==d&&(d[12]=a[12],d[13]=a[13],d[14]=a[14],d[15]=a[15]):d=a;d[0]=b*t+n*u+r*v;d[1]=f*t+o*u+s*v;d[2]=k*t+m*u+A*
v;d[3]=l*t+p*u+B*v;d[4]=b*w+n*x+r*y;d[5]=f*w+o*x+s*y;d[6]=k*w+m*x+A*y;d[7]=l*w+p*x+B*y;d[8]=b*z+n*e+r*g;d[9]=f*z+o*e+s*g;d[10]=k*z+m*e+A*g;d[11]=l*z+p*e+B*g;return d};mat4.rotateX=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[4],g=a[5],f=a[6],h=a[7],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[4]=e*b+i*d;c[5]=g*b+j*d;c[6]=f*b+k*d;c[7]=h*b+l*d;c[8]=e*-d+i*b;c[9]=g*-d+j*b;c[10]=f*-d+k*b;c[11]=h*-d+l*b;return c};
mat4.rotateY=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*-d;c[1]=g*b+j*-d;c[2]=f*b+k*-d;c[3]=h*b+l*-d;c[8]=e*d+i*b;c[9]=g*d+j*b;c[10]=f*d+k*b;c[11]=h*d+l*b;return c};
mat4.rotateZ=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[4],j=a[5],k=a[6],l=a[7];c?a!==c&&(c[8]=a[8],c[9]=a[9],c[10]=a[10],c[11]=a[11],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*d;c[1]=g*b+j*d;c[2]=f*b+k*d;c[3]=h*b+l*d;c[4]=e*-d+i*b;c[5]=g*-d+j*b;c[6]=f*-d+k*b;c[7]=h*-d+l*b;return c};
mat4.frustum=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=e*2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=e*2/i;f[6]=0;f[7]=0;f[8]=(b+a)/h;f[9]=(d+c)/i;f[10]=-(g+e)/j;f[11]=-1;f[12]=0;f[13]=0;f[14]=-(g*e*2)/j;f[15]=0;return f};mat4.perspective=function(a,b,c,d,e){a=c*Math.tan(a*Math.PI/360);b*=a;return mat4.frustum(-b,b,-a,a,c,d,e)};
mat4.ortho=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=2/i;f[6]=0;f[7]=0;f[8]=0;f[9]=0;f[10]=-2/j;f[11]=0;f[12]=-(a+b)/h;f[13]=-(d+c)/i;f[14]=-(g+e)/j;f[15]=1;return f};
mat4.lookAt=function(a,b,c,d){d||(d=mat4.create());var e,g,f,h,i,j,k,l,n=a[0],o=a[1],a=a[2];g=c[0];f=c[1];e=c[2];c=b[1];j=b[2];if(n===b[0]&&o===c&&a===j)return mat4.identity(d);c=n-b[0];j=o-b[1];k=a-b[2];l=1/Math.sqrt(c*c+j*j+k*k);c*=l;j*=l;k*=l;b=f*k-e*j;e=e*c-g*k;g=g*j-f*c;(l=Math.sqrt(b*b+e*e+g*g))?(l=1/l,b*=l,e*=l,g*=l):g=e=b=0;f=j*g-k*e;h=k*b-c*g;i=c*e-j*b;(l=Math.sqrt(f*f+h*h+i*i))?(l=1/l,f*=l,h*=l,i*=l):i=h=f=0;d[0]=b;d[1]=f;d[2]=c;d[3]=0;d[4]=e;d[5]=h;d[6]=j;d[7]=0;d[8]=g;d[9]=i;d[10]=k;d[11]=
0;d[12]=-(b*n+e*o+g*a);d[13]=-(f*n+h*o+i*a);d[14]=-(c*n+j*o+k*a);d[15]=1;return d};mat4.fromRotationTranslation=function(a,b,c){c||(c=mat4.create());var d=a[0],e=a[1],g=a[2],f=a[3],h=d+d,i=e+e,j=g+g,a=d*h,k=d*i;d*=j;var l=e*i;e*=j;g*=j;h*=f;i*=f;f*=j;c[0]=1-(l+g);c[1]=k+f;c[2]=d-i;c[3]=0;c[4]=k-f;c[5]=1-(a+g);c[6]=e+h;c[7]=0;c[8]=d+i;c[9]=e-h;c[10]=1-(a+l);c[11]=0;c[12]=b[0];c[13]=b[1];c[14]=b[2];c[15]=1;return c};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var b=new MatrixArray(4);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3]);return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
quat4.calculateW=function(a,b){var c=a[0],d=a[1],e=a[2];if(!b||a===b)return a[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e)),a;b[0]=c;b[1]=d;b[2]=e;b[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return b};quat4.inverse=function(a,b){if(!b||a===b)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],c=a[1],d=a[2],a=a[3];return Math.sqrt(b*b+c*c+d*d+a*a)};
quat4.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=Math.sqrt(c*c+d*d+e*e+g*g);if(f===0)return b[0]=0,b[1]=0,b[2]=0,b[3]=0,b;f=1/f;b[0]=c*f;b[1]=d*f;b[2]=e*f;b[3]=g*f;return b};quat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],a=a[3],f=b[0],h=b[1],i=b[2],b=b[3];c[0]=d*b+a*f+e*i-g*h;c[1]=e*b+a*h+g*f-d*i;c[2]=g*b+a*i+d*h-e*f;c[3]=a*b-d*f-e*h-g*i;return c};
quat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=a[0],f=a[1],h=a[2],a=a[3],i=a*d+f*g-h*e,j=a*e+h*d-b*g,k=a*g+b*e-f*d,d=-b*d-f*e-h*g;c[0]=i*a+d*-b+j*-h-k*-f;c[1]=j*a+d*-f+k*-b-i*-h;c[2]=k*a+d*-h+i*-f-j*-b;return c};quat4.toMat3=function(a,b){b||(b=mat3.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=k-g;b[4]=1-(j+e);b[5]=d+f;b[6]=c+h;b[7]=d-f;b[8]=1-(j+l);return b};
quat4.toMat4=function(a,b){b||(b=mat4.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=0;b[4]=k-g;b[5]=1-(j+e);b[6]=d+f;b[7]=0;b[8]=c+h;b[9]=d-f;b[10]=1-(j+l);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
quat4.slerp=function(a,b,c,d){d||(d=a);var e=a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3],g,f;if(Math.abs(e)>=1)return d!==a&&(d[0]=a[0],d[1]=a[1],d[2]=a[2],d[3]=a[3]),d;g=Math.acos(e);f=Math.sqrt(1-e*e);if(Math.abs(f)<0.001)return d[0]=a[0]*0.5+b[0]*0.5,d[1]=a[1]*0.5+b[1]*0.5,d[2]=a[2]*0.5+b[2]*0.5,d[3]=a[3]*0.5+b[3]*0.5,d;e=Math.sin((1-c)*g)/f;c=Math.sin(c*g)/f;d[0]=a[0]*e+b[0]*c;d[1]=a[1]*e+b[1]*c;d[2]=a[2]*e+b[2]*c;d[3]=a[3]*e+b[3]*c;return d};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function()
{
	var MAX_VERTICES = 8000;						// equates to 2500 objects being drawn
	var MAX_INDICES = (MAX_VERTICES / 2) * 3;		// 6 indices for every 4 vertices
	var MAX_POINTS = 8000;
	var MULTI_BUFFERS = 4;							// cycle 4 buffers to try and avoid blocking
	var BATCH_NULL = 0;
	var BATCH_QUAD = 1;
	var BATCH_SETTEXTURE = 2;
	var BATCH_SETOPACITY = 3;
	var BATCH_SETBLEND = 4;
	var BATCH_UPDATEMODELVIEW = 5;
	var BATCH_RENDERTOTEXTURE = 6;
	var BATCH_CLEAR = 7;
	var BATCH_POINTS = 8;
	var BATCH_SETPROGRAM = 9;
	var BATCH_SETPROGRAMPARAMETERS = 10;
	var BATCH_SETTEXTURE1 = 11;
	function GLWrap_(gl, isMobile)
	{
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.width = 0;		// not yet known, wait for call to setSize()
		this.height = 0;
		this.cam = vec3.create([0, 0, 100]);			// camera position
		this.look = vec3.create([0, 0, 0]);				// lookat position
		this.up = vec3.create([0, 1, 0]);				// up vector
		this.worldScale = vec3.create([1, 1, 1]);		// world scaling factor
		this.matP = mat4.create();						// perspective matrix
		this.matMV = mat4.create();						// model view matrix
		this.lastMV = mat4.create();
		this.currentMV = mat4.create();
		this.gl = gl;
		this.initState();
	};
	GLWrap_.prototype.initState = function ()
	{
		var gl = this.gl;
		var i, len;
		this.lastOpacity = 1;
		this.lastTexture0 = null;			// last bound to TEXTURE0
		this.lastTexture1 = null;			// last bound to TEXTURE1
		this.currentOpacity = 1;
		gl.clearColor(0, 0, 0, 0);
		gl.clear(gl.COLOR_BUFFER_BIT);
		gl.enable(gl.BLEND);
        gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
		gl.disable(gl.CULL_FACE);
		gl.disable(gl.DEPTH_TEST);
		this.maxTextureSize = gl.getParameter(gl.MAX_TEXTURE_SIZE);
		this.lastSrcBlend = gl.ONE;
		this.lastDestBlend = gl.ONE_MINUS_SRC_ALPHA;
		this.pointBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
		this.vertexBuffers = new Array(MULTI_BUFFERS);
		this.texcoordBuffers = new Array(MULTI_BUFFERS);
		for (i = 0; i < MULTI_BUFFERS; i++)
		{
			this.vertexBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[i]);
			this.texcoordBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[i]);
		}
		this.curBuffer = 0;
		this.indexBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.indexBuffer);
		this.vertexData = new Float32Array(MAX_VERTICES * 2);
		this.texcoordData = new Float32Array(MAX_VERTICES * 2);
		this.pointData = new Float32Array(MAX_POINTS * 4);
		var indexData = new Uint16Array(MAX_INDICES);
		i = 0, len = MAX_INDICES;
		var fv = 0;
		while (i < len)
		{
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 1;	// top right
			indexData[i++] = fv + 2;	// bottom right (first tri)
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 2;	// bottom right
			indexData[i++] = fv + 3;	// bottom left
			fv += 4;
		}
		gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, indexData, gl.STATIC_DRAW);
		this.vertexPtr = 0;
		this.pointPtr = 0;
		var fsSource, vsSource;
		this.shaderPrograms = [];
		fsSource = [
			"varying mediump vec2 vTex;",
			"uniform lowp float opacity;",
			"uniform lowp sampler2D samplerFront;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, vTex);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		vsSource = [
			"attribute highp vec2 aPos;",
			"attribute mediump vec2 aTex;",
			"varying mediump vec2 vTex;",
			"uniform highp mat4 matP;",
			"uniform highp mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	vTex = aTex;",
			"}"
		].join("\n");
		var shaderProg = this.createShaderProgram({src: fsSource}, vsSource, "<default>");
;
		this.shaderPrograms.push(shaderProg);		// Default shader is always shader 0
		fsSource = [
			"uniform mediump sampler2D samplerFront;",
			"varying lowp float opacity;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, gl_PointCoord);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		var pointVsSource = [
			"attribute vec4 aPos;",
			"varying float opacity;",
			"uniform mat4 matP;",
			"uniform mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	gl_PointSize = aPos.z;",
			"	opacity = aPos.w;",
			"}"
		].join("\n");
		shaderProg = this.createShaderProgram({src: fsSource}, pointVsSource, "<point>");
;
		this.shaderPrograms.push(shaderProg);		// Point shader is always shader 1
		for (var shader_name in cr.shaders)
		{
			if (cr.shaders.hasOwnProperty(shader_name))
				this.shaderPrograms.push(this.createShaderProgram(cr.shaders[shader_name], vsSource, shader_name));
		}
		gl.activeTexture(gl.TEXTURE0);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.batch = [];
		this.batchPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.lastProgram = -1;				// start -1 so first switchProgram can do work
		this.currentProgram = -1;			// current program during batch execution
		this.currentShader = null;
		this.fbo = gl.createFramebuffer();
		this.renderToTex = null;
		this.tmpVec3 = vec3.create([0, 0, 0]);
;
;
		var pointsizes = gl.getParameter(gl.ALIASED_POINT_SIZE_RANGE);
		this.minPointSize = pointsizes[0];
		this.maxPointSize = pointsizes[1];
;
		this.switchProgram(0);
		cr.seal(this);
	};
	function GLShaderProgram(gl, shaderProgram, name)
	{
		this.gl = gl;
		this.shaderProgram = shaderProgram;
		this.name = name;
		this.locAPos = gl.getAttribLocation(shaderProgram, "aPos");
		this.locATex = gl.getAttribLocation(shaderProgram, "aTex");
		this.locMatP = gl.getUniformLocation(shaderProgram, "matP");
		this.locMatMV = gl.getUniformLocation(shaderProgram, "matMV");
		this.locOpacity = gl.getUniformLocation(shaderProgram, "opacity");
		this.locSamplerFront = gl.getUniformLocation(shaderProgram, "samplerFront");
		this.locSamplerBack = gl.getUniformLocation(shaderProgram, "samplerBack");
		this.locDestStart = gl.getUniformLocation(shaderProgram, "destStart");
		this.locDestEnd = gl.getUniformLocation(shaderProgram, "destEnd");
		this.locSeconds = gl.getUniformLocation(shaderProgram, "seconds");
		this.locPixelWidth = gl.getUniformLocation(shaderProgram, "pixelWidth");
		this.locPixelHeight = gl.getUniformLocation(shaderProgram, "pixelHeight");
		this.locLayerScale = gl.getUniformLocation(shaderProgram, "layerScale");
		this.locLayerAngle = gl.getUniformLocation(shaderProgram, "layerAngle");
		this.locViewOrigin = gl.getUniformLocation(shaderProgram, "viewOrigin");
		this.hasAnyOptionalUniforms = !!(this.locPixelWidth || this.locPixelHeight || this.locSeconds || this.locSamplerBack || this.locDestStart || this.locDestEnd || this.locLayerScale || this.locLayerAngle || this.locViewOrigin);
		if (this.locOpacity)
			gl.uniform1f(this.locOpacity, 1);
		if (this.locSamplerFront)
			gl.uniform1i(this.locSamplerFront, 0);
		if (this.locSamplerBack)
			gl.uniform1i(this.locSamplerBack, 1);
		if (this.locDestStart)
			gl.uniform2f(this.locDestStart, 0.0, 0.0);
		if (this.locDestEnd)
			gl.uniform2f(this.locDestEnd, 1.0, 1.0);
		if (this.locLayerScale)
			gl.uniform1f(this.locLayerScale, 1.0);
		if (this.locLayerAngle)
			gl.uniform1f(this.locLayerAngle, 0.0);
		if (this.locViewOrigin)
			gl.uniform2f(this.locViewOrigin, 0.0, 0.0);
		this.hasCurrentMatMV = false;		// matMV needs updating
	};
	GLWrap_.prototype.createShaderProgram = function(shaderEntry, vsSource, name)
	{
		var gl = this.gl;
		var fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);
		gl.shaderSource(fragmentShader, shaderEntry.src);
		gl.compileShader(fragmentShader);
		if (!gl.getShaderParameter(fragmentShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			return null;
		}
		var vertexShader = gl.createShader(gl.VERTEX_SHADER);
		gl.shaderSource(vertexShader, vsSource);
		gl.compileShader(vertexShader);
		if (!gl.getShaderParameter(vertexShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			return null;
		}
		var shaderProgram = gl.createProgram();
		gl.attachShader(shaderProgram, fragmentShader);
		gl.attachShader(shaderProgram, vertexShader);
		gl.linkProgram(shaderProgram);
		if (!gl.getProgramParameter(shaderProgram, gl.LINK_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			gl.deleteProgram(shaderProgram);
			return null;
		}
		gl.useProgram(shaderProgram);
;
		gl.deleteShader(fragmentShader);
		gl.deleteShader(vertexShader);
		var ret = new GLShaderProgram(gl, shaderProgram, name);
		ret.extendBoxHorizontal = shaderEntry.extendBoxHorizontal || 0;
		ret.extendBoxVertical = shaderEntry.extendBoxVertical || 0;
		ret.crossSampling = !!shaderEntry.crossSampling;
		ret.animated = !!shaderEntry.animated;
		ret.parameters = shaderEntry.parameters || [];
		var i, len;
		for (i = 0, len = ret.parameters.length; i < len; i++)
		{
			ret.parameters[i][1] = gl.getUniformLocation(shaderProgram, ret.parameters[i][0]);
			gl.uniform1f(ret.parameters[i][1], 0);
		}
		cr.seal(ret);
		return ret;
	};
	GLWrap_.prototype.getShaderIndex = function(name_)
	{
		var i, len;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			if (this.shaderPrograms[i].name === name_)
				return i;
		}
		return -1;
	};
	GLWrap_.prototype.project = function (x, y, out)
	{
		var mv = this.matMV;
		var proj = this.matP;
		var fTempo = [0, 0, 0, 0, 0, 0, 0, 0];
		fTempo[0] = mv[0]*x+mv[4]*y+mv[12];
		fTempo[1] = mv[1]*x+mv[5]*y+mv[13];
		fTempo[2] = mv[2]*x+mv[6]*y+mv[14];
		fTempo[3] = mv[3]*x+mv[7]*y+mv[15];
		fTempo[4] = proj[0]*fTempo[0]+proj[4]*fTempo[1]+proj[8]*fTempo[2]+proj[12]*fTempo[3];
		fTempo[5] = proj[1]*fTempo[0]+proj[5]*fTempo[1]+proj[9]*fTempo[2]+proj[13]*fTempo[3];
		fTempo[6] = proj[2]*fTempo[0]+proj[6]*fTempo[1]+proj[10]*fTempo[2]+proj[14]*fTempo[3];
		fTempo[7] = -fTempo[2];
		if(fTempo[7]===0.0)	//The w value
			return;
		fTempo[7]=1.0/fTempo[7];
		fTempo[4]*=fTempo[7];
		fTempo[5]*=fTempo[7];
		fTempo[6]*=fTempo[7];
		out[0]=(fTempo[4]*0.5+0.5)*this.width;
		out[1]=(fTempo[5]*0.5+0.5)*this.height;
	};
	GLWrap_.prototype.setSize = function(w, h, force)
	{
		if (this.width === w && this.height === h && !force)
			return;
		this.endBatch();
		this.width = w;
		this.height = h;
		this.gl.viewport(0, 0, w, h);
		mat4.perspective(45, w / h, 1, 1000, this.matP);
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		var tl = [0, 0];
		var br = [0, 0];
		this.project(0, 0, tl);
		this.project(1, 1, br);
		this.worldScale[0] = 1 / (br[0] - tl[0]);
		this.worldScale[1] = -1 / (br[1] - tl[1]);
		var i, len, s;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			s = this.shaderPrograms[i];
			s.hasCurrentMatMV = false;
			if (s.locMatP)
			{
				this.gl.useProgram(s.shaderProgram);
				this.gl.uniformMatrix4fv(s.locMatP, false, this.matP);
			}
		}
		this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE1);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE0);
		this.lastTexture0 = null;
		this.lastTexture1 = null;
	};
	GLWrap_.prototype.resetModelView = function ()
	{
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		mat4.scale(this.matMV, this.worldScale);
	};
	GLWrap_.prototype.translate = function (x, y)
	{
		if (x === 0 && y === 0)
			return;
		this.tmpVec3[0] = x;// * this.worldScale[0];
		this.tmpVec3[1] = y;// * this.worldScale[1];
		this.tmpVec3[2] = 0;
		mat4.translate(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.scale = function (x, y)
	{
		if (x === 1 && y === 1)
			return;
		this.tmpVec3[0] = x;
		this.tmpVec3[1] = y;
		this.tmpVec3[2] = 1;
		mat4.scale(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.rotateZ = function (a)
	{
		if (a === 0)
			return;
		mat4.rotateZ(this.matMV, a);
	};
	GLWrap_.prototype.updateModelView = function()
	{
		var anydiff = false;
		for (var i = 0; i < 16; i++)
		{
			if (this.lastMV[i] !== this.matMV[i])
			{
				anydiff = true;
				break;
			}
		}
		if (!anydiff)
			return;
		var b = this.pushBatch();
		b.type = BATCH_UPDATEMODELVIEW;
		if (b.mat4param)
			mat4.set(this.matMV, b.mat4param);
		else
			b.mat4param = mat4.create(this.matMV);
		mat4.set(this.matMV, this.lastMV);
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	/*
	var debugBatch = false;
	jQuery(document).mousedown(
		function(info) {
			if (info.which === 2)
				debugBatch = true;
		}
	);
	*/
	function GLBatchJob(type_, glwrap_)
	{
		this.type = type_;
		this.glwrap = glwrap_;
		this.gl = glwrap_.gl;
		this.opacityParam = 0;		// for setOpacity()
		this.startIndex = 0;		// for quad()
		this.indexCount = 0;		// "
		this.texParam = null;		// for setTexture()
		this.mat4param = null;		// for updateModelView()
		this.shaderParams = [];		// for user parameters
		cr.seal(this);
	};
	GLBatchJob.prototype.doSetTexture = function ()
	{
		this.gl.bindTexture(this.gl.TEXTURE_2D, this.texParam);
	};
	GLBatchJob.prototype.doSetTexture1 = function ()
	{
		var gl = this.gl;
		gl.activeTexture(gl.TEXTURE1);
		gl.bindTexture(gl.TEXTURE_2D, this.texParam);
		gl.activeTexture(gl.TEXTURE0);
	};
	GLBatchJob.prototype.doSetOpacity = function ()
	{
		var o = this.opacityParam;
		var glwrap = this.glwrap;
		glwrap.currentOpacity = o;
		var curProg = glwrap.currentShader;
		if (curProg.locOpacity)
			this.gl.uniform1f(curProg.locOpacity, o);
	};
	GLBatchJob.prototype.doQuad = function ()
	{
		this.gl.drawElements(this.gl.TRIANGLES, this.indexCount, this.gl.UNSIGNED_SHORT, this.startIndex * 2);
	};
	GLBatchJob.prototype.doSetBlend = function ()
	{
		this.gl.blendFunc(this.startIndex, this.indexCount);
	};
	GLBatchJob.prototype.doUpdateModelView = function ()
	{
		var i, len, s, shaderPrograms = this.glwrap.shaderPrograms, currentProgram = this.glwrap.currentProgram;
		for (i = 0, len = shaderPrograms.length; i < len; i++)
		{
			s = shaderPrograms[i];
			if (i === currentProgram && s.locMatMV)
			{
				this.gl.uniformMatrix4fv(s.locMatMV, false, this.mat4param);
				s.hasCurrentMatMV = true;
			}
			else
				s.hasCurrentMatMV = false;
		}
		mat4.set(this.mat4param, this.glwrap.currentMV);
	};
	GLBatchJob.prototype.doRenderToTexture = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		if (this.texParam)
		{
			if (glwrap.lastTexture1 === this.texParam)
			{
				gl.activeTexture(gl.TEXTURE1);
				gl.bindTexture(gl.TEXTURE_2D, null);
				glwrap.lastTexture1 = null;
				gl.activeTexture(gl.TEXTURE0);
			}
			gl.bindFramebuffer(gl.FRAMEBUFFER, glwrap.fbo);
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, this.texParam, 0);
		}
		else
		{
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, null, 0);
			gl.bindFramebuffer(gl.FRAMEBUFFER, null);
		}
	};
	GLBatchJob.prototype.doClear = function ()
	{
		var gl = this.gl;
		if (this.startIndex === 0)		// clear whole surface
		{
			gl.clearColor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clear(gl.COLOR_BUFFER_BIT);
		}
		else							// clear rectangle
		{
			gl.enable(gl.SCISSOR_TEST);
			gl.scissor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clearColor(0, 0, 0, 0);
			gl.clear(this.gl.COLOR_BUFFER_BIT);
			gl.disable(gl.SCISSOR_TEST);
		}
	};
	GLBatchJob.prototype.doPoints = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[1];
		gl.useProgram(s.shaderProgram);
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			gl.uniformMatrix4fv(s.locMatMV, false, glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		gl.enableVertexAttribArray(s.locAPos);
		gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.pointBuffer);
		gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		gl.drawArrays(gl.POINTS, this.startIndex / 4, this.indexCount);
		s = glwrap.currentShader;
		gl.useProgram(s.shaderProgram);
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	};
	GLBatchJob.prototype.doSetProgram = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[this.startIndex];		// recycled param to save memory
		glwrap.currentProgram = this.startIndex;			// current batch program
		glwrap.currentShader = s;
		gl.useProgram(s.shaderProgram);						// switch to
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			gl.uniformMatrix4fv(s.locMatMV, false, glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		if (s.locOpacity)
			gl.uniform1f(s.locOpacity, glwrap.currentOpacity);
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	}
	GLBatchJob.prototype.doSetProgramParameters = function ()
	{
		var i, len, s = this.glwrap.currentShader;
		var gl = this.gl;
		var mat4param = this.mat4param;
		if (s.locSamplerBack && this.glwrap.lastTexture1 !== this.texParam)
		{
			gl.activeTexture(gl.TEXTURE1);
			gl.bindTexture(gl.TEXTURE_2D, this.texParam);
			this.glwrap.lastTexture1 = this.texParam;
			gl.activeTexture(gl.TEXTURE0);
		}
		if (s.locPixelWidth)
			gl.uniform1f(s.locPixelWidth, mat4param[0]);
		if (s.locPixelHeight)
			gl.uniform1f(s.locPixelHeight, mat4param[1]);
		if (s.locDestStart)
			gl.uniform2f(s.locDestStart, mat4param[2], mat4param[3]);
		if (s.locDestEnd)
			gl.uniform2f(s.locDestEnd, mat4param[4], mat4param[5]);
		if (s.locLayerScale)
			gl.uniform1f(s.locLayerScale, mat4param[6]);
		if (s.locLayerAngle)
			gl.uniform1f(s.locLayerAngle, mat4param[7]);
		if (s.locViewOrigin)
			gl.uniform2f(s.locViewOrigin, mat4param[8], mat4param[9]);
		if (s.locSeconds)
			gl.uniform1f(s.locSeconds, cr.performance_now() / 1000.0);
		if (s.parameters.length)
		{
			for (i = 0, len = s.parameters.length; i < len; i++)
			{
				gl.uniform1f(s.parameters[i][1], this.shaderParams[i]);
			}
		}
	};
	GLWrap_.prototype.pushBatch = function ()
	{
		if (this.batchPtr === this.batch.length)
			this.batch.push(new GLBatchJob(BATCH_NULL, this));
		return this.batch[this.batchPtr++];
	};
	GLWrap_.prototype.endBatch = function ()
	{
		if (this.batchPtr === 0)
			return;
		if (this.gl.isContextLost())
			return;
		var gl = this.gl;
		if (this.pointPtr > 0)
		{
			gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
			gl.bufferData(gl.ARRAY_BUFFER, this.pointData.subarray(0, this.pointPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name === "<point>")
				gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		}
		if (this.vertexPtr > 0)
		{
			var s = this.currentShader;
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.vertexData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.texcoordData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locATex >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
		var i, len, b;
		for (i = 0, len = this.batchPtr; i < len; i++)
		{
			b = this.batch[i];
			switch (b.type) {
			case BATCH_QUAD:
				b.doQuad();
				break;
			case BATCH_SETTEXTURE:
				b.doSetTexture();
				break;
			case BATCH_SETOPACITY:
				b.doSetOpacity();
				break;
			case BATCH_SETBLEND:
				b.doSetBlend();
				break;
			case BATCH_UPDATEMODELVIEW:
				b.doUpdateModelView();
				break;
			case BATCH_RENDERTOTEXTURE:
				b.doRenderToTexture();
				break;
			case BATCH_CLEAR:
				b.doClear();
				break;
			case BATCH_POINTS:
				b.doPoints();
				break;
			case BATCH_SETPROGRAM:
				b.doSetProgram();
				break;
			case BATCH_SETPROGRAMPARAMETERS:
				b.doSetProgramParameters();
				break;
			case BATCH_SETTEXTURE1:
				b.doSetTexture1();
				break;
			}
		}
		this.batchPtr = 0;
		this.vertexPtr = 0;
		this.pointPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.curBuffer++;
		if (this.curBuffer >= MULTI_BUFFERS)
			this.curBuffer = 0;
	};
	GLWrap_.prototype.setOpacity = function (op)
	{
		if (op === this.lastOpacity)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETOPACITY;
		b.opacityParam = op;
		this.lastOpacity = op;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setTexture = function (tex)
	{
		if (tex === this.lastTexture0)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_SETTEXTURE;
		b.texParam = tex;
		this.lastTexture0 = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setBlend = function (s, d)
	{
		if (s === this.lastSrcBlend && d === this.lastDestBlend)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETBLEND;
		b.startIndex = s;		// recycle params to save memory
		b.indexCount = d;
		this.lastSrcBlend = s;
		this.lastDestBlend = d;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.isPremultipliedAlphaBlend = function ()
	{
		return (this.lastSrcBlend === this.gl.ONE && this.lastDestBlend === this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setAlphaBlend = function ()
	{
		this.setBlend(this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setNoPremultiplyAlphaBlend = function ()
	{
		this.setBlend(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	var LAST_VERTEX = MAX_VERTICES * 2 - 8;
	GLWrap_.prototype.quad = function(tlx, tly, trx, try_, brx, bry, blx, bly)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = 0;
		vd[v] = tly;
		td[v++] = 0;
		vd[v] = trx;
		td[v++] = 1;
		vd[v] = try_;
		td[v++] = 0;
		vd[v] = brx;
		td[v++] = 1;
		vd[v] = bry;
		td[v++] = 1;
		vd[v] = blx;
		td[v++] = 0;
		vd[v] = bly;
		td[v++] = 1;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTex = function(tlx, tly, trx, try_, brx, bry, blx, bly, rcTex)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		var rc_left = rcTex.left;
		var rc_top = rcTex.top;
		var rc_right = rcTex.right;
		var rc_bottom = rcTex.bottom;
		vd[v] = tlx;
		td[v++] = rc_left;
		vd[v] = tly;
		td[v++] = rc_top;
		vd[v] = trx;
		td[v++] = rc_right;
		vd[v] = try_;
		td[v++] = rc_top;
		vd[v] = brx;
		td[v++] = rc_right;
		vd[v] = bry;
		td[v++] = rc_bottom;
		vd[v] = blx;
		td[v++] = rc_left;
		vd[v] = bly;
		td[v++] = rc_bottom;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTexUV = function(tlx, tly, trx, try_, brx, bry, blx, bly, tlu, tlv, tru, trv, bru, brv, blu, blv)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = tlu;
		vd[v] = tly;
		td[v++] = tlv;
		vd[v] = trx;
		td[v++] = tru;
		vd[v] = try_;
		td[v++] = trv;
		vd[v] = brx;
		td[v++] = bru;
		vd[v] = bry;
		td[v++] = brv;
		vd[v] = blx;
		td[v++] = blu;
		vd[v] = bly;
		td[v++] = blv;
		this.vertexPtr = v;
	};
	var LAST_POINT = MAX_POINTS - 4;
	GLWrap_.prototype.point = function(x_, y_, size_, opacity_)
	{
		if (this.pointPtr >= LAST_POINT)
			this.endBatch();
		var p = this.pointPtr;			// point cursor
		var pd = this.pointData;		// point data array
		if (this.hasPointBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount++;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_POINTS;
			b.startIndex = p;
			b.indexCount = 1;
			this.hasPointBatchTop = true;
			this.hasQuadBatchTop = false;
		}
		pd[p++] = x_;
		pd[p++] = y_;
		pd[p++] = size_;
		pd[p++] = opacity_;
		this.pointPtr = p;
	};
	GLWrap_.prototype.switchProgram = function (progIndex)
	{
		if (this.lastProgram === progIndex)
			return;			// no change
		var shaderProg = this.shaderPrograms[progIndex];
		if (!shaderProg)
		{
			if (this.lastProgram === 0)
				return;								// already on default shader
			progIndex = 0;
			shaderProg = this.shaderPrograms[0];
		}
		var b = this.pushBatch();
		b.type = BATCH_SETPROGRAM;
		b.startIndex = progIndex;
		this.lastProgram = progIndex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.programUsesDest = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd);
	};
	GLWrap_.prototype.programUsesCrossSampling = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd || s.crossSampling);
	};
	GLWrap_.prototype.programExtendsBox = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return s.extendBoxHorizontal !== 0 || s.extendBoxVertical !== 0;
	};
	GLWrap_.prototype.getProgramBoxExtendHorizontal = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxHorizontal;
	};
	GLWrap_.prototype.getProgramBoxExtendVertical = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxVertical;
	};
	GLWrap_.prototype.getProgramParameterType = function (progIndex, paramIndex)
	{
		return this.shaderPrograms[progIndex].parameters[paramIndex][2];
	};
	GLWrap_.prototype.programIsAnimated = function (progIndex)
	{
		return this.shaderPrograms[progIndex].animated;
	};
	GLWrap_.prototype.setProgramParameters = function (backTex, pixelWidth, pixelHeight, destStartX, destStartY, destEndX, destEndY, layerScale, layerAngle, viewOriginLeft, viewOriginTop, params)
	{
		var i, len;
		var s = this.shaderPrograms[this.lastProgram];
		var b, mat4param, shaderParams;
		if (s.hasAnyOptionalUniforms || params.length)
		{
			b = this.pushBatch();
			b.type = BATCH_SETPROGRAMPARAMETERS;
			if (b.mat4param)
				mat4.set(this.matMV, b.mat4param);
			else
				b.mat4param = mat4.create();
			mat4param = b.mat4param;
			mat4param[0] = pixelWidth;
			mat4param[1] = pixelHeight;
			mat4param[2] = destStartX;
			mat4param[3] = destStartY;
			mat4param[4] = destEndX;
			mat4param[5] = destEndY;
			mat4param[6] = layerScale;
			mat4param[7] = layerAngle;
			mat4param[8] = viewOriginLeft;
			mat4param[9] = viewOriginTop;
			if (s.locSamplerBack)
			{
;
				b.texParam = backTex;
			}
			else
				b.texParam = null;
			if (params.length)
			{
				shaderParams = b.shaderParams;
				shaderParams.length = params.length;
				for (i = 0, len = params.length; i < len; i++)
					shaderParams[i] = params[i];
			}
			this.hasQuadBatchTop = false;
			this.hasPointBatchTop = false;
		}
	};
	GLWrap_.prototype.clear = function (r, g, b_, a)
	{
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 0;					// clear all mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = r;
		b.mat4param[1] = g;
		b.mat4param[2] = b_;
		b.mat4param[3] = a;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.clearRect = function (x, y, w, h)
	{
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 1;					// clear rect mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = x;
		b.mat4param[1] = y;
		b.mat4param[2] = w;
		b.mat4param[3] = h;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.present = function ()
	{
		this.endBatch();
		this.gl.flush();
		/*
		if (debugBatch)
		{
;
			debugBatch = false;
		}
		*/
	};
	function nextHighestPowerOfTwo(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	var all_textures = [];
	var textures_by_src = {};
	var BF_RGBA8 = 0;
	var BF_RGB8 = 1;
	var BF_RGBA4 = 2;
	var BF_RGB5_A1 = 3;
	var BF_RGB565 = 4;
	GLWrap_.prototype.loadTexture = function (img, tiling, linearsampling, pixelformat, tiletype)
	{
		tiling = !!tiling;
		linearsampling = !!linearsampling;
		var tex_key = img.src + "," + tiling + "," + linearsampling + (tiling ? ("," + tiletype) : "");
		var webGL_texture = null;
		if (typeof img.src !== "undefined" && textures_by_src.hasOwnProperty(tex_key))
		{
			webGL_texture = textures_by_src[tex_key];
			webGL_texture.c2refcount++;
			return webGL_texture;
		}
		this.endBatch();
;
		var gl = this.gl;
		var isPOT = (cr.isPOT(img.width) && cr.isPOT(img.height));
		webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		var internalformat = gl.RGBA;
		var format = gl.RGBA;
		var type = gl.UNSIGNED_BYTE;
		if (pixelformat && !this.isIE)
		{
			switch (pixelformat) {
			case BF_RGB8:
				internalformat = gl.RGB;
				format = gl.RGB;
				break;
			case BF_RGBA4:
				type = gl.UNSIGNED_SHORT_4_4_4_4;
				break;
			case BF_RGB5_A1:
				type = gl.UNSIGNED_SHORT_5_5_5_1;
				break;
			case BF_RGB565:
				internalformat = gl.RGB;
				format = gl.RGB;
				type = gl.UNSIGNED_SHORT_5_6_5;
				break;
			}
		}
		if (!isPOT && tiling)
		{
			var canvas = document.createElement("canvas");
			canvas.width = cr.nextHighestPowerOfTwo(img.width);
			canvas.height = cr.nextHighestPowerOfTwo(img.height);
			var ctx = canvas.getContext("2d");
			ctx.drawImage(img,
						  0, 0, img.width, img.height,
						  0, 0, canvas.width, canvas.height);
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, canvas);
		}
		else
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, img);
		if (tiling)
		{
			if (tiletype === "repeat-x")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
			}
			else if (tiletype === "repeat-y")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
			else
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		if (linearsampling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
			if (isPOT)
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_LINEAR);
				gl.generateMipmap(gl.TEXTURE_2D);
			}
			else
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
		}
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = img.width;
		webGL_texture.c2height = img.height;
		webGL_texture.c2refcount = 1;
		webGL_texture.c2texkey = tex_key;
		all_textures.push(webGL_texture);
		textures_by_src[tex_key] = webGL_texture;
		return webGL_texture;
	};
	GLWrap_.prototype.createEmptyTexture = function (w, h, linearsampling, _16bit, tiling)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		var webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, w, h, 0, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, null);
		if (tiling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = w;
		webGL_texture.c2height = h;
		all_textures.push(webGL_texture);
		return webGL_texture;
	};
	GLWrap_.prototype.videoToTexture = function (video_, texture_, _16bit)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		gl.bindTexture(gl.TEXTURE_2D, texture_);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, video_);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
	};
	GLWrap_.prototype.deleteTexture = function (tex)
	{
		if (!tex)
			return;
		if (typeof tex.c2refcount !== "undefined" && tex.c2refcount > 1)
		{
			tex.c2refcount--;
			return;
		}
		this.endBatch();
		if (tex === this.lastTexture0)
		{
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.lastTexture0 = null;
		}
		if (tex === this.lastTexture1)
		{
			this.gl.activeTexture(this.gl.TEXTURE1);
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.gl.activeTexture(this.gl.TEXTURE0);
			this.lastTexture1 = null;
		}
		cr.arrayFindRemove(all_textures, tex);
		if (typeof tex.c2texkey !== "undefined")
			delete textures_by_src[tex.c2texkey];
		this.gl.deleteTexture(tex);
	};
	GLWrap_.prototype.estimateVRAM = function ()
	{
		var total = this.width * this.height * 4 * 2;
		var i, len, t;
		for (i = 0, len = all_textures.length; i < len; i++)
		{
			t = all_textures[i];
			total += (t.c2width * t.c2height * 4);
		}
		return total;
	};
	GLWrap_.prototype.textureCount = function ()
	{
		return all_textures.length;
	};
	GLWrap_.prototype.setRenderingToTexture = function (tex)
	{
		if (tex === this.renderToTex)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_RENDERTOTEXTURE;
		b.texParam = tex;
		this.renderToTex = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	cr.GLWrap = GLWrap_;
}());
;
(function()
{
	function Runtime(canvas)
	{
		if (!canvas || (!canvas.getContext && !canvas["dc"]))
			return;
		if (canvas["c2runtime"])
			return;
		else
			canvas["c2runtime"] = this;
		var self = this;
		this.isCrosswalk = /crosswalk/i.test(navigator.userAgent) || /xwalk/i.test(navigator.userAgent) || !!(typeof window["c2isCrosswalk"] !== "undefined" && window["c2isCrosswalk"]);
		this.isPhoneGap = (!this.isCrosswalk && (typeof window["device"] !== "undefined" && (typeof window["device"]["cordova"] !== "undefined" || typeof window["device"]["phonegap"] !== "undefined")));
		this.isDirectCanvas = !!canvas["dc"];
		this.isAppMobi = (typeof window["AppMobi"] !== "undefined" || this.isDirectCanvas);
		this.isCocoonJs = !!window["c2cocoonjs"];
		if (this.isCocoonJs)
		{
			CocoonJS["App"]["onSuspended"].addEventListener(function() {
				self["setSuspended"](true);
			});
			CocoonJS["App"]["onActivated"].addEventListener(function () {
				self["setSuspended"](false);
			});
		}
		this.isDomFree = this.isDirectCanvas || this.isCocoonJs;
		this.isTizen = /tizen/i.test(navigator.userAgent);
		this.isAndroid = /android/i.test(navigator.userAgent) && !this.isTizen;		// tizen says "like Android"
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.isiPhone = /iphone/i.test(navigator.userAgent) || /ipod/i.test(navigator.userAgent);	// treat ipod as an iphone
		this.isiPad = /ipad/i.test(navigator.userAgent);
		this.isiOS = this.isiPhone || this.isiPad;
		this.isiPhoneiOS6 = (this.isiPhone && /os\s6/i.test(navigator.userAgent));
		this.isChrome = /chrome/i.test(navigator.userAgent) || /chromium/i.test(navigator.userAgent);
		this.isAmazonWebApp = /amazonwebappplatform/i.test(navigator.userAgent);
		this.isFirefox = /firefox/i.test(navigator.userAgent);
		this.isSafari = !this.isChrome && /safari/i.test(navigator.userAgent);		// Chrome includes Safari in UA
		this.isWindows = /windows/i.test(navigator.userAgent);
		this.isNodeWebkit = (typeof window["c2nodewebkit"] !== "undefined" || /nodewebkit/i.test(navigator.userAgent));
		this.isArcade = (typeof window["is_scirra_arcade"] !== "undefined");
		this.isWindows8App = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.isWindowsPhone8 = !!(typeof window["c2isWindowsPhone8"] !== "undefined" && window["c2isWindowsPhone8"]);
		this.isBlackberry10 = !!(typeof window["c2isBlackberry10"] !== "undefined" && window["c2isBlackberry10"]);
		this.isAndroidStockBrowser = (this.isAndroid && !this.isChrome && !this.isFirefox && !this.isAmazonWebApp && !this.isDomFree);
		this.devicePixelRatio = 1;
		this.isMobile = (this.isPhoneGap || this.isCrosswalk || this.isAppMobi || this.isCocoonJs || this.isAndroid || this.isiOS || this.isWindowsPhone8 || this.isBlackberry10 || this.isTizen);
		if (!this.isMobile)
			this.isMobile = /(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet)/i.test(navigator.userAgent);
		if (typeof cr_is_preview !== "undefined" && !this.isNodeWebkit && (window.location.search === "?nw" || /nodewebkit/i.test(navigator.userAgent)))
		{
			this.isNodeWebkit = true;
		}
		this.isDebug = (typeof cr_is_preview !== "undefined" && window.location.search.indexOf("debug") > -1)
		this.canvas = canvas;
		this.canvasdiv = document.getElementById("c2canvasdiv");
		this.gl = null;
		this.glwrap = null;
		this.ctx = null;
		this.fullscreenOldMarginCss = "";
		this.firstInFullscreen = false;
		this.oldWidth = 0;		// for restoring non-fullscreen canvas after fullscreen
		this.oldHeight = 0;
		this.canvas.oncontextmenu = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		this.canvas.onselectstart = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		if (this.isDirectCanvas)
			window["c2runtime"] = this;
		if (this.isNodeWebkit)
		{
			window.ondragover = function(e) { e.preventDefault(); return false; };
			window.ondrop = function(e) { e.preventDefault(); return false; };
			require("nw.gui")["App"]["clearCache"]();
		}
		this.width = canvas.width;
		this.height = canvas.height;
		this.draw_width = this.width;
		this.draw_height = this.height;
		this.cssWidth = this.width;
		this.cssHeight = this.height;
		this.lastWindowWidth = window.innerWidth;
		this.lastWindowHeight = window.innerHeight;
		this.redraw = true;
		this.isSuspended = false;
		this.blockSuspend = false;
		if (!Date.now) {
		  Date.now = function now() {
			return +new Date();
		  };
		}
		this.plugins = [];
		this.types = {};
		this.types_by_index = [];
		this.behaviors = [];
		this.layouts = {};
		this.layouts_by_index = [];
		this.eventsheets = {};
		this.eventsheets_by_index = [];
		this.wait_for_textures = [];        // for blocking until textures loaded
		this.triggers_to_postinit = [];
		this.all_global_vars = [];
		this.all_local_vars = [];
		this.solidBehavior = null;
		this.jumpthruBehavior = null;
		this.deathRow = new cr.ObjectSet();
		this.isInClearDeathRow = false;
		this.isInOnDestroy = 0;					// needs to support recursion so increments and decrements and is true if > 0
		this.isRunningEvents = false;
		this.createRow = [];
		this.isLoadingState = false;
		this.saveToSlot = "";
		this.loadFromSlot = "";
		this.loadFromJson = "";
		this.lastSaveJson = "";
		this.signalledContinuousPreview = false;
		this.suspendDrawing = false;		// for hiding display until continuous preview loads
		this.dt = 0;
        this.dt1 = 0;
		this.logictime = 0;			// used to calculate CPUUtilisation
		this.cpuutilisation = 0;
		this.zeroDtCount = 0;
        this.timescale = 1.0;
        this.kahanTime = new cr.KahanAdder();
		this.last_tick_time = 0;
		this.measuring_dt = true;
		this.fps = 0;
		this.last_fps_time = 0;
		this.tickcount = 0;
		this.execcount = 0;
		this.framecount = 0;        // for fps
		this.objectcount = 0;
		this.changelayout = null;
		this.destroycallbacks = [];
		this.event_stack = [];
		this.event_stack_index = -1;
		this.localvar_stack = [[]];
		this.localvar_stack_index = 0;
		this.trigger_depth = 0;		// recursion depth for triggers
		this.pushEventStack(null);
		this.loop_stack = [];
		this.loop_stack_index = -1;
		this.next_uid = 0;
		this.next_puid = 0;		// permanent unique ids
		this.layout_first_tick = true;
		this.family_count = 0;
		this.suspend_events = [];
		this.raf_id = 0;
		this.timeout_id = 0;
		this.isloading = true;
		this.loadingprogress = 0;
		this.isNodeFullscreen = false;
		this.stackLocalCount = 0;	// number of stack-based local vars for recursion
		this.halfFramerateMode = false;
		this.lastRafTime = 0;		// time of last requestAnimationFrame call
		this.ranLastRaf = false;	// false if last requestAnimationFrame was skipped for half framerate mode
		this.had_a_click = false;
		this.isInUserInputEvent = false;
        this.objects_to_tick = new cr.ObjectSet();
		this.objects_to_tick2 = new cr.ObjectSet();
		this.registered_collisions = [];
		this.temp_poly = new cr.CollisionPoly([]);
		this.temp_poly2 = new cr.CollisionPoly([]);
		this.allGroups = [];				// array of all event groups
        this.activeGroups = {};				// event group activation states
		this.cndsBySid = {};
		this.actsBySid = {};
		this.varsBySid = {};
		this.blocksBySid = {};
		this.running_layout = null;			// currently running layout
		this.layer_canvas = null;			// for layers "render-to-texture"
		this.layer_ctx = null;
		this.layer_tex = null;
		this.layout_tex = null;
		this.layout_canvas = null;
		this.layout_ctx = null;
		this.is_WebGL_context_lost = false;
		this.uses_background_blending = false;	// if any shader uses background blending, so entire layout renders to texture
		this.fx_tex = [null, null];
		this.fullscreen_scaling = 0;
		this.files_subfolder = "";			// path with project files
		this.objectsByUid = {};				// maps every in-use UID (as a string) to its instance
		this.loaderlogo = null;
		this.snapshotCanvas = null;
		this.snapshotData = "";
		this.load();
		this.isRetina = (!this.isDomFree && this.useHighDpi && !this.isAndroidStockBrowser);
		this.devicePixelRatio = (this.isRetina ? (window["devicePixelRatio"] || window["webkitDevicePixelRatio"] || window["mozDevicePixelRatio"] || window["msDevicePixelRatio"] || 1) : 1);
		this.ClearDeathRow();
		var attribs;
		var alpha_canvas = this.alphaBackground && !(this.isNodeWebkit || this.isWindows8App || this.isWindowsPhone8);
		if (this.fullscreen_mode > 0)
			this["setSize"](window.innerWidth, window.innerHeight, true);
		try {
			if (this.enableWebGL && (this.isCocoonJs || !this.isDomFree))
			{
				attribs = {
					"alpha": alpha_canvas,
					"depth": false,
					"antialias": false,
					"failIfMajorPerformanceCaveat": true
				};
				this.gl = (canvas.getContext("webgl", attribs) || canvas.getContext("experimental-webgl", attribs));
			}
		}
		catch (e) {
		}
		if (this.gl)
		{
;
			if (!this.isDomFree)
			{
				this.overlay_canvas = document.createElement("canvas");
				jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode);
				this.overlay_canvas.oncontextmenu = function (e) { return false; };
				this.overlay_canvas.onselectstart = function (e) { return false; };
				this.overlay_canvas.width = this.cssWidth;
				this.overlay_canvas.height = this.cssHeight;
				jQuery(this.overlay_canvas).css({"width": this.cssWidth + "px",
												"height": this.cssHeight + "px"});
				this.positionOverlayCanvas();
				this.overlay_ctx = this.overlay_canvas.getContext("2d");
			}
			this.glwrap = new cr.GLWrap(this.gl, this.isMobile);
			this.glwrap.setSize(canvas.width, canvas.height);
			this.ctx = null;
			this.canvas.addEventListener("webglcontextlost", function (ev) {
				ev.preventDefault();
				self.onContextLost();
				console.log("[Construct 2] WebGL context lost");
				window["cr_setSuspended"](true);		// stop rendering
			}, false);
			this.canvas.addEventListener("webglcontextrestored", function (ev) {
				self.glwrap.initState();
				self.glwrap.setSize(self.glwrap.width, self.glwrap.height, true);
				self.layer_tex = null;
				self.layout_tex = null;
				self.fx_tex[0] = null;
				self.fx_tex[1] = null;
				self.onContextRestored();
				self.redraw = true;
				console.log("[Construct 2] WebGL context restored");
				window["cr_setSuspended"](false);		// resume rendering
			}, false);
			var i, len, j, lenj, k, lenk, t, s, l, y;
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
				{
					s = t.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
					this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
				}
			}
			for (i = 0, len = this.layouts_by_index.length; i < len; i++)
			{
				l = this.layouts_by_index[i];
				for (j = 0, lenj = l.effect_types.length; j < lenj; j++)
				{
					s = l.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
				}
				for (j = 0, lenj = l.layers.length; j < lenj; j++)
				{
					y = l.layers[j];
					for (k = 0, lenk = y.effect_types.length; k < lenk; k++)
					{
						s = y.effect_types[k];
						s.shaderindex = this.glwrap.getShaderIndex(s.id);
						this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
					}
				}
			}
		}
		else
		{
			if (this.fullscreen_mode > 0 && this.isDirectCanvas)
			{
;
				this.canvas = null;
				document.oncontextmenu = function (e) { return false; };
				document.onselectstart = function (e) { return false; };
				this.ctx = AppMobi["canvas"]["getContext"]("2d");
				try {
					this.ctx["samplingMode"] = this.linearSampling ? "smooth" : "sharp";
					this.ctx["globalScale"] = 1;
					this.ctx["HTML5CompatibilityMode"] = true;
					this.ctx["imageSmoothingEnabled"] = this.linearSampling;
				} catch(e){}
				if (this.width !== 0 && this.height !== 0)
				{
					this.ctx.width = this.width;
					this.ctx.height = this.height;
				}
			}
			if (!this.ctx)
			{
;
				if (this.isCocoonJs)
				{
					attribs = {
						"antialias": !!this.linearSampling,
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				else
				{
					attribs = {
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["imageSmoothingEnabled"] = this.linearSampling;
			}
			this.overlay_canvas = null;
			this.overlay_ctx = null;
		}
		this.tickFunc = function () { self.tick(); };
		if (window != window.top && !this.isDomFree && !this.isWindows8App)
		{
			document.addEventListener("mousedown", function () {
				window.focus();
			}, true);
			document.addEventListener("touchstart", function () {
				window.focus();
			}, true);
		}
		if (typeof cr_is_preview !== "undefined")
		{
			if (this.isCocoonJs)
				console.log("[Construct 2] In preview-over-wifi via CocoonJS mode");
			if (window.location.search.indexOf("continuous") > -1)
			{
				cr.logexport("Reloading for continuous preview");
				this.loadFromSlot = "__c2_continuouspreview";
				this.suspendDrawing = true;
			}
			if (this.pauseOnBlur && !this.isMobile)
			{
				jQuery(window).focus(function ()
				{
					self["setSuspended"](false);
				});
				jQuery(window).blur(function ()
				{
					self["setSuspended"](true);
				});
			}
		}
		if (this.fullscreen_mode === 0 && this.isRetina && this.devicePixelRatio > 1)
		{
			this["setSize"](this.original_width, this.original_height, true);
		}
		this.tryLockOrientation();
		this.go();			// run loading screen
		this.extra = {};
		cr.seal(this);
	};
	var webkitRepaintFlag = false;
	Runtime.prototype["setSize"] = function (w, h, force)
	{
		var offx = 0, offy = 0;
		var neww = 0, newh = 0, intscale = 0;
		var tryHideAddressBar = (this.isiPhoneiOS6 && this.isSafari && !navigator["standalone"] && !this.isDomFree && !this.isPhoneGap);
		if (tryHideAddressBar)
			h += 60;		// height of Safari iPhone iOS 6 address bar
		if (this.lastWindowWidth === w && this.lastWindowHeight === h && !force)
			return;
		this.lastWindowWidth = w;
		this.lastWindowHeight = h;
		var mode = this.fullscreen_mode;
		var orig_aspect, cur_aspect;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.fullscreen_mode === 0 && !force)
			return;			// ignore size events when not fullscreen and not using a fullscreen-in-browser mode
		if (isfullscreen && this.fullscreen_scaling > 0)
			mode = this.fullscreen_scaling;
		if (mode >= 4)
		{
			orig_aspect = this.original_width / this.original_height;
			cur_aspect = w / h;
			if (cur_aspect > orig_aspect)
			{
				neww = h * orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = neww / this.original_width;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offx = (w - neww) / 2;
					w = neww;
				}
			}
			else
			{
				newh = w / orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = newh / this.original_height;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offy = (h - newh) / 2;
					h = newh;
				}
			}
			if (isfullscreen && !this.isNodeWebkit)
			{
				offx = 0;
				offy = 0;
			}
			offx = Math.floor(offx);
			offy = Math.floor(offy);
			w = Math.floor(w);
			h = Math.floor(h);
		}
		else if (this.isNodeWebkit && this.isNodeFullscreen && this.fullscreen_mode_set === 0)
		{
			offx = Math.floor((w - this.original_width) / 2);
			offy = Math.floor((h - this.original_height) / 2);
			w = this.original_width;
			h = this.original_height;
		}
		if (mode < 2)
			this.aspect_scale = this.devicePixelRatio;
		if (this.isRetina && this.isiPad && this.devicePixelRatio > 1)	// don't apply to iPad 1-2
		{
			if (w >= 1024)
				w = 1023;		// 2046 retina pixels
			if (h >= 1024)
				h = 1023;
		}
		var multiplier = this.devicePixelRatio;
		this.cssWidth = w;
		this.cssHeight = h;
		this.width = Math.round(w * multiplier);
		this.height = Math.round(h * multiplier);
		this.redraw = true;
		if (this.wantFullscreenScalingQuality)
		{
			this.draw_width = this.width;
			this.draw_height = this.height;
			this.fullscreenScalingQuality = true;
		}
		else
		{
			if ((this.width < this.original_width && this.height < this.original_height) || mode === 1)
			{
				this.draw_width = this.width;
				this.draw_height = this.height;
				this.fullscreenScalingQuality = true;
			}
			else
			{
				this.draw_width = this.original_width;
				this.draw_height = this.original_height;
				this.fullscreenScalingQuality = false;
				/*var orig_aspect = this.original_width / this.original_height;
				var cur_aspect = this.width / this.height;
				if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
					this.aspect_scale = this.height / this.original_height;
				else
					this.aspect_scale = this.width / this.original_width;*/
				if (mode === 2)		// scale inner
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect < orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect > orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
				else if (mode === 3)
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect > orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect < orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
			}
		}
		if (this.canvasdiv && !this.isDomFree)
		{
			jQuery(this.canvasdiv).css({"width": w + "px",
										"height": h + "px",
										"margin-left": offx,
										"margin-top": offy});
			if (typeof cr_is_preview !== "undefined")
			{
				jQuery("#borderwrap").css({"width": w + "px",
											"height": h + "px"});
			}
		}
		if (this.canvas)
		{
			this.canvas.width = Math.round(w * multiplier);
			this.canvas.height = Math.round(h * multiplier);
			if (this.isRetina)
			{
				jQuery(this.canvas).css({"width": w + "px",
										"height": h + "px"});
			}
		}
		if (this.overlay_canvas)
		{
			this.overlay_canvas.width = w;
			this.overlay_canvas.height = h;
			jQuery(this.overlay_canvas).css({"width": w + "px",
											"height": h + "px"});
		}
		if (this.glwrap)
		{
			this.glwrap.setSize(Math.round(w * multiplier), Math.round(h * multiplier));
		}
		if (this.isDirectCanvas && this.ctx)
		{
			this.ctx.width = w;
			this.ctx.height = h;
		}
		if (this.ctx)
		{
			this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["imageSmoothingEnabled"] = this.linearSampling;
		}
		this.tryLockOrientation();
		if (tryHideAddressBar)
		{
			window.setTimeout(function () {
				window.scrollTo(0, 1);
			}, 100);
		}
	};
	Runtime.prototype.tryLockOrientation = function ()
	{
		if (!this.autoLockOrientation || this.orientations === 0)
			return;
		var orientation = "portrait";
		if (this.orientations === 2)
			orientation = "landscape";
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Runtime.prototype.onContextLost = function ()
	{
		this.is_WebGL_context_lost = true;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onLostWebGLContext)
				t.onLostWebGLContext();
		}
	};
	Runtime.prototype.onContextRestored = function ()
	{
		this.is_WebGL_context_lost = false;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onRestoreWebGLContext)
				t.onRestoreWebGLContext();
		}
	};
	Runtime.prototype.positionOverlayCanvas = function()
	{
		if (this.isDomFree)
			return;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		var overlay_position = isfullscreen ? jQuery(this.canvas).offset() : jQuery(this.canvas).position();
		overlay_position.position = "absolute";
		jQuery(this.overlay_canvas).css(overlay_position);
	};
	var caf = window["cancelAnimationFrame"] ||
	  window["mozCancelAnimationFrame"]    ||
	  window["webkitCancelAnimationFrame"] ||
	  window["msCancelAnimationFrame"]     ||
	  window["oCancelAnimationFrame"];
	Runtime.prototype["setSuspended"] = function (s)
	{
		var i, len;
		if (s && !this.isSuspended && !this.blockSuspend)
		{
			cr.logexport("[Construct 2] Suspending");
			this.isSuspended = true;			// next tick will be last
			if (this.raf_id !== 0 && caf)		// note: CocoonJS does not implement cancelAnimationFrame
				caf(this.raf_id);
			if (this.timeout_id !== 0)
				clearTimeout(this.timeout_id);
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](true);
		}
		else if (!s && this.isSuspended)
		{
			cr.logexport("[Construct 2] Resuming");
			this.isSuspended = false;
			this.last_tick_time = cr.performance_now();	// ensure first tick is a zero-dt one
			this.last_fps_time = cr.performance_now();	// reset FPS counter
			this.framecount = 0;
			this.logictime = 0;
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](false);
			this.tick();						// kick off runtime again
		}
	};
	Runtime.prototype.addSuspendCallback = function (f)
	{
		this.suspend_events.push(f);
	};
	Runtime.prototype.load = function ()
	{
;
		var pm = cr.getProjectModel();
		this.name = pm[0];
		this.first_layout = pm[1];
		this.fullscreen_mode = pm[11];	// 0 = off, 1 = crop, 2 = scale inner, 3 = scale outer, 4 = letterbox scale, 5 = integer letterbox scale
		this.fullscreen_mode_set = pm[11];
		this.original_width = pm[9];
		this.original_height = pm[10];
		this.parallax_x_origin = this.original_width / 2;
		this.parallax_y_origin = this.original_height / 2;
		if (this.isDomFree && (pm[11] >= 4 || pm[11] === 0))
		{
			cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'");
			this.fullscreen_mode = 3;
			this.fullscreen_mode_set = 3;
		}
		this.uses_loader_layout = pm[17];
		this.loaderstyle = pm[18];
		if (this.loaderstyle === 0)
		{
			this.loaderlogo = new Image();
			this.loaderlogo.src = "loading-logo.png";
		}
		this.next_uid = pm[20];
		this.system = new cr.system_object(this);
		var i, len, j, lenj, k, lenk, idstr, m, b, t, f;
		var plugin, plugin_ctor;
		for (i = 0, len = pm[2].length; i < len; i++)
		{
			m = pm[2][i];
;
			cr.add_common_aces(m);
			plugin = new m[0](this);
			plugin.singleglobal = m[1];
			plugin.is_world = m[2];
			plugin.must_predraw = m[9];
			if (plugin.onCreate)
				plugin.onCreate();  // opportunity to override default ACEs
			cr.seal(plugin);
			this.plugins.push(plugin);
		}
		pm = cr.getProjectModel();
		for (i = 0, len = pm[3].length; i < len; i++)
		{
			m = pm[3][i];
			plugin_ctor = m[1];
;
			plugin = null;
			for (j = 0, lenj = this.plugins.length; j < lenj; j++)
			{
				if (this.plugins[j] instanceof plugin_ctor)
				{
					plugin = this.plugins[j];
					break;
				}
			}
;
;
			var type_inst = new plugin.Type(plugin);
;
			type_inst.name = m[0];
			type_inst.is_family = m[2];
			type_inst.instvar_sids = m[3].slice(0);
			type_inst.vars_count = m[3].length;
			type_inst.behs_count = m[4];
			type_inst.fx_count = m[5];
			type_inst.sid = m[11];
			if (type_inst.is_family)
			{
				type_inst.members = [];				// types in this family
				type_inst.family_index = this.family_count++;
				type_inst.families = null;
			}
			else
			{
				type_inst.members = null;
				type_inst.family_index = -1;
				type_inst.families = [];			// families this type belongs to
			}
			type_inst.family_var_map = null;
			type_inst.family_beh_map = null;
			type_inst.family_fx_map = null;
			type_inst.is_contained = false;
			type_inst.container = null;
			if (m[6])
			{
				type_inst.texture_file = m[6][0];
				type_inst.texture_filesize = m[6][1];
				type_inst.texture_pixelformat = m[6][2];
			}
			else
			{
				type_inst.texture_file = null;
				type_inst.texture_filesize = 0;
				type_inst.texture_pixelformat = 0;		// rgba8
			}
			if (m[7])
			{
				type_inst.animations = m[7];
			}
			else
			{
				type_inst.animations = null;
			}
			type_inst.index = i;                                // save index in to types array in type
			type_inst.instances = [];                           // all instances of this type
			type_inst.deadCache = [];							// destroyed instances to recycle next create
			type_inst.solstack = [new cr.selection(type_inst)]; // initialise SOL stack with one empty SOL
			type_inst.cur_sol = 0;
			type_inst.default_instance = null;
			type_inst.default_layerindex = 0;
			type_inst.stale_iids = true;
			type_inst.updateIIDs = cr.type_updateIIDs;
			type_inst.getFirstPicked = cr.type_getFirstPicked;
			type_inst.getPairedInstance = cr.type_getPairedInstance;
			type_inst.getCurrentSol = cr.type_getCurrentSol;
			type_inst.pushCleanSol = cr.type_pushCleanSol;
			type_inst.pushCopySol = cr.type_pushCopySol;
			type_inst.popSol = cr.type_popSol;
			type_inst.getBehaviorByName = cr.type_getBehaviorByName;
			type_inst.getBehaviorIndexByName = cr.type_getBehaviorIndexByName;
			type_inst.getEffectIndexByName = cr.type_getEffectIndexByName;
			type_inst.applySolToContainer = cr.type_applySolToContainer;
			type_inst.getInstanceByIID = cr.type_getInstanceByIID;
			type_inst.collision_grid = new cr.SparseGrid(this.original_width, this.original_height);
			type_inst.any_cell_changed = true;
			type_inst.any_instance_parallaxed = false;
			type_inst.extra = {};
			type_inst.toString = cr.type_toString;
			type_inst.behaviors = [];
			for (j = 0, lenj = m[8].length; j < lenj; j++)
			{
				b = m[8][j];
				var behavior_ctor = b[1];
				var behavior_plugin = null;
				for (k = 0, lenk = this.behaviors.length; k < lenk; k++)
				{
					if (this.behaviors[k] instanceof behavior_ctor)
					{
						behavior_plugin = this.behaviors[k];
						break;
					}
				}
				if (!behavior_plugin)
				{
					behavior_plugin = new behavior_ctor(this);
					behavior_plugin.my_types = [];						// types using this behavior
					behavior_plugin.my_instances = new cr.ObjectSet(); 	// instances of this behavior
					if (behavior_plugin.onCreate)
						behavior_plugin.onCreate();
					cr.seal(behavior_plugin);
					this.behaviors.push(behavior_plugin);
					if (cr.behaviors.solid && behavior_plugin instanceof cr.behaviors.solid)
						this.solidBehavior = behavior_plugin;
					if (cr.behaviors.jumpthru && behavior_plugin instanceof cr.behaviors.jumpthru)
						this.jumpthruBehavior = behavior_plugin;
				}
				if (behavior_plugin.my_types.indexOf(type_inst) === -1)
					behavior_plugin.my_types.push(type_inst);
				var behavior_type = new behavior_plugin.Type(behavior_plugin, type_inst);
				behavior_type.name = b[0];
				behavior_type.sid = b[2];
				behavior_type.onCreate();
				cr.seal(behavior_type);
				type_inst.behaviors.push(behavior_type);
			}
			type_inst.global = m[9];
			type_inst.isOnLoaderLayout = m[10];
			type_inst.effect_types = [];
			for (j = 0, lenj = m[12].length; j < lenj; j++)
			{
				type_inst.effect_types.push({
					id: m[12][j][0],
					name: m[12][j][1],
					shaderindex: -1,
					active: true,
					index: j
				});
			}
			type_inst.tile_poly_data = m[13];
			if (!this.uses_loader_layout || type_inst.is_family || type_inst.isOnLoaderLayout || !plugin.is_world)
			{
				type_inst.onCreate();
				cr.seal(type_inst);
			}
			if (type_inst.name)
				this.types[type_inst.name] = type_inst;
			this.types_by_index.push(type_inst);
			if (plugin.singleglobal)
			{
				var instance = new plugin.Instance(type_inst);
				instance.uid = this.next_uid++;
				instance.puid = this.next_puid++;
				instance.iid = 0;
				instance.get_iid = cr.inst_get_iid;
				instance.toString = cr.inst_toString;
				instance.properties = m[14];
				instance.onCreate();
				cr.seal(instance);
				type_inst.instances.push(instance);
				this.objectsByUid[instance.uid.toString()] = instance;
			}
		}
		for (i = 0, len = pm[4].length; i < len; i++)
		{
			var familydata = pm[4][i];
			var familytype = this.types_by_index[familydata[0]];
			var familymember;
			for (j = 1, lenj = familydata.length; j < lenj; j++)
			{
				familymember = this.types_by_index[familydata[j]];
				familymember.families.push(familytype);
				familytype.members.push(familymember);
			}
		}
		for (i = 0, len = pm[23].length; i < len; i++)
		{
			var containerdata = pm[23][i];
			var containertypes = [];
			for (j = 0, lenj = containerdata.length; j < lenj; j++)
				containertypes.push(this.types_by_index[containerdata[j]]);
			for (j = 0, lenj = containertypes.length; j < lenj; j++)
			{
				containertypes[j].is_contained = true;
				containertypes[j].container = containertypes;
			}
		}
		if (this.family_count > 0)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (t.is_family || !t.families.length)
					continue;
				t.family_var_map = new Array(this.family_count);
				t.family_beh_map = new Array(this.family_count);
				t.family_fx_map = new Array(this.family_count);
				var all_fx = [];
				var varsum = 0;
				var behsum = 0;
				var fxsum = 0;
				for (j = 0, lenj = t.families.length; j < lenj; j++)
				{
					f = t.families[j];
					t.family_var_map[f.family_index] = varsum;
					varsum += f.vars_count;
					t.family_beh_map[f.family_index] = behsum;
					behsum += f.behs_count;
					t.family_fx_map[f.family_index] = fxsum;
					fxsum += f.fx_count;
					for (k = 0, lenk = f.effect_types.length; k < lenk; k++)
						all_fx.push(cr.shallowCopy({}, f.effect_types[k]));
				}
				t.effect_types = all_fx.concat(t.effect_types);
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
					t.effect_types[j].index = j;
			}
		}
		for (i = 0, len = pm[5].length; i < len; i++)
		{
			m = pm[5][i];
			var layout = new cr.layout(this, m);
			cr.seal(layout);
			this.layouts[layout.name] = layout;
			this.layouts_by_index.push(layout);
		}
		for (i = 0, len = pm[6].length; i < len; i++)
		{
			m = pm[6][i];
			var sheet = new cr.eventsheet(this, m);
			cr.seal(sheet);
			this.eventsheets[sheet.name] = sheet;
			this.eventsheets_by_index.push(sheet);
		}
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].postInit();
		for (i = 0, len = this.triggers_to_postinit.length; i < len; i++)
			this.triggers_to_postinit[i].postInit();
		this.triggers_to_postinit.length = 0;
		this.files_subfolder = pm[7];
		this.pixel_rounding = pm[8];
		this.aspect_scale = 1.0;
		this.enableWebGL = pm[12];
		this.linearSampling = pm[13];
		this.alphaBackground = pm[14];
		this.versionstr = pm[15];
		this.useHighDpi = pm[16];
		this.orientations = pm[19];		// 0 = any, 1 = portrait, 2 = landscape
		this.autoLockOrientation = (this.orientations > 0);
		this.pauseOnBlur = pm[21];
		this.wantFullscreenScalingQuality = pm[22];		// false = low quality, true = high quality
		this.fullscreenScalingQuality = this.wantFullscreenScalingQuality;
		this.start_time = Date.now();
	};
	var anyImageHadError = false;
	Runtime.prototype.waitForImageLoad = function (img_)
	{
		img_.onerror = function ()
		{
			img_.c2error = true;
			anyImageHadError = true;
		};
		this.wait_for_textures.push(img_);
	};
	Runtime.prototype.findWaitingTexture = function (src_)
	{
		var i, len;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			if (this.wait_for_textures[i].cr_src === src_)
				return this.wait_for_textures[i];
		}
		return null;
	};
	Runtime.prototype.areAllTexturesLoaded = function ()
	{
		var totalsize = 0;
		var completedsize = 0;
		var ret = true;
		var i, len, img;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			img = this.wait_for_textures[i];
			var filesize = img.cr_filesize;
			if (!filesize || filesize <= 0)
				filesize = 50000;
			totalsize += filesize;
			if ((img.complete || img["loaded"]) && !img.c2error)
				completedsize += filesize;
			else
				ret = false;    // not all textures loaded
		}
		if (totalsize == 0)
			this.progress = 0;
		else
			this.progress = (completedsize / totalsize);
		return ret;
	};
	Runtime.prototype.go = function ()
	{
		if (!this.ctx && !this.glwrap)
			return;
		var ctx = this.ctx || this.overlay_ctx;
		if (this.overlay_canvas)
			this.positionOverlayCanvas();
		this.progress = 0;
		this.last_progress = -1;
		if (this.areAllTexturesLoaded())
			this.go_textures_done();
		else
		{
			var ms_elapsed = Date.now() - this.start_time;
			if (ctx)
			{
				var overlay_width = this.width;
				var overlay_height = this.height;
				var multiplier = this.devicePixelRatio;
				if (this.overlay_canvas)
				{
					overlay_width = this.cssWidth;
					overlay_height = this.cssHeight;
					multiplier = 1;
				}
				if (this.loaderstyle !== 3 && ms_elapsed >= 500 && this.last_progress != this.progress)
				{
					ctx.clearRect(0, 0, overlay_width, overlay_height);
					var mx = overlay_width / 2;
					var my = overlay_height / 2;
					var haslogo = (this.loaderstyle === 0 && this.loaderlogo.complete);
					var hlw = 40 * multiplier;
					var hlh = 0;
					var logowidth = 80 * multiplier;
					var logoheight;
					if (haslogo)
					{
						logowidth = this.loaderlogo.width * multiplier;
						logoheight = this.loaderlogo.height * multiplier;
						hlw = logowidth / 2;
						hlh = logoheight / 2;
						ctx.drawImage(this.loaderlogo, cr.floor(mx - hlw), cr.floor(my - hlh), logowidth, logoheight);
					}
					if (this.loaderstyle <= 1)
					{
						my += hlh + (haslogo ? 12 * multiplier : 0);
						mx -= hlw;
						mx = cr.floor(mx) + 0.5;
						my = cr.floor(my) + 0.5;
						ctx.fillStyle = anyImageHadError ? "red" : "DodgerBlue";
						ctx.fillRect(mx, my, Math.floor(logowidth * this.progress), 6 * multiplier);
						ctx.strokeStyle = "black";
						ctx.strokeRect(mx, my, logowidth, 6 * multiplier);
						ctx.strokeStyle = "white";
						ctx.strokeRect(mx - 1 * multiplier, my - 1 * multiplier, logowidth + 2 * multiplier, 8 * multiplier);
					}
					else if (this.loaderstyle === 2)
					{
						ctx.font = "12pt Arial";
						ctx.fillStyle = anyImageHadError ? "#f00" : "#999";
						ctx.textBaseLine = "middle";
						var percent_text = Math.round(this.progress * 100) + "%";
						var text_dim = ctx.measureText ? ctx.measureText(percent_text) : null;
						var text_width = text_dim ? text_dim.width : 0;
						ctx.fillText(percent_text, mx - (text_width / 2), my);
					}
				}
				this.last_progress = this.progress;
			}
			setTimeout((function (self) { return function () { self.go(); }; })(this), 100);
		}
	};
	Runtime.prototype.go_textures_done = function ()
	{
		if (this.overlay_canvas)
		{
			this.canvas.parentNode.removeChild(this.overlay_canvas);
			this.overlay_ctx = null;
			this.overlay_canvas = null;
		}
		this.start_time = Date.now();
		this.last_fps_time = cr.performance_now();       // for counting framerate
		var i, len, t;
		if (this.uses_loader_layout)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (!t.is_family && !t.isOnLoaderLayout && t.plugin.is_world)
				{
					t.onCreate();
					cr.seal(t);
				}
			}
		}
		else
			this.isloading = false;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			this.layouts_by_index[i].createGlobalNonWorlds();
		}
		if (this.fullscreen_mode >= 2)
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
				this.aspect_scale = this.height / this.original_height;
			else
				this.aspect_scale = this.width / this.original_width;
		}
		if (this.first_layout)
			this.layouts[this.first_layout].startRunning();
		else
			this.layouts_by_index[0].startRunning();
;
		if (!this.uses_loader_layout)
		{
			this.loadingprogress = 1;
			this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
		}
		if (navigator["splashscreen"] && navigator["splashscreen"]["hide"])
			navigator["splashscreen"]["hide"]();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onAppBegin)
				t.onAppBegin();
		}
		this.tick();
		if (this.isDirectCanvas)
			AppMobi["webview"]["execute"]("onGameReady();");
	};
	var raf = window["requestAnimationFrame"] ||
	  window["mozRequestAnimationFrame"]    ||
	  window["webkitRequestAnimationFrame"] ||
	  window["msRequestAnimationFrame"]     ||
	  window["oRequestAnimationFrame"];
	Runtime.prototype.tick = function ()
	{
		if (!this.running_layout)
			return;
		var logic_start = cr.performance_now();
		if (this.halfFramerateMode && this.ranLastRaf)
		{
			if (logic_start - this.lastRafTime < 29)
			{
				this.ranLastRaf = false;
				this.lastRafTime = logic_start;
				if (raf)
					this.raf_id = raf(this.tickFunc, this.canvas);
				else	// no idea if this works without raf/hi res timers but let's hope for the best
					this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
				return;		// skipped this frame
			}
		}
		this.ranLastRaf = true;
		this.lastRafTime = logic_start;
		var fsmode = this.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"]);
		if ((isfullscreen || this.isNodeFullscreen) && this.fullscreen_scaling > 0)
			fsmode = this.fullscreen_scaling;
		if (fsmode > 0 && (!this.isiPhone || window.self !== window.top))
		{
			var curwidth = window.innerWidth;
			var curheight = window.innerHeight;
			if (this.lastWindowWidth !== curwidth || this.lastWindowHeight !== curheight)
			{
					this["setSize"](curwidth, curheight);
			}
		}
		if (!this.isDomFree)
		{
			if (isfullscreen)
			{
				if (!this.firstInFullscreen)
				{
					this.fullscreenOldMarginCss = jQuery(this.canvas).css("margin") || "0";
					this.firstInFullscreen = true;
				}
				if (!this.isChrome && !this.isNodeWebkit)
				{
					jQuery(this.canvas).css({
						"margin-left": "" + Math.floor((screen.width - (this.width / this.devicePixelRatio)) / 2) + "px",
						"margin-top": "" + Math.floor((screen.height - (this.height / this.devicePixelRatio)) / 2) + "px"
					});
				}
			}
			else
			{
				if (this.firstInFullscreen)
				{
					if (!this.isChrome && !this.isNodeWebkit)
					{
						jQuery(this.canvas).css("margin", this.fullscreenOldMarginCss);
					}
					this.fullscreenOldMarginCss = "";
					this.firstInFullscreen = false;
					if (this.fullscreen_mode === 0)
					{
						this["setSize"](Math.round(this.oldWidth / this.devicePixelRatio), Math.round(this.oldHeight / this.devicePixelRatio), true);
					}
				}
				else
				{
					this.oldWidth = this.width;
					this.oldHeight = this.height;
				}
			}
		}
		if (this.isloading)
		{
			var done = this.areAllTexturesLoaded();		// updates this.progress
			this.loadingprogress = this.progress;
			if (done)
			{
				this.isloading = false;
				this.progress = 1;
				this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
			}
		}
		this.logic();
		if ((this.redraw || this.isCocoonJs) && !this.is_WebGL_context_lost && !this.suspendDrawing)
		{
			this.redraw = false;
			if (this.glwrap)
				this.drawGL();
			else
				this.draw();
			if (this.snapshotCanvas)
			{
				if (this.canvas && this.canvas.toDataURL)
				{
					this.snapshotData = this.canvas.toDataURL(this.snapshotCanvas[0], this.snapshotCanvas[1]);
					this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot, null);
				}
				this.snapshotCanvas = null;
			}
		}
		if (!this.hit_breakpoint)
		{
			this.tickcount++;
			this.execcount++;
			this.framecount++;
		}
		this.logictime += cr.performance_now() - logic_start;
		if (this.isSuspended)
			return;
		if (raf)
			this.raf_id = raf(this.tickFunc, this.canvas);
		else
		{
			this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
		}
	};
	Runtime.prototype.logic = function ()
	{
		var i, leni, j, lenj, k, lenk, type, inst, binst;
		var cur_time = cr.performance_now();
		if (cur_time - this.last_fps_time >= 1000)  // every 1 second
		{
			this.last_fps_time += 1000;
			this.fps = this.framecount;
			this.framecount = 0;
			this.cpuutilisation = this.logictime;
			this.logictime = 0;
		}
		if (this.measuring_dt)
		{
			if (this.last_tick_time !== 0)
			{
				var ms_diff = cur_time - this.last_tick_time;
				if (ms_diff === 0 && !this.isDebug)
				{
					this.zeroDtCount++;
					if (this.zeroDtCout >= 10)
						this.measuring_dt = false;
					this.dt1 = 1.0 / 60.0;            // 60fps assumed (0.01666...)
				}
				else
				{
					this.dt1 = ms_diff / 1000.0; // dt measured in seconds
					if (this.dt1 > 0.5)
						this.dt1 = 0;
					else if (this.dt1 > 0.1)
						this.dt1 = 0.1;
				}
			}
			this.last_tick_time = cur_time;
		}
        this.dt = this.dt1 * this.timescale;
        this.kahanTime.add(this.dt);
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		if (this.fullscreen_mode >= 2 /* scale */ || (isfullscreen && this.fullscreen_scaling > 0))
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			var mode = this.fullscreen_mode;
			if (isfullscreen && this.fullscreen_scaling > 0)
				mode = this.fullscreen_scaling;
			if ((mode !== 2 && cur_aspect > orig_aspect) || (mode === 2 && cur_aspect < orig_aspect))
			{
				this.aspect_scale = this.height / this.original_height;
			}
			else
			{
				this.aspect_scale = this.width / this.original_width;
			}
			if (this.running_layout)
			{
				this.running_layout.scrollToX(this.running_layout.scrollX);
				this.running_layout.scrollToY(this.running_layout.scrollY);
			}
		}
		else
			this.aspect_scale = (this.isRetina ? this.devicePixelRatio : 1);
		this.ClearDeathRow();
		this.isInOnDestroy++;
		this.system.runWaits();		// prevent instance list changing
		this.isInOnDestroy--;
		this.ClearDeathRow();		// allow instance list changing
		this.isInOnDestroy++;
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					inst.behavior_insts[k].tick();
				}
			}
		}
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.posttick)
						binst.posttick();
				}
			}
		}
        var tickarr = this.objects_to_tick.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
		this.handleSaveLoad();		// save/load now if queued
		i = 0;
		while (this.changelayout && i++ < 10)
		{
			this.doChangeLayout(this.changelayout);
		}
        for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
            this.eventsheets_by_index[i].hasRun = false;
		if (this.running_layout.event_sheet)
			this.running_layout.event_sheet.run();
		this.registered_collisions.length = 0;
		this.layout_first_tick = false;
		this.isInOnDestroy++;		// prevent instance lists from being changed
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				var inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.tick2)
						binst.tick2();
				}
			}
		}
        tickarr = this.objects_to_tick2.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick2();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
	};
	Runtime.prototype.doChangeLayout = function (changeToLayout)
	{
;
		var prev_layout = this.running_layout;
		this.running_layout.stopRunning();
		var i, len, j, lenj, k, lenk, type, inst, binst;
		if (this.glwrap)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				type = this.types_by_index[i];
				if (type.is_family)
					continue;
				if (type.unloadTextures && (!type.global || type.instances.length === 0) && changeToLayout.initial_types.indexOf(type) === -1)
				{
					type.unloadTextures();
				}
			}
		}
		if (prev_layout == changeToLayout)
			this.system.waits.length = 0;
		changeToLayout.startRunning();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (!type.global && !type.plugin.singleglobal)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (inst.onLayoutChange)
					inst.onLayoutChange();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.onLayoutChange)
							binst.onLayoutChange();
					}
				}
			}
		}
		this.redraw = true;
		this.layout_first_tick = true;
		this.ClearDeathRow();
	};
    Runtime.prototype.tickMe = function (inst)
    {
        this.objects_to_tick.add(inst);
    };
	Runtime.prototype.untickMe = function (inst)
	{
		this.objects_to_tick.remove(inst);
	};
	Runtime.prototype.tick2Me = function (inst)
    {
        this.objects_to_tick2.add(inst);
    };
	Runtime.prototype.untick2Me = function (inst)
	{
		this.objects_to_tick2.remove(inst);
	};
    Runtime.prototype.getDt = function (inst)
    {
        if (!inst || inst.my_timescale === -1.0)
            return this.dt;
        return this.dt1 * inst.my_timescale;
    };
	Runtime.prototype.draw = function ()
	{
		this.running_layout.draw(this.ctx);
		if (this.isDirectCanvas)
			this.ctx["present"]();
	};
	Runtime.prototype.drawGL = function ()
	{
		this.running_layout.drawGL(this.glwrap);
		this.glwrap.present();
	};
	Runtime.prototype.addDestroyCallback = function (f)
	{
		if (f)
			this.destroycallbacks.push(f);
	};
	Runtime.prototype.removeDestroyCallback = function (f)
	{
		cr.arrayFindRemove(this.destroycallbacks, f);
	};
	Runtime.prototype.getObjectByUID = function (uid_)
	{
;
		var uidstr = uid_.toString();
		if (this.objectsByUid.hasOwnProperty(uidstr))
			return this.objectsByUid[uidstr];
		else
			return null;
	};
	Runtime.prototype.DestroyInstance = function (inst)
	{
		var i, len;
		if (!this.deathRow.contains(inst))
		{
			this.deathRow.add(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					this.DestroyInstance(inst.siblings[i]);
				}
			}
			if (this.isInClearDeathRow)
				this.deathRow.values_cache.push(inst);
			this.isInOnDestroy++;		// support recursion
			this.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnDestroyed, inst);
			this.isInOnDestroy--;
		}
	};
	Runtime.prototype.ClearDeathRow = function ()
	{
		var inst, index, type, instances, binst;
		var i, j, k, leni, lenj, lenk;
		var w, f;
		this.isInClearDeathRow = true;
		for (i = 0, leni = this.createRow.length; i < leni; i++)
		{
			inst = this.createRow[i];
			type = inst.type;
			type.instances.push(inst);
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				type.families[j].instances.push(inst);
				type.families[j].stale_iids = true;
			}
		}
		this.createRow.length = 0;
		var arr = this.deathRow.valuesRef();	// get array of items from set
		for (i = 0; i < arr.length; i++)		// check array length every time in case it changes
		{
			inst = arr[i];
			type = inst.type;
			instances = type.instances;
			for (j = 0, lenj = this.destroycallbacks.length; j < lenj; j++)
				this.destroycallbacks[j](inst);
			cr.arrayFindRemove(instances, inst);
			if (instances.length === 0)
				type.any_instance_parallaxed = false;
			if (inst.collcells)
			{
				type.collision_grid.update(inst, inst.collcells, null);
			}
			if (inst.layer)
			{
				cr.arrayRemove(inst.layer.instances, inst.get_zindex());
				inst.layer.zindices_stale = true;
			}
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				cr.arrayFindRemove(type.families[j].instances, inst);
				type.families[j].stale_iids = true;
			}
			if (inst.behavior_insts)
			{
				for (j = 0, lenj = inst.behavior_insts.length; j < lenj; j++)
				{
					binst = inst.behavior_insts[j];
					if (binst.onDestroy)
						binst.onDestroy();
					binst.behavior.my_instances.remove(inst);
				}
			}
            this.objects_to_tick.remove(inst);
			this.objects_to_tick2.remove(inst);
			for (j = 0, lenj = this.system.waits.length; j < lenj; j++)
			{
				w = this.system.waits[j];
				if (w.sols.hasOwnProperty(type.index))
					cr.arrayFindRemove(w.sols[type.index].insts, inst);
				if (!type.is_family)
				{
					for (k = 0, lenk = type.families.length; k < lenk; k++)
					{
						f = type.families[k];
						if (w.sols.hasOwnProperty(f.index))
							cr.arrayFindRemove(w.sols[f.index].insts, inst);
					}
				}
			}
			if (inst.onDestroy)
				inst.onDestroy();
			if (this.objectsByUid.hasOwnProperty(inst.uid.toString()))
				delete this.objectsByUid[inst.uid.toString()];
			this.objectcount--;
			if (type.deadCache.length < 64)
				type.deadCache.push(inst);
			type.stale_iids = true;
		}
		if (!this.deathRow.isEmpty())
			this.redraw = true;
		this.deathRow.clear();
		this.isInClearDeathRow = false;
	};
	Runtime.prototype.createInstance = function (type, layer, sx, sy)
	{
		if (type.is_family)
		{
			var i = cr.floor(Math.random() * type.members.length);
			return this.createInstance(type.members[i], layer, sx, sy);
		}
		if (!type.default_instance)
		{
			return null;
		}
		return this.createInstanceFromInit(type.default_instance, layer, false, sx, sy, false);
	};
	var all_behaviors = [];
	Runtime.prototype.createInstanceFromInit = function (initial_inst, layer, is_startup_instance, sx, sy, skip_siblings)
	{
		var i, len, j, lenj, p, effect_fallback, x, y;
		if (!initial_inst)
			return null;
		var type = this.types_by_index[initial_inst[1]];
;
;
		var is_world = type.plugin.is_world;
;
		if (this.isloading && is_world && !type.isOnLoaderLayout)
			return null;
		if (is_world && !this.glwrap && initial_inst[0][11] === 11)
			return null;
		var original_layer = layer;
		if (!is_world)
			layer = null;
		var inst;
		if (type.deadCache.length)
		{
			inst = type.deadCache.pop();
			inst.recycled = true;
			type.plugin.Instance.call(inst, type);
		}
		else
		{
			inst = new type.plugin.Instance(type);
			inst.recycled = false;
		}
		if (is_startup_instance && !skip_siblings)
			inst.uid = initial_inst[2];
		else
			inst.uid = this.next_uid++;
		this.objectsByUid[inst.uid.toString()] = inst;
		inst.puid = this.next_puid++;
		inst.iid = type.instances.length;
		for (i = 0, len = this.createRow.length; i < len; ++i)
		{
			if (this.createRow[i].type === type)
				inst.iid++;
		}
		inst.get_iid = cr.inst_get_iid;
		var initial_vars = initial_inst[3];
		if (inst.recycled)
		{
			cr.wipe(inst.extra);
		}
		else
		{
			inst.extra = {};
			if (typeof cr_is_preview !== "undefined")
			{
				inst.instance_var_names = [];
				inst.instance_var_names.length = initial_vars.length;
				for (i = 0, len = initial_vars.length; i < len; i++)
					inst.instance_var_names[i] = initial_vars[i][1];
			}
			inst.instance_vars = [];
			inst.instance_vars.length = initial_vars.length;
		}
		for (i = 0, len = initial_vars.length; i < len; i++)
			inst.instance_vars[i] = initial_vars[i][0];
		if (is_world)
		{
			var wm = initial_inst[0];
;
			inst.x = cr.is_undefined(sx) ? wm[0] : sx;
			inst.y = cr.is_undefined(sy) ? wm[1] : sy;
			inst.z = wm[2];
			inst.width = wm[3];
			inst.height = wm[4];
			inst.depth = wm[5];
			inst.angle = wm[6];
			inst.opacity = wm[7];
			inst.hotspotX = wm[8];
			inst.hotspotY = wm[9];
			inst.blend_mode = wm[10];
			effect_fallback = wm[11];
			if (!this.glwrap && type.effect_types.length)	// no WebGL renderer and shaders used
				inst.blend_mode = effect_fallback;			// use fallback blend mode - destroy mode was handled above
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			if (inst.recycled)
			{
				for (i = 0, len = wm[12].length; i < len; i++)
				{
					for (j = 0, lenj = wm[12][i].length; j < lenj; j++)
						inst.effect_params[i][j] = wm[12][i][j];
				}
				inst.bbox.set(0, 0, 0, 0);
				inst.collcells.set(0, 0, -1, -1);
				inst.bquad.set_from_rect(inst.bbox);
				inst.bbox_changed_callbacks.length = 0;
			}
			else
			{
				inst.effect_params = wm[12].slice(0);
				for (i = 0, len = inst.effect_params.length; i < len; i++)
					inst.effect_params[i] = wm[12][i].slice(0);
				inst.active_effect_types = [];
				inst.active_effect_flags = [];
				inst.active_effect_flags.length = type.effect_types.length;
				inst.bbox = new cr.rect(0, 0, 0, 0);
				inst.collcells = new cr.rect(0, 0, -1, -1);
				inst.bquad = new cr.quad();
				inst.bbox_changed_callbacks = [];
				inst.set_bbox_changed = cr.set_bbox_changed;
				inst.add_bbox_changed_callback = cr.add_bbox_changed_callback;
				inst.contains_pt = cr.inst_contains_pt;
				inst.update_bbox = cr.update_bbox;
				inst.update_collision_cell = cr.update_collision_cell;
				inst.get_zindex = cr.inst_get_zindex;
			}
			inst.tilemap_exists = false;
			inst.tilemap_width = 0;
			inst.tilemap_height = 0;
			inst.tilemap_data = null;
			if (wm.length === 14)
			{
				inst.tilemap_exists = true;
				inst.tilemap_width = wm[13][0];
				inst.tilemap_height = wm[13][1];
				inst.tilemap_data = wm[13][2];
			}
			for (i = 0, len = type.effect_types.length; i < len; i++)
				inst.active_effect_flags[i] = true;
			inst.updateActiveEffects = cr.inst_updateActiveEffects;
			inst.updateActiveEffects();
			inst.uses_shaders = !!inst.active_effect_types.length;
			inst.bbox_changed = true;
			inst.cell_changed = true;
			type.any_cell_changed = true;
			inst.visible = true;
            inst.my_timescale = -1.0;
			inst.layer = layer;
			inst.zindex = layer.instances.length;	// will be placed at top of current layer
			if (typeof inst.collision_poly === "undefined")
				inst.collision_poly = null;
			inst.collisionsEnabled = true;
			this.redraw = true;
		}
		inst.toString = cr.inst_toString;
		var initial_props, binst;
		all_behaviors.length = 0;
		for (i = 0, len = type.families.length; i < len; i++)
		{
			all_behaviors.push.apply(all_behaviors, type.families[i].behaviors);
		}
		all_behaviors.push.apply(all_behaviors, type.behaviors);
		if (inst.recycled)
		{
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				binst = inst.behavior_insts[i];
				binst.recycled = true;
				btype.behavior.Instance.call(binst, btype, inst);
				initial_props = initial_inst[4][i];
				for (j = 0, lenj = initial_props.length; j < lenj; j++)
					binst.properties[j] = initial_props[j];
				binst.onCreate();
				btype.behavior.my_instances.add(inst);
			}
		}
		else
		{
			inst.behavior_insts = [];
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				var binst = new btype.behavior.Instance(btype, inst);
				binst.recycled = false;
				binst.properties = initial_inst[4][i].slice(0);
				binst.onCreate();
				cr.seal(binst);
				inst.behavior_insts.push(binst);
				btype.behavior.my_instances.add(inst);
			}
		}
		initial_props = initial_inst[5];
		if (inst.recycled)
		{
			for (i = 0, len = initial_props.length; i < len; i++)
				inst.properties[i] = initial_props[i];
		}
		else
			inst.properties = initial_props.slice(0);
		this.createRow.push(inst);
		if (layer)
		{
;
			layer.instances.push(inst);
			if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
				type.any_instance_parallaxed = true;
		}
		this.objectcount++;
		if (type.is_contained)
		{
			inst.is_contained = true;
			if (inst.recycled)
				inst.siblings.length = 0;
			else
				inst.siblings = [];			// note: should not include self in siblings
			if (!is_startup_instance && !skip_siblings)	// layout links initial instances
			{
				for (i = 0, len = type.container.length; i < len; i++)
				{
					if (type.container[i] === type)
						continue;
					if (!type.container[i].default_instance)
					{
						return null;
					}
					inst.siblings.push(this.createInstanceFromInit(type.container[i].default_instance, original_layer, false, is_world ? inst.x : sx, is_world ? inst.y : sy, true));
				}
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					inst.siblings[i].siblings.push(inst);
					for (j = 0; j < len; j++)
					{
						if (i !== j)
							inst.siblings[i].siblings.push(inst.siblings[j]);
					}
				}
			}
		}
		else
		{
			inst.is_contained = false;
			inst.siblings = null;
		}
		inst.onCreate();
		if (!inst.recycled)
			cr.seal(inst);
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].postCreate)
				inst.behavior_insts[i].postCreate();
		}
		return inst;
	};
	Runtime.prototype.getLayerByName = function (layer_name)
	{
		var i, len;
		for (i = 0, len = this.running_layout.layers.length; i < len; i++)
		{
			var layer = this.running_layout.layers[i];
			if (cr.equals_nocase(layer.name, layer_name))
				return layer;
		}
		return null;
	};
	Runtime.prototype.getLayerByNumber = function (index)
	{
		index = cr.floor(index);
		if (index < 0)
			index = 0;
		if (index >= this.running_layout.layers.length)
			index = this.running_layout.layers.length - 1;
		return this.running_layout.layers[index];
	};
	Runtime.prototype.getLayer = function (l)
	{
		if (cr.is_number(l))
			return this.getLayerByNumber(l);
		else
			return this.getLayerByName(l.toString());
	};
	Runtime.prototype.clearSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].getCurrentSol().select_all = true;
		}
	};
	Runtime.prototype.pushCleanSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCleanSol();
		}
	};
	Runtime.prototype.pushCopySol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCopySol();
		}
	};
	Runtime.prototype.popSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].popSol();
		}
	};
	Runtime.prototype.updateAllCells = function (type)
	{
		if (!type.any_cell_changed)
			return;		// all instances must already be up-to-date
		var i, len, instances = type.instances;
		for (i = 0, len = instances.length; i < len; ++i)
		{
			instances[i].update_collision_cell();
		}
		var createRow = this.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === type)
				createRow[i].update_collision_cell();
		}
		type.any_cell_changed = false;
	};
	Runtime.prototype.getCollisionCandidates = function (layer, rtype, bbox, candidates)
	{
		var i, len, t;
		var is_parallaxed = (layer ? (layer.parallaxX !== 1 || layer.parallaxY !== 1) : false);
		if (rtype.is_family)
		{
			for (i = 0, len = rtype.members.length; i < len; ++i)
			{
				t = rtype.members[i];
				if (is_parallaxed || t.any_instance_parallaxed)
				{
					cr.appendArray(candidates, t.instances);
				}
				else
				{
					this.updateAllCells(t);
					t.collision_grid.queryRange(bbox, candidates);
				}
			}
		}
		else
		{
			if (is_parallaxed || rtype.any_instance_parallaxed)
			{
				cr.appendArray(candidates, rtype.instances);
			}
			else
			{
				this.updateAllCells(rtype);
				rtype.collision_grid.queryRange(bbox, candidates);
			}
		}
	};
	Runtime.prototype.getTypesCollisionCandidates = function (layer, types, bbox, candidates)
	{
		var i, len;
		for (i = 0, len = types.length; i < len; ++i)
		{
			this.getCollisionCandidates(layer, types[i], bbox, candidates);
		}
	};
	Runtime.prototype.getSolidCollisionCandidates = function (layer, bbox, candidates)
	{
		var solid = this.getSolidBehavior();
		if (!solid)
			return null;
		this.getTypesCollisionCandidates(layer, solid.my_types, bbox, candidates);
	};
	Runtime.prototype.getJumpthruCollisionCandidates = function (layer, bbox, candidates)
	{
		var jumpthru = this.getJumpthruBehavior();
		if (!jumpthru)
			return null;
		this.getTypesCollisionCandidates(layer, jumpthru.my_types, bbox, candidates);
	};
	Runtime.prototype.testAndSelectCanvasPointOverlap = function (type, ptx, pty, inverted)
	{
		var sol = type.getCurrentSol();
		var i, j, inst, len;
		var lx, ly;
		if (sol.select_all)
		{
			if (!inverted)
			{
				sol.select_all = false;
				sol.instances.length = 0;   // clear contents
			}
			for (i = 0, len = type.instances.length; i < len; i++)
			{
				inst = type.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
						sol.instances.push(inst);
				}
			}
		}
		else
		{
			j = 0;
			for (i = 0, len = sol.instances.length; i < len; i++)
			{
				inst = sol.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
					{
						sol.instances[j] = sol.instances[i];
						j++;
					}
				}
			}
			if (!inverted)
				sol.instances.length = j;
		}
		type.applySolToContainer();
		if (inverted)
			return true;		// did not find anything overlapping
		else
			return sol.hasObjects();
	};
	Runtime.prototype.testOverlap = function (a, b)
	{
		if (!a || !b || a === b || !a.collisionsEnabled || !b.collisionsEnabled)
			return false;
		a.update_bbox();
		b.update_bbox();
		var layera = a.layer;
		var layerb = b.layer;
		var different_layers = (layera !== layerb && (layera.parallaxX !== layerb.parallaxX || layerb.parallaxY !== layerb.parallaxY || layera.scale !== layerb.scale || layera.angle !== layerb.angle || layera.zoomRate !== layerb.zoomRate));
		var i, len, i2, i21, x, y, haspolya, haspolyb, polya, polyb;
		if (!different_layers)	// same layers: easy check
		{
			if (!a.bbox.intersects_rect(b.bbox))
				return false;
			if (!a.bquad.intersects_quad(b.bquad))
				return false;
			if (a.tilemap_exists && b.tilemap_exists)
				return false;
			if (a.tilemap_exists)
				return this.testTilemapOverlap(a, b);
			if (b.tilemap_exists)
				return this.testTilemapOverlap(b, a);
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolya && !haspolyb)
				return true;
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				polya = a.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
				polya = this.temp_poly;
			}
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				polyb = b.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
				polyb = this.temp_poly;
			}
			return polya.intersects_poly(polyb, b.x - a.x, b.y - a.y);
		}
		else	// different layers: need to do full translated check
		{
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				this.temp_poly.set_from_poly(a.collision_poly);
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
			}
			polya = this.temp_poly;
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				this.temp_poly2.set_from_poly(b.collision_poly);
			}
			else
			{
				this.temp_poly2.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
			}
			polyb = this.temp_poly2;
			for (i = 0, len = polya.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polya.pts_cache[i2];
				y = polya.pts_cache[i21];
				polya.pts_cache[i2] = layera.layerToCanvas(x + a.x, y + a.y, true);
				polya.pts_cache[i21] = layera.layerToCanvas(x + a.x, y + a.y, false);
			}
			polya.update_bbox();
			for (i = 0, len = polyb.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polyb.pts_cache[i2];
				y = polyb.pts_cache[i21];
				polyb.pts_cache[i2] = layerb.layerToCanvas(x + b.x, y + b.y, true);
				polyb.pts_cache[i21] = layerb.layerToCanvas(x + b.x, y + b.y, false);
			}
			polyb.update_bbox();
			return polya.intersects_poly(polyb, 0, 0);
		}
	};
	var tmpQuad = new cr.quad();
	var tmpRect = new cr.rect(0, 0, 0, 0);
	var collrect_candidates = [];
	Runtime.prototype.testTilemapOverlap = function (tm, a)
	{
		var i, len, c, rc;
		var bbox = a.bbox;
		var tmx = tm.x;
		var tmy = tm.y;
		tm.getCollisionRectCandidates(bbox, collrect_candidates);
		var collrects = collrect_candidates;
		var haspolya = (a.collision_poly && !a.collision_poly.is_empty());
		for (i = 0, len = collrects.length; i < len; ++i)
		{
			c = collrects[i];
			rc = c.rc;
			if (bbox.intersects_rect_off(rc, tmx, tmy))
			{
				tmpQuad.set_from_rect(rc);
				tmpQuad.offset(tmx, tmy);
				if (tmpQuad.intersects_quad(a.bquad))
				{
					if (haspolya)
					{
						a.collision_poly.cache_poly(a.width, a.height, a.angle);
						if (c.poly)
						{
							if (c.poly.intersects_poly(a.collision_poly, a.x - (tmx + rc.left), a.y - (tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							this.temp_poly.set_from_quad(tmpQuad, 0, 0, rc.right - rc.left, rc.bottom - rc.top);
							if (this.temp_poly.intersects_poly(a.collision_poly, a.x, a.y))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
					}
					else
					{
						if (c.poly)
						{
							this.temp_poly.set_from_quad(a.bquad, 0, 0, a.width, a.height);
							if (c.poly.intersects_poly(this.temp_poly, -(tmx + rc.left), -(tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
		}
		collrect_candidates.length = 0;
		return false;
	};
	Runtime.prototype.testRectOverlap = function (r, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		if (!b.bbox.intersects_rect(r))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(r, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (r.intersects_rect_off(tilerc, tmx, tmy))
				{
					if (c.poly)
					{
						this.temp_poly.set_from_rect(r, 0, 0);
						if (c.poly.intersects_poly(this.temp_poly, -(tmx + tilerc.left), -(tmy + tilerc.top)))
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
					else
					{
						collrect_candidates.length = 0;
						return true;
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			tmpQuad.set_from_rect(r);
			if (!b.bquad.intersects_quad(tmpQuad))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			tmpQuad.offset(-r.left, -r.top);
			this.temp_poly.set_from_quad(tmpQuad, 0, 0, 1, 1);
			return b.collision_poly.intersects_poly(this.temp_poly, r.left - b.x, r.top - b.y);
		}
	};
	Runtime.prototype.testSegmentOverlap = function (x1, y1, x2, y2, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		tmpRect.set(cr.min(x1, x2), cr.min(y1, y2), cr.max(x1, x2), cr.max(y1, y2));
		if (!b.bbox.intersects_rect(tmpRect))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(tmpRect, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (tmpRect.intersects_rect_off(tilerc, tmx, tmy))
				{
					tmpQuad.set_from_rect(tilerc);
					tmpQuad.offset(tmx, tmy);
					if (tmpQuad.intersects_segment(x1, y1, x2, y2))
					{
						if (c.poly)
						{
							if (c.poly.intersects_segment(tmx + tilerc.left, tmy + tilerc.top, x1, y1, x2, y2))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			if (!b.bquad.intersects_segment(x1, y1, x2, y2))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			return b.collision_poly.intersects_segment(b.x, b.y, x1, y1, x2, y2);
		}
	};
	Runtime.prototype.typeHasBehavior = function (t, b)
	{
		if (!b)
			return false;
		var i, len, j, lenj, f;
		for (i = 0, len = t.behaviors.length; i < len; i++)
		{
			if (t.behaviors[i].behavior instanceof b)
				return true;
		}
		if (!t.is_family)
		{
			for (i = 0, len = t.families.length; i < len; i++)
			{
				f = t.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (f.behaviors[j].behavior instanceof b)
						return true;
				}
			}
		}
		return false;
	};
	Runtime.prototype.typeHasNoSaveBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.NoSave);
	};
	Runtime.prototype.typeHasPersistBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.Persist);
	};
	Runtime.prototype.getSolidBehavior = function ()
	{
		return this.solidBehavior;
	};
	Runtime.prototype.getJumpthruBehavior = function ()
	{
		return this.jumpthruBehavior;
	};
	var candidates = [];
	Runtime.prototype.testOverlapSolid = function (inst)
	{
		var i, len, s;
		inst.update_bbox();
		this.getSolidCollisionCandidates(inst.layer, inst.bbox, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testOverlap(inst, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	Runtime.prototype.testRectOverlapSolid = function (r)
	{
		var i, len, s;
		this.getSolidCollisionCandidates(null, r, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testRectOverlap(r, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	var jumpthru_array_ret = [];
	Runtime.prototype.testOverlapJumpThru = function (inst, all)
	{
		var ret = null;
		if (all)
		{
			ret = jumpthru_array_ret;
			ret.length = 0;
		}
		inst.update_bbox();
		this.getJumpthruCollisionCandidates(inst.layer, inst.bbox, candidates);
		var i, len, j;
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			j = candidates[i];
			if (!j.extra.jumpthruEnabled)
				continue;
			if (this.testOverlap(inst, j))
			{
				if (all)
					ret.push(j);
				else
				{
					candidates.length = 0;
					return j;
				}
			}
		}
		candidates.length = 0;
		return ret;
	};
	Runtime.prototype.pushOutSolid = function (inst, xdir, ydir, dist, include_jumpthrus, specific_jumpthru)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		var last_overlapped = null, secondlast_overlapped = null;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (last_overlapped)
					secondlast_overlapped = last_overlapped;
				if (!last_overlapped)
				{
					if (include_jumpthrus)
					{
						if (specific_jumpthru)
							last_overlapped = (this.testOverlap(inst, specific_jumpthru) ? specific_jumpthru : null);
						else
							last_overlapped = this.testOverlapJumpThru(inst);
						if (last_overlapped)
							secondlast_overlapped = last_overlapped;
					}
					if (!last_overlapped)
					{
						if (secondlast_overlapped)
							this.pushInFractional(inst, xdir, ydir, secondlast_overlapped, 16);
						return true;
					}
				}
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushOut = function (inst, xdir, ydir, dist, otherinst)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, otherinst))
				return true;
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushInFractional = function (inst, xdir, ydir, obj, limit)
	{
		var divisor = 2;
		var frac;
		var forward = false;
		var overlapping = false;
		var bestx = inst.x;
		var besty = inst.y;
		while (divisor <= limit)
		{
			frac = 1 / divisor;
			divisor *= 2;
			inst.x += xdir * frac * (forward ? 1 : -1);
			inst.y += ydir * frac * (forward ? 1 : -1);
			inst.set_bbox_changed();
			if (this.testOverlap(inst, obj))
			{
				forward = true;
				overlapping = true;
			}
			else
			{
				forward = false;
				overlapping = false;
				bestx = inst.x;
				besty = inst.y;
			}
		}
		if (overlapping)
		{
			inst.x = bestx;
			inst.y = besty;
			inst.set_bbox_changed();
		}
	};
	Runtime.prototype.pushOutSolidNearest = function (inst, max_dist_)
	{
		var max_dist = (cr.is_undefined(max_dist_) ? 100 : max_dist_);
		var dist = 0;
		var oldx = inst.x
		var oldy = inst.y;
		var dir = 0;
		var dx = 0, dy = 0;
		var last_overlapped = this.testOverlapSolid(inst);
		if (!last_overlapped)
			return true;		// already clear of solids
		while (dist <= max_dist)
		{
			switch (dir) {
			case 0:		dx = 0; dy = -1; dist++; break;
			case 1:		dx = 1; dy = -1; break;
			case 2:		dx = 1; dy = 0; break;
			case 3:		dx = 1; dy = 1; break;
			case 4:		dx = 0; dy = 1; break;
			case 5:		dx = -1; dy = 1; break;
			case 6:		dx = -1; dy = 0; break;
			case 7:		dx = -1; dy = -1; break;
			}
			dir = (dir + 1) % 8;
			inst.x = cr.floor(oldx + (dx * dist));
			inst.y = cr.floor(oldy + (dy * dist));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (!last_overlapped)
					return true;
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.registerCollision = function (a, b)
	{
		if (!a.collisionsEnabled || !b.collisionsEnabled)
			return;
		this.registered_collisions.push([a, b]);
	};
	Runtime.prototype.checkRegisteredCollision = function (a, b)
	{
		var i, len, x;
		for (i = 0, len = this.registered_collisions.length; i < len; i++)
		{
			x = this.registered_collisions[i];
			if ((x[0] == a && x[1] == b) || (x[0] == b && x[1] == a))
				return true;
		}
		return false;
	};
	Runtime.prototype.calculateSolidBounceAngle = function(inst, startx, starty, obj)
	{
		var objx = inst.x;
		var objy = inst.y;
		var radius = cr.max(10, cr.distanceTo(startx, starty, objx, objy));
		var startangle = cr.angleTo(startx, starty, objx, objy);
		var firstsolid = obj || this.testOverlapSolid(inst);
		if (!firstsolid)
			return cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		var i, curangle, anticlockwise_free_angle, clockwise_free_angle;
		var increment = cr.to_radians(5);	// 5 degree increments
		for (i = 1; i < 36; i++)
		{
			curangle = startangle - i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					anticlockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			anticlockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		for (i = 1; i < 36; i++)
		{
			curangle = startangle + i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					clockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			clockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		inst.x = objx;
		inst.y = objy;
		inst.set_bbox_changed();
		if (clockwise_free_angle === anticlockwise_free_angle)
			return clockwise_free_angle;
		var half_diff = cr.angleDiff(clockwise_free_angle, anticlockwise_free_angle) / 2;
		var normal;
		if (cr.angleClockwise(clockwise_free_angle, anticlockwise_free_angle))
		{
			normal = cr.clamp_angle(anticlockwise_free_angle + half_diff + cr.PI);
		}
		else
		{
			normal = cr.clamp_angle(clockwise_free_angle + half_diff);
		}
;
		var vx = Math.cos(startangle);
		var vy = Math.sin(startangle);
		var nx = Math.cos(normal);
		var ny = Math.sin(normal);
		var v_dot_n = vx * nx + vy * ny;
		var rx = vx - 2 * v_dot_n * nx;
		var ry = vy - 2 * v_dot_n * ny;
		return cr.angleTo(0, 0, rx, ry);
	};
	var triggerSheetStack = [];
	var triggerSheetIndex = -1;
	Runtime.prototype.trigger = function (method, inst, value /* for fast triggers */)
	{
;
		if (!this.running_layout)
			return false;
		var sheet = this.running_layout.event_sheet;
		if (!sheet)
			return false;     // no event sheet active; nothing to trigger
		triggerSheetIndex++;
		if (triggerSheetIndex === triggerSheetStack.length)
			triggerSheetStack.push(new cr.ObjectSet());
		else
			triggerSheetStack[triggerSheetIndex].clear();
        var ret = this.triggerOnSheet(method, inst, sheet, value);
		triggerSheetIndex--;
		return ret;
    };
    Runtime.prototype.triggerOnSheet = function (method, inst, sheet, value)
    {
		var alreadyTriggeredSheets = triggerSheetStack[triggerSheetIndex];
        if (alreadyTriggeredSheets.contains(sheet))
            return false;
        alreadyTriggeredSheets.add(sheet);
        var includes = sheet.includes.valuesRef();
        var ret = false;
		var i, leni, r;
        for (i = 0, leni = includes.length; i < leni; i++)
        {
			if (includes[i].isActive())
			{
				r = this.triggerOnSheet(method, inst, includes[i].include_sheet, value);
				ret = ret || r;
			}
        }
		if (!inst)
		{
			r = this.triggerOnSheetForTypeName(method, inst, "system", sheet, value);
			ret = ret || r;
		}
		else
		{
			r = this.triggerOnSheetForTypeName(method, inst, inst.type.name, sheet, value);
			ret = ret || r;
			for (i = 0, leni = inst.type.families.length; i < leni; i++)
			{
				r = this.triggerOnSheetForTypeName(method, inst, inst.type.families[i].name, sheet, value);
				ret = ret || r;
			}
		}
		return ret;             // true if anything got triggered
	};
	Runtime.prototype.triggerOnSheetForTypeName = function (method, inst, type_name, sheet, value)
	{
		var i, leni;
		var ret = false, ret2 = false;
		var trig, index;
		var fasttrigger = (typeof value !== "undefined");
		var triggers = (fasttrigger ? sheet.fasttriggers : sheet.triggers);
		var obj_entry = triggers[type_name];
		if (!obj_entry)
			return ret;
		var triggers_list = null;
		for (i = 0, leni = obj_entry.length; i < leni; i++)
		{
			if (obj_entry[i].method == method)
			{
				triggers_list = obj_entry[i].evs;
				break;
			}
		}
		if (!triggers_list)
			return ret;
		var triggers_to_fire;
		if (fasttrigger)
		{
			triggers_to_fire = triggers_list[value];
		}
		else
		{
			triggers_to_fire = triggers_list;
		}
		if (!triggers_to_fire)
			return null;
		for (i = 0, leni = triggers_to_fire.length; i < leni; i++)
		{
			trig = triggers_to_fire[i][0];
			index = triggers_to_fire[i][1];
			ret2 = this.executeSingleTrigger(inst, type_name, trig, index);
			ret = ret || ret2;
		}
		return ret;
	};
	Runtime.prototype.executeSingleTrigger = function (inst, type_name, trig, index)
	{
		var i, leni;
		var ret = false;
		this.trigger_depth++;
		var current_event = this.getCurrentEventStack().current_event;
		if (current_event)
			this.pushCleanSol(current_event.solModifiersIncludingParents);
		var isrecursive = (this.trigger_depth > 1);		// calling trigger from inside another trigger
		this.pushCleanSol(trig.solModifiersIncludingParents);
		if (isrecursive)
			this.pushLocalVarStack();
		var event_stack = this.pushEventStack(trig);
		event_stack.current_event = trig;
		if (inst)
		{
			var sol = this.types[type_name].getCurrentSol();
			sol.select_all = false;
			sol.instances.length = 1;
			sol.instances[0] = inst;
			this.types[type_name].applySolToContainer();
		}
		var ok_to_run = true;
		if (trig.parent)
		{
			var temp_parents_arr = event_stack.temp_parents_arr;
			var cur_parent = trig.parent;
			while (cur_parent)
			{
				temp_parents_arr.push(cur_parent);
				cur_parent = cur_parent.parent;
			}
			temp_parents_arr.reverse();
			for (i = 0, leni = temp_parents_arr.length; i < leni; i++)
			{
				if (!temp_parents_arr[i].run_pretrigger())   // parent event failed
				{
					ok_to_run = false;
					break;
				}
			}
		}
		if (ok_to_run)
		{
			this.execcount++;
			if (trig.orblock)
				trig.run_orblocktrigger(index);
			else
				trig.run();
			ret = ret || event_stack.last_event_true;
		}
		this.popEventStack();
		if (isrecursive)
			this.popLocalVarStack();
		this.popSol(trig.solModifiersIncludingParents);
		if (current_event)
			this.popSol(current_event.solModifiersIncludingParents);
		if (this.isInOnDestroy === 0 && triggerSheetIndex === 0 && !this.isRunningEvents && (!this.deathRow.isEmpty() || this.createRow.length))
		{
			this.ClearDeathRow();
		}
		this.trigger_depth--;
		return ret;
	};
	Runtime.prototype.getCurrentCondition = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.conditions[evinfo.cndindex];
	};
	Runtime.prototype.getCurrentAction = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.actions[evinfo.actindex];
	};
	Runtime.prototype.pushLocalVarStack = function ()
	{
		this.localvar_stack_index++;
		if (this.localvar_stack_index >= this.localvar_stack.length)
			this.localvar_stack.push([]);
	};
	Runtime.prototype.popLocalVarStack = function ()
	{
;
		this.localvar_stack_index--;
	};
	Runtime.prototype.getCurrentLocalVarStack = function ()
	{
		return this.localvar_stack[this.localvar_stack_index];
	};
	Runtime.prototype.pushEventStack = function (cur_event)
	{
		this.event_stack_index++;
		if (this.event_stack_index >= this.event_stack.length)
			this.event_stack.push(new cr.eventStackFrame());
		var ret = this.getCurrentEventStack();
		ret.reset(cur_event);
		return ret;
	};
	Runtime.prototype.popEventStack = function ()
	{
;
		this.event_stack_index--;
	};
	Runtime.prototype.getCurrentEventStack = function ()
	{
		return this.event_stack[this.event_stack_index];
	};
	Runtime.prototype.pushLoopStack = function (name_)
	{
		this.loop_stack_index++;
		if (this.loop_stack_index >= this.loop_stack.length)
		{
			this.loop_stack.push(cr.seal({ name: name_, index: 0, stopped: false }));
		}
		var ret = this.getCurrentLoop();
		ret.name = name_;
		ret.index = 0;
		ret.stopped = false;
		return ret;
	};
	Runtime.prototype.popLoopStack = function ()
	{
;
		this.loop_stack_index--;
	};
	Runtime.prototype.getCurrentLoop = function ()
	{
		return this.loop_stack[this.loop_stack_index];
	};
	Runtime.prototype.getEventVariableByName = function (name, scope)
	{
		var i, leni, j, lenj, sheet, e;
		while (scope)
		{
			for (i = 0, leni = scope.subevents.length; i < leni; i++)
			{
				e = scope.subevents[i];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
			scope = scope.parent;
		}
		for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
		{
			sheet = this.eventsheets_by_index[i];
			for (j = 0, lenj = sheet.events.length; j < lenj; j++)
			{
				e = sheet.events[j];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
		}
		return null;
	};
	Runtime.prototype.getLayoutBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			if (this.layouts_by_index[i].sid === sid_)
				return this.layouts_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getObjectTypeBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			if (this.types_by_index[i].sid === sid_)
				return this.types_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getGroupBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			if (this.allGroups[i].sid === sid_)
				return this.allGroups[i];
		}
		return null;
	};
	function makeSaveDb(e)
	{
		var db = e.target.result;
		db.createObjectStore("saves", { keyPath: "slot" });
	};
	function IndexedDB_WriteSlot(slot_, data_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"], "readwrite");
			var objectStore = transaction.objectStore("saves");
			var putReq = objectStore.put({"slot": slot_, "data": data_ });
			putReq.onsuccess = oncomplete_;
		};
	};
	function IndexedDB_ReadSlot(slot_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"]);
			var objectStore = transaction.objectStore("saves");
			var readReq = objectStore.get(slot_);
			readReq.onsuccess = function (e)
			{
				if (readReq.result)
					oncomplete_(readReq.result["data"]);
				else
					oncomplete_(null);
			};
		};
	};
	Runtime.prototype.signalContinuousPreview = function ()
	{
		this.signalledContinuousPreview = true;
	};
	function doContinuousPreviewReload()
	{
		cr.logexport("Reloading for continuous preview");
		if (!!window["c2cocoonjs"])
		{
			CocoonJS["App"]["reload"]();
		}
		else
		{
			if (window.location.search.indexOf("continuous") > -1)
				window.location.reload(true);
			else
				window.location = window.location + "?continuous";
		}
	};
	Runtime.prototype.handleSaveLoad = function ()
	{
		var self = this;
		var savingToSlot = this.saveToSlot;
		var savingJson = this.lastSaveJson;
		var loadingFromSlot = this.loadFromSlot;
		var continuous = false;
		if (this.signalledContinuousPreview)
		{
			continuous = true;
			savingToSlot = "__c2_continuouspreview";
			this.signalledContinuousPreview = false;
		}
		if (savingToSlot.length)
		{
			this.ClearDeathRow();
			savingJson = this.saveToJSONString();
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_WriteSlot(savingToSlot, savingJson, function ()
				{
					cr.logexport("Saved state to IndexedDB storage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}, function (e)
				{
					try {
						localStorage.setItem("__c2save_" + savingToSlot, savingJson);
						cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
						self.lastSaveJson = savingJson;
						self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
						self.lastSaveJson = "";
						if (continuous)
							doContinuousPreviewReload();
					}
					catch (f)
					{
						cr.logexport("Failed to save game state: " + e + "; " + f);
					}
				});
			}
			else
			{
				try {
					localStorage.setItem("__c2save_" + savingToSlot, savingJson);
					cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					this.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}
				catch (e)
				{
					cr.logexport("Error saving to WebStorage: " + e);
				}
			}
			this.saveToSlot = "";
			this.loadFromSlot = "";
			this.loadFromJson = "";
		}
		if (loadingFromSlot.length)
		{
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_ReadSlot(loadingFromSlot, function (result_)
				{
					if (result_)
					{
						self.loadFromJson = result_;
						cr.logexport("Loaded state from IndexedDB storage (" + self.loadFromJson.length + " bytes)");
					}
					else
					{
						self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
						cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					}
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				}, function (e)
				{
					self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
					cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				});
			}
			else
			{
				this.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
				cr.logexport("Loaded state from WebStorage (" + this.loadFromJson.length + " bytes)");
				this.suspendDrawing = false;
				if (!self.loadFromJson.length)
					self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
			}
			this.loadFromSlot = "";
			this.saveToSlot = "";
		}
		if (this.loadFromJson.length)
		{
			this.ClearDeathRow();
			this.loadFromJSONString(this.loadFromJson);
			this.lastSaveJson = this.loadFromJson;
			this.trigger(cr.system_object.prototype.cnds.OnLoadComplete, null);
			this.lastSaveJson = "";
			this.loadFromJson = "";
		}
	};
	function CopyExtraObject(extra)
	{
		var p, ret = {};
		for (p in extra)
		{
			if (extra.hasOwnProperty(p))
			{
				if (extra[p] instanceof cr.ObjectSet)
					continue;
				if (extra[p] && typeof extra[p].c2userdata !== "undefined")
					continue;
				ret[p] = extra[p];
			}
		}
		return ret;
	};
	Runtime.prototype.saveToJSONString = function()
	{
		var i, len, j, lenj, type, layout, typeobj, g, c, a, v, p;
		var o = {
			"c2save":				true,
			"version":				1,
			"rt": {
				"time":				this.kahanTime.sum,
				"timescale":		this.timescale,
				"tickcount":		this.tickcount,
				"execcount":		this.execcount,
				"next_uid":			this.next_uid,
				"running_layout":	this.running_layout.sid,
				"start_time_offset": (Date.now() - this.start_time)
			},
			"types": {},
			"layouts": {},
			"events": {
				"groups": {},
				"cnds": {},
				"acts": {},
				"vars": {}
			}
		};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || this.typeHasNoSaveBehavior(type))
				continue;
			typeobj = {
				"instances": []
			};
			if (cr.hasAnyOwnProperty(type.extra))
				typeobj["ex"] = CopyExtraObject(type.extra);
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				typeobj["instances"].push(this.saveInstanceToJSON(type.instances[j]));
			}
			o["types"][type.sid.toString()] = typeobj;
		}
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			layout = this.layouts_by_index[i];
			o["layouts"][layout.sid.toString()] = layout.saveToJSON();
		}
		var ogroups = o["events"]["groups"];
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			g = this.allGroups[i];
			ogroups[g.sid.toString()] = !!this.activeGroups[g.group_name];
		}
		var ocnds = o["events"]["cnds"];
		for (p in this.cndsBySid)
		{
			if (this.cndsBySid.hasOwnProperty(p))
			{
				c = this.cndsBySid[p];
				if (cr.hasAnyOwnProperty(c.extra))
					ocnds[p] = { "ex": CopyExtraObject(c.extra) };
			}
		}
		var oacts = o["events"]["acts"];
		for (p in this.actsBySid)
		{
			if (this.actsBySid.hasOwnProperty(p))
			{
				a = this.actsBySid[p];
				if (cr.hasAnyOwnProperty(a.extra))
					oacts[p] = { "ex": a.extra };
			}
		}
		var ovars = o["events"]["vars"];
		for (p in this.varsBySid)
		{
			if (this.varsBySid.hasOwnProperty(p))
			{
				v = this.varsBySid[p];
				if (!v.is_constant && (!v.parent || v.is_static))
					ovars[p] = v.data;
			}
		}
		o["system"] = this.system.saveToJSON();
		return JSON.stringify(o);
	};
	Runtime.prototype.refreshUidMap = function ()
	{
		var i, len, type, j, lenj, inst;
		this.objectsByUid = {};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				this.objectsByUid[inst.uid.toString()] = inst;
			}
		}
	};
	Runtime.prototype.loadFromJSONString = function (str)
	{
		var o = JSON.parse(str);
		if (!o["c2save"])
			return;		// probably not a c2 save state
		if (o["version"] > 1)
			return;		// from future version of c2; assume not compatible
		var rt = o["rt"];
		this.kahanTime.reset();
		this.kahanTime.sum = rt["time"];
		this.timescale = rt["timescale"];
		this.tickcount = rt["tickcount"];
		this.start_time = Date.now() - rt["start_time_offset"];
		var layout_sid = rt["running_layout"];
		if (layout_sid !== this.running_layout.sid)
		{
			var changeToLayout = this.getLayoutBySid(layout_sid);
			if (changeToLayout)
				this.doChangeLayout(changeToLayout);
			else
				return;		// layout that was saved on has gone missing (deleted?)
		}
		this.isLoadingState = true;
		var i, len, j, lenj, k, lenk, p, type, existing_insts, load_insts, inst, binst, layout, layer, g, iid, t;
		var otypes = o["types"];
		for (p in otypes)
		{
			if (otypes.hasOwnProperty(p))
			{
				type = this.getObjectTypeBySid(parseInt(p, 10));
				if (!type || type.is_family || this.typeHasNoSaveBehavior(type))
					continue;
				if (otypes[p]["ex"])
					type.extra = otypes[p]["ex"];
				else
					cr.wipe(type.extra);
				existing_insts = type.instances;
				load_insts = otypes[p]["instances"];
				for (i = 0, len = cr.min(existing_insts.length, load_insts.length); i < len; i++)
				{
					this.loadInstanceFromJSON(existing_insts[i], load_insts[i]);
				}
				for (i = load_insts.length, len = existing_insts.length; i < len; i++)
					this.DestroyInstance(existing_insts[i]);
				for (i = existing_insts.length, len = load_insts.length; i < len; i++)
				{
					layer = null;
					if (type.plugin.is_world)
					{
						layer = this.running_layout.getLayerBySid(load_insts[i]["w"]["l"]);
						if (!layer)
							continue;
					}
					inst = this.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
					this.loadInstanceFromJSON(inst, load_insts[i]);
				}
				type.stale_iids = true;
			}
		}
		this.ClearDeathRow();
		this.refreshUidMap();
		var olayouts = o["layouts"];
		for (p in olayouts)
		{
			if (olayouts.hasOwnProperty(p))
			{
				layout = this.getLayoutBySid(parseInt(p, 10));
				if (!layout)
					continue;		// must've gone missing
				layout.loadFromJSON(olayouts[p]);
			}
		}
		var ogroups = o["events"]["groups"];
		for (p in ogroups)
		{
			if (ogroups.hasOwnProperty(p))
			{
				g = this.getGroupBySid(parseInt(p, 10));
				if (g)
					this.activeGroups[g.group_name] = ogroups[p];
			}
		}
		var ocnds = o["events"]["cnds"];
		for (p in ocnds)
		{
			if (ocnds.hasOwnProperty(p) && this.cndsBySid.hasOwnProperty(p))
			{
				this.cndsBySid[p].extra = ocnds[p]["ex"];
			}
		}
		var oacts = o["events"]["acts"];
		for (p in oacts)
		{
			if (oacts.hasOwnProperty(p) && this.actsBySid.hasOwnProperty(p))
			{
				this.actsBySid[p].extra = oacts[p]["ex"];
			}
		}
		var ovars = o["events"]["vars"];
		for (p in ovars)
		{
			if (ovars.hasOwnProperty(p) && this.varsBySid.hasOwnProperty(p))
			{
				this.varsBySid[p].data = ovars[p];
			}
		}
		this.next_uid = rt["next_uid"];
		this.isLoadingState = false;
		this.system.loadFromJSON(o["system"]);
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (type.is_contained)
				{
					iid = inst.get_iid();
					inst.siblings.length = 0;
					for (k = 0, lenk = type.container.length; k < lenk; k++)
					{
						t = type.container[k];
						if (type === t)
							continue;
;
						inst.siblings.push(t.instances[iid]);
					}
				}
				if (inst.afterLoad)
					inst.afterLoad();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.afterLoad)
							binst.afterLoad();
					}
				}
			}
		}
		this.redraw = true;
	};
	Runtime.prototype.saveInstanceToJSON = function(inst, state_only)
	{
		var i, len, world, behinst, et;
		var type = inst.type;
		var plugin = type.plugin;
		var o = {};
		if (state_only)
			o["c2"] = true;		// mark as known json data from Construct 2
		else
			o["uid"] = inst.uid;
		if (cr.hasAnyOwnProperty(inst.extra))
			o["ex"] = CopyExtraObject(inst.extra);
		if (inst.instance_vars && inst.instance_vars.length)
		{
			o["ivs"] = {};
			for (i = 0, len = inst.instance_vars.length; i < len; i++)
			{
				o["ivs"][inst.type.instvar_sids[i].toString()] = inst.instance_vars[i];
			}
		}
		if (plugin.is_world)
		{
			world = {
				"x": inst.x,
				"y": inst.y,
				"w": inst.width,
				"h": inst.height,
				"l": inst.layer.sid,
				"zi": inst.get_zindex()
			};
			if (inst.angle !== 0)
				world["a"] = inst.angle;
			if (inst.opacity !== 1)
				world["o"] = inst.opacity;
			if (inst.hotspotX !== 0.5)
				world["hX"] = inst.hotspotX;
			if (inst.hotspotY !== 0.5)
				world["hY"] = inst.hotspotY;
			if (inst.blend_mode !== 0)
				world["bm"] = inst.blend_mode;
			if (!inst.visible)
				world["v"] = inst.visible;
			if (!inst.collisionsEnabled)
				world["ce"] = inst.collisionsEnabled;
			if (inst.my_timescale !== -1)
				world["mts"] = inst.my_timescale;
			if (type.effect_types.length)
			{
				world["fx"] = [];
				for (i = 0, len = type.effect_types.length; i < len; i++)
				{
					et = type.effect_types[i];
					world["fx"].push({"name": et.name,
									  "active": inst.active_effect_flags[et.index],
									  "params": inst.effect_params[et.index] });
				}
			}
			o["w"] = world;
		}
		if (inst.behavior_insts && inst.behavior_insts.length)
		{
			o["behs"] = {};
			for (i = 0, len = inst.behavior_insts.length; i < len; i++)
			{
				behinst = inst.behavior_insts[i];
				if (behinst.saveToJSON)
					o["behs"][behinst.type.sid.toString()] = behinst.saveToJSON();
			}
		}
		if (inst.saveToJSON)
			o["data"] = inst.saveToJSON();
		return o;
	};
	Runtime.prototype.getInstanceVarIndexBySid = function (type, sid_)
	{
		var i, len;
		for (i = 0, len = type.instvar_sids.length; i < len; i++)
		{
			if (type.instvar_sids[i] === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.getBehaviorIndexBySid = function (inst, sid_)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].type.sid === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.loadInstanceFromJSON = function(inst, o, state_only)
	{
		var p, i, len, iv, oivs, world, fxindex, obehs, behindex;
		var oldlayer;
		var type = inst.type;
		var plugin = type.plugin;
		if (state_only)
		{
			if (!o["c2"])
				return;
		}
		else
			inst.uid = o["uid"];
		if (o["ex"])
			inst.extra = o["ex"];
		else
			cr.wipe(inst.extra);
		oivs = o["ivs"];
		if (oivs)
		{
			for (p in oivs)
			{
				if (oivs.hasOwnProperty(p))
				{
					iv = this.getInstanceVarIndexBySid(type, parseInt(p, 10));
					if (iv < 0 || iv >= inst.instance_vars.length)
						continue;		// must've gone missing
					inst.instance_vars[iv] = oivs[p];
				}
			}
		}
		if (plugin.is_world)
		{
			world = o["w"];
			if (inst.layer.sid !== world["l"])
			{
				oldlayer = inst.layer;
				inst.layer = this.running_layout.getLayerBySid(world["l"]);
				if (inst.layer)
				{
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
					cr.arrayFindRemove(oldlayer.instances, inst);
					oldlayer.zindices_stale = true;
				}
				else
				{
					inst.layer = oldlayer;
					this.DestroyInstance(inst);
				}
			}
			inst.x = world["x"];
			inst.y = world["y"];
			inst.width = world["w"];
			inst.height = world["h"];
			inst.zindex = world["zi"];
			inst.angle = world.hasOwnProperty("a") ? world["a"] : 0;
			inst.opacity = world.hasOwnProperty("o") ? world["o"] : 1;
			inst.hotspotX = world.hasOwnProperty("hX") ? world["hX"] : 0.5;
			inst.hotspotY = world.hasOwnProperty("hY") ? world["hY"] : 0.5;
			inst.visible = world.hasOwnProperty("v") ? world["v"] : true;
			inst.collisionsEnabled = world.hasOwnProperty("ce") ? world["ce"] : true;
			inst.my_timescale = world.hasOwnProperty("mts") ? world["mts"] : -1;
			inst.blend_mode = world.hasOwnProperty("bm") ? world["bm"] : 0;;
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			inst.set_bbox_changed();
			if (world.hasOwnProperty("fx"))
			{
				for (i = 0, len = world["fx"].length; i < len; i++)
				{
					fxindex = type.getEffectIndexByName(world["fx"][i]["name"]);
					if (fxindex < 0)
						continue;		// must've gone missing
					inst.active_effect_flags[fxindex] = world["fx"][i]["active"];
					inst.effect_params[fxindex] = world["fx"][i]["params"];
				}
			}
			inst.updateActiveEffects();
		}
		obehs = o["behs"];
		if (obehs)
		{
			for (p in obehs)
			{
				if (obehs.hasOwnProperty(p))
				{
					behindex = this.getBehaviorIndexBySid(inst, parseInt(p, 10));
					if (behindex < 0)
						continue;		// must've gone missing
					inst.behavior_insts[behindex].loadFromJSON(obehs[p]);
				}
			}
		}
		if (o["data"])
			inst.loadFromJSON(o["data"]);
	};
	cr.runtime = Runtime;
	cr.createRuntime = function (canvasid)
	{
		return new Runtime(document.getElementById(canvasid));
	};
	cr.createDCRuntime = function (w, h)
	{
		return new Runtime({ "dc": true, "width": w, "height": h });
	};
	window["cr_createRuntime"] = cr.createRuntime;
	window["cr_createDCRuntime"] = cr.createDCRuntime;
	window["createCocoonJSRuntime"] = function ()
	{
		window["c2cocoonjs"] = true;
		var canvas = document.createElement("screencanvas") || document.createElement("canvas");
		canvas.screencanvas = true;
		document.body.appendChild(canvas);
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window.addEventListener("orientationchange", function () {
			window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		});
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
}());
window["cr_getC2Runtime"] = function()
{
	var canvas = document.getElementById("c2canvas");
	if (canvas)
		return canvas["c2runtime"];
	else if (window["c2runtime"])
		return window["c2runtime"];
	else
		return null;
}
window["cr_sizeCanvas"] = function(w, h)
{
	if (w === 0 || h === 0)
		return;
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSize"](w, h);
}
window["cr_setSuspended"] = function(s)
{
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSuspended"](s);
}
;
(function()
{
	function Layout(runtime, m)
	{
		this.runtime = runtime;
		this.event_sheet = null;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		this.scale = 1.0;
		this.angle = 0;
		this.first_visit = true;
		this.name = m[0];
		this.width = m[1];
		this.height = m[2];
		this.unbounded_scrolling = m[3];
		this.sheetname = m[4];
		this.sid = m[5];
		var lm = m[6];
		var i, len;
		this.layers = [];
		this.initial_types = [];
		for (i = 0, len = lm.length; i < len; i++)
		{
			var layer = new cr.layer(this, lm[i]);
			layer.number = i;
			cr.seal(layer);
			this.layers.push(layer);
		}
		var im = m[7];
		this.initial_nonworld = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
				type.default_instance = inst;
			this.initial_nonworld.push(inst);
			if (this.initial_types.indexOf(type) === -1)
				this.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[8].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[8][i][0],
				name: m[8][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[8][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
		this.persist_data = {};
	};
	Layout.prototype.saveObjectToPersist = function (inst)
	{
		var sidStr = inst.type.sid.toString();
		if (!this.persist_data.hasOwnProperty(sidStr))
			this.persist_data[sidStr] = [];
		var type_persist = this.persist_data[sidStr];
		type_persist.push(this.runtime.saveInstanceToJSON(inst));
	};
	Layout.prototype.hasOpaqueBottomLayer = function ()
	{
		var layer = this.layers[0];
		return !layer.transparent && layer.opacity === 1.0 && !layer.forceOwnTexture && layer.visible;
	};
	Layout.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layout.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	var created_instances = [];
	Layout.prototype.startRunning = function ()
	{
		if (this.sheetname)
		{
			this.event_sheet = this.runtime.eventsheets[this.sheetname];
;
		}
		this.runtime.running_layout = this;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		var i, k, len, lenk, type, type_instances, inst, iid, t, s, p, q, type_data, layer;
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.is_family)
				continue;		// instances are only transferred for their real type
			type_instances = type.instances;
			for (k = 0, lenk = type_instances.length; k < lenk; k++)
			{
				inst = type_instances[k];
				if (inst.layer)
				{
					var num = inst.layer.number;
					if (num >= this.layers.length)
						num = this.layers.length - 1;
					inst.layer = this.layers[num];
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
				}
			}
		}
		var layer;
		created_instances.length = 0;
		this.boundScrolling();
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			layer.createInitialInstances();		// fills created_instances
			layer.disableAngle = true;
			var px = layer.canvasToLayer(0, 0, true, true);
			var py = layer.canvasToLayer(0, 0, false, true);
			layer.disableAngle = false;
			if (this.runtime.pixel_rounding)
			{
				px = (px + 0.5) | 0;
				py = (py + 0.5) | 0;
			}
			layer.rotateViewport(px, py, null);
		}
		var uids_changed = false;
		if (!this.first_visit)
		{
			for (p in this.persist_data)
			{
				if (this.persist_data.hasOwnProperty(p))
				{
					type = this.runtime.getObjectTypeBySid(parseInt(p, 10));
					if (!type || type.is_family || !this.runtime.typeHasPersistBehavior(type))
						continue;
					type_data = this.persist_data[p];
					for (i = 0, len = type_data.length; i < len; i++)
					{
						layer = null;
						if (type.plugin.is_world)
						{
							layer = this.getLayerBySid(type_data[i]["w"]["l"]);
							if (!layer)
								continue;
						}
						inst = this.runtime.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
						this.runtime.loadInstanceFromJSON(inst, type_data[i]);
						uids_changed = true;
						created_instances.push(inst);
					}
					type_data.length = 0;
				}
			}
			for (i = 0, len = this.layers.length; i < len; i++)
			{
				this.layers[i].instances.sort(sortInstanceByZIndex);
				this.layers[i].zindices_stale = true;		// in case of duplicates/holes
			}
		}
		if (uids_changed)
		{
			this.runtime.ClearDeathRow();
			this.runtime.refreshUidMap();
		}
		for (i = 0; i < created_instances.length; i++)
		{
			inst = created_instances[i];
			if (!inst.type.is_contained)
				continue;
			iid = inst.get_iid();
			for (k = 0, lenk = inst.type.container.length; k < lenk; k++)
			{
				t = inst.type.container[k];
				if (inst.type === t)
					continue;
				if (t.instances.length > iid)
					inst.siblings.push(t.instances[iid]);
				else
				{
					if (!t.default_instance)
					{
					}
					else
					{
						s = this.runtime.createInstanceFromInit(t.default_instance, inst.layer, true, inst.x, inst.y, true);
						this.runtime.ClearDeathRow();
						t.updateIIDs();
						inst.siblings.push(s);
						created_instances.push(s);		// come back around and link up its own instances too
					}
				}
			}
		}
		for (i = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			inst = this.runtime.createInstanceFromInit(this.initial_nonworld[i], null, true);
;
		}
		this.runtime.changelayout = null;
		this.runtime.ClearDeathRow();
		if (this.runtime.ctx && !this.runtime.isDomFree)
		{
			for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
			{
				t = this.runtime.types_by_index[i];
				if (t.is_family || !t.instances.length || !t.preloadCanvas2D)
					continue;
				t.preloadCanvas2D(this.runtime.ctx);
			}
		}
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout start: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		for (i = 0, len = created_instances.length; i < len; i++)
		{
			inst = created_instances[i];
			this.runtime.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnCreated, inst);
		}
		created_instances.length = 0;
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart, null);
		this.first_visit = false;
	};
	Layout.prototype.createGlobalNonWorlds = function ()
	{
		var i, k, len, initial_inst, inst, type;
		for (i = 0, k = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			initial_inst = this.initial_nonworld[i];
			type = this.runtime.types_by_index[initial_inst[1]];
			if (type.global)
				inst = this.runtime.createInstanceFromInit(initial_inst, null, true);
			else
			{
				this.initial_nonworld[k] = initial_inst;
				k++;
			}
		}
		this.initial_nonworld.length = k;
	};
	Layout.prototype.stopRunning = function ()
	{
;
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout end: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd, null);
		this.runtime.system.waits.length = 0;
		var i, leni, j, lenj;
		var layer_instances, inst, type;
		for (i = 0, leni = this.layers.length; i < leni; i++)
		{
			layer_instances = this.layers[i].instances;
			for (j = 0, lenj = layer_instances.length; j < lenj; j++)
			{
				inst = layer_instances[j];
				if (!inst.type.global)
				{
					if (this.runtime.typeHasPersistBehavior(inst.type))
						this.saveObjectToPersist(inst);
					this.runtime.DestroyInstance(inst);
				}
			}
			this.runtime.ClearDeathRow();
			layer_instances.length = 0;
			this.layers[i].zindices_stale = true;
		}
		for (i = 0, leni = this.runtime.types_by_index.length; i < leni; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.global || type.plugin.is_world || type.plugin.singleglobal || type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
				this.runtime.DestroyInstance(type.instances[j]);
			this.runtime.ClearDeathRow();
		}
	};
	Layout.prototype.draw = function (ctx)
	{
		var layout_canvas;
		var layout_ctx = ctx;
		var ctx_changed = false;
		var render_offscreen = !this.runtime.fullscreenScalingQuality;
		if (render_offscreen)
		{
			if (!this.runtime.layout_canvas)
			{
				this.runtime.layout_canvas = document.createElement("canvas");
				layout_canvas = this.runtime.layout_canvas;
				layout_canvas.width = this.runtime.draw_width;
				layout_canvas.height = this.runtime.draw_height;
				this.runtime.layout_ctx = layout_canvas.getContext("2d");
				ctx_changed = true;
			}
			layout_canvas = this.runtime.layout_canvas;
			layout_ctx = this.runtime.layout_ctx;
			if (layout_canvas.width !== this.runtime.draw_width)
			{
				layout_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layout_canvas.height !== this.runtime.draw_height)
			{
				layout_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layout_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
		}
		layout_ctx.globalAlpha = 1;
		layout_ctx.globalCompositeOperation = "source-over";
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			layout_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		var i, len, l;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.visible && l.opacity > 0 && l.blend_mode !== 11)
				l.draw(layout_ctx);
		}
		if (render_offscreen)
		{
			ctx.drawImage(layout_canvas, 0, 0, this.runtime.width, this.runtime.height);
		}
	};
	Layout.prototype.drawGL = function (glw)
	{
		var render_to_texture = (this.active_effect_types.length > 0 ||
								 this.runtime.uses_background_blending ||
								 !this.runtime.fullscreenScalingQuality);
		if (render_to_texture)
		{
			if (!this.runtime.layout_tex)
			{
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layout_tex.c2width !== this.runtime.draw_width || this.runtime.layout_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layout_tex);
			if (!this.runtime.fullscreenScalingQuality)
			{
				glw.setSize(this.runtime.draw_width, this.runtime.draw_height);
			}
		}
		else
		{
			if (this.runtime.layout_tex)
			{
				glw.setRenderingToTexture(null);
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = null;
			}
		}
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			glw.clear(0, 0, 0, 0);
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].visible && this.layers[i].opacity > 0)
				this.layers[i].drawGL(glw);
		}
		if (render_to_texture)
		{
			if (this.active_effect_types.length === 0 ||
				(this.active_effect_types.length === 1 && this.runtime.fullscreenScalingQuality))
			{
				if (this.active_effect_types.length === 1)
				{
					var etindex = this.active_effect_types[0].index;
					glw.switchProgram(this.active_effect_types[0].shaderindex);
					glw.setProgramParameters(null,								// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.scale,						// layerScale
											 this.angle,						// layerAngle
											 0.0, 0.0,							// viewOrigin
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(this.active_effect_types[0].shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
				}
				glw.setRenderingToTexture(null);				// to backbuffer
				glw.setOpacity(1);
				glw.setTexture(this.runtime.layout_tex);
				glw.setAlphaBlend();
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.width / 2;
				var halfh = this.runtime.height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.renderEffectChain(glw, null, null, null);
			}
		}
	};
	Layout.prototype.getRenderTarget = function()
	{
		return (this.active_effect_types.length > 0 ||
				this.runtime.uses_background_blending ||
				!this.runtime.fullscreenScalingQuality) ? this.runtime.layout_tex : null;
	};
	Layout.prototype.getMinLayerScale = function ()
	{
		var m = this.layers[0].getScale();
		var i, len, l;
		for (i = 1, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.parallaxX === 0 && l.parallaxY === 0)
				continue;
			if (l.getScale() < m)
				m = l.getScale();
		}
		return m;
	};
	Layout.prototype.scrollToX = function (x)
	{
		if (!this.unbounded_scrolling)
		{
			var widthBoundary = (this.runtime.draw_width * (1 / this.getMinLayerScale()) / 2);
			if (x > this.width - widthBoundary)
				x = this.width - widthBoundary;
			if (x < widthBoundary)
				x = widthBoundary;
		}
		if (this.scrollX !== x)
		{
			this.scrollX = x;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.scrollToY = function (y)
	{
		if (!this.unbounded_scrolling)
		{
			var heightBoundary = (this.runtime.draw_height * (1 / this.getMinLayerScale()) / 2);
			if (y > this.height - heightBoundary)
				y = this.height - heightBoundary;
			if (y < heightBoundary)
				y = heightBoundary;
		}
		if (this.scrollY !== y)
		{
			this.scrollY = y;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.boundScrolling = function ()
	{
		this.scrollToX(this.scrollX);
		this.scrollToY(this.scrollY);
	};
	Layout.prototype.renderEffectChain = function (glw, layer, inst, rendertarget)
	{
		var active_effect_types = inst ?
							inst.active_effect_types :
							layer ?
								layer.active_effect_types :
								this.active_effect_types;
		var layerScale = 1, layerAngle = 0, viewOriginLeft = 0, viewOriginTop = 0;
		if (inst)
		{
			layerScale = inst.layer.getScale();
			layerAngle = inst.layer.getAngle();
			viewOriginLeft = inst.layer.viewLeft;
			viewOriginTop = inst.layer.viewTop;
		}
		else if (layer)
		{
			layerScale = layer.getScale();
			layerAngle = layer.getAngle();
			viewOriginLeft = layer.viewLeft;
			viewOriginTop = layer.viewTop;
		}
		var fx_tex = this.runtime.fx_tex;
		var i, len, last, temp, fx_index = 0, other_fx_index = 1;
		var y, h;
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var halfw = windowWidth / 2;
		var halfh = windowHeight / 2;
		var rcTex = layer ? layer.rcTex : this.rcTex;
		var rcTex2 = layer ? layer.rcTex2 : this.rcTex2;
		var screenleft = 0, clearleft = 0;
		var screentop = 0, cleartop = 0;
		var screenright = windowWidth, clearright = windowWidth;
		var screenbottom = windowHeight, clearbottom = windowHeight;
		var boxExtendHorizontal = 0;
		var boxExtendVertical = 0;
		var inst_layer_angle = inst ? inst.layer.getAngle() : 0;
		if (inst)
		{
			for (i = 0, len = active_effect_types.length; i < len; i++)
			{
				boxExtendHorizontal += glw.getProgramBoxExtendHorizontal(active_effect_types[i].shaderindex);
				boxExtendVertical += glw.getProgramBoxExtendVertical(active_effect_types[i].shaderindex);
			}
			var bbox = inst.bbox;
			screenleft = layer.layerToCanvas(bbox.left, bbox.top, true, true);
			screentop = layer.layerToCanvas(bbox.left, bbox.top, false, true);
			screenright = layer.layerToCanvas(bbox.right, bbox.bottom, true, true);
			screenbottom = layer.layerToCanvas(bbox.right, bbox.bottom, false, true);
			if (inst_layer_angle !== 0)
			{
				var screentrx = layer.layerToCanvas(bbox.right, bbox.top, true, true);
				var screentry = layer.layerToCanvas(bbox.right, bbox.top, false, true);
				var screenblx = layer.layerToCanvas(bbox.left, bbox.bottom, true, true);
				var screenbly = layer.layerToCanvas(bbox.left, bbox.bottom, false, true);
				temp = Math.min(screenleft, screenright, screentrx, screenblx);
				screenright = Math.max(screenleft, screenright, screentrx, screenblx);
				screenleft = temp;
				temp = Math.min(screentop, screenbottom, screentry, screenbly);
				screenbottom = Math.max(screentop, screenbottom, screentry, screenbly);
				screentop = temp;
			}
			screenleft -= boxExtendHorizontal;
			screentop -= boxExtendVertical;
			screenright += boxExtendHorizontal;
			screenbottom += boxExtendVertical;
			rcTex2.left = screenleft / windowWidth;
			rcTex2.top = 1 - screentop / windowHeight;
			rcTex2.right = screenright / windowWidth;
			rcTex2.bottom = 1 - screenbottom / windowHeight;
			clearleft = screenleft = cr.floor(screenleft);
			cleartop = screentop = cr.floor(screentop);
			clearright = screenright = cr.ceil(screenright);
			clearbottom = screenbottom = cr.ceil(screenbottom);
			clearleft -= boxExtendHorizontal;
			cleartop -= boxExtendVertical;
			clearright += boxExtendHorizontal;
			clearbottom += boxExtendVertical;
			if (screenleft < 0)					screenleft = 0;
			if (screentop < 0)					screentop = 0;
			if (screenright > windowWidth)		screenright = windowWidth;
			if (screenbottom > windowHeight)	screenbottom = windowHeight;
			if (clearleft < 0)					clearleft = 0;
			if (cleartop < 0)					cleartop = 0;
			if (clearright > windowWidth)		clearright = windowWidth;
			if (clearbottom > windowHeight)		clearbottom = windowHeight;
			rcTex.left = screenleft / windowWidth;
			rcTex.top = 1 - screentop / windowHeight;
			rcTex.right = screenright / windowWidth;
			rcTex.bottom = 1 - screenbottom / windowHeight;
		}
		else
		{
			rcTex.left = rcTex2.left = 0;
			rcTex.top = rcTex2.top = 0;
			rcTex.right = rcTex2.right = 1;
			rcTex.bottom = rcTex2.bottom = 1;
		}
		var pre_draw = (inst && (((inst.angle || inst_layer_angle) && glw.programUsesDest(active_effect_types[0].shaderindex)) || boxExtendHorizontal !== 0 || boxExtendVertical !== 0 || inst.opacity !== 1 || inst.type.plugin.must_predraw)) || (layer && !inst && layer.opacity !== 1);
		glw.setAlphaBlend();
		if (pre_draw)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(0);
			glw.setRenderingToTexture(fx_tex[fx_index]);
			h = clearbottom - cleartop;
			y = (windowHeight - cleartop) - h;
			glw.clearRect(clearleft, y, clearright - clearleft, h);
			if (inst)
			{
				inst.drawGL(glw);
			}
			else
			{
				glw.setTexture(this.runtime.layer_tex);
				glw.setOpacity(layer.opacity);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			}
			rcTex2.left = rcTex2.top = 0;
			rcTex2.right = rcTex2.bottom = 1;
			if (inst)
			{
				temp = rcTex.top;
				rcTex.top = rcTex.bottom;
				rcTex.bottom = temp;
			}
			fx_index = 1;
			other_fx_index = 0;
		}
		glw.setOpacity(1);
		var last = active_effect_types.length - 1;
		var post_draw = glw.programUsesCrossSampling(active_effect_types[last].shaderindex) ||
						(!layer && !inst && !this.runtime.fullscreenScalingQuality);
		var etindex = 0;
		for (i = 0, len = active_effect_types.length; i < len; i++)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(active_effect_types[i].shaderindex);
			etindex = active_effect_types[i].index;
			if (glw.programIsAnimated(active_effect_types[i].shaderindex))
				this.runtime.redraw = true;
			if (i == 0 && !pre_draw)
			{
				glw.setRenderingToTexture(fx_tex[fx_index]);
				h = clearbottom - cleartop;
				y = (windowHeight - cleartop) - h;
				glw.clearRect(clearleft, y, clearright - clearleft, h);
				if (inst)
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / inst.width,				// pixelWidth
											 1.0 / inst.height,				// pixelHeight
											 rcTex2.left, rcTex2.top,		// destStart
											 rcTex2.right, rcTex2.bottom,	// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 inst.effect_params[etindex]);	// fx params
					inst.drawGL(glw);
				}
				else
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / windowWidth,				// pixelWidth
											 1.0 / windowHeight,			// pixelHeight
											 0.0, 0.0,						// destStart
											 1.0, 1.0,						// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 layer ?						// fx params
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
					glw.setTexture(layer ? this.runtime.layer_tex : this.runtime.layout_tex);
					glw.resetModelView();
					glw.translate(-halfw, -halfh);
					glw.updateModelView();
					glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				}
				rcTex2.left = rcTex2.top = 0;
				rcTex2.right = rcTex2.bottom = 1;
				if (inst && !post_draw)
				{
					temp = screenbottom;
					screenbottom = screentop;
					screentop = temp;
				}
			}
			else
			{
				glw.setProgramParameters(rendertarget,						// backTex
										 1.0 / windowWidth,					// pixelWidth
										 1.0 / windowHeight,				// pixelHeight
										 rcTex2.left, rcTex2.top,			// destStart
										 rcTex2.right, rcTex2.bottom,		// destEnd
										 layerScale,
										 layerAngle,
										 viewOriginLeft, viewOriginTop,
										 inst ?								// fx params
											inst.effect_params[etindex] :
											layer ?
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
				glw.setTexture(null);
				if (i === last && !post_draw)
				{
					if (inst)
						glw.setBlend(inst.srcBlend, inst.destBlend);
					else if (layer)
						glw.setBlend(layer.srcBlend, layer.destBlend);
					glw.setRenderingToTexture(rendertarget);
				}
				else
				{
					glw.setRenderingToTexture(fx_tex[fx_index]);
					h = clearbottom - cleartop;
					y = (windowHeight - cleartop) - h;
					glw.clearRect(clearleft, y, clearright - clearleft, h);
				}
				glw.setTexture(fx_tex[other_fx_index]);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				if (i === last && !post_draw)
					glw.setTexture(null);
			}
			fx_index = (fx_index === 0 ? 1 : 0);
			other_fx_index = (fx_index === 0 ? 1 : 0);		// will be opposite to fx_index since it was just assigned
		}
		if (post_draw)
		{
			glw.switchProgram(0);
			if (inst)
				glw.setBlend(inst.srcBlend, inst.destBlend);
			else if (layer)
				glw.setBlend(layer.srcBlend, layer.destBlend);
			else
			{
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
					halfw = this.runtime.width / 2;
					halfh = this.runtime.height / 2;
					screenleft = 0;
					screentop = 0;
					screenright = this.runtime.width;
					screenbottom = this.runtime.height;
				}
			}
			glw.setRenderingToTexture(rendertarget);
			glw.setTexture(fx_tex[other_fx_index]);
			glw.resetModelView();
			glw.translate(-halfw, -halfh);
			glw.updateModelView();
			if (inst && active_effect_types.length === 1 && !pre_draw)
				glw.quadTex(screenleft, screentop, screenright, screentop, screenright, screenbottom, screenleft, screenbottom, rcTex);
			else
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			glw.setTexture(null);
		}
	};
	Layout.prototype.getLayerBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].sid === sid_)
				return this.layers[i];
		}
		return null;
	};
	Layout.prototype.saveToJSON = function ()
	{
		var i, len, layer, et;
		var o = {
			"sx": this.scrollX,
			"sy": this.scrollY,
			"s": this.scale,
			"a": this.angle,
			"w": this.width,
			"h": this.height,
			"fv": this.first_visit,			// added r127
			"persist": this.persist_data,
			"fx": [],
			"layers": {}
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			o["layers"][layer.sid.toString()] = layer.saveToJSON();
		}
		return o;
	};
	Layout.prototype.loadFromJSON = function (o)
	{
		var i, len, fx, p, layer;
		this.scrollX = o["sx"];
		this.scrollY = o["sy"];
		this.scale = o["s"];
		this.angle = o["a"];
		this.width = o["w"];
		this.height = o["h"];
		this.persist_data = o["persist"];
		if (typeof o["fv"] !== "undefined")
			this.first_visit = o["fv"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		var olayers = o["layers"];
		for (p in olayers)
		{
			if (olayers.hasOwnProperty(p))
			{
				layer = this.getLayerBySid(parseInt(p, 10));
				if (!layer)
					continue;		// must've gone missing
				layer.loadFromJSON(olayers[p]);
			}
		}
	};
	cr.layout = Layout;
	function Layer(layout, m)
	{
		this.layout = layout;
		this.runtime = layout.runtime;
		this.instances = [];        // running instances
		this.scale = 1.0;
		this.angle = 0;
		this.disableAngle = false;
		this.tmprect = new cr.rect(0, 0, 0, 0);
		this.tmpquad = new cr.quad();
		this.viewLeft = 0;
		this.viewRight = 0;
		this.viewTop = 0;
		this.viewBottom = 0;
		this.zindices_stale = false;
		this.name = m[0];
		this.index = m[1];
		this.sid = m[2];
		this.visible = m[3];		// initially visible
		this.background_color = m[4];
		this.transparent = m[5];
		this.parallaxX = m[6];
		this.parallaxY = m[7];
		this.opacity = m[8];
		this.forceOwnTexture = m[9];
		this.zoomRate = m[10];
		this.blend_mode = m[11];
		this.effect_fallback = m[12];
		this.compositeOp = "source-over";
		this.srcBlend = 0;
		this.destBlend = 0;
		this.render_offscreen = false;
		var im = m[13];
		var i, len;
		this.initial_instances = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
			{
				type.default_instance = inst;
				type.default_layerindex = this.index;
			}
			this.initial_instances.push(inst);
			if (this.layout.initial_types.indexOf(type) === -1)
				this.layout.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[14].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[14][i][0],
				name: m[14][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[14][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
	};
	Layer.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layer.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	Layer.prototype.createInitialInstances = function ()
	{
		var i, k, len, inst, initial_inst, type, keep, hasPersistBehavior;
		for (i = 0, k = 0, len = this.initial_instances.length; i < len; i++)
		{
			initial_inst = this.initial_instances[i];
			type = this.runtime.types_by_index[initial_inst[1]];
;
			hasPersistBehavior = this.runtime.typeHasPersistBehavior(type);
			keep = true;
			if (!hasPersistBehavior || this.layout.first_visit)
			{
				inst = this.runtime.createInstanceFromInit(initial_inst, this, true);
;
				created_instances.push(inst);
				if (inst.type.global)
					keep = false;
			}
			if (keep)
			{
				this.initial_instances[k] = this.initial_instances[i];
				k++;
			}
		}
		this.initial_instances.length = k;
		this.runtime.ClearDeathRow();		// flushes creation row so IIDs will be correct
		if (!this.runtime.glwrap && this.effect_types.length)	// no WebGL renderer and shaders used
			this.blend_mode = this.effect_fallback;				// use fallback blend mode
		this.compositeOp = cr.effectToCompositeOp(this.blend_mode);
		if (this.runtime.gl)
			cr.setGLBlend(this, this.blend_mode, this.runtime.gl);
	};
	Layer.prototype.updateZIndices = function ()
	{
		if (!this.zindices_stale)
			return;
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
;
;
			this.instances[i].zindex = i;
		}
		this.zindices_stale = false;
	};
	Layer.prototype.getScale = function (include_aspect)
	{
		return this.getNormalScale() * (this.runtime.fullscreenScalingQuality || include_aspect ? this.runtime.aspect_scale : 1);
	};
	Layer.prototype.getNormalScale = function ()
	{
		return ((this.scale * this.layout.scale) - 1) * this.zoomRate + 1;
	};
	Layer.prototype.getAngle = function ()
	{
		if (this.disableAngle)
			return 0;
		return cr.clamp_angle(this.layout.angle + this.angle);
	};
	Layer.prototype.draw = function (ctx)
	{
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.blend_mode !== 0);
		var layer_canvas = this.runtime.canvas;
		var layer_ctx = ctx;
		var ctx_changed = false;
		ctx.globalAlpha = 1;
		ctx.globalCompositeOperation = "source-over";
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_canvas)
			{
				this.runtime.layer_canvas = document.createElement("canvas");
;
				layer_canvas = this.runtime.layer_canvas;
				layer_canvas.width = this.runtime.draw_width;
				layer_canvas.height = this.runtime.draw_height;
				this.runtime.layer_ctx = layer_canvas.getContext("2d");
;
				ctx_changed = true;
			}
			layer_canvas = this.runtime.layer_canvas;
			layer_ctx = this.runtime.layer_ctx;
			if (layer_canvas.width !== this.runtime.draw_width)
			{
				layer_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layer_canvas.height !== this.runtime.draw_height)
			{
				layer_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layer_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
			if (this.transparent)
				layer_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		if (!this.transparent)
		{
			layer_ctx.fillStyle = "rgb(" + this.background_color[0] + "," + this.background_color[1] + "," + this.background_color[2] + ")";
			layer_ctx.fillRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.save();
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, layer_ctx);
		var myscale = this.getScale();
		layer_ctx.scale(myscale, myscale);
		layer_ctx.translate(-px, -py);
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			layer_ctx.globalCompositeOperation = inst.compositeOp;
			inst.draw(layer_ctx);
		}
		layer_ctx.restore();
		if (this.render_offscreen)
		{
			ctx.globalCompositeOperation = this.compositeOp;
			ctx.globalAlpha = this.opacity;
			ctx.drawImage(layer_canvas, 0, 0);
		}
	};
	Layer.prototype.rotateViewport = function (px, py, ctx)
	{
		var myscale = this.getScale();
		this.viewLeft = px;
		this.viewTop = py;
		this.viewRight = px + (this.runtime.draw_width * (1 / myscale));
		this.viewBottom = py + (this.runtime.draw_height * (1 / myscale));
		var myAngle = this.getAngle();
		if (myAngle !== 0)
		{
			if (ctx)
			{
				ctx.translate(this.runtime.draw_width / 2, this.runtime.draw_height / 2);
				ctx.rotate(-myAngle);
				ctx.translate(this.runtime.draw_width / -2, this.runtime.draw_height / -2);
			}
			this.tmprect.set(this.viewLeft, this.viewTop, this.viewRight, this.viewBottom);
			this.tmprect.offset((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
			this.tmpquad.set_from_rotated_rect(this.tmprect, myAngle);
			this.tmpquad.bounding_box(this.tmprect);
			this.tmprect.offset((this.viewLeft + this.viewRight) / 2, (this.viewTop + this.viewBottom) / 2);
			this.viewLeft = this.tmprect.left;
			this.viewTop = this.tmprect.top;
			this.viewRight = this.tmprect.right;
			this.viewBottom = this.tmprect.bottom;
		}
	}
	Layer.prototype.drawGL = function (glw)
	{
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var shaderindex = 0;
		var etindex = 0;
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.active_effect_types.length > 0 || this.blend_mode !== 0);
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_tex)
			{
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layer_tex.c2width !== this.runtime.draw_width || this.runtime.layer_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layer_tex);
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layer_tex);
			if (this.transparent)
				glw.clear(0, 0, 0, 0);
		}
		if (!this.transparent)
		{
			glw.clear(this.background_color[0] / 255, this.background_color[1] / 255, this.background_color[2] / 255, 1);
		}
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, null);
		var myscale = this.getScale();
		glw.resetModelView();
		glw.scale(myscale, myscale);
		glw.rotateZ(-this.getAngle());
		glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
		glw.updateModelView();
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			if (inst.uses_shaders)
			{
				shaderindex = inst.active_effect_types[0].shaderindex;
				etindex = inst.active_effect_types[0].index;
				if (inst.active_effect_types.length === 1 && !glw.programUsesCrossSampling(shaderindex) &&
					!glw.programExtendsBox(shaderindex) && ((!inst.angle && !inst.layer.getAngle()) || !glw.programUsesDest(shaderindex)) &&
					inst.opacity === 1 && !inst.type.plugin.must_predraw)
				{
					glw.switchProgram(shaderindex);
					glw.setBlend(inst.srcBlend, inst.destBlend);
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
					var destStartX = 0, destStartY = 0, destEndX = 0, destEndY = 0;
					if (glw.programUsesDest(shaderindex))
					{
						var bbox = inst.bbox;
						var screenleft = this.layerToCanvas(bbox.left, bbox.top, true, true);
						var screentop = this.layerToCanvas(bbox.left, bbox.top, false, true);
						var screenright = this.layerToCanvas(bbox.right, bbox.bottom, true, true);
						var screenbottom = this.layerToCanvas(bbox.right, bbox.bottom, false, true);
						destStartX = screenleft / windowWidth;
						destStartY = 1 - screentop / windowHeight;
						destEndX = screenright / windowWidth;
						destEndY = 1 - screenbottom / windowHeight;
					}
					glw.setProgramParameters(this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget(), // backTex
											 1.0 / inst.width,			// pixelWidth
											 1.0 / inst.height,			// pixelHeight
											 destStartX, destStartY,
											 destEndX, destEndY,
											 this.getScale(),
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 inst.effect_params[etindex]);
					inst.drawGL(glw);
				}
				else
				{
					this.layout.renderEffectChain(glw, this, inst, this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget());
					glw.resetModelView();
					glw.scale(myscale, myscale);
					glw.rotateZ(-this.getAngle());
					glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
					glw.updateModelView();
				}
			}
			else
			{
				glw.switchProgram(0);		// un-set any previously set shader
				glw.setBlend(inst.srcBlend, inst.destBlend);
				inst.drawGL(glw);
			}
		}
		if (this.render_offscreen)
		{
			shaderindex = this.active_effect_types.length ? this.active_effect_types[0].shaderindex : 0;
			etindex = this.active_effect_types.length ? this.active_effect_types[0].index : 0;
			if (this.active_effect_types.length === 0 || (this.active_effect_types.length === 1 &&
				!glw.programUsesCrossSampling(shaderindex) && this.opacity === 1))
			{
				if (this.active_effect_types.length === 1)
				{
					glw.switchProgram(shaderindex);
					glw.setProgramParameters(this.layout.getRenderTarget(),		// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.getScale(),					// layerScale
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				glw.setRenderingToTexture(this.layout.getRenderTarget());
				glw.setOpacity(this.opacity);
				glw.setTexture(this.runtime.layer_tex);
				glw.setBlend(this.srcBlend, this.destBlend);
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.draw_width / 2;
				var halfh = this.runtime.draw_height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.layout.renderEffectChain(glw, this, null, this.layout.getRenderTarget());
			}
		}
	};
	Layer.prototype.canvasToLayer = function (ptx, pty, getx, using_draw_area)
	{
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			ptx *= multiplier;
			pty *= multiplier;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x += ptx * invScale;
		y += pty * invScale;
		var a = this.getAngle();
		if (a !== 0)
		{
			x -= this.layout.scrollX;
			y -= this.layout.scrollY;
			var cosa = Math.cos(a);
			var sina = Math.sin(a);
			var x_temp = (x * cosa) - (y * sina);
			y = (y * cosa) + (x * sina);
			x = x_temp;
			x += this.layout.scrollX;
			y += this.layout.scrollY;
		}
		return getx ? x : y;
	};
	Layer.prototype.layerToCanvas = function (ptx, pty, getx, using_draw_area)
	{
		var a = this.getAngle();
		if (a !== 0)
		{
			ptx -= this.layout.scrollX;
			pty -= this.layout.scrollY;
			var cosa = Math.cos(-a);
			var sina = Math.sin(-a);
			var x_temp = (ptx * cosa) - (pty * sina);
			pty = (pty * cosa) + (ptx * sina);
			ptx = x_temp;
			ptx += this.layout.scrollX;
			pty += this.layout.scrollY;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x = (ptx - x) / invScale;
		y = (pty - y) / invScale;
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			x /= multiplier;
			y /= multiplier;
		}
		return getx ? x : y;
	};
	Layer.prototype.rotatePt = function (x_, y_, getx)
	{
		if (this.getAngle() === 0)
			return getx ? x_ : y_;
		var nx = this.layerToCanvas(x_, y_, true);
		var ny = this.layerToCanvas(x_, y_, false);
		this.disableAngle = true;
		var px = this.canvasToLayer(nx, ny, true);
		var py = this.canvasToLayer(nx, ny, true);
		this.disableAngle = false;
		return getx ? px : py;
	};
	Layer.prototype.saveToJSON = function ()
	{
		var i, len, et;
		var o = {
			"s": this.scale,
			"a": this.angle,
			"vl": this.viewLeft,
			"vt": this.viewTop,
			"vr": this.viewRight,
			"vb": this.viewBottom,
			"v": this.visible,
			"bc": this.background_color,
			"t": this.transparent,
			"px": this.parallaxX,
			"py": this.parallaxY,
			"o": this.opacity,
			"zr": this.zoomRate,
			"fx": [],
			"instances": []
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		return o;
	};
	function sortInstanceByZIndex(a, b)
	{
		return a.zindex - b.zindex;
	};
	Layer.prototype.loadFromJSON = function (o)
	{
		var i, len, p, inst, fx;
		this.scale = o["s"];
		this.angle = o["a"];
		this.viewLeft = o["vl"];
		this.viewTop = o["vt"];
		this.viewRight = o["vr"];
		this.viewBottom = o["vb"];
		this.visible = o["v"];
		this.background_color = o["bc"];
		this.transparent = o["t"];
		this.parallaxX = o["px"];
		this.parallaxY = o["py"];
		this.opacity = o["o"];
		this.zoomRate = o["zr"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		this.instances.sort(sortInstanceByZIndex);
		this.zindices_stale = true;
	};
	cr.layer = Layer;
}());
;
(function()
{
	var allUniqueSolModifiers = [];
	function testSolsMatch(arr1, arr2)
	{
		var i, len = arr1.length;
		switch (len) {
		case 0:
			return true;
		case 1:
			return arr1[0] === arr2[0];
		case 2:
			return arr1[0] === arr2[0] && arr1[1] === arr2[1];
		default:
			for (i = 0; i < len; i++)
			{
				if (arr1[i] !== arr2[i])
					return false;
			}
			return true;
		}
	};
	function solArraySorter(t1, t2)
	{
		return t1.index - t2.index;
	};
	function findMatchingSolModifier(arr)
	{
		var i, len, u, temp, subarr;
		if (arr.length === 2)
		{
			if (arr[0].index > arr[1].index)
			{
				temp = arr[0];
				arr[0] = arr[1];
				arr[1] = temp;
			}
		}
		else if (arr.length > 2)
			arr.sort(solArraySorter);		// so testSolsMatch compares in same order
		if (arr.length >= allUniqueSolModifiers.length)
			allUniqueSolModifiers.length = arr.length + 1;
		if (!allUniqueSolModifiers[arr.length])
			allUniqueSolModifiers[arr.length] = [];
		subarr = allUniqueSolModifiers[arr.length];
		for (i = 0, len = subarr.length; i < len; i++)
		{
			u = subarr[i];
			if (testSolsMatch(arr, u))
				return u;
		}
		subarr.push(arr);
		return arr;
	};
	function EventSheet(runtime, m)
	{
		this.runtime = runtime;
		this.triggers = {};
		this.fasttriggers = {};
        this.hasRun = false;
        this.includes = new cr.ObjectSet(); // all event sheets included by this sheet, at first-level indirection only
		this.name = m[0];
		var em = m[1];		// events model
		this.events = [];       // triggers won't make it to this array
		var i, len;
		for (i = 0, len = em.length; i < len; i++)
			this.init_event(em[i], null, this.events);
	};
    EventSheet.prototype.toString = function ()
    {
        return this.name;
    };
	EventSheet.prototype.init_event = function (m, parent, nontriggers)
	{
		switch (m[0]) {
		case 0:	// event block
		{
			var block = new cr.eventblock(this, parent, m);
			cr.seal(block);
			if (block.orblock)
			{
				nontriggers.push(block);
				var i, len;
				for (i = 0, len = block.conditions.length; i < len; i++)
				{
					if (block.conditions[i].trigger)
						this.init_trigger(block, i);
				}
			}
			else
			{
				if (block.is_trigger())
					this.init_trigger(block, 0);
				else
					nontriggers.push(block);
			}
			break;
		}
		case 1: // variable
		{
			var v = new cr.eventvariable(this, parent, m);
			cr.seal(v);
			nontriggers.push(v);
			break;
		}
        case 2:	// include
        {
            var inc = new cr.eventinclude(this, parent, m);
			cr.seal(inc);
            nontriggers.push(inc);
			break;
        }
		default:
;
		}
	};
	EventSheet.prototype.postInit = function ()
	{
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			this.events[i].postInit(i < len - 1 && this.events[i + 1].is_else_block);
		}
	};
	EventSheet.prototype.run = function (from_include)
	{
		if (!this.runtime.resuming_breakpoint)
		{
			this.hasRun = true;
			if (!from_include)
				this.runtime.isRunningEvents = true;
		}
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			var ev = this.events[i];
			ev.run();
				this.runtime.clearSol(ev.solModifiers);
				if (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length)
					this.runtime.ClearDeathRow();
		}
			if (!from_include)
				this.runtime.isRunningEvents = false;
	};
	EventSheet.prototype.init_trigger = function (trig, index)
	{
		if (!trig.orblock)
			this.runtime.triggers_to_postinit.push(trig);	// needs to be postInit'd later
		var i, len;
		var cnd = trig.conditions[index];
		var type_name;
		if (cnd.type)
			type_name = cnd.type.name;
		else
			type_name = "system";
		var fasttrigger = cnd.fasttrigger;
		var triggers = (fasttrigger ? this.fasttriggers : this.triggers);
		if (!triggers[type_name])
			triggers[type_name] = [];
		var obj_entry = triggers[type_name];
		var method = cnd.func;
		if (fasttrigger)
		{
			if (!cnd.parameters.length)				// no parameters
				return;
			var firstparam = cnd.parameters[0];
			if (firstparam.type !== 1 ||			// not a string param
				firstparam.expression.type !== 2)	// not a string literal node
			{
				return;
			}
			var fastevs;
			var firstvalue = firstparam.expression.value.toLowerCase();
			var i, len;
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					fastevs = obj_entry[i].evs;
					if (!fastevs[firstvalue])
						fastevs[firstvalue] = [[trig, index]];
					else
						fastevs[firstvalue].push([trig, index]);
					return;
				}
			}
			fastevs = {};
			fastevs[firstvalue] = [[trig, index]];
			obj_entry.push({ method: method, evs: fastevs });
		}
		else
		{
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					obj_entry[i].evs.push([trig, index]);
					return;
				}
			}
			obj_entry.push({ method: method, evs: [[trig, index]]});
		}
	};
	cr.eventsheet = EventSheet;
	function Selection(type)
	{
		this.type = type;
		this.instances = [];        // subset of picked instances
		this.else_instances = [];	// subset of unpicked instances
		this.select_all = true;
	};
	Selection.prototype.hasObjects = function ()
	{
		if (this.select_all)
			return this.type.instances.length;
		else
			return this.instances.length;
	};
	Selection.prototype.getObjects = function ()
	{
		if (this.select_all)
			return this.type.instances;
		else
			return this.instances;
	};
	/*
	Selection.prototype.ensure_picked = function (inst, skip_siblings)
	{
		var i, len;
		var orblock = inst.runtime.getCurrentEventStack().current_event.orblock;
		if (this.select_all)
		{
			this.select_all = false;
			if (orblock)
			{
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				cr.arrayFindRemove(this.else_instances, inst);
			}
			this.instances.length = 1;
			this.instances[0] = inst;
		}
		else
		{
			if (orblock)
			{
				i = this.else_instances.indexOf(inst);
				if (i !== -1)
				{
					this.instances.push(this.else_instances[i]);
					this.else_instances.splice(i, 1);
				}
			}
			else
			{
				if (this.instances.indexOf(inst) === -1)
					this.instances.push(inst);
			}
		}
		if (!skip_siblings)
		{
		}
	};
	*/
	Selection.prototype.pick_one = function (inst)
	{
		if (!inst)
			return;
		if (inst.runtime.getCurrentEventStack().current_event.orblock)
		{
			if (this.select_all)
			{
				this.instances.length = 0;
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				this.select_all = false;
			}
			var i = this.else_instances.indexOf(inst);
			if (i !== -1)
			{
				this.instances.push(this.else_instances[i]);
				this.else_instances.splice(i, 1);
			}
		}
		else
		{
			this.select_all = false;
			this.instances.length = 1;
			this.instances[0] = inst;
		}
	};
	cr.selection = Selection;
	function EventBlock(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.solModifiersIncludingParents = [];
		this.solWriterAfterCnds = false;	// block does not change SOL after running its conditions
		this.group = false;					// is group of events
		this.initially_activated = false;	// if a group, is active on startup
		this.toplevelevent = false;			// is an event block parented only by a top-level group
		this.toplevelgroup = false;			// is parented only by other groups or is top-level (i.e. not in a subevent)
		this.has_else_block = false;		// is followed by else
;
		this.conditions = [];
		this.actions = [];
		this.subevents = [];
        if (m[1])
        {
			this.group_name = m[1][1].toLowerCase();
			this.group = true;
			this.initially_activated = !!m[1][0];
			this.runtime.allGroups.push(this);
            this.runtime.activeGroups[(/*this.sheet.name + "|" + */this.group_name).toLowerCase()] = this.initially_activated;
        }
		else
		{
			this.group_name = "";
			this.group = false;
			this.initially_activated = false;
		}
		this.orblock = m[2];
		this.sid = m[4];
		if (!this.group)
			this.runtime.blocksBySid[this.sid.toString()] = this;
		var i, len;
		var cm = m[5];
		for (i = 0, len = cm.length; i < len; i++)
		{
			var cnd = new cr.condition(this, cm[i]);
			cnd.index = i;
			cr.seal(cnd);
			this.conditions.push(cnd);
			/*
			if (cnd.is_logical())
				this.is_logical = true;
			if (cnd.type && !cnd.type.plugin.singleglobal && this.cndReferences.indexOf(cnd.type) === -1)
				this.cndReferences.push(cnd.type);
			*/
			this.addSolModifier(cnd.type);
		}
		var am = m[6];
		for (i = 0, len = am.length; i < len; i++)
		{
			var act = new cr.action(this, am[i]);
			act.index = i;
			cr.seal(act);
			this.actions.push(act);
		}
		if (m.length === 8)
		{
			var em = m[7];
			for (i = 0, len = em.length; i < len; i++)
				this.sheet.init_event(em[i], this, this.subevents);
		}
		this.is_else_block = false;
		if (this.conditions.length)
		{
			this.is_else_block = (this.conditions[0].type == null && this.conditions[0].func == cr.system_object.prototype.cnds.Else);
		}
	};
	window["_c2hh_"] = "2CB0FC228CED31A04553643400D1CBEDB0718555";
	EventBlock.prototype.postInit = function (hasElse/*, prevBlock_*/)
	{
		var i, len;
		var p = this.parent;
		if (this.group)
		{
			this.toplevelgroup = true;
			while (p)
			{
				if (!p.group)
				{
					this.toplevelgroup = false;
					break;
				}
				p = p.parent;
			}
		}
		this.toplevelevent = !this.is_trigger() && (!this.parent || (this.parent.group && this.parent.toplevelgroup));
		this.has_else_block = !!hasElse;
		this.solModifiersIncludingParents = this.solModifiers.slice(0);
		p = this.parent;
		while (p)
		{
			for (i = 0, len = p.solModifiers.length; i < len; i++)
				this.addParentSolModifier(p.solModifiers[i]);
			p = p.parent;
		}
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		this.solModifiersIncludingParents = findMatchingSolModifier(this.solModifiersIncludingParents);
		var i, len/*, s*/;
		for (i = 0, len = this.conditions.length; i < len; i++)
			this.conditions[i].postInit();
		for (i = 0, len = this.actions.length; i < len; i++)
			this.actions[i].postInit();
		for (i = 0, len = this.subevents.length; i < len; i++)
		{
			this.subevents[i].postInit(i < len - 1 && this.subevents[i + 1].is_else_block);
		}
		/*
		if (this.is_else_block && this.prev_block)
		{
			for (i = 0, len = this.prev_block.solModifiers.length; i < len; i++)
			{
				s = this.prev_block.solModifiers[i];
				if (this.solModifiers.indexOf(s) === -1)
					this.solModifiers.push(s);
			}
		}
		*/
	}
	function addSolModifierToList(type, arr)
	{
		var i, len, t;
		if (!type)
			return;
		if (arr.indexOf(type) === -1)
			arr.push(type);
		if (type.is_contained)
		{
			for (i = 0, len = type.container.length; i < len; i++)
			{
				t = type.container[i];
				if (type === t)
					continue;		// already handled
				if (arr.indexOf(t) === -1)
					arr.push(t);
			}
		}
	};
	EventBlock.prototype.addSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiers);
	};
	EventBlock.prototype.addParentSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiersIncludingParents);
	};
	EventBlock.prototype.setSolWriterAfterCnds = function ()
	{
		this.solWriterAfterCnds = true;
		if (this.parent)
			this.parent.setSolWriterAfterCnds();
	};
	EventBlock.prototype.is_trigger = function ()
	{
		if (!this.conditions.length)    // no conditions
			return false;
		else
			return this.conditions[0].trigger;
	};
	EventBlock.prototype.run = function ()
	{
		var i, len, any_true = false, cnd_result;
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
			if (!this.is_else_block)
				evinfo.else_branch_ran = false;
		if (this.orblock)
		{
			if (this.conditions.length === 0)
				any_true = true;		// be sure to run if empty block
				evinfo.cndindex = 0
			for (len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (this.conditions[evinfo.cndindex].trigger)		// skip triggers when running OR block
					continue;
				cnd_result = this.conditions[evinfo.cndindex].run();
				if (cnd_result)			// make sure all conditions run and run if any were true
					any_true = true;
			}
			evinfo.last_event_true = any_true;
			if (any_true)
				this.run_actions_and_subevents();
		}
		else
		{
				evinfo.cndindex = 0
			for (len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				cnd_result = this.conditions[evinfo.cndindex].run();
				if (!cnd_result)    // condition failed
				{
					evinfo.last_event_true = false;
					if (this.toplevelevent && (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length))
						this.runtime.ClearDeathRow();
					return;		// bail out now
				}
			}
			evinfo.last_event_true = true;
			this.run_actions_and_subevents();
		}
		this.end_run(evinfo);
	};
	EventBlock.prototype.end_run = function (evinfo)
	{
		if (evinfo.last_event_true && this.has_else_block)
			evinfo.else_branch_ran = true;
		if (this.toplevelevent && (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length))
			this.runtime.ClearDeathRow();
	};
	EventBlock.prototype.run_orblocktrigger = function (index)
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		if (this.conditions[index].run())
		{
			this.run_actions_and_subevents();
			this.runtime.getCurrentEventStack().last_event_true = true;
		}
	};
	EventBlock.prototype.run_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (evinfo.actindex = 0, len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.resume_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.run_subevents = function ()
	{
		if (!this.subevents.length)
			return;
		var i, len, subev, pushpop/*, skipped_pop = false, pop_modifiers = null*/;
		var last = this.subevents.length - 1;
			this.runtime.pushEventStack(this);
		if (this.solWriterAfterCnds)
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				subev = this.subevents[i];
					pushpop = (!this.toplevelgroup || (!this.group && i < last));
					if (pushpop)
						this.runtime.pushCopySol(subev.solModifiers);
				subev.run();
					if (pushpop)
						this.runtime.popSol(subev.solModifiers);
					else
						this.runtime.clearSol(subev.solModifiers);
			}
		}
		else
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				this.subevents[i].run();
			}
		}
			this.runtime.popEventStack();
	};
	EventBlock.prototype.run_pretrigger = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var any_true = false;
		var i, len;
		for (evinfo.cndindex = 0, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
		{
;
			if (this.conditions[evinfo.cndindex].run())
				any_true = true;
			else if (!this.orblock)			// condition failed (let OR blocks run all conditions anyway)
				return false;               // bail out
		}
		return this.orblock ? any_true : true;
	};
	EventBlock.prototype.retrigger = function ()
	{
		this.runtime.execcount++;
		var prevcndindex = this.runtime.getCurrentEventStack().cndindex;
		var len;
		var evinfo = this.runtime.pushEventStack(this);
		if (!this.orblock)
		{
			for (evinfo.cndindex = prevcndindex + 1, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (!this.conditions[evinfo.cndindex].run())    // condition failed
				{
					this.runtime.popEventStack();               // moving up level of recursion
					return false;                               // bail out
				}
			}
		}
		this.run_actions_and_subevents();
		this.runtime.popEventStack();
		return true;		// ran an iteration
	};
	EventBlock.prototype.isFirstConditionOfType = function (cnd)
	{
		var cndindex = cnd.index;
		if (cndindex === 0)
			return true;
		--cndindex;
		for ( ; cndindex >= 0; --cndindex)
		{
			if (this.conditions[cndindex].type === cnd.type)
				return false;
		}
		return true;
	};
	cr.eventblock = EventBlock;
	function Condition(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.func = m[1];
;
		this.trigger = (m[3] > 0);
		this.fasttrigger = (m[3] === 2);
		this.looping = m[4];
		this.inverted = m[5];
		this.isstatic = m[6];
		this.sid = m[7];
		this.runtime.cndsBySid[this.sid.toString()] = this;
		if (m[0] === -1)		// system object
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			if (this.isstatic)
				this.run = this.run_static;
			else
				this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
			if (this.block.parent)
				this.block.parent.setSolWriterAfterCnds();
		}
		if (this.fasttrigger)
			this.run = this.run_true;
		if (m.length === 10)
		{
			var i, len;
			var em = m[9];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Condition.prototype.postInit = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.parameters[i].postInit();
	};
	/*
	Condition.prototype.is_logical = function ()
	{
		return !this.type || this.type.plugin.singleglobal;
	};
	*/
	Condition.prototype.run_true = function ()
	{
		return true;
	};
	Condition.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return cr.xor(this.func.apply(this.runtime.system, this.results), this.inverted);
	};
	Condition.prototype.run_static = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get(i);
		var ret = this.func.apply(this.behaviortype ? this.behaviortype : this.type, this.results);
		this.type.applySolToContainer();
		return ret;
	};
	Condition.prototype.run_object = function ()
	{
		var i, j, leni, lenj, ret, met, inst, s, sol2;
		var sol = this.type.getCurrentSol();
		var is_orblock = this.block.orblock && !this.trigger;		// triggers in OR blocks need to work normally
		var offset = 0;
		var is_contained = this.type.is_contained;
		if (sol.select_all) {
			sol.instances.length = 0;       // clear contents
			sol.else_instances.length = 0;
			for (i = 0, leni = this.type.instances.length; i < leni; i++)
			{
				inst = this.type.instances[i];
;
				for (j = 0, lenj = this.parameters.length; j < lenj; j++)
					this.results[j] = this.parameters[j].get(i);        // default SOL index is current object
				if (this.beh_index > -1)
				{
					if (this.type.is_family)
					{
						offset = inst.type.family_beh_map[this.type.family_index];
					}
					ret = this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
				}
				else
					ret = this.func.apply(inst, this.results);
				met = cr.xor(ret, this.inverted);
				if (met)
					sol.instances.push(inst);
				else if (is_orblock)					// in OR blocks, keep the instances not meeting the condition for subsequent testing
					sol.else_instances.push(inst);
			}
			if (this.type.finish)
				this.type.finish(true);
			sol.select_all = false;
			this.type.applySolToContainer();
			return sol.hasObjects();
		}
		else {
			var k = 0;
			var using_else_instances = (is_orblock && !this.block.isFirstConditionOfType(this));
			var arr = (using_else_instances ? sol.else_instances : sol.instances);
			var any_true = false;
			for (i = 0, leni = arr.length; i < leni; i++)
			{
				inst = arr[i];
;
				for (j = 0, lenj = this.parameters.length; j < lenj; j++)
					this.results[j] = this.parameters[j].get(i);        // default SOL index is current object
				if (this.beh_index > -1)
				{
					if (this.type.is_family)
					{
						offset = inst.type.family_beh_map[this.type.family_index];
					}
					ret = this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
				}
				else
					ret = this.func.apply(inst, this.results);
				if (cr.xor(ret, this.inverted))
				{
					any_true = true;
					if (using_else_instances)
					{
						sol.instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances.push(s);
							}
						}
					}
					else
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances[k] = s;
							}
						}
						k++;
					}
				}
				else
				{
					if (using_else_instances)
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances[k] = s;
							}
						}
						k++;
					}
					else if (is_orblock)
					{
						sol.else_instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances.push(s);
							}
						}
					}
				}
			}
			arr.length = k;
			if (is_contained)
			{
				for (i = 0, leni = this.type.container.length; i < leni; i++)
				{
					sol2 = this.type.container[i].getCurrentSol();
					if (using_else_instances)
						sol2.else_instances.length = k;
					else
						sol2.instances.length = k;
				}
			}
			var pick_in_finish = any_true;		// don't pick in finish() if we're only doing the logic test below
			if (using_else_instances && !any_true)
			{
				for (i = 0, leni = sol.instances.length; i < leni; i++)
				{
					inst = sol.instances[i];
					for (j = 0, lenj = this.parameters.length; j < lenj; j++)
						this.results[j] = this.parameters[j].get(i);
					if (this.beh_index > -1)
						ret = this.func.apply(inst.behavior_insts[this.beh_index], this.results);
					else
						ret = this.func.apply(inst, this.results);
					if (cr.xor(ret, this.inverted))
					{
						any_true = true;
						break;		// got our flag, don't need to test any more
					}
				}
			}
			if (this.type.finish)
				this.type.finish(pick_in_finish || is_orblock);
			return is_orblock ? any_true : sol.hasObjects();
		}
	};
	cr.condition = Condition;
	function Action(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.func = m[1];
;
		if (m[0] === -1)	// system
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
		}
		this.sid = m[3];
		this.runtime.actsBySid[this.sid.toString()] = this;
		if (m.length === 6)
		{
			var i, len;
			var em = m[5];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Action.prototype.postInit = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.parameters[i].postInit();
	};
	Action.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return this.func.apply(this.runtime.system, this.results);
	};
	Action.prototype.run_object = function ()
	{
		var instances = this.type.getCurrentSol().getObjects();
		var i, j, leni, lenj, inst;
		for (i = 0, leni = instances.length; i < leni; i++)
		{
			inst = instances[i];
			for (j = 0, lenj = this.parameters.length; j < lenj; j++)
				this.results[j] = this.parameters[j].get(i);    // pass i to use as default SOL index
			if (this.beh_index > -1)
			{
				var offset = 0;
				if (this.type.is_family)
				{
					offset = inst.type.family_beh_map[this.type.family_index];
				}
				this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
			}
			else
				this.func.apply(inst, this.results);
		}
		return false;
	};
	cr.action = Action;
	var tempValues = [];
	var tempValuesPtr = -1;
	function Parameter(owner, m)
	{
		this.owner = owner;
		this.block = owner.block;
		this.sheet = owner.sheet;
		this.runtime = owner.runtime;
		this.type = m[0];
		this.expression = null;
		this.solindex = 0;
		this.combosel = 0;
		this.layout = null;
		this.key = 0;
		this.object = null;
		this.index = 0;
		this.varname = null;
		this.eventvar = null;
		this.fileinfo = null;
		this.subparams = null;
		this.variadicret = null;
		var i, len, param;
		switch (m[0])
		{
			case 0:		// number
			case 7:		// any
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp;
				break;
			case 1:		// string
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp_str;
				break;
			case 5:		// layer
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_layer;
				break;
			case 3:		// combo
			case 8:		// cmp
				this.combosel = m[1];
				this.get = this.get_combosel;
				break;
			case 6:		// layout
				this.layout = this.runtime.layouts[m[1]];
;
				this.get = this.get_layout;
				break;
			case 9:		// keyb
				this.key = m[1];
				this.get = this.get_key;
				break;
			case 4:		// object
				this.object = this.runtime.types_by_index[m[1]];
;
				this.get = this.get_object;
				this.block.addSolModifier(this.object);
				if (this.owner instanceof cr.action)
					this.block.setSolWriterAfterCnds();
				else if (this.block.parent)
					this.block.parent.setSolWriterAfterCnds();
				break;
			case 10:	// instvar
				this.index = m[1];
				if (owner.type.is_family)
					this.get = this.get_familyvar;
				else
					this.get = this.get_instvar;
				break;
			case 11:	// eventvar
				this.varname = m[1];
				this.eventvar = null;
				this.get = this.get_eventvar;
				break;
			case 2:		// audiofile	["name", ismusic]
			case 12:	// fileinfo		"name"
				this.fileinfo = m[1];
				this.get = this.get_audiofile;
				break;
			case 13:	// variadic
				this.get = this.get_variadic;
				this.subparams = [];
				this.variadicret = [];
				for (i = 1, len = m.length; i < len; i++)
				{
					param = new cr.parameter(this.owner, m[i]);
					cr.seal(param);
					this.subparams.push(param);
					this.variadicret.push(0);
				}
				break;
			default:
;
		}
	};
	Parameter.prototype.postInit = function ()
	{
		var i, len;
		if (this.type === 11)		// eventvar
		{
			this.eventvar = this.runtime.getEventVariableByName(this.varname, this.block.parent);
;
		}
		else if (this.type === 13)	// variadic, postInit all sub-params
		{
			for (i = 0, len = this.subparams.length; i < len; i++)
				this.subparams[i].postInit();
		}
		if (this.expression)
			this.expression.postInit();
	};
	Parameter.prototype.pushTempValue = function ()
	{
		tempValuesPtr++;
		if (tempValues.length === tempValuesPtr)
			tempValues.push(new cr.expvalue());
		return tempValues[tempValuesPtr];
	};
	Parameter.prototype.popTempValue = function ()
	{
		tempValuesPtr--;
	};
	Parameter.prototype.get_exp = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		return temp.data;      			// return actual JS value, not expvalue
	};
	Parameter.prototype.get_exp_str = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (cr.is_string(temp.data))
			return temp.data;
		else
			return "";
	};
	Parameter.prototype.get_object = function ()
	{
		return this.object;
	};
	Parameter.prototype.get_combosel = function ()
	{
		return this.combosel;
	};
	Parameter.prototype.get_layer = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (temp.is_number())
			return this.runtime.getLayerByNumber(temp.data);
		else
			return this.runtime.getLayerByName(temp.data);
	}
	Parameter.prototype.get_layout = function ()
	{
		return this.layout;
	};
	Parameter.prototype.get_key = function ()
	{
		return this.key;
	};
	Parameter.prototype.get_instvar = function ()
	{
		return this.index;
	};
	Parameter.prototype.get_familyvar = function (solindex)
	{
		var familytype = this.owner.type;
		var realtype = null;
		var sol = familytype.getCurrentSol();
		var objs = sol.getObjects();
		if (objs.length)
			realtype = objs[solindex % objs.length].type;
		else
		{
;
			realtype = sol.else_instances[solindex % sol.else_instances.length].type;
		}
		return this.index + realtype.family_var_map[familytype.family_index];
	};
	Parameter.prototype.get_eventvar = function ()
	{
		return this.eventvar;
	};
	Parameter.prototype.get_audiofile = function ()
	{
		return this.fileinfo;
	};
	Parameter.prototype.get_variadic = function ()
	{
		var i, len;
		for (i = 0, len = this.subparams.length; i < len; i++)
		{
			this.variadicret[i] = this.subparams[i].get();
		}
		return this.variadicret;
	};
	cr.parameter = Parameter;
	function EventVariable(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.name = m[1];
		this.vartype = m[2];
		this.initial = m[3];
		this.is_static = !!m[4];
		this.is_constant = !!m[5];
		this.sid = m[6];
		this.runtime.varsBySid[this.sid.toString()] = this;
		this.data = this.initial;	// note: also stored in event stack frame for local nonstatic nonconst vars
		if (this.parent)			// local var
		{
			if (this.is_static || this.is_constant)
				this.localIndex = -1;
			else
				this.localIndex = this.runtime.stackLocalCount++;
			this.runtime.all_local_vars.push(this);
		}
		else						// global var
		{
			this.localIndex = -1;
			this.runtime.all_global_vars.push(this);
		}
	};
	EventVariable.prototype.postInit = function ()
	{
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
	};
	EventVariable.prototype.setValue = function (x)
	{
;
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs)
			this.data = x;
		else	// local nonstatic variable: use event stack to keep value at this level of recursion
		{
			if (this.localIndex >= lvs.length)
				lvs.length = this.localIndex + 1;
			lvs[this.localIndex] = x;
		}
	};
	EventVariable.prototype.getValue = function ()
	{
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs || this.is_constant)
			return this.data;
		else	// local nonstatic variable
		{
			if (this.localIndex >= lvs.length)
			{
;
				return this.initial;
			}
			if (typeof lvs[this.localIndex] === "undefined")
			{
;
				return this.initial;
			}
			return lvs[this.localIndex];
		}
	};
	EventVariable.prototype.run = function ()
	{
			if (this.parent && !this.is_static && !this.is_constant)
				this.setValue(this.initial);
	};
	cr.eventvariable = EventVariable;
	function EventInclude(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.include_sheet = null;		// determined in postInit
		this.include_sheet_name = m[1];
	};
	EventInclude.prototype.toString = function ()
	{
		return "include:" + this.include_sheet.toString();
	};
	EventInclude.prototype.postInit = function ()
	{
        this.include_sheet = this.runtime.eventsheets[this.include_sheet_name];
;
;
        this.sheet.includes.add(this);
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
	};
	EventInclude.prototype.run = function ()
	{
			if (this.parent)
				this.runtime.pushCleanSol(this.runtime.types_by_index);
        if (!this.include_sheet.hasRun)
            this.include_sheet.run(true);			// from include
			if (this.parent)
				this.runtime.popSol(this.runtime.types_by_index);
	};
	EventInclude.prototype.isActive = function ()
	{
		var p = this.parent;
		while (p)
		{
			if (p.group)
			{
				if (!this.runtime.activeGroups[p.group_name.toLowerCase()])
					return false;
			}
			p = p.parent;
		}
		return true;
	};
	cr.eventinclude = EventInclude;
	function EventStackFrame()
	{
		this.temp_parents_arr = [];
		this.reset(null);
		cr.seal(this);
	};
	EventStackFrame.prototype.reset = function (cur_event)
	{
		this.current_event = cur_event;
		this.cndindex = 0;
		this.actindex = 0;
		this.temp_parents_arr.length = 0;
		this.last_event_true = false;
		this.else_branch_ran = false;
		this.any_true_state = false;
	};
	EventStackFrame.prototype.isModifierAfterCnds = function ()
	{
		if (this.current_event.solWriterAfterCnds)
			return true;
		if (this.cndindex < this.current_event.conditions.length - 1)
			return !!this.current_event.solModifiers.length;
		return false;
	};
	cr.eventStackFrame = EventStackFrame;
}());
(function()
{
	function ExpNode(owner_, m)
	{
		this.owner = owner_;
		this.runtime = owner_.runtime;
		this.type = m[0];
;
		this.get = [this.eval_int,
					this.eval_float,
					this.eval_string,
					this.eval_unaryminus,
					this.eval_add,
					this.eval_subtract,
					this.eval_multiply,
					this.eval_divide,
					this.eval_mod,
					this.eval_power,
					this.eval_and,
					this.eval_or,
					this.eval_equal,
					this.eval_notequal,
					this.eval_less,
					this.eval_lessequal,
					this.eval_greater,
					this.eval_greaterequal,
					this.eval_conditional,
					this.eval_system_exp,
					this.eval_object_behavior_exp,
					this.eval_instvar_exp,
					this.eval_object_behavior_exp,
					this.eval_eventvar_exp][this.type];
		var paramsModel = null;
		this.value = null;
		this.first = null;
		this.second = null;
		this.third = null;
		this.func = null;
		this.results = null;
		this.parameters = null;
		this.object_type = null;
		this.beh_index = -1;
		this.instance_expr = null;
		this.varindex = -1;
		this.behavior_type = null;
		this.varname = null;
		this.eventvar = null;
		this.return_string = false;
		switch (this.type) {
		case 0:		// int
		case 1:		// float
		case 2:		// string
			this.value = m[1];
			break;
		case 3:		// unaryminus
			this.first = new cr.expNode(owner_, m[1]);
			break;
		case 18:	// conditional
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
			this.third = new cr.expNode(owner_, m[3]);
			break;
		case 19:	// system_exp
			this.func = m[1];
;
			this.results = [];
			this.parameters = [];
			if (m.length === 3)
			{
				paramsModel = m[2];
				this.results.length = paramsModel.length + 1;	// must also fit 'ret'
			}
			else
				this.results.length = 1;      // to fit 'ret'
			break;
		case 20:	// object_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.beh_index = -1;
			this.func = m[2];
			this.return_string = m[3];
			if (m[4])
				this.instance_expr = new cr.expNode(owner_, m[4]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 6)
			{
				paramsModel = m[5];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 21:		// instvar_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.return_string = m[2];
			if (m[3])
				this.instance_expr = new cr.expNode(owner_, m[3]);
			else
				this.instance_expr = null;
			this.varindex = m[4];
			break;
		case 22:		// behavior_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.behavior_type = this.object_type.getBehaviorByName(m[2]);
;
			this.beh_index = this.object_type.getBehaviorIndexByName(m[2]);
			this.func = m[3];
			this.return_string = m[4];
			if (m[5])
				this.instance_expr = new cr.expNode(owner_, m[5]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 7)
			{
				paramsModel = m[6];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 23:		// eventvar_exp
			this.varname = m[1];
			this.eventvar = null;	// assigned in postInit
			break;
		}
		if (this.type >= 4 && this.type <= 17)
		{
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
		}
		if (paramsModel)
		{
			var i, len;
			for (i = 0, len = paramsModel.length; i < len; i++)
				this.parameters.push(new cr.expNode(owner_, paramsModel[i]));
		}
		cr.seal(this);
	};
	ExpNode.prototype.postInit = function ()
	{
		if (this.type === 23)	// eventvar_exp
		{
			this.eventvar = this.owner.runtime.getEventVariableByName(this.varname, this.owner.block.parent);
;
		}
		if (this.first)
			this.first.postInit();
		if (this.second)
			this.second.postInit();
		if (this.third)
			this.third.postInit();
		if (this.instance_expr)
			this.instance_expr.postInit();
		if (this.parameters)
		{
			var i, len;
			for (i = 0, len = this.parameters.length; i < len; i++)
				this.parameters[i].postInit();
		}
	};
	ExpNode.prototype.eval_system_exp = function (ret)
	{
		this.results[0] = ret;
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		this.owner.popTempValue();
		this.func.apply(this.runtime.system, this.results);
	};
	ExpNode.prototype.eval_object_behavior_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		this.results[0] = ret;
		ret.object_class = this.object_type;		// so expression can access family type if need be
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++) {
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		var index = this.owner.solindex;
		if (this.instance_expr) {
			this.instance_expr.get(temp);
			if (temp.is_number()) {
				index = temp.data;
				instances = this.object_type.instances;    // pick from all instances, not SOL
			}
		}
		this.owner.popTempValue();
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var returned_val;
		var inst = instances[index];
		if (this.beh_index > -1)
		{
			var offset = 0;
			if (this.object_type.is_family)
			{
				offset = inst.type.family_beh_map[this.object_type.family_index];
			}
			returned_val = this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
		}
		else
			returned_val = this.func.apply(inst, this.results);
;
	};
	ExpNode.prototype.eval_instvar_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		var index = this.owner.solindex;
		if (this.instance_expr)
		{
			var temp = this.owner.pushTempValue();
			this.instance_expr.get(temp);
			if (temp.is_number())
			{
				index = temp.data;
				var type_instances = this.object_type.instances;
				index %= type_instances.length;     // wraparound
				if (index < 0)                      // offset
					index += type_instances.length;
				var to_ret = type_instances[index].instance_vars[this.varindex];
				if (cr.is_string(to_ret))
					ret.set_string(to_ret);
				else
					ret.set_float(to_ret);
				this.owner.popTempValue();
				return;         // done
			}
			this.owner.popTempValue();
		}
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var inst = instances[index];
		var offset = 0;
		if (this.object_type.is_family)
		{
			offset = inst.type.family_var_map[this.object_type.family_index];
		}
		var to_ret = inst.instance_vars[this.varindex + offset];
		if (cr.is_string(to_ret))
			ret.set_string(to_ret);
		else
			ret.set_float(to_ret);
	};
	ExpNode.prototype.eval_int = function (ret)
	{
		ret.type = cr.exptype.Integer;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_float = function (ret)
	{
		ret.type = cr.exptype.Float;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_string = function (ret)
	{
		ret.type = cr.exptype.String;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_unaryminus = function (ret)
	{
		this.first.get(ret);                // retrieve operand
		if (ret.is_number())
			ret.data = -ret.data;
	};
	ExpNode.prototype.eval_add = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data += temp.data;          // both operands numbers: add
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_subtract = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data -= temp.data;          // both operands numbers: subtract
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_multiply = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data *= temp.data;          // both operands numbers: multiply
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_divide = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data /= temp.data;          // both operands numbers: divide
			ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_mod = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data %= temp.data;          // both operands numbers: modulo
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_power = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data = Math.pow(ret.data, temp.data);   // both operands numbers: raise to power
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_and = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number())
		{
			if (temp.is_string())
			{
				ret.set_string(ret.data.toString() + temp.data);
			}
			else
			{
				if (ret.data && temp.data)
					ret.set_int(1);
				else
					ret.set_int(0);
			}
		}
		else if (ret.is_string())
		{
			if (temp.is_string())
				ret.data += temp.data;
			else
			{
				ret.data += (Math.round(temp.data * 1e10) / 1e10).toString();
			}
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_or = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			if (ret.data || temp.data)
				ret.set_int(1);
			else
				ret.set_int(0);
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_conditional = function (ret)
	{
		this.first.get(ret);                // condition operand
		if (ret.data)                       // is true
			this.second.get(ret);           // evaluate second operand to ret
		else
			this.third.get(ret);            // evaluate third operand to ret
	};
	ExpNode.prototype.eval_equal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data === temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_notequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data !== temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_less = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data < temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_lessequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data <= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greater = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data > temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greaterequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data >= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_eventvar_exp = function (ret)
	{
		var val = this.eventvar.getValue();
		if (cr.is_number(val))
			ret.set_float(val);
		else
			ret.set_string(val);
	};
	cr.expNode = ExpNode;
	function ExpValue(type, data)
	{
		this.type = type || cr.exptype.Integer;
		this.data = data || 0;
		this.object_class = null;
;
;
;
		if (this.type == cr.exptype.Integer)
			this.data = Math.floor(this.data);
		cr.seal(this);
	};
	ExpValue.prototype.is_int = function ()
	{
		return this.type === cr.exptype.Integer;
	};
	ExpValue.prototype.is_float = function ()
	{
		return this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_number = function ()
	{
		return this.type === cr.exptype.Integer || this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_string = function ()
	{
		return this.type === cr.exptype.String;
	};
	ExpValue.prototype.make_int = function ()
	{
		if (!this.is_int())
		{
			if (this.is_float())
				this.data = Math.floor(this.data);      // truncate float
			else if (this.is_string())
				this.data = parseInt(this.data, 10);
			this.type = cr.exptype.Integer;
		}
	};
	ExpValue.prototype.make_float = function ()
	{
		if (!this.is_float())
		{
			if (this.is_string())
				this.data = parseFloat(this.data);
			this.type = cr.exptype.Float;
		}
	};
	ExpValue.prototype.make_string = function ()
	{
		if (!this.is_string())
		{
			this.data = this.data.toString();
			this.type = cr.exptype.String;
		}
	};
	ExpValue.prototype.set_int = function (val)
	{
;
		this.type = cr.exptype.Integer;
		this.data = Math.floor(val);
	};
	ExpValue.prototype.set_float = function (val)
	{
;
		this.type = cr.exptype.Float;
		this.data = val;
	};
	ExpValue.prototype.set_string = function (val)
	{
;
		this.type = cr.exptype.String;
		this.data = val;
	};
	ExpValue.prototype.set_any = function (val)
	{
		if (cr.is_number(val))
		{
			this.type = cr.exptype.Float;
			this.data = val;
		}
		else if (cr.is_string(val))
		{
			this.type = cr.exptype.String;
			this.data = val.toString();
		}
		else
		{
			this.type = cr.exptype.Integer;
			this.data = 0;
		}
	};
	cr.expvalue = ExpValue;
	cr.exptype = {
		Integer: 0,     // emulated; no native integer support in javascript
		Float: 1,
		String: 2
	};
}());
;
cr.system_object = function (runtime)
{
    this.runtime = runtime;
	this.waits = [];
};
cr.system_object.prototype.saveToJSON = function ()
{
	var o = {};
	var i, len, j, lenj, p, w, t, sobj;
	o["waits"] = [];
	var owaits = o["waits"];
	var waitobj;
	for (i = 0, len = this.waits.length; i < len; i++)
	{
		w = this.waits[i];
		waitobj = {
			"t": w.time,
			"ev": w.ev.sid,
			"sm": [],
			"sols": {}
		};
		if (w.ev.actions[w.actindex])
			waitobj["act"] = w.ev.actions[w.actindex].sid;
		for (j = 0, lenj = w.solModifiers.length; j < lenj; j++)
			waitobj["sm"].push(w.solModifiers[j].sid);
		for (p in w.sols)
		{
			if (w.sols.hasOwnProperty(p))
			{
				t = this.runtime.types_by_index[parseInt(p, 10)];
;
				sobj = {
					"sa": w.sols[p].sa,
					"insts": []
				};
				for (j = 0, lenj = w.sols[p].insts.length; j < lenj; j++)
					sobj["insts"].push(w.sols[p].insts[j].uid);
				waitobj["sols"][t.sid.toString()] = sobj;
			}
		}
		owaits.push(waitobj);
	}
	return o;
};
cr.system_object.prototype.loadFromJSON = function (o)
{
	var owaits = o["waits"];
	var i, len, j, lenj, p, w, addWait, e, aindex, t, savedsol, nusol, inst;
	this.waits.length = 0;
	for (i = 0, len = owaits.length; i < len; i++)
	{
		w = owaits[i];
		e = this.runtime.blocksBySid[w["ev"].toString()];
		if (!e)
			continue;	// event must've gone missing
		aindex = -1;
		for (j = 0, lenj = e.actions.length; j < lenj; j++)
		{
			if (e.actions[j].sid === w["act"])
			{
				aindex = j;
				break;
			}
		}
		if (aindex === -1)
			continue;	// action must've gone missing
		addWait = {};
		addWait.sols = {};
		addWait.solModifiers = [];
		addWait.deleteme = false;
		addWait.time = w["t"];
		addWait.ev = e;
		addWait.actindex = aindex;
		for (j = 0, lenj = w["sm"].length; j < lenj; j++)
		{
			t = this.runtime.getObjectTypeBySid(w["sm"][j]);
			if (t)
				addWait.solModifiers.push(t);
		}
		for (p in w["sols"])
		{
			if (w["sols"].hasOwnProperty(p))
			{
				t = this.runtime.getObjectTypeBySid(parseInt(p, 10));
				if (!t)
					continue;		// type must've been deleted
				savedsol = w["sols"][p];
				nusol = {
					sa: savedsol["sa"],
					insts: []
				};
				for (j = 0, lenj = savedsol["insts"].length; j < lenj; j++)
				{
					inst = this.runtime.getObjectByUID(savedsol["insts"][j]);
					if (inst)
						nusol.insts.push(inst);
				}
				addWait.sols[t.index.toString()] = nusol;
			}
		}
		this.waits.push(addWait);
	}
};
(function ()
{
	var sysProto = cr.system_object.prototype;
	function SysCnds() {};
    SysCnds.prototype.EveryTick = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutStart = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutEnd = function()
    {
        return true;
    };
    SysCnds.prototype.Compare = function(x, cmp, y)
    {
        return cr.do_cmp(x, cmp, y);
    };
    SysCnds.prototype.CompareTime = function (cmp, t)
    {
        var elapsed = this.runtime.kahanTime.sum;
        if (cmp === 0)
        {
            var cnd = this.runtime.getCurrentCondition();
            if (!cnd.extra.CompareTime_executed)
            {
                if (elapsed >= t)
                {
                    cnd.extra.CompareTime_executed = true;
                    return true;
                }
            }
            return false;
        }
        return cr.do_cmp(elapsed, cmp, t);
    };
    SysCnds.prototype.LayerVisible = function (layer)
    {
        if (!layer)
            return false;
        else
            return layer.visible;
    };
	SysCnds.prototype.LayerCmpOpacity = function (layer, cmp, opacity_)
	{
		if (!layer)
			return false;
		return cr.do_cmp(layer.opacity * 100, cmp, opacity_);
	};
    SysCnds.prototype.Repeat = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				current_loop.index = i;
				current_event.retrigger();
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	SysCnds.prototype.While = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				if (!current_event.retrigger())		// one of the other conditions returned false
					current_loop.stopped = true;	// break
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				current_loop.index = i;
				if (!current_event.retrigger())
					current_loop.stopped = true;
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
    SysCnds.prototype.For = function (name, start, end)
    {
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack(name);
        var i;
		if (end < start)
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
		else
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	var foreach_instancestack = [];
	var foreach_instanceptr = -1;
    SysCnds.prototype.ForEach = function (obj)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i, len, j, lenj, inst, s, sol2;
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	function foreach_sortinstances(a, b)
	{
		var va = a.extra.c2_foreachordered_val;
		var vb = b.extra.c2_foreachordered_val;
		if (cr.is_number(va) && cr.is_number(vb))
			return va - vb;
		else
		{
			va = "" + va;
			vb = "" + vb;
			if (va < vb)
				return -1;
			else if (va > vb)
				return 1;
			else
				return 0;
		}
	};
	SysCnds.prototype.ForEachOrdered = function (obj, exp, order)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var current_condition = this.runtime.getCurrentCondition();
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
		var i, len, j, lenj, inst, s, sol2;
		for (i = 0, len = instances.length; i < len; i++)
		{
			instances[i].extra.c2_foreachordered_val = current_condition.parameters[1].get(i);
		}
		instances.sort(foreach_sortinstances);
		if (order === 1)
			instances.reverse();
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	SysCnds.prototype.PickByComparison = function (obj_, exp_, cmp_, val_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			val_ = current_condition.parameters[3].get(i);
			if (cr.do_cmp(exp_, cmp_, val_))
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
	SysCnds.prototype.PickByEvaluate = function (obj_, exp_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			if (exp_)
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
    SysCnds.prototype.TriggerOnce = function ()
    {
        var cndextra = this.runtime.getCurrentCondition().extra;
		if (typeof cndextra.TriggerOnce_lastTick === "undefined")
			cndextra.TriggerOnce_lastTick = -1;
        var last_tick = cndextra.TriggerOnce_lastTick;
        var cur_tick = this.runtime.tickcount;
        cndextra.TriggerOnce_lastTick = cur_tick;
        return this.runtime.layout_first_tick || last_tick !== cur_tick - 1;
    };
    SysCnds.prototype.Every = function (seconds)
    {
        var cnd = this.runtime.getCurrentCondition();
        var last_time = cnd.extra.Every_lastTime || 0;
        var cur_time = this.runtime.kahanTime.sum;
		if (typeof cnd.extra.Every_seconds === "undefined")
			cnd.extra.Every_seconds = seconds;
		var this_seconds = cnd.extra.Every_seconds;
        if (cur_time >= last_time + this_seconds)
        {
            cnd.extra.Every_lastTime = last_time + this_seconds;
			if (cur_time >= cnd.extra.Every_lastTime + 0.04)
			{
				cnd.extra.Every_lastTime = cur_time;
			}
			cnd.extra.Every_seconds = seconds;
            return true;
        }
        else
            return false;
    };
    SysCnds.prototype.PickNth = function (obj, index)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		index = cr.floor(index);
        if (index < 0 || index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.PickRandom = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		var index = cr.floor(Math.random() * instances.length);
        if (index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.CompareVar = function (v, cmp, val)
    {
        return cr.do_cmp(v.getValue(), cmp, val);
    };
    SysCnds.prototype.IsGroupActive = function (group)
    {
        return this.runtime.activeGroups[(/*this.runtime.getCurrentCondition().sheet.name + "|" + */group).toLowerCase()];
    };
	SysCnds.prototype.IsPreview = function ()
	{
		return typeof cr_is_preview !== "undefined";
	};
	SysCnds.prototype.PickAll = function (obj)
    {
        if (!obj)
            return false;
		if (!obj.instances.length)
			return false;
        var sol = obj.getCurrentSol();
        sol.select_all = true;
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.IsMobile = function ()
	{
		return this.runtime.isMobile;
	};
	SysCnds.prototype.CompareBetween = function (x, a, b)
	{
		return x >= a && x <= b;
	};
	SysCnds.prototype.Else = function ()
	{
		var current_frame = this.runtime.getCurrentEventStack();
		if (current_frame.else_branch_ran)
			return false;		// another event in this else-if chain has run
		else
			return !current_frame.last_event_true;
		/*
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var prev_event = current_event.prev_block;
		if (!prev_event)
			return false;
		if (prev_event.is_logical)
			return !this.runtime.last_event_true;
		var i, len, j, lenj, s, sol, temp, inst, any_picked = false;
		for (i = 0, len = prev_event.cndReferences.length; i < len; i++)
		{
			s = prev_event.cndReferences[i];
			sol = s.getCurrentSol();
			if (sol.select_all || sol.instances.length === s.instances.length)
			{
				sol.select_all = false;
				sol.instances.length = 0;
			}
			else
			{
				if (sol.instances.length === 1 && sol.else_instances.length === 0 && s.instances.length >= 2)
				{
					inst = sol.instances[0];
					sol.instances.length = 0;
					for (j = 0, lenj = s.instances.length; j < lenj; j++)
					{
						if (s.instances[j] != inst)
							sol.instances.push(s.instances[j]);
					}
					any_picked = true;
				}
				else
				{
					temp = sol.instances;
					sol.instances = sol.else_instances;
					sol.else_instances = temp;
					any_picked = true;
				}
			}
		}
		return any_picked;
		*/
	};
	SysCnds.prototype.OnLoadFinished = function ()
	{
		return true;
	};
	SysCnds.prototype.OnCanvasSnapshot = function ()
	{
		return true;
	};
	SysCnds.prototype.EffectsSupported = function ()
	{
		return !!this.runtime.glwrap;
	};
	SysCnds.prototype.OnSaveComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadFailed = function ()
	{
		return true;
	};
	SysCnds.prototype.ObjectUIDExists = function (u)
	{
		return !!this.runtime.getObjectByUID(u);
	};
	SysCnds.prototype.IsOnPlatform = function (p)
	{
		var rt = this.runtime;
		switch (p) {
		case 0:		// HTML5 website
			return !rt.isDomFree && !rt.isNodeWebkit && !rt.isPhoneGap && !rt.isCrosswalk && !rt.isWindows8App && !rt.isWindowsPhone8 && !rt.isBlackberry10 && !rt.isAmazonWebApp;
		case 1:		// iOS
			return rt.isiOS;
		case 2:		// Android
			return rt.isAndroid;
		case 3:		// Windows 8
			return rt.isWindows8App;
		case 4:		// Windows Phone 8
			return rt.isWindowsPhone8;
		case 5:		// Blackberry 10
			return rt.isBlackberry10;
		case 6:		// Tizen
			return rt.isTizen;
		case 7:		// CocoonJS
			return rt.isCocoonJs;
		case 8:		// PhoneGap
			return rt.isPhoneGap;
		case 9:	// Scirra Arcade
			return rt.isArcade;
		case 10:	// node-webkit
			return rt.isNodeWebkit;
		case 11:	// crosswalk
			return rt.isCrosswalk;
		case 12:	// amazon webapp
			return rt.isAmazonWebApp;
		default:	// should not be possible
			return false;
		}
	};
	var cacheRegex = null;
	var lastRegex = "";
	var lastFlags = "";
	function getRegex(regex_, flags_)
	{
		if (!cacheRegex || regex_ !== lastRegex || flags_ !== lastFlags)
		{
			cacheRegex = new RegExp(regex_, flags_);
			lastRegex = regex_;
			lastFlags = flags_;
		}
		cacheRegex.lastIndex = 0;		// reset
		return cacheRegex;
	};
	SysCnds.prototype.RegexTest = function (str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		return regex.test(str_);
	};
	var tmp_arr = [];
	SysCnds.prototype.PickOverlappingPoint = function (obj_, x_, y_)
	{
		if (!obj_)
            return false;
        var sol = obj_.getCurrentSol();
        var instances = sol.getObjects();
		var current_event = this.runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		var cnd = this.runtime.getCurrentCondition();
		var i, len, inst, pick;
		if (sol.select_all)
		{
			cr.shallowAssignArray(tmp_arr, instances);
			sol.else_instances.length = 0;
			sol.select_all = false;
			sol.instances.length = 0;
		}
		else
		{
			if (orblock)
			{
				cr.shallowAssignArray(tmp_arr, sol.else_instances);
				sol.else_instances.length = 0;
			}
			else
			{
				cr.shallowAssignArray(tmp_arr, instances);
				sol.instances.length = 0;
			}
		}
		for (i = 0, len = tmp_arr.length; i < len; ++i)
		{
			inst = tmp_arr[i];
			pick = cr.xor(inst.contains_pt(x_, y_), cnd.inverted);
			if (pick)
				sol.instances.push(inst);
			else
				sol.else_instances.push(inst);
		}
		obj_.applySolToContainer();
		return cr.xor(!!sol.instances.length, cnd.inverted);
	};
	sysProto.cnds = new SysCnds();
    function SysActs() {};
    SysActs.prototype.GoToLayout = function(to)
    {
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
        this.runtime.changelayout = to;
    };
    SysActs.prototype.CreateObject = function (obj, layer, x, y)
    {
        if (!layer || !obj)
            return;
        var inst = this.runtime.createInstance(obj, layer, x, y);
		if (!inst)
			return;
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
        var sol = obj.getCurrentSol();
        sol.select_all = false;
		sol.instances.length = 1;
		sol.instances[0] = inst;
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				sol = s.type.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = s;
			}
		}
    };
    SysActs.prototype.SetLayerVisible = function (layer, visible_)
    {
        if (!layer)
            return;
		if (layer.visible !== visible_)
		{
			layer.visible = visible_;
			this.runtime.redraw = true;
		}
    };
	SysActs.prototype.SetLayerOpacity = function (layer, opacity_)
	{
		if (!layer)
			return;
		opacity_ = cr.clamp(opacity_ / 100, 0, 1);
		if (layer.opacity !== opacity_)
		{
			layer.opacity = opacity_;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayerScaleRate = function (layer, sr)
	{
		if (!layer)
			return;
		if (layer.zoomRate !== sr)
		{
			layer.zoomRate = sr;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayoutScale = function (s)
	{
		if (!this.runtime.running_layout)
			return;
		if (this.runtime.running_layout.scale !== s)
		{
			this.runtime.running_layout.scale = s;
			this.runtime.running_layout.boundScrolling();
			this.runtime.redraw = true;
		}
	};
    SysActs.prototype.ScrollX = function(x)
    {
        this.runtime.running_layout.scrollToX(x);
    };
    SysActs.prototype.ScrollY = function(y)
    {
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.Scroll = function(x, y)
    {
        this.runtime.running_layout.scrollToX(x);
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.ScrollToObject = function(obj)
    {
        var inst = obj.getFirstPicked();
        if (inst)
        {
            this.runtime.running_layout.scrollToX(inst.x);
            this.runtime.running_layout.scrollToY(inst.y);
        }
    };
	SysActs.prototype.SetVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(x);
			else
				v.setValue(parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(x.toString());
	};
	SysActs.prototype.AddVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() + x);
			else
				v.setValue(v.getValue() + parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(v.getValue() + x.toString());
	};
	SysActs.prototype.SubVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() - x);
			else
				v.setValue(v.getValue() - parseFloat(x));
		}
	};
    SysActs.prototype.SetGroupActive = function (group, active)
    {
		var activeGroups = this.runtime.activeGroups;
		var groupkey = (/*this.runtime.getCurrentAction().sheet.name + "|" + */group).toLowerCase();
		switch (active) {
		case 0:
			activeGroups[groupkey] = false;
			break;
		case 1:
			activeGroups[groupkey] = true;
			break;
		case 2:
			activeGroups[groupkey] = !activeGroups[groupkey];
			break;
		}
    };
    SysActs.prototype.SetTimescale = function (ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        this.runtime.timescale = ts;
    };
    SysActs.prototype.SetObjectTimescale = function (obj, ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        if (!obj)
            return;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = ts;
        }
    };
    SysActs.prototype.RestoreObjectTimescale = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = -1.0;
        }
    };
	var waitobjrecycle = [];
	function allocWaitObject()
	{
		var w;
		if (waitobjrecycle.length)
			w = waitobjrecycle.pop();
		else
		{
			w = {};
			w.sols = {};
			w.solModifiers = [];
		}
		w.deleteme = false;
		return w;
	};
	function freeWaitObject(w)
	{
		cr.wipe(w.sols);
		w.solModifiers.length = 0;
		waitobjrecycle.push(w);
	};
	var solstateobjects = [];
	function allocSolStateObject()
	{
		var s;
		if (solstateobjects.length)
			s = solstateobjects.pop();
		else
		{
			s = {};
			s.insts = [];
		}
		s.sa = false;
		return s;
	};
	function freeSolStateObject(s)
	{
		s.insts.length = 0;
		solstateobjects.push(s);
	};
	SysActs.prototype.Wait = function (seconds)
	{
		if (seconds < 0)
			return;
		var i, len, s, t, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		var waitobj = allocWaitObject();
		waitobj.time = this.runtime.kahanTime.sum + seconds;
		waitobj.ev = evinfo.current_event;
		waitobj.actindex = evinfo.actindex + 1;	// pointing at next action
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			t = this.runtime.types_by_index[i];
			s = t.getCurrentSol();
			if (s.select_all && evinfo.current_event.solModifiers.indexOf(t) === -1)
				continue;
			waitobj.solModifiers.push(t);
			ss = allocSolStateObject();
			ss.sa = s.select_all;
			cr.shallowAssignArray(ss.insts, s.instances);
			waitobj.sols[i.toString()] = ss;
		}
		this.waits.push(waitobj);
		return true;
	};
	SysActs.prototype.SetLayerScale = function (layer, scale)
    {
        if (!layer)
            return;
		if (layer.scale === scale)
			return;
        layer.scale = scale;
        this.runtime.redraw = true;
    };
	SysActs.prototype.ResetGlobals = function ()
	{
		var i, len, g;
		for (i = 0, len = this.runtime.all_global_vars.length; i < len; i++)
		{
			g = this.runtime.all_global_vars[i];
			g.data = g.initial;
		}
	};
	SysActs.prototype.SetLayoutAngle = function (a)
	{
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (this.runtime.running_layout)
		{
			if (this.runtime.running_layout.angle !== a)
			{
				this.runtime.running_layout.angle = a;
				this.runtime.redraw = true;
			}
		}
	};
	SysActs.prototype.SetLayerAngle = function (layer, a)
    {
        if (!layer)
            return;
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (layer.angle === a)
			return;
        layer.angle = a;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerParallax = function (layer, px, py)
    {
        if (!layer)
            return;
		if (layer.parallaxX === px / 100 && layer.parallaxY === py / 100)
			return;
        layer.parallaxX = px / 100;
		layer.parallaxY = py / 100;
		if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
		{
			var i, len, instances = layer.instances;
			for (i = 0, len = instances.length; i < len; ++i)
			{
				instances[i].type.any_instance_parallaxed = true;
			}
		}
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerBackground = function (layer, c)
    {
        if (!layer)
            return;
		var r = cr.GetRValue(c);
		var g = cr.GetGValue(c);
		var b = cr.GetBValue(c);
		if (layer.background_color[0] === r && layer.background_color[1] === g && layer.background_color[2] === b)
			return;
        layer.background_color[0] = r;
		layer.background_color[1] = g;
		layer.background_color[2] = b;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerTransparent = function (layer, t)
    {
        if (!layer)
            return;
		if (!!t === !!layer.transparent)
			return;
		layer.transparent = !!t;
        this.runtime.redraw = true;
    };
	SysActs.prototype.StopLoop = function ()
	{
		if (this.runtime.loop_stack_index < 0)
			return;		// no loop currently running
		this.runtime.getCurrentLoop().stopped = true;
	};
	SysActs.prototype.GoToLayoutByName = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to different layout
;
		var l;
		for (l in this.runtime.layouts)
		{
			if (this.runtime.layouts.hasOwnProperty(l) && cr.equals_nocase(l, layoutname))
			{
				this.runtime.changelayout = this.runtime.layouts[l];
				return;
			}
		}
	};
	SysActs.prototype.RestartLayout = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot restart loader layouts
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
		if (!this.runtime.running_layout)
			return;
		this.runtime.changelayout = this.runtime.running_layout;
		var i, len, g;
		for (i = 0, len = this.runtime.allGroups.length; i < len; i++)
		{
			g = this.runtime.allGroups[i];
			this.runtime.activeGroups[g.group_name.toLowerCase()] = g.initially_activated;
		}
	};
	SysActs.prototype.SnapshotCanvas = function (format_, quality_)
	{
		this.runtime.snapshotCanvas = [format_ === 0 ? "image/png" : "image/jpeg", quality_ / 100];
		this.runtime.redraw = true;		// force redraw so snapshot is always taken
	};
	SysActs.prototype.SetCanvasSize = function (w, h)
	{
		if (w <= 0 || h <= 0)
			return;
		var mode = this.runtime.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
		if (isfullscreen && this.runtime.fullscreen_scaling > 0)
			mode = this.runtime.fullscreen_scaling;
		if (mode === 0)
		{
			this.runtime["setSize"](w, h, true);
		}
		else
		{
			this.runtime.original_width = w;
			this.runtime.original_height = h;
			this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
		}
	};
	SysActs.prototype.SetLayoutEffectEnabled = function (enable_, effectname_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		this.runtime.running_layout.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectEnabled = function (layer, enable_, effectname_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		layer.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayoutEffectParam = function (effectname_, index_, value_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = this.runtime.running_layout.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectParam = function (layer, effectname_, index_, value_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = layer.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SaveState = function (slot_)
	{
		this.runtime.saveToSlot = slot_;
	};
	SysActs.prototype.LoadState = function (slot_)
	{
		this.runtime.loadFromSlot = slot_;
	};
	SysActs.prototype.LoadStateJSON = function (jsonstr_)
	{
		this.runtime.loadFromJson = jsonstr_;
	};
	SysActs.prototype.SetHalfFramerateMode = function (set_)
	{
		this.runtime.halfFramerateMode = (set_ !== 0);
	};
	SysActs.prototype.SetFullscreenQuality = function (q)
	{
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.runtime.fullscreen_mode === 0)
			return;
		this.runtime.wantFullscreenScalingQuality = (q !== 0);
		this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
	};
	sysProto.acts = new SysActs();
    function SysExps() {};
    SysExps.prototype["int"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_int(parseInt(x, 10));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_int(x);
    };
    SysExps.prototype["float"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_float(parseFloat(x));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_float(x);
    };
    SysExps.prototype.str = function(ret, x)
    {
        if (cr.is_string(x))
            ret.set_string(x);
        else
            ret.set_string(x.toString());
    };
    SysExps.prototype.len = function(ret, x)
    {
        ret.set_int(x.length || 0);
    };
    SysExps.prototype.random = function (ret, a, b)
    {
        if (b === undefined)
        {
            ret.set_float(Math.random() * a);
        }
        else
        {
            ret.set_float(Math.random() * (b - a) + a);
        }
    };
    SysExps.prototype.sqrt = function(ret, x)
    {
        ret.set_float(Math.sqrt(x));
    };
    SysExps.prototype.abs = function(ret, x)
    {
        ret.set_float(Math.abs(x));
    };
    SysExps.prototype.round = function(ret, x)
    {
        ret.set_int(Math.round(x));
    };
    SysExps.prototype.floor = function(ret, x)
    {
        ret.set_int(Math.floor(x));
    };
    SysExps.prototype.ceil = function(ret, x)
    {
        ret.set_int(Math.ceil(x));
    };
    SysExps.prototype.sin = function(ret, x)
    {
        ret.set_float(Math.sin(cr.to_radians(x)));
    };
    SysExps.prototype.cos = function(ret, x)
    {
        ret.set_float(Math.cos(cr.to_radians(x)));
    };
    SysExps.prototype.tan = function(ret, x)
    {
        ret.set_float(Math.tan(cr.to_radians(x)));
    };
    SysExps.prototype.asin = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.asin(x)));
    };
    SysExps.prototype.acos = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.acos(x)));
    };
    SysExps.prototype.atan = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.atan(x)));
    };
    SysExps.prototype.exp = function(ret, x)
    {
        ret.set_float(Math.exp(x));
    };
    SysExps.prototype.ln = function(ret, x)
    {
        ret.set_float(Math.log(x));
    };
    SysExps.prototype.log10 = function(ret, x)
    {
        ret.set_float(Math.log(x) / Math.LN10);
    };
    SysExps.prototype.max = function(ret)
    {
		var max_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (max_ < arguments[i])
				max_ = arguments[i];
		}
		ret.set_float(max_);
    };
    SysExps.prototype.min = function(ret)
    {
        var min_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (min_ > arguments[i])
				min_ = arguments[i];
		}
		ret.set_float(min_);
    };
    SysExps.prototype.dt = function(ret)
    {
        ret.set_float(this.runtime.dt);
    };
    SysExps.prototype.timescale = function(ret)
    {
        ret.set_float(this.runtime.timescale);
    };
    SysExps.prototype.wallclocktime = function(ret)
    {
        ret.set_float((Date.now() - this.runtime.start_time) / 1000.0);
    };
    SysExps.prototype.time = function(ret)
    {
        ret.set_float(this.runtime.kahanTime.sum);
    };
    SysExps.prototype.tickcount = function(ret)
    {
        ret.set_int(this.runtime.tickcount);
    };
    SysExps.prototype.objectcount = function(ret)
    {
        ret.set_int(this.runtime.objectcount);
    };
    SysExps.prototype.fps = function(ret)
    {
        ret.set_int(this.runtime.fps);
    };
    SysExps.prototype.loopindex = function(ret, name_)
    {
		var loop, i, len;
        if (!this.runtime.loop_stack.length)
        {
            ret.set_int(0);
            return;
        }
        if (name_)
        {
            for (i = 0, len = this.runtime.loop_stack.length; i < len; i++)
            {
                loop = this.runtime.loop_stack[i];
                if (loop.name === name_)
                {
                    ret.set_int(loop.index);
                    return;
                }
            }
            ret.set_int(0);
        }
        else
        {
			loop = this.runtime.getCurrentLoop();
			ret.set_int(loop ? loop.index : -1);
        }
    };
    SysExps.prototype.distance = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.distanceTo(x1, y1, x2, y2));
    };
    SysExps.prototype.angle = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.to_degrees(cr.angleTo(x1, y1, x2, y2)));
    };
    SysExps.prototype.scrollx = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollX);
    };
    SysExps.prototype.scrolly = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollY);
    };
    SysExps.prototype.newline = function(ret)
    {
        ret.set_string("\n");
    };
    SysExps.prototype.lerp = function(ret, a, b, x)
    {
        ret.set_float(cr.lerp(a, b, x));
    };
    SysExps.prototype.windowwidth = function(ret)
    {
        ret.set_int(this.runtime.width);
    };
    SysExps.prototype.windowheight = function(ret)
    {
        ret.set_int(this.runtime.height);
    };
	SysExps.prototype.uppercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toUpperCase() : "");
	};
	SysExps.prototype.lowercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toLowerCase() : "");
	};
	SysExps.prototype.clamp = function(ret, x, l, u)
	{
		if (x < l)
			ret.set_float(l);
		else if (x > u)
			ret.set_float(u);
		else
			ret.set_float(x);
	};
	SysExps.prototype.layerscale = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.scale);
	};
	SysExps.prototype.layeropacity = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.opacity * 100);
	};
	SysExps.prototype.layerscalerate = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.zoomRate);
	};
	SysExps.prototype.layerparallaxx = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxX * 100);
	};
	SysExps.prototype.layerparallaxy = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxY * 100);
	};
	SysExps.prototype.layoutscale = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_float(this.runtime.running_layout.scale);
		else
			ret.set_float(0);
	};
	SysExps.prototype.layoutangle = function (ret)
	{
		ret.set_float(cr.to_degrees(this.runtime.running_layout.angle));
	};
	SysExps.prototype.layerangle = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(cr.to_degrees(layer.angle));
	};
	SysExps.prototype.layoutwidth = function (ret)
	{
		ret.set_int(this.runtime.running_layout.width);
	};
	SysExps.prototype.layoutheight = function (ret)
	{
		ret.set_int(this.runtime.running_layout.height);
	};
	SysExps.prototype.find = function (ret, text, searchstr)
	{
		if (cr.is_string(text) && cr.is_string(searchstr))
			ret.set_int(text.search(new RegExp(cr.regexp_escape(searchstr), "i")));
		else
			ret.set_int(-1);
	};
	SysExps.prototype.left = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(0, n) : "");
	};
	SysExps.prototype.right = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(text.length - n) : "");
	};
	SysExps.prototype.mid = function (ret, text, index_, length_)
	{
		ret.set_string(cr.is_string(text) ? text.substr(index_, length_) : "");
	};
	SysExps.prototype.tokenat = function (ret, text, index_, sep)
	{
		if (cr.is_string(text) && cr.is_string(sep))
		{
			var arr = text.split(sep);
			var i = cr.floor(index_);
			if (i < 0 || i >= arr.length)
				ret.set_string("");
			else
				ret.set_string(arr[i]);
		}
		else
			ret.set_string("");
	};
	SysExps.prototype.tokencount = function (ret, text, sep)
	{
		if (cr.is_string(text) && text.length)
			ret.set_int(text.split(sep).length);
		else
			ret.set_int(0);
	};
	SysExps.prototype.replace = function (ret, text, find_, replace_)
	{
		if (cr.is_string(text) && cr.is_string(find_) && cr.is_string(replace_))
			ret.set_string(text.replace(new RegExp(cr.regexp_escape(find_), "gi"), replace_));
		else
			ret.set_string(cr.is_string(text) ? text : "");
	};
	SysExps.prototype.trim = function (ret, text)
	{
		ret.set_string(cr.is_string(text) ? text.trim() : "");
	};
	SysExps.prototype.pi = function (ret)
	{
		ret.set_float(cr.PI);
	};
	SysExps.prototype.layoutname = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_string(this.runtime.running_layout.name);
		else
			ret.set_string("");
	};
	SysExps.prototype.renderer = function (ret)
	{
		ret.set_string(this.runtime.gl ? "webgl" : "canvas2d");
	};
	SysExps.prototype.anglediff = function (ret, a, b)
	{
		ret.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(a), cr.to_radians(b))));
	};
	SysExps.prototype.choose = function (ret)
	{
		var index = cr.floor(Math.random() * (arguments.length - 1));
		ret.set_any(arguments[index + 1]);
	};
	SysExps.prototype.rgb = function (ret, r, g, b)
	{
		ret.set_int(cr.RGB(r, g, b));
	};
	SysExps.prototype.projectversion = function (ret)
	{
		ret.set_string(this.runtime.versionstr);
	};
	SysExps.prototype.anglelerp = function (ret, a, b, x)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			ret.set_float(cr.to_clamped_degrees(a + diff * x));
		}
		else
		{
			ret.set_float(cr.to_clamped_degrees(a - diff * x));
		}
	};
	SysExps.prototype.anglerotate = function (ret, a, b, c)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		c = cr.to_radians(c);
		ret.set_float(cr.to_clamped_degrees(cr.angleRotate(a, b, c)));
	};
	SysExps.prototype.zeropad = function (ret, n, d)
	{
		var s = (n < 0 ? "-" : "");
		if (n < 0) n = -n;
		var zeroes = d - n.toString().length;
		for (var i = 0; i < zeroes; i++)
			s += "0";
		ret.set_string(s + n.toString());
	};
	SysExps.prototype.cpuutilisation = function (ret)
	{
		ret.set_float(this.runtime.cpuutilisation / 1000);
	};
	SysExps.prototype.viewportleft = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewLeft : 0);
	};
	SysExps.prototype.viewporttop = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewTop : 0);
	};
	SysExps.prototype.viewportright = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewRight : 0);
	};
	SysExps.prototype.viewportbottom = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewBottom : 0);
	};
	SysExps.prototype.loadingprogress = function (ret)
	{
		ret.set_float(this.runtime.loadingprogress);
	};
	SysExps.prototype.unlerp = function(ret, a, b, y)
    {
        ret.set_float(cr.unlerp(a, b, y));
    };
	SysExps.prototype.canvassnapshot = function (ret)
	{
		ret.set_string(this.runtime.snapshotData);
	};
	SysExps.prototype.urlencode = function (ret, s)
	{
		ret.set_string(encodeURIComponent(s));
	};
	SysExps.prototype.urldecode = function (ret, s)
	{
		ret.set_string(decodeURIComponent(s));
	};
	SysExps.prototype.canvastolayerx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, true) : 0);
	};
	SysExps.prototype.canvastolayery = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, false) : 0);
	};
	SysExps.prototype.layertocanvasx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, true) : 0);
	};
	SysExps.prototype.layertocanvasy = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, false) : 0);
	};
	SysExps.prototype.savestatejson = function (ret)
	{
		ret.set_string(this.runtime.lastSaveJson);
	};
	SysExps.prototype.imagememoryusage = function (ret)
	{
		if (this.runtime.glwrap)
			ret.set_float(Math.round(100 * this.runtime.glwrap.estimateVRAM() / (1024 * 1024)) / 100);
		else
			ret.set_float(0);
	};
	SysExps.prototype.regexsearch = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_int(str_ ? str_.search(regex) : -1);
	};
	SysExps.prototype.regexreplace = function (ret, str_, regex_, flags_, replace_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_string(str_ ? str_.replace(regex, replace_) : "");
	};
	var regexMatches = [];
	var lastMatchesStr = "";
	var lastMatchesRegex = "";
	var lastMatchesFlags = "";
	function updateRegexMatches(str_, regex_, flags_)
	{
		if (str_ === lastMatchesStr && regex_ === lastMatchesRegex && flags_ === lastMatchesFlags)
			return;
		var regex = getRegex(regex_, flags_);
		regexMatches = str_.match(regex);
		lastMatchesStr = str_;
		lastMatchesRegex = regex_;
		lastMatchesFlags = flags_;
	};
	SysExps.prototype.regexmatchcount = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		ret.set_int(regexMatches ? regexMatches.length : 0);
	};
	SysExps.prototype.regexmatchat = function (ret, str_, regex_, flags_, index_)
	{
		index_ = Math.floor(index_);
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		if (!regexMatches || index_ < 0 || index_ >= regexMatches.length)
			ret.set_string("");
		else
			ret.set_string(regexMatches[index_]);
	};
	SysExps.prototype.infinity = function (ret)
	{
		ret.set_float(Infinity);
	};
	SysExps.prototype.setbit = function (ret, n, b, v)
	{
		n = n | 0;
		b = b | 0;
		v = (v !== 0 ? 1 : 0);
		ret.set_int((n & ~(1 << b)) | (v << b));
	};
	SysExps.prototype.togglebit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int(n ^ (1 << b));
	};
	SysExps.prototype.getbit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int((n & (1 << b)) ? 1 : 0);
	};
	sysProto.exps = new SysExps();
	sysProto.runWaits = function ()
	{
		var i, j, len, w, k, s, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		for (i = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			if (w.time > this.runtime.kahanTime.sum)
				continue;
			evinfo.current_event = w.ev;
			evinfo.actindex = w.actindex;
			evinfo.cndindex = 0;
			for (k in w.sols)
			{
				if (w.sols.hasOwnProperty(k))
				{
					s = this.runtime.types_by_index[parseInt(k, 10)].getCurrentSol();
					ss = w.sols[k];
					s.select_all = ss.sa;
					cr.shallowAssignArray(s.instances, ss.insts);
					freeSolStateObject(ss);
				}
			}
			w.ev.resume_actions_and_subevents();
			this.runtime.clearSol(w.solModifiers);
			w.deleteme = true;
		}
		for (i = 0, j = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			this.waits[j] = w;
			if (w.deleteme)
				freeWaitObject(w);
			else
				j++;
		}
		this.waits.length = j;
	};
}());
;
(function () {
	cr.add_common_aces = function (m)
	{
		var pluginProto = m[0].prototype;
		var singleglobal_ = m[1];
		var position_aces = m[3];
		var size_aces = m[4];
		var angle_aces = m[5];
		var appearance_aces = m[6];
		var zorder_aces = m[7];
		var effects_aces = m[8];
		if (!pluginProto.cnds)
			pluginProto.cnds = {};
		if (!pluginProto.acts)
			pluginProto.acts = {};
		if (!pluginProto.exps)
			pluginProto.exps = {};
		var cnds = pluginProto.cnds;
		var acts = pluginProto.acts;
		var exps = pluginProto.exps;
		if (position_aces)
		{
			cnds.CompareX = function (cmp, x)
			{
				return cr.do_cmp(this.x, cmp, x);
			};
			cnds.CompareY = function (cmp, y)
			{
				return cr.do_cmp(this.y, cmp, y);
			};
			cnds.IsOnScreen = function ()
			{
				var layer = this.layer;
				this.update_bbox();
				var bbox = this.bbox;
				return !(bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom);
			};
			cnds.IsOutsideLayout = function ()
			{
				this.update_bbox();
				var bbox = this.bbox;
				var layout = this.runtime.running_layout;
				return (bbox.right < 0 || bbox.bottom < 0 || bbox.left > layout.width || bbox.top > layout.height);
			};
			cnds.PickDistance = function (which, x, y)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var dist = cr.distanceTo(inst.x, inst.y, x, y);
				var i, len, d;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					d = cr.distanceTo(inst.x, inst.y, x, y);
					if ((which === 0 && d < dist) || (which === 1 && d > dist))
					{
						dist = d;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.SetX = function (x)
			{
				if (this.x !== x)
				{
					this.x = x;
					this.set_bbox_changed();
				}
			};
			acts.SetY = function (y)
			{
				if (this.y !== y)
				{
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPos = function (x, y)
			{
				if (this.x !== x || this.y !== y)
				{
					this.x = x;
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPosToObject = function (obj, imgpt)
			{
				var inst = obj.getPairedInstance(this);
				if (!inst)
					return;
				var newx, newy;
				if (inst.getImagePoint)
				{
					newx = inst.getImagePoint(imgpt, true);
					newy = inst.getImagePoint(imgpt, false);
				}
				else
				{
					newx = inst.x;
					newy = inst.y;
				}
				if (this.x !== newx || this.y !== newy)
				{
					this.x = newx;
					this.y = newy;
					this.set_bbox_changed();
				}
			};
			acts.MoveForward = function (dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(this.angle) * dist;
					this.y += Math.sin(this.angle) * dist;
					this.set_bbox_changed();
				}
			};
			acts.MoveAtAngle = function (a, dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(cr.to_radians(a)) * dist;
					this.y += Math.sin(cr.to_radians(a)) * dist;
					this.set_bbox_changed();
				}
			};
			exps.X = function (ret)
			{
				ret.set_float(this.x);
			};
			exps.Y = function (ret)
			{
				ret.set_float(this.y);
			};
			exps.dt = function (ret)
			{
				ret.set_float(this.runtime.getDt(this));
			};
		}
		if (size_aces)
		{
			cnds.CompareWidth = function (cmp, w)
			{
				return cr.do_cmp(this.width, cmp, w);
			};
			cnds.CompareHeight = function (cmp, h)
			{
				return cr.do_cmp(this.height, cmp, h);
			};
			acts.SetWidth = function (w)
			{
				if (this.width !== w)
				{
					this.width = w;
					this.set_bbox_changed();
				}
			};
			acts.SetHeight = function (h)
			{
				if (this.height !== h)
				{
					this.height = h;
					this.set_bbox_changed();
				}
			};
			acts.SetSize = function (w, h)
			{
				if (this.width !== w || this.height !== h)
				{
					this.width = w;
					this.height = h;
					this.set_bbox_changed();
				}
			};
			exps.Width = function (ret)
			{
				ret.set_float(this.width);
			};
			exps.Height = function (ret)
			{
				ret.set_float(this.height);
			};
			exps.BBoxLeft = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.left);
			};
			exps.BBoxTop = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.top);
			};
			exps.BBoxRight = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.right);
			};
			exps.BBoxBottom = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.bottom);
			};
		}
		if (angle_aces)
		{
			cnds.AngleWithin = function (within, a)
			{
				return cr.angleDiff(this.angle, cr.to_radians(a)) <= cr.to_radians(within);
			};
			cnds.IsClockwiseFrom = function (a)
			{
				return cr.angleClockwise(this.angle, cr.to_radians(a));
			};
			cnds.IsBetweenAngles = function (a, b)
			{
				var lower = cr.to_clamped_radians(a);
				var upper = cr.to_clamped_radians(b);
				var angle = cr.clamp_angle(this.angle);
				var obtuse = (!cr.angleClockwise(upper, lower));
				if (obtuse)
					return !(!cr.angleClockwise(angle, lower) && cr.angleClockwise(angle, upper));
				else
					return cr.angleClockwise(angle, lower) && !cr.angleClockwise(angle, upper);
			};
			acts.SetAngle = function (a)
			{
				var newangle = cr.to_radians(cr.clamp_angle_degrees(a));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateClockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle += cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateCounterclockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle -= cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardAngle = function (amt, target)
			{
				var newangle = cr.angleRotate(this.angle, cr.to_radians(target), cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardPosition = function (amt, x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var target = Math.atan2(dy, dx);
				var newangle = cr.angleRotate(this.angle, target, cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.SetTowardPosition = function (x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var newangle = Math.atan2(dy, dx);
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			exps.Angle = function (ret)
			{
				ret.set_float(cr.to_clamped_degrees(this.angle));
			};
		}
		if (!singleglobal_)
		{
			cnds.CompareInstanceVar = function (iv, cmp, val)
			{
				return cr.do_cmp(this.instance_vars[iv], cmp, val);
			};
			cnds.IsBoolInstanceVarSet = function (iv)
			{
				return this.instance_vars[iv];
			};
			cnds.PickInstVarHiLow = function (which, iv)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var val = inst.instance_vars[iv];
				var i, len, v;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					v = inst.instance_vars[iv];
					if ((which === 0 && v < val) || (which === 1 && v > val))
					{
						val = v;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			cnds.PickByUID = function (u)
			{
				var i, len, j, inst, families, instances, sol;
				var cnd = this.runtime.getCurrentCondition();
				if (cnd.inverted)
				{
					sol = this.getCurrentSol();
					if (sol.select_all)
					{
						sol.select_all = false;
						sol.instances.length = 0;
						sol.else_instances.length = 0;
						instances = this.instances;
						for (i = 0, len = instances.length; i < len; i++)
						{
							inst = instances[i];
							if (inst.uid === u)
								sol.else_instances.push(inst);
							else
								sol.instances.push(inst);
						}
						this.applySolToContainer();
						return !!sol.instances.length;
					}
					else
					{
						for (i = 0, j = 0, len = sol.instances.length; i < len; i++)
						{
							inst = sol.instances[i];
							sol.instances[j] = inst;
							if (inst.uid === u)
							{
								sol.else_instances.push(inst);
							}
							else
								j++;
						}
						sol.instances.length = j;
						this.applySolToContainer();
						return !!sol.instances.length;
					}
				}
				else
				{
					inst = this.runtime.getObjectByUID(u);
					if (!inst)
						return false;
					sol = this.getCurrentSol();
					if (!sol.select_all && sol.instances.indexOf(inst) === -1)
						return false;		// not picked
					if (this.is_family)
					{
						families = inst.type.families;
						for (i = 0, len = families.length; i < len; i++)
						{
							if (families[i] === this)
							{
								sol.pick_one(inst);
								this.applySolToContainer();
								return true;
							}
						}
					}
					else if (inst.type === this)
					{
						sol.pick_one(inst);
						this.applySolToContainer();
						return true;
					}
					return false;
				}
			};
			cnds.OnCreated = function ()
			{
				return true;
			};
			cnds.OnDestroyed = function ()
			{
				return true;
			};
			acts.SetInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = val.toString();
				}
				else
;
			};
			acts.AddInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += val.toString();
				}
				else
;
			};
			acts.SubInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] -= val;
					else
						myinstvars[iv] -= parseFloat(val);
				}
				else
;
			};
			acts.SetBoolInstanceVar = function (iv, val)
			{
				this.instance_vars[iv] = val ? 1 : 0;
			};
			acts.ToggleBoolInstanceVar = function (iv)
			{
				this.instance_vars[iv] = 1 - this.instance_vars[iv];
			};
			acts.Destroy = function ()
			{
				this.runtime.DestroyInstance(this);
			};
			if (!acts.LoadFromJsonString)
			{
				acts.LoadFromJsonString = function (str_)
				{
					var o, i, len, binst;
					try {
						o = JSON.parse(str_);
					}
					catch (e) {
						return;
					}
					this.runtime.loadInstanceFromJSON(this, o, true);
					if (this.afterLoad)
						this.afterLoad();
					if (this.behavior_insts)
					{
						for (i = 0, len = this.behavior_insts.length; i < len; ++i)
						{
							binst = this.behavior_insts[i];
							if (binst.afterLoad)
								binst.afterLoad();
						}
					}
				};
			}
			exps.Count = function (ret)
			{
				var count = ret.object_class.instances.length;
				var i, len, inst;
				for (i = 0, len = this.runtime.createRow.length; i < len; i++)
				{
					inst = this.runtime.createRow[i];
					if (ret.object_class.is_family)
					{
						if (inst.type.families.indexOf(ret.object_class) >= 0)
							count++;
					}
					else
					{
						if (inst.type === ret.object_class)
							count++;
					}
				}
				ret.set_int(count);
			};
			exps.PickedCount = function (ret)
			{
				ret.set_int(ret.object_class.getCurrentSol().getObjects().length);
			};
			exps.UID = function (ret)
			{
				ret.set_int(this.uid);
			};
			exps.IID = function (ret)
			{
				ret.set_int(this.get_iid());
			};
			if (!exps.AsJSON)
			{
				exps.AsJSON = function (ret)
				{
					ret.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this, true)));
				};
			}
		}
		if (appearance_aces)
		{
			cnds.IsVisible = function ()
			{
				return this.visible;
			};
			acts.SetVisible = function (v)
			{
				if (!v !== !this.visible)
				{
					this.visible = v;
					this.runtime.redraw = true;
				}
			};
			cnds.CompareOpacity = function (cmp, x)
			{
				return cr.do_cmp(cr.round6dp(this.opacity * 100), cmp, x);
			};
			acts.SetOpacity = function (x)
			{
				var new_opacity = x / 100.0;
				if (new_opacity < 0)
					new_opacity = 0;
				else if (new_opacity > 1)
					new_opacity = 1;
				if (new_opacity !== this.opacity)
				{
					this.opacity = new_opacity;
					this.runtime.redraw = true;
				}
			};
			exps.Opacity = function (ret)
			{
				ret.set_float(cr.round6dp(this.opacity * 100.0));
			};
		}
		if (zorder_aces)
		{
			cnds.IsOnLayer = function (layer_)
			{
				if (!layer_)
					return false;
				return this.layer === layer_;
			};
			cnds.PickTopBottom = function (which_)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var i, len;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					if (which_ === 0)
					{
						if (inst.layer.index > pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() > pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
					else
					{
						if (inst.layer.index < pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() < pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.MoveToTop = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === this.layer.instances.length - 1)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.push(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToBottom = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === 0)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.unshift(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToLayer = function (layerMove)
			{
				if (!layerMove || layerMove == this.layer)
					return;
				cr.arrayRemove(this.layer.instances, this.get_zindex());
				this.layer.zindices_stale = true;
				this.layer = layerMove;
				this.zindex = layerMove.instances.length;
				layerMove.instances.push(this);
				this.runtime.redraw = true;
			};
			acts.ZMoveToObject = function (where_, obj_)
			{
				var isafter = (where_ === 0);
				if (!obj_)
					return;
				var other = obj_.getFirstPicked(this);
				if (!other || other.uid === this.uid)
					return;
				if (this.layer.index !== other.layer.index)
				{
					cr.arrayRemove(this.layer.instances, this.get_zindex());
					this.layer.zindices_stale = true;
					this.layer = other.layer;
					this.zindex = other.layer.instances.length;
					other.layer.instances.push(this);
				}
				var myZ = this.get_zindex();
				var insertZ = other.get_zindex();
				cr.arrayRemove(this.layer.instances, myZ);
				if (myZ < insertZ)
					insertZ--;
				if (isafter)
					insertZ++;
				if (insertZ === this.layer.instances.length)
					this.layer.instances.push(this);
				else
					this.layer.instances.splice(insertZ, 0, this);
				this.layer.zindices_stale = true;
				this.runtime.redraw = true;
			};
			exps.LayerNumber = function (ret)
			{
				ret.set_int(this.layer.number);
			};
			exps.LayerName = function (ret)
			{
				ret.set_string(this.layer.name);
			};
			exps.ZIndex = function (ret)
			{
				ret.set_int(this.get_zindex());
			};
		}
		if (effects_aces)
		{
			acts.SetEffectEnabled = function (enable_, effectname_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var enable = (enable_ === 1);
				if (this.active_effect_flags[i] === enable)
					return;		// no change
				this.active_effect_flags[i] = enable;
				this.updateActiveEffects();
				this.runtime.redraw = true;
			};
			acts.SetEffectParam = function (effectname_, index_, value_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var et = this.type.effect_types[i];
				var params = this.effect_params[i];
				index_ = Math.floor(index_);
				if (index_ < 0 || index_ >= params.length)
					return;		// effect index out of bounds
				if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
					value_ /= 100.0;
				if (params[index_] === value_)
					return;		// no change
				params[index_] = value_;
				if (et.active)
					this.runtime.redraw = true;
			};
		}
	};
	cr.set_bbox_changed = function ()
	{
		this.bbox_changed = true;      		// will recreate next time box requested
		this.cell_changed = true;
		this.type.any_cell_changed = true;	// avoid unnecessary updateAllBBox() calls
		this.runtime.redraw = true;     	// assume runtime needs to redraw
		var i, len, callbacks = this.bbox_changed_callbacks;
		for (i = 0, len = callbacks.length; i < len; ++i)
		{
			callbacks[i](this);
		}
	};
	cr.add_bbox_changed_callback = function (f)
	{
		if (f)
		{
			this.bbox_changed_callbacks.push(f);
		}
	};
	cr.update_bbox = function ()
	{
		if (!this.bbox_changed)
			return;                 // bounding box not changed
		var bbox = this.bbox;
		var bquad = this.bquad;
		bbox.set(this.x, this.y, this.x + this.width, this.y + this.height);
		bbox.offset(-this.hotspotX * this.width, -this.hotspotY * this.height);
		if (!this.angle)
		{
			bquad.set_from_rect(bbox);    // make bounding quad from box
		}
		else
		{
			bbox.offset(-this.x, -this.y);       			// translate to origin
			bquad.set_from_rotated_rect(bbox, this.angle);	// rotate around origin
			bquad.offset(this.x, this.y);      				// translate back to original position
			bquad.bounding_box(bbox);
		}
		bbox.normalize();
		this.bbox_changed = false;  // bounding box up to date
	};
	var tmprc = new cr.rect(0, 0, 0, 0);
	cr.update_collision_cell = function ()
	{
		if (!this.cell_changed || !this.collisionsEnabled)
			return;
		this.update_bbox();
		var mygrid = this.type.collision_grid;
		var collcells = this.collcells;
		var bbox = this.bbox;
		tmprc.set(mygrid.XToCell(bbox.left), mygrid.YToCell(bbox.top), mygrid.XToCell(bbox.right), mygrid.YToCell(bbox.bottom));
		if (collcells.equals(tmprc))
			return;
		if (collcells.right < collcells.left)
			mygrid.update(this, null, tmprc);		// first insertion with invalid rect: don't provide old range
		else
			mygrid.update(this, collcells, tmprc);
		collcells.copy(tmprc);
		this.cell_changed = false;
	};
	cr.inst_contains_pt = function (x, y)
	{
		if (!this.bbox.contains_pt(x, y))
			return false;
		if (!this.bquad.contains_pt(x, y))
			return false;
		if (this.collision_poly && !this.collision_poly.is_empty())
		{
			this.collision_poly.cache_poly(this.width, this.height, this.angle);
			return this.collision_poly.contains_pt(x - this.x, y - this.y);
		}
		else
			return true;
	};
	cr.inst_get_iid = function ()
	{
		this.type.updateIIDs();
		return this.iid;
	};
	cr.inst_get_zindex = function ()
	{
		this.layer.updateZIndices();
		return this.zindex;
	};
	cr.inst_updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et, inst;
		for (i = 0, len = this.active_effect_flags.length; i < len; i++)
		{
			if (this.active_effect_flags[i])
				this.active_effect_types.push(this.type.effect_types[i]);
		}
		this.uses_shaders = !!this.active_effect_types.length;
	};
	cr.inst_toString = function ()
	{
		return "Inst" + this.puid;
	};
	cr.type_getFirstPicked = function (frominst)
	{
		if (frominst && frominst.is_contained && frominst.type != this)
		{
			var i, len, s;
			for (i = 0, len = frominst.siblings.length; i < len; i++)
			{
				s = frominst.siblings[i];
				if (s.type == this)
					return s;
			}
		}
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[0];
		else
			return null;
	};
	cr.type_getPairedInstance = function (inst)
	{
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[inst.get_iid() % instances.length];
		else
			return null;
	};
	cr.type_updateIIDs = function ()
	{
		if (!this.stale_iids || this.is_family)
			return;		// up to date or is family - don't want family to overwrite IIDs
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].iid = i;
		var next_iid = i;
		var createRow = this.runtime.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === this)
				createRow[i].iid = next_iid++;
		}
		this.stale_iids = false;
	};
	cr.type_getInstanceByIID = function (i)
	{
		if (i < this.instances.length)
			return this.instances[i];
		i -= this.instances.length;
		var createRow = this.runtime.createRow;
		var j, lenj;
		for (j = 0, lenj = createRow.length; j < lenj; ++j)
		{
			if (createRow[j].type === this)
			{
				if (i === 0)
					return createRow[j];
				--i;
			}
		}
;
		return null;
	};
	cr.type_getCurrentSol = function ()
	{
		return this.solstack[this.cur_sol];
	};
	cr.type_pushCleanSol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		else
			this.solstack[this.cur_sol].select_all = true;  // else clear next SOL
	};
	cr.type_pushCopySol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		var clonesol = this.solstack[this.cur_sol];
		var prevsol = this.solstack[this.cur_sol - 1];
		if (prevsol.select_all)
			clonesol.select_all = true;
		else
		{
			clonesol.select_all = false;
			cr.shallowAssignArray(clonesol.instances, prevsol.instances);
			cr.shallowAssignArray(clonesol.else_instances, prevsol.else_instances);
		}
	};
	cr.type_popSol = function ()
	{
;
		this.cur_sol--;
	};
	cr.type_getBehaviorByName = function (behname)
	{
		var i, len, j, lenj, f, index = 0;
		if (!this.is_family)
		{
			for (i = 0, len = this.families.length; i < len; i++)
			{
				f = this.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (behname === f.behaviors[j].name)
					{
						this.extra.lastBehIndex = index;
						return f.behaviors[j];
					}
					index++;
				}
			}
		}
		for (i = 0, len = this.behaviors.length; i < len; i++) {
			if (behname === this.behaviors[i].name)
			{
				this.extra.lastBehIndex = index;
				return this.behaviors[i];
			}
			index++;
		}
		return null;
	};
	cr.type_getBehaviorIndexByName = function (behname)
	{
		var b = this.getBehaviorByName(behname);
		if (b)
			return this.extra.lastBehIndex;
		else
			return -1;
	};
	cr.type_getEffectIndexByName = function (name_)
	{
		var i, len;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			if (this.effect_types[i].name === name_)
				return i;
		}
		return -1;
	};
	cr.type_applySolToContainer = function ()
	{
		if (!this.is_contained || this.is_family)
			return;
		var i, len, j, lenj, t, sol, sol2;
		this.updateIIDs();
		sol = this.getCurrentSol();
		var select_all = sol.select_all;
		var es = this.runtime.getCurrentEventStack();
		var orblock = es && es.current_event && es.current_event.orblock;
		for (i = 0, len = this.container.length; i < len; i++)
		{
			t = this.container[i];
			if (t === this)
				continue;
			t.updateIIDs();
			sol2 = t.getCurrentSol();
			sol2.select_all = select_all;
			if (!select_all)
			{
				sol2.instances.length = sol.instances.length;
				for (j = 0, lenj = sol.instances.length; j < lenj; j++)
					sol2.instances[j] = t.getInstanceByIID(sol.instances[j].iid);
				if (orblock)
				{
					sol2.else_instances.length = sol.else_instances.length;
					for (j = 0, lenj = sol.else_instances.length; j < lenj; j++)
						sol2.else_instances[j] = t.getInstanceByIID(sol.else_instances[j].iid);
				}
			}
		}
	};
	cr.type_toString = function ()
	{
		return "Type" + this.sid;
	};
	cr.do_cmp = function (x, cmp, y)
	{
		if (typeof x === "undefined" || typeof y === "undefined")
			return false;
		switch (cmp)
		{
			case 0:     // equal
				return x === y;
			case 1:     // not equal
				return x !== y;
			case 2:     // less
				return x < y;
			case 3:     // less/equal
				return x <= y;
			case 4:     // greater
				return x > y;
			case 5:     // greater/equal
				return x >= y;
			default:
;
				return false;
		}
	};
})();
cr.shaders = {};
;
;
cr.plugins_.Audio = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Audio.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	var audRuntime = null;
	var audInst = null;
	var audTag = "";
	var appPath = "";			// for PhoneGap only
	var API_HTML5 = 0;
	var API_WEBAUDIO = 1;
	var API_PHONEGAP = 2;
	var API_APPMOBI = 3;
	var api = API_HTML5;
	var context = null;
	var audioBuffers = [];		// cache of buffers
	var audioInstances = [];	// cache of instances
	var lastAudio = null;
	var useOgg = false;			// determined at create time
	var timescale_mode = 0;
	var silent = false;
	var masterVolume = 1;
	var listenerX = 0;
	var listenerY = 0;
	var panningModel = 1;		// HRTF
	var distanceModel = 1;		// Inverse
	var refDistance = 10;
	var maxDistance = 10000;
	var rolloffFactor = 1;
	var micSource = null;
	var micTag = "";
	var isMusicWorkaround = false;
	var musicPlayNextTouch = [];
	function dbToLinear(x)
	{
		var v = dbToLinear_nocap(x);
		if (v < 0)
			v = 0;
		if (v > 1)
			v = 1;
		return v;
	};
	function linearToDb(x)
	{
		if (x < 0)
			x = 0;
		if (x > 1)
			x = 1;
		return linearToDb_nocap(x);
	};
	function dbToLinear_nocap(x)
	{
		return Math.pow(10, x / 20);
	};
	function linearToDb_nocap(x)
	{
		return (Math.log(x) / Math.log(10)) * 20;
	};
	var effects = {};
	function getDestinationForTag(tag)
	{
		tag = tag.toLowerCase();
		if (effects.hasOwnProperty(tag))
		{
			if (effects[tag].length)
				return effects[tag][0].getInputNode();
		}
		return context["destination"];
	};
	function createGain()
	{
		if (context["createGain"])
			return context["createGain"]();
		else
			return context["createGainNode"]();
	};
	function createDelay(d)
	{
		if (context["createDelay"])
			return context["createDelay"](d);
		else
			return context["createDelayNode"](d);
	};
	function startSource(s)
	{
		if (s["start"])
			s["start"](0);
		else
			s["noteOn"](0);
	};
	function startSourceAt(s, x, d)
	{
		if (s["start"])
			s["start"](0, x);
		else
			s["noteGrainOn"](0, x, d - x);
	};
	function stopSource(s)
	{
		try {
			if (s["stop"])
				s["stop"](0);
			else
				s["noteOff"](0);
		}
		catch (e) {}
	};
	function setAudioParam(ap, value, ramp, time)
	{
		if (!ap)
			return;		// iOS is missing some parameters
		ap["cancelScheduledValues"](0);
		if (time === 0)
		{
			ap["value"] = value;
			return;
		}
		var curTime = context["currentTime"];
		time += curTime;
		switch (ramp) {
		case 0:		// step
			ap["setValueAtTime"](value, time);
			break;
		case 1:		// linear
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["linearRampToValueAtTime"](value, time);
			break;
		case 2:		// exponential
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["exponentialRampToValueAtTime"](value, time);
			break;
		}
	};
	var filterTypes = ["lowpass", "highpass", "bandpass", "lowshelf", "highshelf", "peaking", "notch", "allpass"];
	function FilterEffect(type, freq, detune, q, gain, mix)
	{
		this.type = "filter";
		this.params = [type, freq, detune, q, gain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = type;
		else
			this.filterNode["type"] = filterTypes[type];
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.filterNode["gain"]["value"] = gain;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
	};
	FilterEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	FilterEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	FilterEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FilterEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 1:		// filter frequency
			this.params[1] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[2] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[3] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is in dB here)
			this.params[4] = value;
			setAudioParam(this.filterNode["gain"], value, ramp, time);
			break;
		}
	};
	function DelayEffect(delayTime, delayGain, mix)
	{
		this.type = "delay";
		this.params = [delayTime, delayGain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.mainNode = createGain();
		this.delayNode = createDelay(delayTime);
		this.delayNode["delayTime"]["value"] = delayTime;
		this.delayGainNode = createGain();
		this.delayGainNode["gain"]["value"] = delayGain;
		this.inputNode["connect"](this.mainNode);
		this.inputNode["connect"](this.dryNode);
		this.mainNode["connect"](this.wetNode);
		this.mainNode["connect"](this.delayNode);
		this.delayNode["connect"](this.delayGainNode);
		this.delayGainNode["connect"](this.mainNode);
	};
	DelayEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DelayEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.mainNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.delayGainNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DelayEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DelayEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[2] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is passed in dB but needs to be linear here)
			this.params[1] = dbToLinear(value);
			setAudioParam(this.delayGainNode["gain"], dbToLinear(value), ramp, time);
			break;
		case 5:		// delay time
			this.params[0] = value;
			setAudioParam(this.delayNode["delayTime"], value, ramp, time);
			break;
		}
	};
	function ConvolveEffect(buffer, normalize, mix, src)
	{
		this.type = "convolve";
		this.params = [normalize, mix, src];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.convolveNode = context["createConvolver"]();
		if (buffer)
		{
			this.convolveNode["normalize"] = normalize;
			this.convolveNode["buffer"] = buffer;
		}
		this.inputNode["connect"](this.convolveNode);
		this.inputNode["connect"](this.dryNode);
		this.convolveNode["connect"](this.wetNode);
	};
	ConvolveEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	ConvolveEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.convolveNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	ConvolveEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	ConvolveEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function FlangerEffect(delay, modulation, freq, feedback, mix)
	{
		this.type = "flanger";
		this.params = [delay, modulation, freq, feedback, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.feedbackNode = createGain();
		this.feedbackNode["gain"]["value"] = feedback;
		this.delayNode = createDelay(delay + modulation);
		this.delayNode["delayTime"]["value"] = delay;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.delayNode);
		this.inputNode["connect"](this.dryNode);
		this.delayNode["connect"](this.wetNode);
		this.delayNode["connect"](this.feedbackNode);
		this.feedbackNode["connect"](this.delayNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.delayNode["delayTime"]);
		startSource(this.oscNode);
	};
	FlangerEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	FlangerEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.feedbackNode["disconnect"]();
	};
	FlangerEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FlangerEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 6:		// modulation
			this.params[1] = value / 1000;
			setAudioParam(this.oscGainNode["gain"], value / 1000, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[2] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		case 8:		// feedback
			this.params[3] = value / 100;
			setAudioParam(this.feedbackNode["gain"], value / 100, ramp, time);
			break;
		}
	};
	function PhaserEffect(freq, detune, q, modulation, modfreq, mix)
	{
		this.type = "phaser";
		this.params = [freq, detune, q, modulation, modfreq, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = 7;	// all-pass
		else
			this.filterNode["type"] = "allpass";
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = modfreq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.filterNode["frequency"]);
		startSource(this.oscNode);
	};
	PhaserEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	PhaserEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
	};
	PhaserEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	PhaserEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 1:		// filter frequency
			this.params[0] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[1] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[2] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 6:		// modulation
			this.params[3] = value;
			setAudioParam(this.oscGainNode["gain"], value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[4] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function GainEffect(g)
	{
		this.type = "gain";
		this.params = [g];
		this.node = createGain();
		this.node["gain"]["value"] = g;
	};
	GainEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	GainEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	GainEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	GainEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 4:		// gain
			this.params[0] = dbToLinear(value);
			setAudioParam(this.node["gain"], dbToLinear(value), ramp, time);
			break;
		}
	};
	function TremoloEffect(freq, mix)
	{
		this.type = "tremolo";
		this.params = [freq, mix];
		this.node = createGain();
		this.node["gain"]["value"] = 1 - (mix / 2);
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = mix / 2;
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.node["gain"]);
		startSource(this.oscNode);
	};
	TremoloEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	TremoloEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.node["disconnect"]();
	};
	TremoloEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	TremoloEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.node["gain"]["value"], 1 - (value / 2), ramp, time);
			setAudioParam(this.oscGainNode["gain"]["value"], value / 2, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function RingModulatorEffect(freq, mix)
	{
		this.type = "ringmod";
		this.params = [freq, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.ringNode = createGain();
		this.ringNode["gain"]["value"] = 0;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscNode["connect"](this.ringNode["gain"]);
		startSource(this.oscNode);
		this.inputNode["connect"](this.ringNode);
		this.inputNode["connect"](this.dryNode);
		this.ringNode["connect"](this.wetNode);
	};
	RingModulatorEffect.prototype.connectTo = function (node_)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node_);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node_);
	};
	RingModulatorEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.ringNode["disconnect"]();
		this.inputNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	RingModulatorEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	RingModulatorEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function DistortionEffect(threshold, headroom, drive, makeupgain, mix)
	{
		this.type = "distortion";
		this.params = [threshold, headroom, drive, makeupgain, mix];
		this.inputNode = createGain();
		this.preGain = createGain();
		this.postGain = createGain();
		this.setDrive(drive, dbToLinear_nocap(makeupgain));
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.waveShaper = context["createWaveShaper"]();
		this.curve = new Float32Array(65536);
		this.generateColortouchCurve(threshold, headroom);
		this.waveShaper.curve = this.curve;
		this.inputNode["connect"](this.preGain);
		this.inputNode["connect"](this.dryNode);
		this.preGain["connect"](this.waveShaper);
		this.waveShaper["connect"](this.postGain);
		this.postGain["connect"](this.wetNode);
	};
	DistortionEffect.prototype.setDrive = function (drive, makeupgain)
	{
		if (drive < 0.01)
			drive = 0.01;
		this.preGain["gain"]["value"] = drive;
		this.postGain["gain"]["value"] = Math.pow(1 / drive, 0.6) * makeupgain;
	};
	function e4(x, k)
	{
		return 1.0 - Math.exp(-k * x);
	}
	DistortionEffect.prototype.shape = function (x, linearThreshold, linearHeadroom)
	{
		var maximum = 1.05 * linearHeadroom * linearThreshold;
		var kk = (maximum - linearThreshold);
		var sign = x < 0 ? -1 : +1;
		var absx = x < 0 ? -x : x;
		var shapedInput = absx < linearThreshold ? absx : linearThreshold + kk * e4(absx - linearThreshold, 1.0 / kk);
		shapedInput *= sign;
		return shapedInput;
	};
	DistortionEffect.prototype.generateColortouchCurve = function (threshold, headroom)
	{
		var linearThreshold = dbToLinear_nocap(threshold);
		var linearHeadroom = dbToLinear_nocap(headroom);
		var n = 65536;
		var n2 = n / 2;
		var x = 0;
		for (var i = 0; i < n2; ++i) {
			x = i / n2;
			x = this.shape(x, linearThreshold, linearHeadroom);
			this.curve[n2 + i] = x;
			this.curve[n2 - i - 1] = -x;
		}
	};
	DistortionEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DistortionEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.preGain["disconnect"]();
		this.waveShaper["disconnect"]();
		this.postGain["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DistortionEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DistortionEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function CompressorEffect(threshold, knee, ratio, attack, release)
	{
		this.type = "compressor";
		this.params = [threshold, knee, ratio, attack, release];
		this.node = context["createDynamicsCompressor"]();
		try {
			this.node["threshold"]["value"] = threshold;
			this.node["knee"]["value"] = knee;
			this.node["ratio"]["value"] = ratio;
			this.node["attack"]["value"] = attack;
			this.node["release"]["value"] = release;
		}
		catch (e) {}
	};
	CompressorEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	CompressorEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	CompressorEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	CompressorEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	function AnalyserEffect(fftSize, smoothing)
	{
		this.type = "analyser";
		this.params = [fftSize, smoothing];
		this.node = context["createAnalyser"]();
		this.node["fftSize"] = fftSize;
		this.node["smoothingTimeConstant"] = smoothing;
		this.freqBins = new Float32Array(this.node["frequencyBinCount"]);
		this.signal = new Uint8Array(fftSize);
		this.peak = 0;
		this.rms = 0;
	};
	AnalyserEffect.prototype.tick = function ()
	{
		this.node["getFloatFrequencyData"](this.freqBins);
		this.node["getByteTimeDomainData"](this.signal);
		var fftSize = this.node["fftSize"];
		var i = 0;
		this.peak = 0;
		var rmsSquaredSum = 0;
		var s = 0;
		for ( ; i < fftSize; i++)
		{
			s = (this.signal[i] - 128) / 128;
			if (s < 0)
				s = -s;
			if (this.peak < s)
				this.peak = s;
			rmsSquaredSum += s * s;
		}
		this.peak = linearToDb(this.peak);
		this.rms = linearToDb(Math.sqrt(rmsSquaredSum / fftSize));
	};
	AnalyserEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	AnalyserEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	AnalyserEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	AnalyserEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	var OT_POS_SAMPLES = 4;
	function ObjectTracker()
	{
		this.obj = null;
		this.loadUid = 0;
		this.speeds = [];
		this.lastX = 0;
		this.lastY = 0;
		this.moveAngle = 0;
	};
	ObjectTracker.prototype.setObject = function (obj_)
	{
		this.obj = obj_;
		if (this.obj)
		{
			this.lastX = this.obj.x;
			this.lastY = this.obj.y;
		}
		this.speeds.length = 0;
	};
	ObjectTracker.prototype.hasObject = function ()
	{
		return !!this.obj;
	};
	ObjectTracker.prototype.tick = function (dt)
	{
		if (!this.obj || dt === 0)
			return;
		this.moveAngle = cr.angleTo(this.lastX, this.lastY, this.obj.x, this.obj.y);
		var s = cr.distanceTo(this.lastX, this.lastY, this.obj.x, this.obj.y) / dt;
		if (this.speeds.length < OT_POS_SAMPLES)
			this.speeds.push(s);
		else
		{
			this.speeds.shift();
			this.speeds.push(s);
		}
		this.lastX = this.obj.x;
		this.lastY = this.obj.y;
	};
	ObjectTracker.prototype.getSpeed = function ()
	{
		if (!this.speeds.length)
			return 0;
		var i, len, sum = 0;
		for (i = 0, len = this.speeds.length; i < len; i++)
		{
			sum += this.speeds[i];
		}
		return sum / this.speeds.length;
	};
	ObjectTracker.prototype.getVelocityX = function ()
	{
		return Math.cos(this.moveAngle) * this.getSpeed();
	};
	ObjectTracker.prototype.getVelocityY = function ()
	{
		return Math.sin(this.moveAngle) * this.getSpeed();
	};
	var iOShadtouch = false;	// has had touch input on iOS to work around web audio API muting
	function C2AudioBuffer(src_, is_music)
	{
		this.src = src_;
		this.myapi = api;
		this.is_music = is_music;
		this.added_end_listener = false;
		var self = this;
		this.outNode = null;
		this.mediaSourceNode = null;
		this.panWhenReady = [];		// for web audio API positioned sounds
		this.seekWhenReady = 0;
		this.pauseWhenReady = false;
		this.supportWebAudioAPI = false;
		if (api === API_WEBAUDIO && is_music)
		{
			this.myapi = API_HTML5;
			this.outNode = createGain();
		}
		this.bufferObject = null;			// actual audio object
		this.audioData = null;				// web audio api: ajax request result (compressed audio that needs decoding)
		var request;
		switch (this.myapi) {
		case API_HTML5:
			this.bufferObject = new Audio();
			if (api === API_WEBAUDIO && context["createMediaElementSource"] && !audRuntime.isFirefox)
			{
				this.supportWebAudioAPI = true;		// can be routed through web audio api
				this.bufferObject.addEventListener("canplay", function ()
				{
					if (!self.mediaSourceNode)		// protect against this event firing twice
					{
						self.mediaSourceNode = context["createMediaElementSource"](self.bufferObject);
						self.mediaSourceNode["connect"](self.outNode);
					}
				});
			}
			this.bufferObject.autoplay = false;	// this is only a source buffer, not an instance
			this.bufferObject.preload = "auto";
			this.bufferObject.src = src_;
			break;
		case API_WEBAUDIO:
			request = new XMLHttpRequest();
			request.open("GET", src_, true);
			request.responseType = "arraybuffer";
			request.onload = function () {
				self.audioData = request.response;
				self.decodeAudioBuffer();
			};
			request.send();
			break;
		case API_PHONEGAP:
			this.bufferObject = true;
			break;
		case API_APPMOBI:
			this.bufferObject = true;
			break;
		}
	};
	C2AudioBuffer.prototype.decodeAudioBuffer = function ()
	{
		if (this.bufferObject || !this.audioData)
			return;		// audio already decoded or AJAX request not yet complete
		var self = this;
		if (context["decodeAudioData"])
		{
			context["decodeAudioData"](this.audioData, function (buffer) {
					self.bufferObject = buffer;
					var p, i, len, a;
					if (!cr.is_undefined(self.playTagWhenReady) && !silent)
					{
						if (self.panWhenReady.length)
						{
							for (i = 0, len = self.panWhenReady.length; i < len; i++)
							{
								p = self.panWhenReady[i];
								a = new C2AudioInstance(self, p.thistag);
								a.setPannerEnabled(true);
								if (typeof p.objUid !== "undefined")
								{
									p.obj = audRuntime.getObjectByUID(p.objUid);
									if (!p.obj)
										continue;
								}
								if (p.obj)
								{
									var px = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, true);
									var py = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, false);
									a.setPan(px, py, cr.to_degrees(p.obj.angle - p.obj.layer.getAngle()), p.ia, p.oa, p.og);
									a.setObject(p.obj);
								}
								else
								{
									a.setPan(p.x, p.y, p.a, p.ia, p.oa, p.og);
								}
								a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
								if (self.pauseWhenReady)
									a.pause();
								audioInstances.push(a);
							}
							self.panWhenReady.length = 0;
						}
						else
						{
							a = new C2AudioInstance(self, self.playTagWhenReady);
							a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
							if (self.pauseWhenReady)
								a.pause();
							audioInstances.push(a);
						}
					}
					else if (!cr.is_undefined(self.convolveWhenReady))
					{
						var convolveNode = self.convolveWhenReady.convolveNode;
						convolveNode["normalize"] = self.normalizeWhenReady;
						convolveNode["buffer"] = buffer;
					}
			});
		}
		else
		{
			this.bufferObject = context["createBuffer"](this.audioData, false);
			if (!cr.is_undefined(this.playTagWhenReady) && !silent)
			{
				var a = new C2AudioInstance(this, this.playTagWhenReady);
				a.play(this.loopWhenReady, this.volumeWhenReady, this.seekWhenReady);
				if (this.pauseWhenReady)
					a.pause();
				audioInstances.push(a);
			}
			else if (!cr.is_undefined(this.convolveWhenReady))
			{
				var convolveNode = this.convolveWhenReady.convolveNode;
				convolveNode["normalize"] = this.normalizeWhenReady;
				convolveNode["buffer"] = this.bufferObject;
			}
		}
	};
	C2AudioBuffer.prototype.isLoaded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return this.bufferObject["readyState"] === 4;	// HAVE_ENOUGH_DATA
		case API_WEBAUDIO:
			return !!this.audioData;			// null until AJAX request completes
		case API_PHONEGAP:
			return true;
		case API_APPMOBI:
			return true;
		}
		return false;
	};
	function C2AudioInstance(buffer_, tag_)
	{
		var self = this;
		this.tag = tag_;
		this.fresh = true;
		this.stopped = true;
		this.src = buffer_.src;
		this.buffer = buffer_;
		this.myapi = api;
		this.is_music = buffer_.is_music;
		this.playbackRate = 1;
		this.pgended = true;			// for PhoneGap only: ended flag
		this.resume_me = false;			// make sure resumes when leaving suspend
		this.is_paused = false;
		this.resume_position = 0;		// for web audio api to resume from correct playback position
		this.looping = false;
		this.is_muted = false;
		this.is_silent = false;
		this.volume = 1;
		this.mutevol = 1;
		this.startTime = audRuntime.kahanTime.sum;
		this.gainNode = null;
		this.pannerNode = null;
		this.pannerEnabled = false;
		this.objectTracker = null;
		this.panX = 0;
		this.panY = 0;
		this.panAngle = 0;
		this.panConeInner = 0;
		this.panConeOuter = 0;
		this.panConeOuterGain = 0;
		this.instanceObject = null;
		var add_end_listener = false;
		if (this.myapi === API_WEBAUDIO && this.buffer.myapi === API_HTML5 && !this.buffer.supportWebAudioAPI)
			this.myapi = API_HTML5;
		switch (this.myapi) {
		case API_HTML5:
			if (this.is_music)
			{
				this.instanceObject = buffer_.bufferObject;
				add_end_listener = !buffer_.added_end_listener;
				buffer_.added_end_listener = true;
			}
			else
			{
				this.instanceObject = new Audio();
				this.instanceObject.autoplay = false;
				this.instanceObject.src = buffer_.bufferObject.src;
				add_end_listener = true;
			}
			if (add_end_listener)
			{
				this.instanceObject.addEventListener('ended', function () {
						audTag = self.tag;
						self.stopped = true;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				});
			}
			break;
		case API_WEBAUDIO:
			this.gainNode = createGain();
			this.gainNode["connect"](getDestinationForTag(tag_));
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (buffer_.bufferObject)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = buffer_.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
			}
			else
			{
				this.instanceObject = this.buffer.bufferObject;		// reference the audio element
				this.buffer.outNode["connect"](this.gainNode);
			}
			break;
		case API_PHONEGAP:
			this.instanceObject = new window["Media"](appPath + this.src, null, null, function (status) {
					if (status === window["Media"]["MEDIA_STOPPED"])
					{
						self.pgended = true;
						self.stopped = true;
						audTag = self.tag;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
					}
			});
			break;
		case API_APPMOBI:
			this.instanceObject = true;
			break;
		}
	};
	C2AudioInstance.prototype.hasEnded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return this.instanceObject.ended;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh && !this.stopped && this.instanceObject["loop"])
					return false;
				if (this.is_paused)
					return false;
				return (audRuntime.kahanTime.sum - this.startTime) > this.buffer.bufferObject["duration"];
			}
			else
				return this.instanceObject.ended;
		case API_PHONEGAP:
			return this.pgended;
		case API_APPMOBI:
			true;	// recycling an AppMobi sound does not matter because it will just do another throwaway playSound
		}
		return true;
	};
	C2AudioInstance.prototype.canBeRecycled = function ()
	{
		if (this.fresh || this.stopped)
			return true;		// not yet used or is not playing
		return this.hasEnded();
	};
	C2AudioInstance.prototype.setPannerEnabled = function (enable_)
	{
		if (api !== API_WEBAUDIO)
			return;
		if (!this.pannerEnabled && enable_)
		{
			if (!this.gainNode)
				return;
			if (!this.pannerNode)
			{
				this.pannerNode = context["createPanner"]();
				if (typeof this.pannerNode["panningModel"] === "number")
					this.pannerNode["panningModel"] = panningModel;
				else
					this.pannerNode["panningModel"] = ["equalpower", "HRTF", "soundfield"][panningModel];
				if (typeof this.pannerNode["distanceModel"] === "number")
					this.pannerNode["distanceModel"] = distanceModel;
				else
					this.pannerNode["distanceModel"] = ["linear", "inverse", "exponential"][distanceModel];
				this.pannerNode["refDistance"] = refDistance;
				this.pannerNode["maxDistance"] = maxDistance;
				this.pannerNode["rolloffFactor"] = rolloffFactor;
			}
			this.gainNode["disconnect"]();
			this.gainNode["connect"](this.pannerNode);
			this.pannerNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = true;
		}
		else if (this.pannerEnabled && !enable_)
		{
			if (!this.gainNode)
				return;
			this.pannerNode["disconnect"]();
			this.gainNode["disconnect"]();
			this.gainNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = false;
		}
	};
	C2AudioInstance.prototype.setPan = function (x, y, angle, innerangle, outerangle, outergain)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		this.pannerNode["setPosition"](x, y, 0);
		this.pannerNode["setOrientation"](Math.cos(cr.to_radians(angle)), Math.sin(cr.to_radians(angle)), 0);
		this.pannerNode["coneInnerAngle"] = innerangle;
		this.pannerNode["coneOuterAngle"] = outerangle;
		this.pannerNode["coneOuterGain"] = outergain;
		this.panX = x;
		this.panY = y;
		this.panAngle = angle;
		this.panConeInner = innerangle;
		this.panConeOuter = outerangle;
		this.panConeOuterGain = outergain;
	};
	C2AudioInstance.prototype.setObject = function (o)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		if (!this.objectTracker)
			this.objectTracker = new ObjectTracker();
		this.objectTracker.setObject(o);
	};
	C2AudioInstance.prototype.tick = function (dt)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO || !this.objectTracker || !this.objectTracker.hasObject() || !this.isPlaying())
		{
			return;
		}
		this.objectTracker.tick(dt);
		var inst = this.objectTracker.obj;
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		this.pannerNode["setPosition"](px, py, 0);
		var a = 0;
		if (typeof this.objectTracker.obj.angle !== "undefined")
		{
			a = inst.angle - inst.layer.getAngle();
			this.pannerNode["setOrientation"](Math.cos(a), Math.sin(a), 0);
		}
		px = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, true);
		py = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, false);
		this.pannerNode["setVelocity"](px, py, 0);
	};
	C2AudioInstance.prototype.play = function (looping, vol, fromPosition)
	{
		var instobj = this.instanceObject;
		this.looping = looping;
		this.volume = vol;
		var seekPos = fromPosition || 0;
		switch (this.myapi) {
		case API_HTML5:
			if (instobj.playbackRate !== 1.0)
				instobj.playbackRate = 1.0;
			if (instobj.volume !== vol * masterVolume)
				instobj.volume = vol * masterVolume;
			if (instobj.loop !== looping)
				instobj.loop = looping;
			if (instobj.muted)
				instobj.muted = false;
			if (instobj.currentTime !== seekPos)
			{
				try {
					instobj.currentTime = seekPos;
				}
				catch (err)
				{
;
				}
			}
			if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
				musicPlayNextTouch.push(this);
			else
				this.instanceObject.play();
			break;
		case API_WEBAUDIO:
			this.muted = false;
			this.mutevol = 1;
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = this.buffer.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
				this.instanceObject.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (seekPos === 0)
					startSource(this.instanceObject);
				else
					startSourceAt(this.instanceObject, seekPos, this.getDuration());
			}
			else
			{
				if (instobj.playbackRate !== 1.0)
					instobj.playbackRate = 1.0;
				if (instobj.loop !== looping)
					instobj.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (instobj.currentTime !== seekPos)
				{
					try {
						instobj.currentTime = seekPos;
					}
					catch (err)
					{
;
					}
				}
				if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
					musicPlayNextTouch.push(this);
				else
					instobj.play();
			}
			break;
		case API_PHONEGAP:
			if ((!this.fresh && this.stopped) || seekPos !== 0)
				instobj["seekTo"](seekPos);
			instobj["play"]();
			this.pgended = false;
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["playSound"](this.src, looping);
			else
				AppMobi["player"]["playSound"](this.src, looping);
			break;
		}
		this.playbackRate = 1;
		this.startTime = audRuntime.kahanTime.sum - seekPos;
		this.fresh = false;
		this.stopped = false;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.stop = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
				stopSource(this.instanceObject);
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["stop"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.stopped = true;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.pause = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.resume_position = this.getPlaybackTime();
				if (this.looping)
					this.resume_position = this.resume_position % this.getDuration();
				stopSource(this.instanceObject);
			}
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["pause"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.is_paused = true;
	};
	C2AudioInstance.prototype.resume = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || !this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			this.instanceObject.play();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.instanceObject = context["createBufferSource"]();
				this.instanceObject["buffer"] = this.buffer.bufferObject;
				this.instanceObject["connect"](this.gainNode);
				this.instanceObject.loop = this.looping;
				this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
				this.startTime = audRuntime.kahanTime.sum - this.resume_position;
				startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
			}
			else
			{
				this.instanceObject.play();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["play"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["resumeSound"](this.src);
			break;
		}
		this.is_paused = false;
	};
	C2AudioInstance.prototype.seek = function (pos)
	{
		if (this.fresh || this.stopped || this.hasEnded())
			return;
		switch (this.myapi) {
		case API_HTML5:
			try {
				this.instanceObject.currentTime = pos;
			}
			catch (e) {}
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					this.resume_position = pos;
				else
				{
					this.pause();
					this.resume_position = pos;
					this.resume();
				}
			}
			else
			{
				try {
					this.instanceObject.currentTime = pos;
				}
				catch (e) {}
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["seekSound"](this.src, pos);
			break;
		}
	};
	C2AudioInstance.prototype.reconnect = function (toNode)
	{
		if (this.myapi !== API_WEBAUDIO)
			return;
		if (this.pannerEnabled)
		{
			this.pannerNode["disconnect"]();
			this.pannerNode["connect"](toNode);
		}
		else
		{
			this.gainNode["disconnect"]();
			this.gainNode["connect"](toNode);
		}
	};
	C2AudioInstance.prototype.getDuration = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.duration !== "undefined")
				return this.instanceObject.duration;
			else
				return 0;
		case API_WEBAUDIO:
			return this.buffer.bufferObject["duration"];
		case API_PHONEGAP:
			return this.instanceObject["getDuration"]();
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				return AppMobi["context"]["getDurationSound"](this.src);
			else
				return 0;
		}
		return 0;
	};
	C2AudioInstance.prototype.getPlaybackTime = function ()
	{
		var duration = this.getDuration();
		var ret = 0;
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					return this.resume_position;
				else
					ret = audRuntime.kahanTime.sum - this.startTime;
			}
			else if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				ret = AppMobi["context"]["getPlaybackTimeSound"](this.src);
			break;
		}
		if (!this.looping && ret > duration)
			ret = duration;
		return ret;
	};
	C2AudioInstance.prototype.isPlaying = function ()
	{
		return !this.is_paused && !this.fresh && !this.stopped && !this.hasEnded();
	};
	C2AudioInstance.prototype.setVolume = function (v)
	{
		this.volume = v;
		this.updateVolume();
	};
	C2AudioInstance.prototype.updateVolume = function ()
	{
		var volToSet = this.volume * masterVolume;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.volume && this.instanceObject.volume !== volToSet)
				this.instanceObject.volume = volToSet;
			break;
		case API_WEBAUDIO:
			this.gainNode["gain"]["value"] = volToSet * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.getVolume = function ()
	{
		return this.volume;
	};
	C2AudioInstance.prototype.doSetMuted = function (m)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.muted !== !!m)
				this.instanceObject.muted = !!m;
			break;
		case API_WEBAUDIO:
			this.mutevol = (m ? 0 : 1);
			this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setMuted = function (m)
	{
		this.is_muted = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setSilent = function (m)
	{
		this.is_silent = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setLooping = function (l)
	{
		this.looping = l;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_WEBAUDIO:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["setLoopingSound"](this.src, l);
			break;
		}
	};
	C2AudioInstance.prototype.setPlaybackRate = function (r)
	{
		this.playbackRate = r;
		this.updatePlaybackRate();
	};
	C2AudioInstance.prototype.updatePlaybackRate = function ()
	{
		var r = this.playbackRate;
		if ((timescale_mode === 1 && !this.is_music) || timescale_mode === 2)
			r *= audRuntime.timescale;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.playbackRate !== r)
				this.instanceObject.playbackRate = r;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.instanceObject["playbackRate"]["value"] !== r)
					this.instanceObject["playbackRate"]["value"] = r;
			}
			else
			{
				if (this.instanceObject.playbackRate !== r)
					this.instanceObject.playbackRate = r;
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setSuspended = function (s)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_WEBAUDIO:
			if (s)
			{
				if (this.isPlaying())
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.resume_position = this.getPlaybackTime();
						if (this.looping)
							this.resume_position = this.resume_position % this.getDuration();
						stopSource(this.instanceObject);
					}
					else
						this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.instanceObject = context["createBufferSource"]();
						this.instanceObject["buffer"] = this.buffer.bufferObject;
						this.instanceObject["connect"](this.gainNode);
						this.instanceObject.loop = this.looping;
						this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
						this.startTime = audRuntime.kahanTime.sum - this.resume_position;
						startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
					}
					else
					{
						this.instanceObject["play"]();
					}
				}
			}
			break;
		case API_PHONEGAP:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_APPMOBI:
			break;
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		audRuntime = this.runtime;
		audInst = this;
		this.listenerTracker = null;
		this.listenerZ = -600;
		if ((this.runtime.isiOS || (this.runtime.isAndroid && (this.runtime.isChrome || this.runtime.isAndroidStockBrowser))) && !this.runtime.isCrosswalk && !this.runtime.isDomFree)
		{
			isMusicWorkaround = true;
		}
		context = null;
		if (typeof AudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new AudioContext();
		}
		else if (typeof webkitAudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new webkitAudioContext();
		}
		if ((this.runtime.isiOS && api === API_WEBAUDIO) || isMusicWorkaround)
		{
			document.addEventListener("touchstart", function ()
			{
				var i, len, m;
				if (!iOShadtouch && context)
				{
					var buffer = context["createBuffer"](1, 1, 22050);
					var source = context["createBufferSource"]();
					source["buffer"] = buffer;
					source["connect"](context["destination"]);
					startSource(source);
					iOShadtouch = true;
				}
				if (isMusicWorkaround)
				{
					if (!silent)
					{
						for (i = 0, len = musicPlayNextTouch.length; i < len; ++i)
						{
							m = musicPlayNextTouch[i];
							if (!m.stopped && !m.is_paused)
								m.instanceObject.play();
						}
					}
					musicPlayNextTouch.length = 0;
				}
			}, true);
		}
		if (api !== API_WEBAUDIO)
		{
			if (this.runtime.isPhoneGap)
				api = API_PHONEGAP;
			else if (this.runtime.isAppMobi)
				api = API_APPMOBI;
		}
		if (api === API_PHONEGAP)
		{
			appPath = location.href;
			var i = appPath.lastIndexOf("/");
			if (i > -1)
				appPath = appPath.substr(0, i + 1);
			appPath = appPath.replace("file://", "");
		}
		if (this.runtime.isSafari && this.runtime.isWindows && typeof Audio === "undefined")
		{
			alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed.");
			this.runtime.DestroyInstance(this);
		}
		else
		{
			if (this.runtime.isDirectCanvas)
				useOgg = this.runtime.isAndroid;		// AAC on iOS, OGG on Android
			else
			{
				try {
					useOgg = !!(new Audio().canPlayType('audio/ogg; codecs="vorbis"'));
				}
				catch (e)
				{
					useOgg = false;
				}
			}
			switch (api) {
			case API_HTML5:
;
				break;
			case API_WEBAUDIO:
;
				break;
			case API_PHONEGAP:
;
				break;
			case API_APPMOBI:
;
				break;
			default:
;
			}
			this.runtime.tickMe(this);
		}
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function ()
	{
		timescale_mode = this.properties[0];	// 0 = off, 1 = sounds only, 2 = all
		this.saveload = this.properties[1];		// 0 = all, 1 = sounds only, 2 = music only, 3 = none
		panningModel = this.properties[2];		// 0 = equalpower, 1 = hrtf, 3 = soundfield
		distanceModel = this.properties[3];		// 0 = linear, 1 = inverse, 2 = exponential
		this.listenerZ = -this.properties[4];
		refDistance = this.properties[5];
		maxDistance = this.properties[6];
		rolloffFactor = this.properties[7];
		this.listenerTracker = new ObjectTracker();
		if (api === API_WEBAUDIO)
		{
			context["listener"]["speedOfSound"] = this.properties[8];
			context["listener"]["dopplerFactor"] = this.properties[9];
			context["listener"]["setPosition"](this.runtime.draw_width / 2, this.runtime.draw_height / 2, this.listenerZ);
			context["listener"]["setOrientation"](0, 0, 1, 0, -1, 0);
			window["c2OnAudioMicStream"] = function (localMediaStream, tag)
			{
				if (micSource)
					micSource["disconnect"]();
				micTag = tag.toLowerCase();
				micSource = context["createMediaStreamSource"](localMediaStream);
				micSource["connect"](getDestinationForTag(micTag));
			};
		}
		this.runtime.addSuspendCallback(function(s)
		{
			audInst.onSuspend(s);
		});
		var self = this;
		this.runtime.addDestroyCallback(function (inst)
		{
			self.onInstanceDestroyed(inst);
		});
	};
	instanceProto.onInstanceDestroyed = function (inst)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.objectTracker)
			{
				if (a.objectTracker.obj === inst)
				{
					a.objectTracker.obj = null;
					if (a.pannerEnabled && a.isPlaying() && a.looping)
						a.stop();
				}
			}
		}
		if (this.listenerTracker.obj === inst)
			this.listenerTracker.obj = null;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"silent": silent,
			"masterVolume": masterVolume,
			"listenerZ": this.listenerZ,
			"listenerUid": this.listenerTracker.hasObject() ? this.listenerTracker.obj.uid : -1,
			"playing": [],
			"effects": {}
		};
		var playingarr = o["playing"];
		var i, len, a, d, p, panobj, playbackTime;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (!a.isPlaying())
				continue;				// no need to save stopped sounds
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			if (a.is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!a.is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			playbackTime = a.getPlaybackTime();
			if (a.looping)
				playbackTime = playbackTime % a.getDuration();
			d = {
				"tag": a.tag,
				"buffersrc": a.buffer.src,
				"is_music": a.is_music,
				"playbackTime": playbackTime,
				"volume": a.volume,
				"looping": a.looping,
				"muted": a.is_muted,
				"playbackRate": a.playbackRate,
				"paused": a.is_paused,
				"resume_position": a.resume_position
			};
			if (a.pannerEnabled)
			{
				d["pan"] = {};
				panobj = d["pan"];
				if (a.objectTracker && a.objectTracker.hasObject())
				{
					panobj["objUid"] = a.objectTracker.obj.uid;
				}
				else
				{
					panobj["x"] = a.panX;
					panobj["y"] = a.panY;
					panobj["a"] = a.panAngle;
				}
				panobj["ia"] = a.panConeInner;
				panobj["oa"] = a.panConeOuter;
				panobj["og"] = a.panConeOuterGain;
			}
			playingarr.push(d);
		}
		var fxobj = o["effects"];
		var fxarr;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				fxarr = [];
				for (i = 0, len = effects[p].length; i < len; i++)
				{
					fxarr.push({ "type": effects[p][i].type, "params": effects[p][i].params });
				}
				fxobj[p] = fxarr;
			}
		}
		return o;
	};
	var objectTrackerUidsToLoad = [];
	instanceProto.loadFromJSON = function (o)
	{
		var setSilent = o["silent"];
		masterVolume = o["masterVolume"];
		this.listenerZ = o["listenerZ"];
		this.listenerTracker.setObject(null);
		var listenerUid = o["listenerUid"];
		if (listenerUid !== -1)
		{
			this.listenerTracker.loadUid = listenerUid;
			objectTrackerUidsToLoad.push(this.listenerTracker);
		}
		var playingarr = o["playing"];
		var i, len, d, src, is_music, tag, playbackTime, looping, vol, b, a, p, pan, panObjUid;
		if (this.saveload !== 3)
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
			{
				a = audioInstances[i];
				if (a.is_music && this.saveload === 1)
					continue;		// only saving/loading sound: leave music playing
				if (!a.is_music && this.saveload === 2)
					continue;		// only saving/loading music: leave sound playing
				a.stop();
			}
		}
		var fxarr, fxtype, fxparams, fx;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				for (i = 0, len = effects[p].length; i < len; i++)
					effects[p][i].remove();
			}
		}
		cr.wipe(effects);
		for (p in o["effects"])
		{
			if (o["effects"].hasOwnProperty(p))
			{
				fxarr = o["effects"][p];
				for (i = 0, len = fxarr.length; i < len; i++)
				{
					fxtype = fxarr[i]["type"];
					fxparams = fxarr[i]["params"];
					switch (fxtype) {
					case "filter":
						addEffectForTag(p, new FilterEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "delay":
						addEffectForTag(p, new DelayEffect(fxparams[0], fxparams[1], fxparams[2]));
						break;
					case "convolve":
						src = fxparams[2];
						b = this.getAudioBuffer(src, false);
						if (b.bufferObject)
						{
							fx = new ConvolveEffect(b.bufferObject, fxparams[0], fxparams[1], src);
						}
						else
						{
							fx = new ConvolveEffect(null, fxparams[0], fxparams[1], src);
							b.normalizeWhenReady = fxparams[0];
							b.convolveWhenReady = fx;
						}
						addEffectForTag(p, fx);
						break;
					case "flanger":
						addEffectForTag(p, new FlangerEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "phaser":
						addEffectForTag(p, new PhaserEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "gain":
						addEffectForTag(p, new GainEffect(fxparams[0]));
						break;
					case "tremolo":
						addEffectForTag(p, new TremoloEffect(fxparams[0], fxparams[1]));
						break;
					case "ringmod":
						addEffectForTag(p, new RingModulatorEffect(fxparams[0], fxparams[1]));
						break;
					case "distortion":
						addEffectForTag(p, new DistortionEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "compressor":
						addEffectForTag(p, new CompressorEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "analyser":
						addEffectForTag(p, new AnalyserEffect(fxparams[0], fxparams[1]));
						break;
					}
				}
			}
		}
		for (i = 0, len = playingarr.length; i < len; i++)
		{
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			d = playingarr[i];
			src = d["buffersrc"];
			is_music = d["is_music"];
			tag = d["tag"];
			playbackTime = d["playbackTime"];
			looping = d["looping"];
			vol = d["volume"];
			pan = d["pan"];
			panObjUid = (pan && pan.hasOwnProperty("objUid")) ? pan["objUid"] : -1;
			if (is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			a = this.getAudioInstance(src, tag, is_music, looping, vol);
			if (!a)
			{
				b = this.getAudioBuffer(src, is_music);
				b.seekWhenReady = playbackTime;
				b.pauseWhenReady = d["paused"];
				if (pan)
				{
					if (panObjUid !== -1)
					{
						b.panWhenReady.push({ objUid: panObjUid, ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
					else
					{
						b.panWhenReady.push({ x: pan["x"], y: pan["y"], a: pan["a"], ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
				}
				continue;
			}
			a.resume_position = d["resume_position"];
			a.setPannerEnabled(!!pan);
			a.play(looping, vol, playbackTime);
			a.updatePlaybackRate();
			a.updateVolume();
			a.doSetMuted(a.is_muted || a.is_silent);
			if (d["paused"])
				a.pause();
			if (d["muted"])
				a.setMuted(true);
			a.doSetMuted(a.is_muted || a.is_silent);
			if (pan)
			{
				if (panObjUid !== -1)
				{
					a.objectTracker = a.objectTracker || new ObjectTracker();
					a.objectTracker.loadUid = panObjUid;
					objectTrackerUidsToLoad.push(a.objectTracker);
				}
				else
				{
					a.setPan(pan["x"], pan["y"], pan["a"], pan["ia"], pan["oa"], pan["og"]);
				}
			}
		}
		if (setSilent && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (!setSilent && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	instanceProto.afterLoad = function ()
	{
		var i, len, ot, inst;
		for (i = 0, len = objectTrackerUidsToLoad.length; i < len; i++)
		{
			ot = objectTrackerUidsToLoad[i];
			inst = this.runtime.getObjectByUID(ot.loadUid);
			ot.setObject(inst);
			ot.loadUid = -1;
			if (inst)
			{
				listenerX = inst.x;
				listenerY = inst.y;
			}
		}
		objectTrackerUidsToLoad.length = 0;
	};
	instanceProto.onSuspend = function (s)
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].setSuspended(s);
	};
	instanceProto.tick = function ()
	{
		var dt = this.runtime.dt;
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			a.tick(dt);
			if (a.myapi !== API_HTML5 && a.myapi !== API_APPMOBI)
			{
				if (!a.fresh && !a.stopped && a.hasEnded())
				{
					a.stopped = true;
					audTag = a.tag;
					audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				}
			}
			if (timescale_mode !== 0)
				a.updatePlaybackRate();
		}
		var p, arr, f;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				arr = effects[p];
				for (i = 0, len = arr.length; i < len; i++)
				{
					f = arr[i];
					if (f.tick)
						f.tick();
				}
			}
		}
		if (api === API_WEBAUDIO && this.listenerTracker.hasObject())
		{
			this.listenerTracker.tick(dt);
			listenerX = this.listenerTracker.obj.x;
			listenerY = this.listenerTracker.obj.y;
			context["listener"]["setPosition"](this.listenerTracker.obj.x, this.listenerTracker.obj.y, this.listenerZ);
			context["listener"]["setVelocity"](this.listenerTracker.getVelocityX(), this.listenerTracker.getVelocityY(), 0);
		}
	};
	instanceProto.getAudioBuffer = function (src_, is_music)
	{
		var i, len, a, ret = null, j, k, lenj, ai;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			a = audioBuffers[i];
			if (a.src === src_)
			{
				ret = a;
				break;
			}
		}
		if (!ret)
		{
			ret = new C2AudioBuffer(src_, is_music);
			audioBuffers.push(ret);
		}
		return ret;
	};
	instanceProto.getAudioInstance = function (src_, tag, is_music, looping, vol)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.src === src_ && (a.canBeRecycled() || is_music))
			{
				a.tag = tag;
				return a;
			}
		}
		var b = this.getAudioBuffer(src_, is_music);
		if (!b.bufferObject)
		{
			if (tag !== "<preload>")
			{
				b.playTagWhenReady = tag;
				b.loopWhenReady = looping;
				b.volumeWhenReady = vol;
			}
			return null;
		}
		a = new C2AudioInstance(b, tag);
		audioInstances.push(a);
		return a;
	};
	var taggedAudio = [];
	function getAudioByTag(tag)
	{
		taggedAudio.length = 0;
		if (!tag.length)
		{
			if (!lastAudio || lastAudio.hasEnded())
				return;
			else
			{
				taggedAudio.length = 1;
				taggedAudio[0] = lastAudio;
				return;
			}
		}
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (cr.equals_nocase(tag, a.tag))
				taggedAudio.push(a);
		}
	};
	function reconnectEffects(tag)
	{
		var i, len, arr, n, toNode = context["destination"];
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				toNode = arr[0].getInputNode();
				for (i = 0, len = arr.length; i < len; i++)
				{
					n = arr[i];
					if (i + 1 === len)
						n.connectTo(context["destination"]);
					else
						n.connectTo(arr[i + 1].getInputNode());
				}
			}
		}
		getAudioByTag(tag);
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].reconnect(toNode);
		if (micSource && micTag === tag)
		{
			micSource["disconnect"]();
			micSource["connect"](toNode);
		}
	};
	function addEffectForTag(tag, fx)
	{
		if (!effects.hasOwnProperty(tag))
			effects[tag] = [fx];
		else
			effects[tag].push(fx);
		reconnectEffects(tag);
	};
	function Cnds() {};
	Cnds.prototype.OnEnded = function (t)
	{
		return cr.equals_nocase(audTag, t);
	};
	Cnds.prototype.PreloadsComplete = function ()
	{
		var i, len;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			if (!audioBuffers[i].isLoaded())
				return false;
		}
		return true;
	};
	Cnds.prototype.AdvancedAudioSupported = function ()
	{
		return api === API_WEBAUDIO;
	};
	Cnds.prototype.IsSilent = function ()
	{
		return silent;
	};
	Cnds.prototype.IsAnyPlaying = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			if (audioInstances[i].isPlaying())
				return true;
		}
		return false;
	};
	Cnds.prototype.IsTagPlaying = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (taggedAudio[i].isPlaying())
				return true;
		}
		return false;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Play = function (file, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPosition = function (file, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObject = function (file, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayByName = function (folder, filename, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPositionByName = function (folder, filename, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObjectByName = function (folder, filename, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.SetLooping = function (tag, looping)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setLooping(looping === 0);
	};
	Acts.prototype.SetMuted = function (tag, muted)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setMuted(muted === 0);
	};
	Acts.prototype.SetVolume = function (tag, vol)
	{
		getAudioByTag(tag);
		var v = dbToLinear(vol);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setVolume(v);
	};
	Acts.prototype.Preload = function (file)
	{
		if (silent)
			return;
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.PreloadByName = function (folder, filename)
	{
		if (silent)
			return;
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.SetPlaybackRate = function (tag, rate)
	{
		getAudioByTag(tag);
		if (rate < 0.0)
			rate = 0;
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setPlaybackRate(rate);
	};
	Acts.prototype.Stop = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].stop();
	};
	Acts.prototype.StopAll = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].stop();
	};
	Acts.prototype.SetPaused = function (tag, state)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (state === 0)
				taggedAudio[i].pause();
			else
				taggedAudio[i].resume();
		}
	};
	Acts.prototype.Seek = function (tag, pos)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			taggedAudio[i].seek(pos);
		}
	};
	Acts.prototype.SetSilent = function (s)
	{
		var i, len;
		if (s === 2)					// toggling
			s = (silent ? 1 : 0);		// choose opposite state
		if (s === 0 && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (s === 1 && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	Acts.prototype.SetMasterVolume = function (vol)
	{
		masterVolume = dbToLinear(vol);
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].updateVolume();
	};
	Acts.prototype.AddFilterEffect = function (tag, type, freq, detune, q, gain, mix)
	{
		if (api !== API_WEBAUDIO || type < 0 || type >= filterTypes.length || !context["createBiquadFilter"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FilterEffect(type, freq, detune, q, gain, mix));
	};
	Acts.prototype.AddDelayEffect = function (tag, delay, gain, mix)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DelayEffect(delay, dbToLinear(gain), mix));
	};
	Acts.prototype.AddFlangerEffect = function (tag, delay, modulation, freq, feedback, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FlangerEffect(delay / 1000, modulation / 1000, freq, feedback / 100, mix));
	};
	Acts.prototype.AddPhaserEffect = function (tag, freq, detune, q, mod, modfreq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new PhaserEffect(freq, detune, q, mod, modfreq, mix));
	};
	Acts.prototype.AddConvolutionEffect = function (tag, file, norm, mix)
	{
		if (api !== API_WEBAUDIO || !context["createConvolver"])
			return;
		var doNormalize = (norm === 0);
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		var b = this.getAudioBuffer(src, false);
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		var fx;
		if (b.bufferObject)
		{
			fx = new ConvolveEffect(b.bufferObject, doNormalize, mix, src);
		}
		else
		{
			fx = new ConvolveEffect(null, doNormalize, mix, src);
			b.normalizeWhenReady = doNormalize;
			b.convolveWhenReady = fx;
		}
		addEffectForTag(tag, fx);
	};
	Acts.prototype.AddGainEffect = function (tag, g)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(dbToLinear(g)));
	};
	Acts.prototype.AddMuteEffect = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(0));	// re-use gain effect with 0 gain
	};
	Acts.prototype.AddTremoloEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new TremoloEffect(freq, mix));
	};
	Acts.prototype.AddRingModEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new RingModulatorEffect(freq, mix));
	};
	Acts.prototype.AddDistortionEffect = function (tag, threshold, headroom, drive, makeupgain, mix)
	{
		if (api !== API_WEBAUDIO || !context["createWaveShaper"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DistortionEffect(threshold, headroom, drive, makeupgain, mix));
	};
	Acts.prototype.AddCompressorEffect = function (tag, threshold, knee, ratio, attack, release)
	{
		if (api !== API_WEBAUDIO || !context["createDynamicsCompressor"])
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new CompressorEffect(threshold, knee, ratio, attack / 1000, release / 1000));
	};
	Acts.prototype.AddAnalyserEffect = function (tag, fftSize, smoothing)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new AnalyserEffect(fftSize, smoothing));
	};
	Acts.prototype.RemoveEffects = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		var i, len, arr;
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				for (i = 0, len = arr.length; i < len; i++)
					arr[i].remove();
				arr.length = 0;
				reconnectEffects(tag);
			}
		}
	};
	Acts.prototype.SetEffectParameter = function (tag, index, param, value, ramp, time)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var arr;
		if (!effects.hasOwnProperty(tag))
			return;
		arr = effects[tag];
		if (index < 0 || index >= arr.length)
			return;
		arr[index].setParam(param, value, ramp, time);
	};
	Acts.prototype.SetListenerObject = function (obj_)
	{
		if (!obj_ || api !== API_WEBAUDIO)
			return;
		var inst = obj_.getFirstPicked();
		if (!inst)
			return;
		this.listenerTracker.setObject(inst);
		listenerX = inst.x;
		listenerY = inst.y;
	};
	Acts.prototype.SetListenerZ = function (z)
	{
		this.listenerZ = z;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Duration = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getDuration());
		else
			ret.set_float(0);
	};
	Exps.prototype.PlaybackTime = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getPlaybackTime());
		else
			ret.set_float(0);
	};
	Exps.prototype.Volume = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
		{
			var v = taggedAudio[0].getVolume();
			ret.set_float(linearToDb(v));
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.MasterVolume = function (ret)
	{
		ret.set_float(masterVolume);
	};
	Exps.prototype.EffectCount = function (ret, tag)
	{
		tag = tag.toLowerCase();
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		ret.set_int(arr ? arr.length : 0);
	};
	function getAnalyser(tag, index)
	{
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		if (arr && index >= 0 && index < arr.length && arr[index].freqBins)
			return arr[index];
		else
			return null;
	};
	Exps.prototype.AnalyserFreqBinCount = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		ret.set_int(analyser ? analyser.node["frequencyBinCount"] : 0);
	};
	Exps.prototype.AnalyserFreqBinAt = function (ret, tag, index, bin)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		bin = Math.floor(bin);
		var analyser = getAnalyser(tag, index);
		if (!analyser)
			ret.set_float(0);
		else if (bin < 0 || bin >= analyser.node["frequencyBinCount"])
			ret.set_float(0);
		else
			ret.set_float(analyser.freqBins[bin]);
	};
	Exps.prototype.AnalyserPeakLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.peak);
		else
			ret.set_float(0);
	};
	Exps.prototype.AnalyserRMSLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.rms);
		else
			ret.set_float(0);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Browser = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Browser.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		window.addEventListener("resize", function () {
			self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize, self);
		});
		if (typeof navigator.onLine !== "undefined")
		{
			window.addEventListener("online", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline, self);
			});
			window.addEventListener("offline", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline, self);
			});
		}
		if (typeof window.applicationCache !== "undefined")
		{
			window.applicationCache.addEventListener('updateready', function() {
				self.runtime.loadingprogress = 1;
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			window.applicationCache.addEventListener('progress', function(e) {
				self.runtime.loadingprogress = e["loaded"] / e["total"];
			});
		}
		if (!this.runtime.isDirectCanvas)
		{
			document.addEventListener("appMobi.device.update.available", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			document.addEventListener("backbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			});
			document.addEventListener("menubutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
			});
			document.addEventListener("searchbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton, self);
			});
			document.addEventListener("tizenhwkey", function (e) {
				var ret;
				switch (e["keyName"]) {
				case "back":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
					if (!ret)
					{
						if (window["tizen"])
							window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
					}
					break;
				case "menu":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
					if (!ret)
						e.preventDefault();
					break;
				}
			});
		}
		this.runtime.addSuspendCallback(function(s) {
			if (s)
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden, self);
			}
			else
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible, self);
			}
		});
		this.is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	};
	function Cnds() {};
	Cnds.prototype.CookiesEnabled = function()
	{
		return navigator ? navigator.cookieEnabled : false;
	};
	Cnds.prototype.IsOnline = function()
	{
		return navigator ? navigator.onLine : false;
	};
	Cnds.prototype.HasJava = function()
	{
		return navigator ? navigator.javaEnabled() : false;
	};
	Cnds.prototype.OnOnline = function()
	{
		return true;
	};
	Cnds.prototype.OnOffline = function()
	{
		return true;
	};
	Cnds.prototype.IsDownloadingUpdate = function ()
	{
		if (typeof window["applicationCache"] === "undefined")
			return false;
		else
			return window["applicationCache"]["status"] === window["applicationCache"]["DOWNLOADING"];
	};
	Cnds.prototype.OnUpdateReady = function ()
	{
		return true;
	};
	Cnds.prototype.PageVisible = function ()
	{
		return !this.runtime.isSuspended;
	};
	Cnds.prototype.OnPageVisible = function ()
	{
		return true;
	};
	Cnds.prototype.OnPageHidden = function ()
	{
		return true;
	};
	Cnds.prototype.OnResize = function ()
	{
		return true;
	};
	Cnds.prototype.IsFullscreen = function ()
	{
		return !!(document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
	};
	Cnds.prototype.OnBackButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnMenuButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnSearchButton = function ()
	{
		return true;
	};
	Cnds.prototype.IsMetered = function ()
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			return false;
		return connection["metered"];
	};
	Cnds.prototype.IsCharging = function ()
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			return true;
		return battery["charging"];
	};
	Cnds.prototype.IsPortraitLandscape = function (p)
	{
		var current = (window.innerWidth <= window.innerHeight ? 0 : 1);
		return current === p;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Alert = function (msg)
	{
		if (!this.runtime.isDomFree)
			alert(msg.toString());
	};
	Acts.prototype.Close = function ()
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["forceToFinish"]();
		else if (window["tizen"])
			window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
		else if (navigator["app"] && navigator["app"]["exitApp"])
			navigator["app"]["exitApp"]();
		else if (navigator["device"] && navigator["device"]["exitApp"])
			navigator["device"]["exitApp"]();
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.close();
	};
	Acts.prototype.Focus = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["focus"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.focus();
	};
	Acts.prototype.Blur = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["blur"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.blur();
	};
	Acts.prototype.GoBack = function ()
	{
		if (navigator["app"] && navigator["app"]["backHistory"])
			navigator["app"]["backHistory"]();
		else if (!this.is_arcade && !this.runtime.isDomFree && window.back)
			window.back();
	};
	Acts.prototype.GoForward = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.forward)
			window.forward();
	};
	Acts.prototype.GoHome = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.home)
			window.home();
	};
	Acts.prototype.GoToURL = function (url)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.location = url;
	};
	Acts.prototype.GoToURLWindow = function (url, tag)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.open(url, tag);
	};
	Acts.prototype.Reload = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree)
			window.location.reload();
	};
	var firstRequestFullscreen = true;
	var crruntime = null;
	function onFullscreenError()
	{
		if (typeof jQuery !== "undefined")
		{
			crruntime["setSize"](jQuery(window).width(), jQuery(window).height());
		}
	};
	Acts.prototype.RequestFullScreen = function (stretchmode)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (stretchmode >= 2)
			stretchmode += 1;
		if (stretchmode === 6)
			stretchmode = 2;
		if (this.runtime.isNodeWebkit)
		{
			if (!this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["enterFullscreen"]();
				this.runtime.isNodeFullscreen = true;
			}
		}
		else
		{
			if (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"])
			{
				return;
			}
			this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			var elem = this.runtime.canvasdiv || this.runtime.canvas;
			if (firstRequestFullscreen)
			{
				firstRequestFullscreen = false;
				crruntime = this.runtime;
				elem.addEventListener("mozfullscreenerror", onFullscreenError);
				elem.addEventListener("webkitfullscreenerror", onFullscreenError);
				elem.addEventListener("msfullscreenerror", onFullscreenError);
				elem.addEventListener("fullscreenerror", onFullscreenError);
			}
			if (!cr.is_undefined(elem["requestFullscreen"]))
				elem["requestFullscreen"]();
			else if (!cr.is_undefined(elem["webkitRequestFullScreen"]))
			{
				if (typeof Element !== "undefined" && typeof Element["ALLOW_KEYBOARD_INPUT"] !== "undefined")
					elem["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
				else
					elem["webkitRequestFullScreen"]();
			}
			else if (!cr.is_undefined(elem["mozRequestFullScreen"]))
				elem["mozRequestFullScreen"]();
			else if (!cr.is_undefined(elem["msRequestFullscreen"]))
				elem["msRequestFullscreen"]();
		}
	};
	Acts.prototype.CancelFullScreen = function ()
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (this.runtime.isNodeWebkit)
		{
			if (this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["leaveFullscreen"]();
				this.runtime.isNodeFullscreen = false;
			}
		}
		else
		{
			if (!cr.is_undefined(document["exitFullscreen"]))
				document["exitFullscreen"]();
			else if (!cr.is_undefined(document["webkitCancelFullScreen"]))
				document["webkitCancelFullScreen"]();
			else if (!cr.is_undefined(document["mozCancelFullScreen"]))
				document["mozCancelFullScreen"]();
			else if (!cr.is_undefined(document["msExitFullscreen"]))
				document["msExitFullscreen"]();
		}
	};
	Acts.prototype.Vibrate = function (pattern_)
	{
		try {
			var arr = pattern_.split(",");
			var i, len;
			for (i = 0, len = arr.length; i < len; i++)
			{
				arr[i] = parseInt(arr[i], 10);
			}
			if (navigator["vibrate"])
				navigator["vibrate"](arr);
			else if (navigator["mozVibrate"])
				navigator["mozVibrate"](arr);
			else if (navigator["webkitVibrate"])
				navigator["webkitVibrate"](arr);
			else if (navigator["msVibrate"])
				navigator["msVibrate"](arr);
		}
		catch (e) {}
	};
	Acts.prototype.InvokeDownload = function (url_, filename_)
	{
		var a = document.createElement("a");
		if (typeof a.download === "undefined")
		{
			window.open(url_);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = url_;
			a.download = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.InvokeDownloadString = function (str_, mimetype_, filename_)
	{
		var datauri = "data:" + mimetype_ + "," + encodeURIComponent(str_);
		var a = document.createElement("a");
		if (typeof a.download === "undefined")
		{
			window.open(datauri);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = datauri;
			a.download = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.ConsoleLog = function (type_, msg_)
	{
		if (typeof console === "undefined")
			return;
		if (type_ === 0 && console.log)
			console.log(msg_.toString());
		if (type_ === 1 && console.warn)
			console.warn(msg_.toString());
		if (type_ === 2 && console.error)
			console.error(msg_.toString());
	};
	Acts.prototype.ConsoleGroup = function (name_)
	{
		if (console && console.group)
			console.group(name_);
	};
	Acts.prototype.ConsoleGroupEnd = function ()
	{
		if (console && console.groupEnd)
			console.groupEnd();
	};
	Acts.prototype.ExecJs = function (js_)
	{
		if (eval)
			eval(js_);
	};
	var orientations = [
		"portrait",
		"landscape",
		"portrait-primary",
		"portrait-secondary",
		"landscape-primary",
		"landscape-secondary"
	];
	Acts.prototype.LockOrientation = function (o)
	{
		o = Math.floor(o);
		if (o < 0 || o >= orientations.length)
			return;
		this.runtime.autoLockOrientation = false;
		var orientation = orientations[o];
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Acts.prototype.UnlockOrientation = function ()
	{
		this.runtime.autoLockOrientation = false;
		if (screen["unlockOrientation"])
			screen["unlockOrientation"]();
		else if (screen["webkitUnlockOrientation"])
			screen["webkitUnlockOrientation"]();
		else if (screen["mozUnlockOrientation"])
			screen["mozUnlockOrientation"]();
		else if (screen["msUnlockOrientation"])
			screen["msUnlockOrientation"]();
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.URL = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.toString());
	};
	Exps.prototype.Protocol = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.protocol);
	};
	Exps.prototype.Domain = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hostname);
	};
	Exps.prototype.PathName = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.pathname);
	};
	Exps.prototype.Hash = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hash);
	};
	Exps.prototype.Referrer = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.referrer);
	};
	Exps.prototype.Title = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.title);
	};
	Exps.prototype.Name = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appName);
	};
	Exps.prototype.Version = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appVersion);
	};
	Exps.prototype.Language = function (ret)
	{
		if (navigator && navigator.language)
			ret.set_string(navigator.language);
		else
			ret.set_string("");
	};
	Exps.prototype.Platform = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.platform);
	};
	Exps.prototype.Product = function (ret)
	{
		if (navigator && navigator.product)
			ret.set_string(navigator.product);
		else
			ret.set_string("");
	};
	Exps.prototype.Vendor = function (ret)
	{
		if (navigator && navigator.vendor)
			ret.set_string(navigator.vendor);
		else
			ret.set_string("");
	};
	Exps.prototype.UserAgent = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.userAgent);
	};
	Exps.prototype.QueryString = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.search);
	};
	Exps.prototype.QueryParam = function (ret, paramname)
	{
		if (this.runtime.isDomFree)
		{
			ret.set_string("");
			return;
		}
		var match = RegExp('[?&]' + paramname + '=([^&]*)').exec(window.location.search);
		if (match)
			ret.set_string(decodeURIComponent(match[1].replace(/\+/g, ' ')));
		else
			ret.set_string("");
	};
	Exps.prototype.Bandwidth = function (ret)
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(connection["bandwidth"]);
	};
	Exps.prototype.BatteryLevel = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(1);
		else
			ret.set_float(battery["level"]);
	};
	Exps.prototype.BatteryTimeLeft = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(battery["dischargingTime"]);
	};
	Exps.prototype.ExecJS = function (ret, js_)
	{
		if (!eval)
		{
			ret.set_any(0);
			return;
		}
		var result = eval(js_);
		if (typeof result === "number")
			ret.set_any(result);
		else if (typeof result === "string")
			ret.set_any(result);
		else if (typeof result === "boolean")
			ret.set_any(result ? 1 : 0);
		else
			ret.set_any(0);
	};
	Exps.prototype.ScreenWidth = function (ret)
	{
		ret.set_int(screen.width);
	};
	Exps.prototype.ScreenHeight = function (ret)
	{
		ret.set_int(screen.height);
	};
	Exps.prototype.DevicePixelRatio = function (ret)
	{
		ret.set_float(this.runtime.devicePixelRatio);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.CJSAds = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var input_text = "";
	var products_list = [];
	var requested_score = 0;
	var bannerPosition = 0;
	var preloadingBanner = false;
	var bannerReady = false;
	var preloadingFullscreen = false;
	var fullscreenReady = false;
	var pluginProto = cr.plugins_.CJSAds.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.isShowingBanner = false;
		this.isShowingFullscreen = false;
		this.triggerProduct = "";
		this.socialService = null;
		this.socialServiceAvailable = false;
		this.storeServiceAvailable = (this.runtime.isCocoonJs && typeof CocoonJS["Store"]["nativeExtensionObjectAvailable"] !== "undefined");
		this.storeManaged = (this.properties[0] !== 1);
		this.storeSandboxed = (this.properties[1] !== 0);
		this.onConsumePurchaseFailedTransactionId = "";
		this.onConsumePurchaseCompleted = "";
		var self = this;
		if (this.runtime.isCocoonJs)
		{
			CocoonJS["App"]["onTextDialogFinished"].addEventListener(function(text) {
				input_text = text;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK, self);
			});
			CocoonJS["App"]["onTextDialogCancelled"].addEventListener(function() {
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled, self);
			});
			CocoonJS["Ad"]["onBannerShown"].addEventListener(function ()
			{
				self.isShowingBanner = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown, self);
			});
			CocoonJS["Ad"]["onBannerReady"].addEventListener(function ()
			{
				bannerReady = true;
				if (!preloadingBanner)
				{
					CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
					CocoonJS["Ad"]["showBanner"]();
				}
			});
			CocoonJS["Ad"]["onFullScreenShown"].addEventListener(function ()
			{
				self.isShowingFullscreen = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown, self);
			});
			CocoonJS["Ad"]["onFullScreenHidden"].addEventListener(function ()
			{
				self.isShowingFullscreen = false;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden, self);
			});
			CocoonJS["Ad"]["onFullScreenReady"].addEventListener(function ()
			{
				fullscreenReady = true;
				if (!preloadFullScreen)
					CocoonJS["Ad"]["showFullScreen"]();
			});
			if (this.storeServiceAvailable)
			{
				CocoonJS["Store"]["onProductPurchaseCompleted"].addEventListener(function (purchase)
				{
					self.triggerProduct = purchase["productId"];
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete, self);
					CocoonJS["Store"]["addPurchase"](purchase);
					CocoonJS["Store"]["consumePurchase"](purchase["transactionId"], purchase["productId"]);
					CocoonJS["Store"]["finishPurchase"](purchase["transactionId"]);
				});
				CocoonJS["Store"]["onConsumePurchaseFailed"].addEventListener(function(transactionId, errorMessage)
				{
					this.onConsumePurchaseFailedTransactionId = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed, self);
				});
				CocoonJS["Store"]["onConsumePurchaseCompleted"].addEventListener(function(transactionId)
				{
					this.onConsumePurchaseCompleted = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted, self);
				});
				CocoonJS["Store"]["onProductPurchaseFailed"].addEventListener(function (productId, errorMsg)
				{
					self.triggerProduct = productId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail, self);
				});
				CocoonJS["Store"]["onProductPurchaseStarted"].addEventListener(function (productinfo)
				{
					self.triggerProduct = productinfo["productId"];
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart, self);
				});
				CocoonJS["Store"]["onProductsFetchStarted"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted, self);
				});
				CocoonJS["Store"]["onProductsFetchFailed"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed, self);
				});
				CocoonJS["Store"]["onProductsFetchCompleted"].addEventListener(function (products)
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted, self);
				});
				CocoonJS["Store"]["requestInitialization"]({
					"managed": this.storeManaged,
					"sandbox": this.storeSandboxed
				});
				CocoonJS["Store"]["start"]();
			}
			this.socialService = CocoonJS["SocialGaming"]["GameCenter"];
			this.socialServiceAvailable = !!this.socialService["nativeExtensionObjectAvailable"];
			this.socialService["onRequestLoginSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess, self);
			});
			this.socialService["onRequestLoginFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail, self);
			});
			this.socialService["onLogout"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout, self);
			});
			this.socialService["onRequestUserScoreSucceed"].addEventListener(function (userInfo) {
				requested_score = userInfo["score"] || 0;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived, self);
			});
			this.socialService["onRequestUserScoreFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable, self);
			});
			this.socialService["onSubmitUserScoreSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess, self);
			});
			this.socialService["onSubmitUserScoreFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail, self);
			});
			this.socialService["onLeaderboardViewSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen, self);
			});
			this.socialService["onLeaderboardViewClosed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose, self);
			});
		}
	};
	function Cnds() {};
	Cnds.prototype.IsShowingBanner = function ()
	{
		return this.isShowingBanner;
	};
	Cnds.prototype.IsCocoonJS = function ()
	{
		return this.runtime.isCocoonJs;
	};
	Cnds.prototype.OnBannerShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenHidden = function ()
	{
		return true;
	};
	Cnds.prototype.IsShowingFullscreen = function ()
	{
		return this.isShowingFullscreen;
	};
	Cnds.prototype.IsStoreAvailable = function ()
	{
		if (this.runtime.isCocoonJs)
			return this.storeServiceAvailable && CocoonJS["Store"]["canPurchase"]();
		else
			return false;
	};
	Cnds.prototype.OnPurchaseStart = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseComplete = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseFail = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.onProductsFetchStarted = function(){
		return true;
	}
	Cnds.prototype.onConsumePurchaseFailed = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchCompleted = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchFailed = function(){
		return true;
	}
	Cnds.prototype.IsProductPurchased = function (productid)
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["isProductPurchased"](productid);
		else
			return false;
	};
	Cnds.prototype.OnKeyboardCancelled = function ()
	{
		return true;
	};
	Cnds.prototype.OnKeyboardOK = function ()
	{
		return true;
	};
	Cnds.prototype.IsGCAvailable = function ()
	{
		return this.socialServiceAvailable;
	};
	Cnds.prototype.IsGCLoggedIn = function ()
	{
		if (!this.socialServiceAvailable)
			return false;
		return this.socialService["isLoggedIn"]();
	};
	Cnds.prototype.OnGCLoginSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLoginFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLogout = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreReceived = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreUnavailable = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreSubmitSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreSubmitFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLeaderboardOpen = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLeaderboardClose = function ()
	{
		return true;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.ShowBanner = function (layout_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		bannerPosition = (layout_ === 0 ? CocoonJS["Ad"]["BannerLayout"]["TOP_CENTER"] : CocoonJS["Ad"]["BannerLayout"]["BOTTOM_CENTER"]);
		preloadingBanner = false;
		if (bannerReady)
		{
			CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
			CocoonJS["Ad"]["showBanner"]();
		}
		else
		{
			CocoonJS["Ad"]["preloadBanner"]();
		}
	};
	Acts.prototype.ShowFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = false;
		if (fullscreenReady)
			CocoonJS["Ad"]["showFullScreen"]();
		else
			CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.HideBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["hideBanner"]();
		this.isShowingBanner = false;
	};
	Acts.prototype.PreloadBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingBanner = true;
		CocoonJS["Ad"]["preloadBanner"]();
	};
	Acts.prototype.PreloadFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = true;
		CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.RefreshBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshBanner"]();
	};
	Acts.prototype.RefreshFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshFullScreen"]();
	};
	Acts.prototype.Purchase = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProduct"](productid);
	};
	Acts.prototype.fetchProductsFromStore = function (products)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["fetchProductsFromStore"](products.split(","));
	};
	Acts.prototype.restorePurchases = function ()
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PurchasePreview = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProductModalWithPreview"](productid);
	};
	Acts.prototype.RestorePurchases = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PromptKeyboard = function (title_, message_, initial_, type_, canceltext_, oktext_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		var typestr = ["text", "num", "phone", "email", "url"][type_];
		CocoonJS["App"]["showTextDialog"](title_, message_, initial_, typestr, canceltext_, oktext_);
	};
	Acts.prototype.UpdateProductsList = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		if (!CocoonJS["Store"]["canPurchase"]())
			return;
		products_list = CocoonJS["Store"]["getProducts"]();
	};
	Acts.prototype.GCLogin = function ()
	{
		if (!this.socialServiceAvailable || this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestLogin"]();
	};
	Acts.prototype.GCLogout = function ()
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestLogout"]();
	};
	Acts.prototype.GCSubmitScore = function (score_, leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["submitUserScore"](score_, leaderboard_);
	};
	Acts.prototype.GCRequestScore = function (leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestUserScore"](leaderboard_);
	};
	Acts.prototype.GCOpenLeaderboard = function (leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["showLeaderboardView"](leaderboard_);
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.InputText = function (ret)
	{
		ret.set_string(input_text);
	};
	Exps.prototype.ProductCount = function (ret)
	{
		ret.set_int(products_list.length);
	};
	Exps.prototype.ProductDescription = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["description"]);
	};
	Exps.prototype.ProductLocalizedPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["localizedPrice"]);
	};
	Exps.prototype.ProductPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["price"]);
	};
	Exps.prototype.ProductAlias = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productAlias"]);
	};
	Exps.prototype.ProductID = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productId"]);
	};
	Exps.prototype.ProductTitle = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["title"]);
	};
	Exps.prototype.GameCenterScore = function (ret)
	{
		ret.set_float(requested_score);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Sprite = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Sprite.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	function frame_getDataUri()
	{
		if (this.datauri.length === 0)
		{
			var tmpcanvas = document.createElement("canvas");
			tmpcanvas.width = this.width;
			tmpcanvas.height = this.height;
			var tmpctx = tmpcanvas.getContext("2d");
			if (this.spritesheeted)
			{
				tmpctx.drawImage(this.texture_img, this.offx, this.offy, this.width, this.height,
										 0, 0, this.width, this.height);
			}
			else
			{
				tmpctx.drawImage(this.texture_img, 0, 0, this.width, this.height);
			}
			this.datauri = tmpcanvas.toDataURL("image/png");
		}
		return this.datauri;
	};
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		var i, leni, j, lenj;
		var anim, frame, animobj, frameobj, wt, uv;
		this.all_frames = [];
		this.has_loaded_textures = false;
		for (i = 0, leni = this.animations.length; i < leni; i++)
		{
			anim = this.animations[i];
			animobj = {};
			animobj.name = anim[0];
			animobj.speed = anim[1];
			animobj.loop = anim[2];
			animobj.repeatcount = anim[3];
			animobj.repeatto = anim[4];
			animobj.pingpong = anim[5];
			animobj.sid = anim[6];
			animobj.frames = [];
			for (j = 0, lenj = anim[7].length; j < lenj; j++)
			{
				frame = anim[7][j];
				frameobj = {};
				frameobj.texture_file = frame[0];
				frameobj.texture_filesize = frame[1];
				frameobj.offx = frame[2];
				frameobj.offy = frame[3];
				frameobj.width = frame[4];
				frameobj.height = frame[5];
				frameobj.duration = frame[6];
				frameobj.hotspotX = frame[7];
				frameobj.hotspotY = frame[8];
				frameobj.image_points = frame[9];
				frameobj.poly_pts = frame[10];
				frameobj.pixelformat = frame[11];
				frameobj.spritesheeted = (frameobj.width !== 0);
				frameobj.datauri = "";		// generated on demand and cached
				frameobj.getDataUri = frame_getDataUri;
				uv = {};
				uv.left = 0;
				uv.top = 0;
				uv.right = 1;
				uv.bottom = 1;
				frameobj.sheetTex = uv;
				frameobj.webGL_texture = null;
				wt = this.runtime.findWaitingTexture(frame[0]);
				if (wt)
				{
					frameobj.texture_img = wt;
				}
				else
				{
					frameobj.texture_img = new Image();
					frameobj.texture_img["idtkLoadDisposed"] = true;
					frameobj.texture_img.src = frame[0];
					frameobj.texture_img.cr_src = frame[0];
					frameobj.texture_img.cr_filesize = frame[1];
					frameobj.texture_img.c2webGL_texture = null;
					this.runtime.waitForImageLoad(frameobj.texture_img);
				}
				cr.seal(frameobj);
				animobj.frames.push(frameobj);
				this.all_frames.push(frameobj);
			}
			cr.seal(animobj);
			this.animations[i] = animobj;		// swap array data for object
		}
	};
	typeProto.updateAllCurrentTexture = function ()
	{
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.curWebGLTexture = inst.curFrame.webGL_texture;
		}
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.texture_img.c2webGL_texture = null;
			frame.webGL_texture = null;
		}
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.updateAllCurrentTexture();
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.has_loaded_textures || !this.runtime.glwrap)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.has_loaded_textures = true;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.has_loaded_textures)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			this.runtime.glwrap.deleteTexture(frame.webGL_texture);
		}
		this.has_loaded_textures = false;
	};
	var already_drawn_images = [];
	typeProto.preloadCanvas2D = function (ctx)
	{
		var i, len, frameimg;
		already_drawn_images.length = 0;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frameimg = this.all_frames[i].texture_img;
			if (already_drawn_images.indexOf(frameimg) !== -1)
					continue;
			ctx.drawImage(frameimg, 0, 0);
			already_drawn_images.push(frameimg);
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		var poly_pts = this.type.animations[0].frames[0].poly_pts;
		if (this.recycled)
			this.collision_poly.set_pts(poly_pts);
		else
			this.collision_poly = new cr.CollisionPoly(poly_pts);
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);	// 0=visible, 1=invisible
		this.isTicking = false;
		this.inAnimTrigger = false;
		this.collisionsEnabled = (this.properties[3] !== 0);
		if (!(this.type.animations.length === 1 && this.type.animations[0].frames.length === 1) && this.type.animations[0].speed !== 0)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		this.cur_animation = this.getAnimationByName(this.properties[1]) || this.type.animations[0];
		this.cur_frame = this.properties[2];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		var curanimframe = this.cur_animation.frames[this.cur_frame];
		this.collision_poly.set_pts(curanimframe.poly_pts);
		this.hotspotX = curanimframe.hotspotX;
		this.hotspotY = curanimframe.hotspotY;
		this.cur_anim_speed = this.cur_animation.speed;
		if (this.recycled)
			this.animTimer.reset();
		else
			this.animTimer = new cr.KahanAdder();
		this.frameStart = this.getNowTime();
		this.animPlaying = true;
		this.animRepeats = 0;
		this.animForwards = true;
		this.animTriggerName = "";
		this.changeAnimName = "";
		this.changeAnimFrom = 0;
		this.changeAnimFrame = -1;
		this.type.loadTextures();
		var i, leni, j, lenj;
		var anim, frame, uv, maintex;
		for (i = 0, leni = this.type.animations.length; i < leni; i++)
		{
			anim = this.type.animations[i];
			for (j = 0, lenj = anim.frames.length; j < lenj; j++)
			{
				frame = anim.frames[j];
				if (frame.width === 0)
				{
					frame.width = frame.texture_img.width;
					frame.height = frame.texture_img.height;
				}
				if (frame.spritesheeted)
				{
					maintex = frame.texture_img;
					uv = frame.sheetTex;
					uv.left = frame.offx / maintex.width;
					uv.top = frame.offy / maintex.height;
					uv.right = (frame.offx + frame.width) / maintex.width;
					uv.bottom = (frame.offy + frame.height) / maintex.height;
					if (frame.offx === 0 && frame.offy === 0 && frame.width === maintex.width && frame.height === maintex.height)
					{
						frame.spritesheeted = false;
					}
				}
			}
		}
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"a": this.cur_animation.sid,
			"f": this.cur_frame,
			"cas": this.cur_anim_speed,
			"fs": this.frameStart,
			"ar": this.animRepeats,
			"at": this.animTimer.sum
		};
		if (!this.animPlaying)
			o["ap"] = this.animPlaying;
		if (!this.animForwards)
			o["af"] = this.animForwards;
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		var anim = this.getAnimationBySid(o["a"]);
		if (anim)
			this.cur_animation = anim;
		this.cur_frame = o["f"];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		this.cur_anim_speed = o["cas"];
		this.frameStart = o["fs"];
		this.animRepeats = o["ar"];
		this.animTimer.reset();
		this.animTimer.sum = o["at"];
		this.animPlaying = o.hasOwnProperty("ap") ? o["ap"] : true;
		this.animForwards = o.hasOwnProperty("af") ? o["af"] : true;
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
		this.collision_poly.set_pts(this.curFrame.poly_pts);
		this.hotspotX = this.curFrame.hotspotX;
		this.hotspotY = this.curFrame.hotspotY;
	};
	instanceProto.animationFinish = function (reverse)
	{
		this.cur_frame = reverse ? 0 : this.cur_animation.frames.length - 1;
		this.animPlaying = false;
		this.animTriggerName = this.cur_animation.name;
		this.inAnimTrigger = true;
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished, this);
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished, this);
		this.inAnimTrigger = false;
		this.animRepeats = 0;
	};
	instanceProto.getNowTime = function()
	{
		return this.animTimer.sum;
	};
	instanceProto.tick = function()
	{
		this.animTimer.add(this.runtime.getDt(this));
		if (this.changeAnimName.length)
			this.doChangeAnim();
		if (this.changeAnimFrame >= 0)
			this.doChangeAnimFrame();
		var now = this.getNowTime();
		var cur_animation = this.cur_animation;
		var prev_frame = cur_animation.frames[this.cur_frame];
		var next_frame;
		var cur_frame_time = prev_frame.duration / this.cur_anim_speed;
		if (this.animPlaying && now >= this.frameStart + cur_frame_time)
		{
			if (this.animForwards)
			{
				this.cur_frame++;
			}
			else
			{
				this.cur_frame--;
			}
			this.frameStart += cur_frame_time;
			if (this.cur_frame >= cur_animation.frames.length)
			{
				if (cur_animation.pingpong)
				{
					this.animForwards = false;
					this.cur_frame = cur_animation.frames.length - 2;
				}
				else if (cur_animation.loop)
				{
					this.cur_frame = cur_animation.repeatto;
				}
				else
				{
					this.animRepeats++;
					if (this.animRepeats >= cur_animation.repeatcount)
					{
						this.animationFinish(false);
					}
					else
					{
						this.cur_frame = cur_animation.repeatto;
					}
				}
			}
			if (this.cur_frame < 0)
			{
				if (cur_animation.pingpong)
				{
					this.cur_frame = 1;
					this.animForwards = true;
					if (!cur_animation.loop)
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
					}
				}
				else
				{
					if (cur_animation.loop)
					{
						this.cur_frame = cur_animation.repeatto;
					}
					else
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
						else
						{
							this.cur_frame = cur_animation.repeatto;
						}
					}
				}
			}
			if (this.cur_frame < 0)
				this.cur_frame = 0;
			else if (this.cur_frame >= cur_animation.frames.length)
				this.cur_frame = cur_animation.frames.length - 1;
			if (now > this.frameStart + (cur_animation.frames[this.cur_frame].duration / this.cur_anim_speed))
			{
				this.frameStart = now;
			}
			next_frame = cur_animation.frames[this.cur_frame];
			this.OnFrameChanged(prev_frame, next_frame);
			this.runtime.redraw = true;
		}
	};
	instanceProto.getAnimationByName = function (name_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (cr.equals_nocase(a.name, name_))
				return a;
		}
		return null;
	};
	instanceProto.getAnimationBySid = function (sid_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (a.sid === sid_)
				return a;
		}
		return null;
	};
	instanceProto.doChangeAnim = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var anim = this.getAnimationByName(this.changeAnimName);
		this.changeAnimName = "";
		if (!anim)
			return;
		if (cr.equals_nocase(anim.name, this.cur_animation.name) && this.animPlaying)
			return;
		this.cur_animation = anim;
		this.cur_anim_speed = anim.speed;
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (this.changeAnimFrom === 1)
			this.cur_frame = 0;
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		this.animForwards = true;
		this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
		this.runtime.redraw = true;
	};
	instanceProto.doChangeAnimFrame = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var prev_frame_number = this.cur_frame;
		this.cur_frame = cr.floor(this.changeAnimFrame);
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (prev_frame_number !== this.cur_frame)
		{
			this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
			this.frameStart = this.getNowTime();
			this.runtime.redraw = true;
		}
		this.changeAnimFrame = -1;
	};
	instanceProto.OnFrameChanged = function (prev_frame, next_frame)
	{
		var oldw = prev_frame.width;
		var oldh = prev_frame.height;
		var neww = next_frame.width;
		var newh = next_frame.height;
		if (oldw != neww)
			this.width *= (neww / oldw);
		if (oldh != newh)
			this.height *= (newh / oldh);
		this.hotspotX = next_frame.hotspotX;
		this.hotspotY = next_frame.hotspotY;
		this.collision_poly.set_pts(next_frame.poly_pts);
		this.set_bbox_changed();
		this.curFrame = next_frame;
		this.curWebGLTexture = next_frame.webGL_texture;
		var i, len, b;
		for (i = 0, len = this.behavior_insts.length; i < len; i++)
		{
			b = this.behavior_insts[i];
			if (b.onSpriteFrameChanged)
				b.onSpriteFrameChanged(prev_frame, next_frame);
		}
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged, this);
	};
	instanceProto.draw = function(ctx)
	{
		ctx.globalAlpha = this.opacity;
		var cur_frame = this.curFrame;
		var spritesheeted = cur_frame.spritesheeted;
		var cur_image = cur_frame.texture_img;
		var myx = this.x;
		var myy = this.y;
		var w = this.width;
		var h = this.height;
		if (this.angle === 0 && w >= 0 && h >= 0)
		{
			myx -= this.hotspotX * w;
			myy -= this.hotspotY * h;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 myx, myy, w, h);
			}
			else
			{
				ctx.drawImage(cur_image, myx, myy, w, h);
			}
		}
		else
		{
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			var widthfactor = w > 0 ? 1 : -1;
			var heightfactor = h > 0 ? 1 : -1;
			ctx.translate(myx, myy);
			if (widthfactor !== 1 || heightfactor !== 1)
				ctx.scale(widthfactor, heightfactor);
			ctx.rotate(this.angle * widthfactor * heightfactor);
			var drawx = 0 - (this.hotspotX * cr.abs(w))
			var drawy = 0 - (this.hotspotY * cr.abs(h));
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 drawx, drawy, cr.abs(w), cr.abs(h));
			}
			else
			{
				ctx.drawImage(cur_image, drawx, drawy, cr.abs(w), cr.abs(h));
			}
			ctx.restore();
		}
		/*
		ctx.strokeStyle = "#f00";
		ctx.lineWidth = 3;
		ctx.beginPath();
		this.collision_poly.cache_poly(this.width, this.height, this.angle);
		var i, len, ax, ay, bx, by;
		for (i = 0, len = this.collision_poly.pts_count; i < len; i++)
		{
			ax = this.collision_poly.pts_cache[i*2] + this.x;
			ay = this.collision_poly.pts_cache[i*2+1] + this.y;
			bx = this.collision_poly.pts_cache[((i+1)%len)*2] + this.x;
			by = this.collision_poly.pts_cache[((i+1)%len)*2+1] + this.y;
			ctx.moveTo(ax, ay);
			ctx.lineTo(bx, by);
		}
		ctx.stroke();
		ctx.closePath();
		*/
		/*
		if (this.behavior_insts.length >= 1 && this.behavior_insts[0].draw)
		{
			this.behavior_insts[0].draw(ctx);
		}
		*/
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.curWebGLTexture);
		glw.setOpacity(this.opacity);
		var cur_frame = this.curFrame;
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = ((this.x + 0.5) | 0) - this.x;
			var oy = ((this.y + 0.5) | 0) - this.y;
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy, cur_frame.sheetTex);
			else
				glw.quad(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy);
		}
		else
		{
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly, cur_frame.sheetTex);
			else
				glw.quad(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly);
		}
	};
	instanceProto.getImagePointIndexByName = function(name_)
	{
		var cur_frame = this.curFrame;
		var i, len;
		for (i = 0, len = cur_frame.image_points.length; i < len; i++)
		{
			if (cr.equals_nocase(name_, cur_frame.image_points[i][0]))
				return i;
		}
		return -1;
	};
	instanceProto.getImagePoint = function(imgpt, getX)
	{
		var cur_frame = this.curFrame;
		var image_points = cur_frame.image_points;
		var index;
		if (cr.is_string(imgpt))
			index = this.getImagePointIndexByName(imgpt);
		else
			index = imgpt - 1;	// 0 is origin
		index = cr.floor(index);
		if (index < 0 || index >= image_points.length)
			return getX ? this.x : this.y;	// return origin
		var x = (image_points[index][1] - cur_frame.hotspotX) * this.width;
		var y = image_points[index][2];
		y = (y - cur_frame.hotspotY) * this.height;
		var cosa = Math.cos(this.angle);
		var sina = Math.sin(this.angle);
		var x_temp = (x * cosa) - (y * sina);
		y = (y * cosa) + (x * sina);
		x = x_temp;
		x += this.x;
		y += this.y;
		return getX ? x : y;
	};
	function Cnds() {};
	var arrCache = [];
	function allocArr()
	{
		if (arrCache.length)
			return arrCache.pop();
		else
			return [0, 0, 0];
	};
	function freeArr(a)
	{
		a[0] = 0;
		a[1] = 0;
		a[2] = 0;
		arrCache.push(a);
	};
	function makeCollKey(a, b)
	{
		if (a < b)
			return "" + a + "," + b;
		else
			return "" + b + "," + a;
	};
	function collmemory_add(collmemory, a, b, tickcount)
	{
		var a_uid = a.uid;
		var b_uid = b.uid;
		var key = makeCollKey(a_uid, b_uid);
		if (collmemory.hasOwnProperty(key))
		{
			collmemory[key][2] = tickcount;
			return;
		}
		var arr = allocArr();
		arr[0] = a_uid;
		arr[1] = b_uid;
		arr[2] = tickcount;
		collmemory[key] = arr;
	};
	function collmemory_remove(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			freeArr(collmemory[key]);
			delete collmemory[key];
		}
	};
	function collmemory_removeInstance(collmemory, inst)
	{
		var uid = inst.uid;
		var p, entry;
		for (p in collmemory)
		{
			if (collmemory.hasOwnProperty(p))
			{
				entry = collmemory[p];
				if (entry[0] === uid || entry[1] === uid)
				{
					freeArr(collmemory[p]);
					delete collmemory[p];
				}
			}
		}
	};
	var last_coll_tickcount = -2;
	function collmemory_has(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			last_coll_tickcount = collmemory[key][2];
			return true;
		}
		else
		{
			last_coll_tickcount = -2;
			return false;
		}
	};
	var candidates = [];
	Cnds.prototype.OnCollision = function (rtype)
	{
		if (!rtype)
			return false;
		var runtime = this.runtime;
		var cnd = runtime.getCurrentCondition();
		var ltype = cnd.type;
		if (!cnd.extra.collmemory)
		{
			cnd.extra.collmemory = {};
			runtime.addDestroyCallback((function (collmemory) {
				return function(inst) {
					collmemory_removeInstance(collmemory, inst);
				};
			})(cnd.extra.collmemory));
		}
		var collmemory = cnd.extra.collmemory;
		var lsol = ltype.getCurrentSol();
		var rsol = rtype.getCurrentSol();
		var linstances = lsol.getObjects();
		var rinstances;
		var l, linst, r, rinst;
		var curlsol, currsol;
		var tickcount = this.runtime.tickcount;
		var lasttickcount = tickcount - 1;
		var exists, run;
		var current_event = runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		for (l = 0; l < linstances.length; l++)
		{
			linst = linstances[l];
			if (rsol.select_all)
			{
				linst.update_bbox();
				this.runtime.getCollisionCandidates(linst.layer, rtype, linst.bbox, candidates);
				rinstances = candidates;
			}
			else
				rinstances = rsol.getObjects();
			for (r = 0; r < rinstances.length; r++)
			{
				rinst = rinstances[r];
				if (runtime.testOverlap(linst, rinst) || runtime.checkRegisteredCollision(linst, rinst))
				{
					exists = collmemory_has(collmemory, linst, rinst);
					run = (!exists || (last_coll_tickcount < lasttickcount));
					collmemory_add(collmemory, linst, rinst, tickcount);
					if (run)
					{
						runtime.pushCopySol(current_event.solModifiers);
						curlsol = ltype.getCurrentSol();
						currsol = rtype.getCurrentSol();
						curlsol.select_all = false;
						currsol.select_all = false;
						if (ltype === rtype)
						{
							curlsol.instances.length = 2;	// just use lsol, is same reference as rsol
							curlsol.instances[0] = linst;
							curlsol.instances[1] = rinst;
							ltype.applySolToContainer();
						}
						else
						{
							curlsol.instances.length = 1;
							currsol.instances.length = 1;
							curlsol.instances[0] = linst;
							currsol.instances[0] = rinst;
							ltype.applySolToContainer();
							rtype.applySolToContainer();
						}
						current_event.retrigger();
						runtime.popSol(current_event.solModifiers);
					}
				}
				else
				{
					collmemory_remove(collmemory, linst, rinst);
				}
			}
			candidates.length = 0;
		}
		return false;
	};
	var rpicktype = null;
	var rtopick = new cr.ObjectSet();
	var needscollisionfinish = false;
	function DoOverlapCondition(rtype, offx, offy)
	{
		if (!rtype)
			return false;
		var do_offset = (offx !== 0 || offy !== 0);
		var oldx, oldy, ret = false, r, lenr, rinst;
		var cnd = this.runtime.getCurrentCondition();
		var ltype = cnd.type;
		var inverted = cnd.inverted;
		var rsol = rtype.getCurrentSol();
		var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
		var rinstances;
		if (rsol.select_all)
		{
			this.update_bbox();
			this.runtime.getCollisionCandidates(this.layer, rtype, this.bbox, candidates);
			rinstances = candidates;
		}
		else if (orblock)
			rinstances = rsol.else_instances;
		else
			rinstances = rsol.instances;
		rpicktype = rtype;
		needscollisionfinish = (ltype !== rtype && !inverted);
		if (do_offset)
		{
			oldx = this.x;
			oldy = this.y;
			this.x += offx;
			this.y += offy;
			this.set_bbox_changed();
		}
		for (r = 0, lenr = rinstances.length; r < lenr; r++)
		{
			rinst = rinstances[r];
			if (this.runtime.testOverlap(this, rinst))
			{
				ret = true;
				if (inverted)
					break;
				if (ltype !== rtype)
					rtopick.add(rinst);
			}
		}
		if (do_offset)
		{
			this.x = oldx;
			this.y = oldy;
			this.set_bbox_changed();
		}
		candidates.length = 0;
		return ret;
	};
	typeProto.finish = function (do_pick)
	{
		if (!needscollisionfinish)
			return;
		if (do_pick)
		{
			var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
			var sol = rpicktype.getCurrentSol();
			var topick = rtopick.valuesRef();
			var i, len, inst;
			if (sol.select_all)
			{
				sol.select_all = false;
				sol.instances.length = topick.length;
				for (i = 0, len = topick.length; i < len; i++)
				{
					sol.instances[i] = topick[i];
				}
				if (orblock)
				{
					sol.else_instances.length = 0;
					for (i = 0, len = rpicktype.instances.length; i < len; i++)
					{
						inst = rpicktype.instances[i];
						if (!rtopick.contains(inst))
							sol.else_instances.push(inst);
					}
				}
			}
			else
			{
				if (orblock)
				{
					var initsize = sol.instances.length;
					sol.instances.length = initsize + topick.length;
					for (i = 0, len = topick.length; i < len; i++)
					{
						sol.instances[initsize + i] = topick[i];
						cr.arrayFindRemove(sol.else_instances, topick[i]);
					}
				}
				else
				{
					cr.shallowAssignArray(sol.instances, topick);
				}
			}
			rpicktype.applySolToContainer();
		}
		rtopick.clear();
		needscollisionfinish = false;
	};
	Cnds.prototype.IsOverlapping = function (rtype)
	{
		return DoOverlapCondition.call(this, rtype, 0, 0);
	};
	Cnds.prototype.IsOverlappingOffset = function (rtype, offx, offy)
	{
		return DoOverlapCondition.call(this, rtype, offx, offy);
	};
	Cnds.prototype.IsAnimPlaying = function (animname)
	{
		if (this.changeAnimName.length)
			return cr.equals_nocase(this.changeAnimName, animname);
		else
			return cr.equals_nocase(this.cur_animation.name, animname);
	};
	Cnds.prototype.CompareFrame = function (cmp, framenum)
	{
		return cr.do_cmp(this.cur_frame, cmp, framenum);
	};
	Cnds.prototype.CompareAnimSpeed = function (cmp, x)
	{
		var s = (this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
		return cr.do_cmp(s, cmp, x);
	};
	Cnds.prototype.OnAnimFinished = function (animname)
	{
		return cr.equals_nocase(this.animTriggerName, animname);
	};
	Cnds.prototype.OnAnyAnimFinished = function ()
	{
		return true;
	};
	Cnds.prototype.OnFrameChanged = function ()
	{
		return true;
	};
	Cnds.prototype.IsMirrored = function ()
	{
		return this.width < 0;
	};
	Cnds.prototype.IsFlipped = function ()
	{
		return this.height < 0;
	};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	Cnds.prototype.IsCollisionEnabled = function ()
	{
		return this.collisionsEnabled;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Spawn = function (obj, layer, imgpt)
	{
		if (!obj || !layer)
			return;
		var inst = this.runtime.createInstance(obj, layer, this.getImagePoint(imgpt, true), this.getImagePoint(imgpt, false));
		if (!inst)
			return;
		if (typeof inst.angle !== "undefined")
		{
			inst.angle = this.angle;
			inst.set_bbox_changed();
		}
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
		var cur_act = this.runtime.getCurrentAction();
		var reset_sol = false;
		if (cr.is_undefined(cur_act.extra.Spawn_LastExec) || cur_act.extra.Spawn_LastExec < this.runtime.execcount)
		{
			reset_sol = true;
			cur_act.extra.Spawn_LastExec = this.runtime.execcount;
		}
		var sol;
		if (obj != this.type)
		{
			sol = obj.getCurrentSol();
			sol.select_all = false;
			if (reset_sol)
			{
				sol.instances.length = 1;
				sol.instances[0] = inst;
			}
			else
				sol.instances.push(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					s = inst.siblings[i];
					sol = s.type.getCurrentSol();
					sol.select_all = false;
					if (reset_sol)
					{
						sol.instances.length = 1;
						sol.instances[0] = s;
					}
					else
						sol.instances.push(s);
				}
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.StopAnim = function ()
	{
		this.animPlaying = false;
	};
	Acts.prototype.StartAnim = function (from)
	{
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		if (from === 1 && this.cur_frame !== 0)
		{
			this.changeAnimFrame = 0;
			if (!this.inAnimTrigger)
				this.doChangeAnimFrame();
		}
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetAnim = function (animname, from)
	{
		this.changeAnimName = animname;
		this.changeAnimFrom = from;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnim();
	};
	Acts.prototype.SetAnimFrame = function (framenumber)
	{
		this.changeAnimFrame = framenumber;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnimFrame();
	};
	Acts.prototype.SetAnimSpeed = function (s)
	{
		this.cur_anim_speed = cr.abs(s);
		this.animForwards = (s >= 0);
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetMirrored = function (m)
	{
		var neww = cr.abs(this.width) * (m === 0 ? -1 : 1);
		if (this.width === neww)
			return;
		this.width = neww;
		this.set_bbox_changed();
	};
	Acts.prototype.SetFlipped = function (f)
	{
		var newh = cr.abs(this.height) * (f === 0 ? -1 : 1);
		if (this.height === newh)
			return;
		this.height = newh;
		this.set_bbox_changed();
	};
	Acts.prototype.SetScale = function (s)
	{
		var cur_frame = this.curFrame;
		var mirror_factor = (this.width < 0 ? -1 : 1);
		var flip_factor = (this.height < 0 ? -1 : 1);
		var new_width = cur_frame.width * s * mirror_factor;
		var new_height = cur_frame.height * s * flip_factor;
		if (this.width !== new_width || this.height !== new_height)
		{
			this.width = new_width;
			this.height = new_height;
			this.set_bbox_changed();
		}
	};
	Acts.prototype.LoadURL = function (url_, resize_)
	{
		var img = new Image();
		var self = this;
		var curFrame_ = this.curFrame;
		img.onload = function ()
		{
			if (curFrame_.texture_img.src === img.src)
			{
				if (self.runtime.glwrap && self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.runtime.redraw = true;
				self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
				return;
			}
			curFrame_.texture_img = img;
			curFrame_.offx = 0;
			curFrame_.offy = 0;
			curFrame_.width = img.width;
			curFrame_.height = img.height;
			curFrame_.spritesheeted = false;
			curFrame_.datauri = "";
			if (self.runtime.glwrap)
			{
				if (curFrame_.webGL_texture)
					self.runtime.glwrap.deleteTexture(curFrame_.webGL_texture);
				curFrame_.webGL_texture = self.runtime.glwrap.loadTexture(img, false, self.runtime.linearSampling);
				if (self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.type.updateAllCurrentTexture();
			}
			if (resize_ === 0)		// resize to image size
			{
				self.width = img.width;
				self.height = img.height;
				self.set_bbox_changed();
			}
			self.runtime.redraw = true;
			self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
		};
		if (url_.substr(0, 5) !== "data:")
			img.crossOrigin = 'anonymous';
		img.src = url_;
	};
	Acts.prototype.SetCollisions = function (set_)
	{
		if (this.collisionsEnabled === (set_ !== 0))
			return;		// no change
		this.collisionsEnabled = (set_ !== 0);
		if (this.collisionsEnabled)
			this.set_bbox_changed();		// needs to be added back to cells
		else
		{
			if (this.collcells.right >= this.collcells.left)
				this.type.collision_grid.update(this, this.collcells, null);
			this.collcells.set(0, 0, -1, -1);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.AnimationFrame = function (ret)
	{
		ret.set_int(this.cur_frame);
	};
	Exps.prototype.AnimationFrameCount = function (ret)
	{
		ret.set_int(this.cur_animation.frames.length);
	};
	Exps.prototype.AnimationName = function (ret)
	{
		ret.set_string(this.cur_animation.name);
	};
	Exps.prototype.AnimationSpeed = function (ret)
	{
		ret.set_float(this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
	};
	Exps.prototype.ImagePointX = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, true));
	};
	Exps.prototype.ImagePointY = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, false));
	};
	Exps.prototype.ImagePointCount = function (ret)
	{
		ret.set_int(this.curFrame.image_points.length);
	};
	Exps.prototype.ImageWidth = function (ret)
	{
		ret.set_float(this.curFrame.width);
	};
	Exps.prototype.ImageHeight = function (ret)
	{
		ret.set_float(this.curFrame.height);
	};
	pluginProto.exps = new Exps();
}());
/* global cr,log,assert2 */
/* jshint globalstrict: true */
/* jshint strict: true */
;
;
cr.plugins_.Spritefont2 = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Spritefont2.prototype;
	pluginProto.onCreate = function ()
	{
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.runtime.waitForImageLoad(this.texture_img);
		this.webGL_texture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, false, this.runtime.linearSampling, this.texture_pixelformat);
		}
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].webGL_texture = this.webGL_texture;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onDestroy = function()
	{
		freeAllLines (this.lines);
		freeAllClip  (this.clipList);
		freeAllClipUV(this.clipUV);
		cr.wipe(this.characterWidthList);
	};
	instanceProto.onCreate = function()
	{
		this.texture_img      = this.type.texture_img;
		this.characterWidth   = this.properties[0];
		this.characterHeight  = this.properties[1];
		this.characterSet     = this.properties[2];
		this.text             = this.properties[3];
		this.characterScale   = this.properties[4];
		this.visible          = (this.properties[5] === 0);	// 0=visible, 1=invisible
		this.halign           = this.properties[6]/2.0;			// 0=left, 1=center, 2=right
		this.valign           = this.properties[7]/2.0;			// 0=top, 1=center, 2=bottom
		this.wrapbyword       = (this.properties[9] === 0);	// 0=word, 1=character
		this.characterSpacing = this.properties[10];
		this.lineHeight       = this.properties[11];
		this.textWidth  = 0;
		this.textHeight = 0;
		if (this.recycled)
		{
			this.lines.length = 0;
			cr.wipe(this.clipList);
			cr.wipe(this.clipUV);
			cr.wipe(this.characterWidthList);
		}
		else
		{
			this.lines = [];
			this.clipList = {};
			this.clipUV = {};
			this.characterWidthList = {};
		}
		this.text_changed = true;
		this.lastwrapwidth = this.width;
		if (this.runtime.glwrap)
		{
			if (!this.type.webGL_texture)
			{
				this.type.webGL_texture = this.runtime.glwrap.loadTexture(this.type.texture_img, false, this.runtime.linearSampling, this.type.texture_pixelformat);
			}
			this.webGL_texture = this.type.webGL_texture;
		}
		this.SplitSheet();
	};
	instanceProto.saveToJSON = function ()
	{
		var save = {
			"t": this.text,
			"csc": this.characterScale,
			"csp": this.characterSpacing,
			"lh": this.lineHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick,
			"cw": {}
		};
		for (var ch in this.characterWidthList)
			save["cw"][ch] = this.characterWidthList[ch];
		return save;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.characterScale = o["csc"];
		this.characterSpacing = o["csp"];
		this.lineHeight = o["lh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		for(var ch in o["cw"])
			this.characterWidthList[ch] = o["cw"][ch];
		this.text_changed = true;
		this.lastwrapwidth = this.width;
	};
	function trimRight(text)
	{
		return text.replace(/\s\s*$/, '');
	}
	var MAX_CACHE_SIZE = 1000;
	function alloc(cache,Constructor)
	{
		if (cache.length)
			return cache.pop();
		else
			return new Constructor();
	}
	function free(cache,data)
	{
		if (cache.length < MAX_CACHE_SIZE)
		{
			cache.push(data);
		}
	}
	function freeAll(cache,dataList,isArray)
	{
		if (isArray) {
			var i, len;
			for (i = 0, len = dataList.length; i < len; i++)
			{
				free(cache,dataList[i]);
			}
			dataList.length = 0;
		} else {
			var prop;
			for(prop in dataList) {
				if(Object.prototype.hasOwnProperty.call(dataList,prop)) {
					free(cache,dataList[prop]);
					delete dataList[prop];
				}
			}
		}
	}
	function addLine(inst,lineIndex,cur_line) {
		var lines = inst.lines;
		var line;
		cur_line = trimRight(cur_line);
		if (lineIndex >= lines.length)
			lines.push(allocLine());
		line = lines[lineIndex];
		line.text = cur_line;
		line.width = inst.measureWidth(cur_line);
		inst.textWidth = cr.max(inst.textWidth,line.width);
	}
	var linesCache = [];
	function allocLine()       { return alloc(linesCache,Object); }
	function freeLine(l)       { free(linesCache,l); }
	function freeAllLines(arr) { freeAll(linesCache,arr,true); }
	function addClip(obj,property,x,y,w,h) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipCache,Object);
		}
		obj[property].x = x;
		obj[property].y = y;
		obj[property].w = w;
		obj[property].h = h;
	}
	var clipCache = [];
	function allocClip()      { return alloc(clipCache,Object); }
	function freeAllClip(obj) { freeAll(clipCache,obj,false);}
	function addClipUV(obj,property,left,top,right,bottom) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipUVCache,cr.rect);
		}
		obj[property].left   = left;
		obj[property].top    = top;
		obj[property].right  = right;
		obj[property].bottom = bottom;
	}
	var clipUVCache = [];
	function allocClipUV()      { return alloc(clipUVCache,cr.rect);}
	function freeAllClipUV(obj) { freeAll(clipUVCache,obj,false);}
	instanceProto.SplitSheet = function() {
		var texture      = this.texture_img;
		var texWidth     = texture.width;
		var texHeight    = texture.height;
		var charWidth    = this.characterWidth;
		var charHeight   = this.characterHeight;
		var charU        = charWidth /texWidth;
		var charV        = charHeight/texHeight;
		var charSet      = this.characterSet ;
		var cols = Math.floor(texWidth/charWidth);
		var rows = Math.floor(texHeight/charHeight);
		for ( var c = 0; c < charSet.length; c++) {
			if  (c >= cols * rows) break;
			var x = c%cols;
			var y = Math.floor(c/cols);
			var letter = charSet.charAt(c);
			if (this.runtime.glwrap) {
				addClipUV(
					this.clipUV, letter,
					x * charU ,
					y * charV ,
					(x+1) * charU ,
					(y+1) * charV
				);
			} else {
				addClip(
					this.clipList, letter,
					x * charWidth,
					y * charHeight,
					charWidth,
					charHeight
				);
			}
		}
	};
	/*
     *	Word-Wrapping
     */
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	pluginProto.WordWrap = function (inst)
	{
		var text = inst.text;
		var lines = inst.lines;
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		var width = inst.width;
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		var charWidth = inst.characterWidth;
		var charScale = inst.characterScale;
		var charSpacing = inst.characterSpacing;
		if ( (text.length * (charWidth * charScale + charSpacing) - charSpacing) <= width && text.indexOf("\n") === -1)
		{
			var all_width = inst.measureWidth(text);
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				inst.textWidth  = all_width;
				inst.textHeight = inst.characterHeight * charScale + inst.lineHeight;
				return;
			}
		}
		var wrapbyword = inst.wrapbyword;
		this.WrapText(inst);
		inst.textHeight = lines.length * (inst.characterHeight * charScale + inst.lineHeight);
	};
	pluginProto.WrapText = function (inst)
	{
		var wrapbyword = inst.wrapbyword;
		var text       = inst.text;
		var lines      = inst.lines;
		var width      = inst.width;
		var wordArray;
		if (wrapbyword) {
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		} else {
			wordArray = text;
		}
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		var ignore_newline = false;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (ignore_newline === true) {
					ignore_newline = false;
				} else {
					addLine(inst,lineIndex,cur_line);
					lineIndex++;
				}
				cur_line = "";
				continue;
			}
			ignore_newline = false;
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = inst.measureWidth(trimRight(cur_line));
			if (line_width > width)
			{
				if (prev_line === "") {
					addLine(inst,lineIndex,cur_line);
					cur_line = "";
					ignore_newline = true;
				} else {
					addLine(inst,lineIndex,prev_line);
					cur_line = wordArray[i];
				}
				lineIndex++;
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (trimRight(cur_line).length)
		{
			addLine(inst,lineIndex,cur_line);
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	instanceProto.measureWidth = function(text) {
		var spacing = this.characterSpacing;
		var len     = text.length;
		var width   = 0;
		for (var i = 0; i < len; i++) {
			width += this.getCharacterWidth(text.charAt(i)) * this.characterScale + spacing;
		}
		width -= (width > 0) ? spacing : 0;
		return width;
	};
	/***/
	instanceProto.getCharacterWidth = function(character) {
		var widthList = this.characterWidthList;
		if (widthList[character] !== undefined) {
			return widthList[character];
		} else {
			return this.characterWidth;
		}
	};
	instanceProto.rebuildText = function() {
		if (this.text_changed || this.width !== this.lastwrapwidth) {
			this.textWidth = 0;
			this.textHeight = 0;
			this.type.plugin.WordWrap(this);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
	};
	var EPSILON = 0.00001;
	instanceProto.draw = function(ctx, glmode)
	{
		var texture = this.texture_img;
		if (this.text !== "" && texture != null) {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			ctx.globalAlpha = this.opacity;
			var myx = this.x;
			var myy = this.y;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			ctx.translate(myx, myy);
			ctx.rotate(this.angle);
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = -(this.hotspotX * this.width);
			var offy = -(this.hotspotY * this.height);
			offy += valign;
			var drawX ;
			var drawY = offy;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line = lines[i].text;
				var len  = lines[i].width;
				halign = ha * cr.max(0,this.width - len);
				drawX = offx + halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clip = this.clipList[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale > this.width + EPSILON ) {
						break;
					}
					if (clip !== undefined) {
						roundX = drawX;
						roundY = drawY;
						if (this.angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						ctx.drawImage( this.texture_img,
									 clip.x, clip.y, clip.w, clip.h,
									 roundX,roundY,clip.w*scale,clip.h*scale);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
			ctx.restore();
		}
	};
	var dQuad = new cr.quad();
	function rotateQuad(quad,cosa,sina) {
		var x_temp;
		x_temp   = (quad.tlx * cosa) - (quad.tly * sina);
		quad.tly = (quad.tly * cosa) + (quad.tlx * sina);
		quad.tlx = x_temp;
		x_temp    = (quad.trx * cosa) - (quad.try_ * sina);
		quad.try_ = (quad.try_ * cosa) + (quad.trx * sina);
		quad.trx  = x_temp;
		x_temp   = (quad.blx * cosa) - (quad.bly * sina);
		quad.bly = (quad.bly * cosa) + (quad.blx * sina);
		quad.blx = x_temp;
		x_temp    = (quad.brx * cosa) - (quad.bry * sina);
		quad.bry = (quad.bry * cosa) + (quad.brx * sina);
		quad.brx  = x_temp;
	}
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.webGL_texture);
		glw.setOpacity(this.opacity);
		if (this.text !== "") {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			this.update_bbox();
			var q = this.bquad;
			var ox = 0;
			var oy = 0;
			if (this.runtime.pixel_rounding)
			{
				ox = ((this.x + 0.5) | 0) - this.x;
				oy = ((this.y + 0.5) | 0) - this.y;
			}
			var angle      = this.angle;
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;   // to precalculate in onCreate or on change
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var cosa,sina;
			if (angle !== 0)
			{
				cosa = Math.cos(angle);
				sina = Math.sin(angle);
			}
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = q.tlx + ox;
			var offy = q.tly + oy;
			var drawX ;
			var drawY = valign;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line       = lines[i].text;
				var lineWidth  = lines[i].width;
				halign = ha * cr.max(0,this.width - lineWidth);
				drawX = halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clipUV = this.clipUV[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale  > this.width + EPSILON) {
						break;
					}
					if (clipUV !== undefined) {
						var clipWidth  = this.characterWidth*scale;
						var clipHeight = this.characterHeight*scale;
						roundX = drawX;
						roundY = drawY;
						if (angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						dQuad.tlx  = roundX;
						dQuad.tly  = roundY;
						dQuad.trx  = roundX + clipWidth;
						dQuad.try_ = roundY ;
						dQuad.blx  = roundX;
						dQuad.bly  = roundY + clipHeight;
						dQuad.brx  = roundX + clipWidth;
						dQuad.bry  = roundY + clipHeight;
						if(angle !== 0)
						{
							rotateQuad(dQuad,cosa,sina);
						}
						dQuad.offset(offx,offy);
						glw.quadTex(
							dQuad.tlx, dQuad.tly,
							dQuad.trx, dQuad.try_,
							dQuad.brx, dQuad.bry,
							dQuad.blx, dQuad.bly,
							clipUV
						);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
		}
	};
	function Cnds() {}
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {}
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetScale = function(param)
	{
		if (param !== this.characterScale) {
			this.characterScale = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterSpacing = function(param)
	{
		if (param !== this.CharacterSpacing) {
			this.characterSpacing = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetLineHeight = function(param)
	{
		if (param !== this.lineHeight) {
			this.lineHeight = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	instanceProto.SetCharWidth = function(character,width) {
		var w = parseInt(width,10);
		if (this.characterWidthList[character] !== w) {
			this.characterWidthList[character] = w;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterWidth = function(characterSet,width)
	{
		if (characterSet !== "") {
			for(var c = 0; c < characterSet.length; c++) {
				this.SetCharWidth(characterSet.charAt(c),width);
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetHAlign = function (a)
	{
		this.halign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetVAlign = function (a)
	{
		this.valign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {}
	Exps.prototype.CharacterWidth = function(ret,character)
	{
		ret.set_int(this.getCharacterWidth(character));
	};
	Exps.prototype.CharacterHeight = function(ret)
	{
		ret.set_int(this.characterHeight);
	};
	Exps.prototype.CharacterScale = function(ret)
	{
		ret.set_float(this.characterScale);
	};
	Exps.prototype.CharacterSpacing = function(ret)
	{
		ret.set_int(this.characterSpacing);
	};
	Exps.prototype.LineHeight = function(ret)
	{
		ret.set_int(this.lineHeight);
	};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textWidth);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textHeight);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Text = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Text.prototype;
	pluginProto.onCreate = function ()
	{
		pluginProto.acts.SetWidth = function (w)
		{
			if (this.width !== w)
			{
				this.width = w;
				this.text_changed = true;	// also recalculate text wrapping
				this.set_bbox_changed();
			}
		};
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.mycanvas = null;
			inst.myctx = null;
			inst.mytex = null;
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		if (this.recycled)
			this.lines.length = 0;
		else
			this.lines = [];		// for word wrapping
		this.text_changed = true;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var requestedWebFonts = {};		// already requested web fonts have an entry here
	instanceProto.onCreate = function()
	{
		this.text = this.properties[0];
		this.visible = (this.properties[1] === 0);		// 0=visible, 1=invisible
		this.font = this.properties[2];
		this.color = this.properties[3];
		this.halign = this.properties[4];				// 0=left, 1=center, 2=right
		this.valign = this.properties[5];				// 0=top, 1=center, 2=bottom
		this.wrapbyword = (this.properties[7] === 0);	// 0=word, 1=character
		this.lastwidth = this.width;
		this.lastwrapwidth = this.width;
		this.lastheight = this.height;
		this.line_height_offset = this.properties[8];
		this.facename = "";
		this.fontstyle = "";
		this.ptSize = 0;
		this.textWidth = 0;
		this.textHeight = 0;
		this.parseFont();
		this.mycanvas = null;
		this.myctx = null;
		this.mytex = null;
		this.need_text_redraw = false;
		this.last_render_tick = this.runtime.tickcount;
		if (this.recycled)
			this.rcTex.set(0, 0, 1, 1);
		else
			this.rcTex = new cr.rect(0, 0, 1, 1);
		if (this.runtime.glwrap)
			this.runtime.tickMe(this);
;
	};
	instanceProto.parseFont = function ()
	{
		var arr = this.font.split(" ");
		var i;
		for (i = 0; i < arr.length; i++)
		{
			if (arr[i].substr(arr[i].length - 2, 2) === "pt")
			{
				this.ptSize = parseInt(arr[i].substr(0, arr[i].length - 2));
				this.pxHeight = Math.ceil((this.ptSize / 72.0) * 96.0) + 4;	// assume 96dpi...
				if (i > 0)
					this.fontstyle = arr[i - 1];
				this.facename = arr[i + 1];
				for (i = i + 2; i < arr.length; i++)
					this.facename += " " + arr[i];
				break;
			}
		}
	};
	instanceProto.saveToJSON = function ()
	{
		return {
			"t": this.text,
			"f": this.font,
			"c": this.color,
			"ha": this.halign,
			"va": this.valign,
			"wr": this.wrapbyword,
			"lho": this.line_height_offset,
			"fn": this.facename,
			"fs": this.fontstyle,
			"ps": this.ptSize,
			"pxh": this.pxHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.font = o["f"];
		this.color = o["c"];
		this.halign = o["ha"];
		this.valign = o["va"];
		this.wrapbyword = o["wr"];
		this.line_height_offset = o["lho"];
		this.facename = o["fn"];
		this.fontstyle = o["fs"];
		this.ptSize = o["ps"];
		this.pxHeight = o["pxh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		this.text_changed = true;
		this.lastwidth = this.width;
		this.lastwrapwidth = this.width;
		this.lastheight = this.height;
	};
	instanceProto.tick = function ()
	{
		if (this.runtime.glwrap && this.mytex && (this.runtime.tickcount - this.last_render_tick >= 300))
		{
			var layer = this.layer;
            this.update_bbox();
            var bbox = this.bbox;
            if (bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom)
			{
				this.runtime.glwrap.deleteTexture(this.mytex);
				this.mytex = null;
				this.myctx = null;
				this.mycanvas = null;
			}
		}
	};
	instanceProto.onDestroy = function ()
	{
		this.myctx = null;
		this.mycanvas = null;
		if (this.runtime.glwrap && this.mytex)
			this.runtime.glwrap.deleteTexture(this.mytex);
		this.mytex = null;
	};
	instanceProto.updateFont = function ()
	{
		this.font = this.fontstyle + " " + this.ptSize.toString() + "pt " + this.facename;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	instanceProto.draw = function(ctx, glmode)
	{
		ctx.font = this.font;
		ctx.textBaseline = "top";
		ctx.fillStyle = this.color;
		ctx.globalAlpha = glmode ? 1 : this.opacity;
		var myscale = 1;
		if (glmode)
		{
			myscale = this.layer.getScale();
			ctx.save();
			ctx.scale(myscale, myscale);
		}
		if (this.text_changed || this.width !== this.lastwrapwidth)
		{
			this.type.plugin.WordWrap(this.text, this.lines, ctx, this.width, this.wrapbyword);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
		this.update_bbox();
		var penX = glmode ? 0 : this.bquad.tlx;
		var penY = glmode ? 0 : this.bquad.tly;
		if (this.runtime.pixel_rounding)
		{
			penX = (penX + 0.5) | 0;
			penY = (penY + 0.5) | 0;
		}
		if (this.angle !== 0 && !glmode)
		{
			ctx.save();
			ctx.translate(penX, penY);
			ctx.rotate(this.angle);
			penX = 0;
			penY = 0;
		}
		var endY = penY + this.height;
		var line_height = this.pxHeight;
		line_height += this.line_height_offset;
		var drawX;
		var i;
		if (this.valign === 1)		// center
			penY += Math.max(this.height / 2 - (this.lines.length * line_height) / 2, 0);
		else if (this.valign === 2)	// bottom
			penY += Math.max(this.height - (this.lines.length * line_height) - 2, 0);
		for (i = 0; i < this.lines.length; i++)
		{
			drawX = penX;
			if (this.halign === 1)		// center
				drawX = penX + (this.width - this.lines[i].width) / 2;
			else if (this.halign === 2)	// right
				drawX = penX + (this.width - this.lines[i].width);
			ctx.fillText(this.lines[i].text, drawX, penY);
			penY += line_height;
			if (penY >= endY - line_height)
				break;
		}
		if (this.angle !== 0 || glmode)
			ctx.restore();
		this.last_render_tick = this.runtime.tickcount;
	};
	instanceProto.drawGL = function(glw)
	{
		if (this.width < 1 || this.height < 1)
			return;
		var need_redraw = this.text_changed || this.need_text_redraw;
		this.need_text_redraw = false;
		var layer_scale = this.layer.getScale();
		var layer_angle = this.layer.getAngle();
		var rcTex = this.rcTex;
		var floatscaledwidth = layer_scale * this.width;
		var floatscaledheight = layer_scale * this.height;
		var scaledwidth = Math.ceil(floatscaledwidth);
		var scaledheight = Math.ceil(floatscaledheight);
		var halfw = this.runtime.draw_width / 2;
		var halfh = this.runtime.draw_height / 2;
		if (!this.myctx)
		{
			this.mycanvas = document.createElement("canvas");
			this.mycanvas.width = scaledwidth;
			this.mycanvas.height = scaledheight;
			this.lastwidth = scaledwidth;
			this.lastheight = scaledheight;
			need_redraw = true;
			this.myctx = this.mycanvas.getContext("2d");
		}
		if (scaledwidth !== this.lastwidth || scaledheight !== this.lastheight)
		{
			this.mycanvas.width = scaledwidth;
			this.mycanvas.height = scaledheight;
			if (this.mytex)
			{
				glw.deleteTexture(this.mytex);
				this.mytex = null;
			}
			need_redraw = true;
		}
		if (need_redraw)
		{
			this.myctx.clearRect(0, 0, scaledwidth, scaledheight);
			this.draw(this.myctx, true);
			if (!this.mytex)
				this.mytex = glw.createEmptyTexture(scaledwidth, scaledheight, this.runtime.linearSampling, this.runtime.isMobile);
			glw.videoToTexture(this.mycanvas, this.mytex, this.runtime.isMobile);
		}
		this.lastwidth = scaledwidth;
		this.lastheight = scaledheight;
		glw.setTexture(this.mytex);
		glw.setOpacity(this.opacity);
		glw.resetModelView();
		glw.translate(-halfw, -halfh);
		glw.updateModelView();
		var q = this.bquad;
		var old_dpr = this.runtime.devicePixelRatio;
		this.runtime.devicePixelRatio = 1;
		var tlx = this.layer.layerToCanvas(q.tlx, q.tly, true, true);
		var tly = this.layer.layerToCanvas(q.tlx, q.tly, false, true);
		var trx = this.layer.layerToCanvas(q.trx, q.try_, true, true);
		var try_ = this.layer.layerToCanvas(q.trx, q.try_, false, true);
		var brx = this.layer.layerToCanvas(q.brx, q.bry, true, true);
		var bry = this.layer.layerToCanvas(q.brx, q.bry, false, true);
		var blx = this.layer.layerToCanvas(q.blx, q.bly, true, true);
		var bly = this.layer.layerToCanvas(q.blx, q.bly, false, true);
		this.runtime.devicePixelRatio = old_dpr;
		if (this.runtime.pixel_rounding || (this.angle === 0 && layer_angle === 0))
		{
			var ox = ((tlx + 0.5) | 0) - tlx;
			var oy = ((tly + 0.5) | 0) - tly
			tlx += ox;
			tly += oy;
			trx += ox;
			try_ += oy;
			brx += ox;
			bry += oy;
			blx += ox;
			bly += oy;
		}
		if (this.angle === 0 && layer_angle === 0)
		{
			trx = tlx + scaledwidth;
			try_ = tly;
			brx = trx;
			bry = tly + scaledheight;
			blx = tlx;
			bly = bry;
			rcTex.right = 1;
			rcTex.bottom = 1;
		}
		else
		{
			rcTex.right = floatscaledwidth / scaledwidth;
			rcTex.bottom = floatscaledheight / scaledheight;
		}
		glw.quadTex(tlx, tly, trx, try_, brx, bry, blx, bly, rcTex);
		glw.resetModelView();
		glw.scale(layer_scale, layer_scale);
		glw.rotateZ(-this.layer.getAngle());
		glw.translate((this.layer.viewLeft + this.layer.viewRight) / -2, (this.layer.viewTop + this.layer.viewBottom) / -2);
		glw.updateModelView();
		this.last_render_tick = this.runtime.tickcount;
	};
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	var linesCache = [];
	function allocLine()
	{
		if (linesCache.length)
			return linesCache.pop();
		else
			return {};
	};
	function freeLine(l)
	{
		linesCache.push(l);
	};
	function freeAllLines(arr)
	{
		var i, len;
		for (i = 0, len = arr.length; i < len; i++)
		{
			freeLine(arr[i]);
		}
		arr.length = 0;
	};
	pluginProto.WordWrap = function (text, lines, ctx, width, wrapbyword)
	{
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		if (text.length <= 100 && text.indexOf("\n") === -1)
		{
			var all_width = ctx.measureText(text).width;
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				return;
			}
		}
		this.WrapText(text, lines, ctx, width, wrapbyword);
	};
	pluginProto.WrapText = function (text, lines, ctx, width, wrapbyword)
	{
		var wordArray;
		if (wrapbyword)
		{
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		}
		else
			wordArray = text;
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (lineIndex >= lines.length)
					lines.push(allocLine());
				line = lines[lineIndex];
				line.text = cur_line;
				line.width = ctx.measureText(cur_line).width;
				lineIndex++;
				cur_line = "";
				continue;
			}
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = ctx.measureText(cur_line).width;
			if (line_width >= width)
			{
				if (lineIndex >= lines.length)
					lines.push(allocLine());
				line = lines[lineIndex];
				line.text = prev_line;
				line.width = ctx.measureText(prev_line).width;
				lineIndex++;
				cur_line = wordArray[i];
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (cur_line.length)
		{
			if (lineIndex >= lines.length)
				lines.push(allocLine());
			line = lines[lineIndex];
			line.text = cur_line;
			line.width = ctx.measureText(cur_line).width;
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	function Cnds() {};
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetFontFace = function (face_, style_)
	{
		var newstyle = "";
		switch (style_) {
		case 1: newstyle = "bold"; break;
		case 2: newstyle = "italic"; break;
		case 3: newstyle = "bold italic"; break;
		}
		if (face_ === this.facename && newstyle === this.fontstyle)
			return;		// no change
		this.facename = face_;
		this.fontstyle = newstyle;
		this.updateFont();
	};
	Acts.prototype.SetFontSize = function (size_)
	{
		if (this.ptSize === size_)
			return;
		this.ptSize = size_;
		this.pxHeight = Math.ceil((this.ptSize / 72.0) * 96.0) + 4;	// assume 96dpi...
		this.updateFont();
	};
	Acts.prototype.SetFontColor = function (rgb)
	{
		var newcolor = "rgb(" + cr.GetRValue(rgb).toString() + "," + cr.GetGValue(rgb).toString() + "," + cr.GetBValue(rgb).toString() + ")";
		if (newcolor === this.color)
			return;
		this.color = newcolor;
		this.need_text_redraw = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetWebFont = function (familyname_, cssurl_)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");
			return;		// DC todo
		}
		var self = this;
		var refreshFunc = (function () {
							self.runtime.redraw = true;
							self.text_changed = true;
						});
		if (requestedWebFonts.hasOwnProperty(cssurl_))
		{
			var newfacename = "'" + familyname_ + "'";
			if (this.facename === newfacename)
				return;	// no change
			this.facename = newfacename;
			this.updateFont();
			for (var i = 1; i < 10; i++)
			{
				setTimeout(refreshFunc, i * 100);
				setTimeout(refreshFunc, i * 1000);
			}
			return;
		}
		var wf = document.createElement("link");
		wf.href = cssurl_;
		wf.rel = "stylesheet";
		wf.type = "text/css";
		wf.onload = refreshFunc;
		document.getElementsByTagName('head')[0].appendChild(wf);
		requestedWebFonts[cssurl_] = true;
		this.facename = "'" + familyname_ + "'";
		this.updateFont();
		for (var i = 1; i < 10; i++)
		{
			setTimeout(refreshFunc, i * 100);
			setTimeout(refreshFunc, i * 1000);
		}
;
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.FaceName = function (ret)
	{
		ret.set_string(this.facename);
	};
	Exps.prototype.FaceSize = function (ret)
	{
		ret.set_int(this.ptSize);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		var w = 0;
		var i, len, x;
		for (i = 0, len = this.lines.length; i < len; i++)
		{
			x = this.lines[i].width;
			if (w < x)
				w = x;
		}
		ret.set_int(w);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		ret.set_int(this.lines.length * (this.pxHeight + this.line_height_offset) - this.line_height_offset);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Touch = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Touch.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.touches = [];
		this.mouseDown = false;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var dummyoffset = {left: 0, top: 0};
	instanceProto.findTouch = function (id)
	{
		var i, len;
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			if (this.touches[i]["id"] === id)
				return i;
		}
		return -1;
	};
	var appmobi_accx = 0;
	var appmobi_accy = 0;
	var appmobi_accz = 0;
	function AppMobiGetAcceleration(evt)
	{
		appmobi_accx = evt.x;
		appmobi_accy = evt.y;
		appmobi_accz = evt.z;
	};
	var pg_accx = 0;
	var pg_accy = 0;
	var pg_accz = 0;
	function PhoneGapGetAcceleration(evt)
	{
		pg_accx = evt.x;
		pg_accy = evt.y;
		pg_accz = evt.z;
	};
	var theInstance = null;
	instanceProto.onCreate = function()
	{
		theInstance = this;
		this.isWindows8 = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.orient_alpha = 0;
		this.orient_beta = 0;
		this.orient_gamma = 0;
		this.acc_g_x = 0;
		this.acc_g_y = 0;
		this.acc_g_z = 0;
		this.acc_x = 0;
		this.acc_y = 0;
		this.acc_z = 0;
		this.curTouchX = 0;
		this.curTouchY = 0;
		this.trigger_index = 0;
		this.trigger_id = 0;
		this.useMouseInput = (this.properties[0] !== 0);
		var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
		var elem2 = document;
		if (this.runtime.isDirectCanvas)
			elem2 = elem = window["Canvas"];
		else if (this.runtime.isCocoonJs)
			elem2 = elem = window;
		var self = this;
		if (window.navigator["pointerEnabled"])
		{
			elem.addEventListener("pointerdown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("pointermove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("pointerup",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("pointercancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				this.runtime.canvas.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else if (window.navigator["msPointerEnabled"])
		{
			elem.addEventListener("MSPointerDown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("MSPointerMove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("MSPointerUp",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("MSPointerCancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else
		{
			elem.addEventListener("touchstart",
				function(info) {
					self.onTouchStart(info);
				},
				false
			);
			elem.addEventListener("touchmove",
				function(info) {
					self.onTouchMove(info);
				},
				false
			);
			elem2.addEventListener("touchend",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
			elem2.addEventListener("touchcancel",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
		}
		if (this.isWindows8)
		{
			var win8accelerometerFn = function(e) {
					var reading = e["reading"];
					self.acc_x = reading["accelerationX"];
					self.acc_y = reading["accelerationY"];
					self.acc_z = reading["accelerationZ"];
				};
			var win8inclinometerFn = function(e) {
					var reading = e["reading"];
					self.orient_alpha = reading["yawDegrees"];
					self.orient_beta = reading["pitchDegrees"];
					self.orient_gamma = reading["rollDegrees"];
				};
			var accelerometer = Windows["Devices"]["Sensors"]["Accelerometer"]["getDefault"]();
            if (accelerometer)
			{
                accelerometer["reportInterval"] = Math.max(accelerometer["minimumReportInterval"], 16);
				accelerometer.addEventListener("readingchanged", win8accelerometerFn);
            }
			var inclinometer = Windows["Devices"]["Sensors"]["Inclinometer"]["getDefault"]();
			if (inclinometer)
			{
				inclinometer["reportInterval"] = Math.max(inclinometer["minimumReportInterval"], 16);
				inclinometer.addEventListener("readingchanged", win8inclinometerFn);
			}
			document.addEventListener("visibilitychange", function(e) {
				if (document["hidden"] || document["msHidden"])
				{
					if (accelerometer)
						accelerometer.removeEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.removeEventListener("readingchanged", win8inclinometerFn);
				}
				else
				{
					if (accelerometer)
						accelerometer.addEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.addEventListener("readingchanged", win8inclinometerFn);
				}
			}, false);
		}
		else
		{
			window.addEventListener("deviceorientation", function (eventData) {
				self.orient_alpha = eventData["alpha"] || 0;
				self.orient_beta = eventData["beta"] || 0;
				self.orient_gamma = eventData["gamma"] || 0;
			}, false);
			window.addEventListener("devicemotion", function (eventData) {
				if (eventData["accelerationIncludingGravity"])
				{
					self.acc_g_x = eventData["accelerationIncludingGravity"]["x"] || 0;
					self.acc_g_y = eventData["accelerationIncludingGravity"]["y"] || 0;
					self.acc_g_z = eventData["accelerationIncludingGravity"]["z"] || 0;
				}
				if (eventData["acceleration"])
				{
					self.acc_x = eventData["acceleration"]["x"] || 0;
					self.acc_y = eventData["acceleration"]["y"] || 0;
					self.acc_z = eventData["acceleration"]["z"] || 0;
				}
			}, false);
		}
		if (this.useMouseInput && !this.runtime.isDomFree)
		{
			jQuery(document).mousemove(
				function(info) {
					self.onMouseMove(info);
				}
			);
			jQuery(document).mousedown(
				function(info) {
					self.onMouseDown(info);
				}
			);
			jQuery(document).mouseup(
				function(info) {
					self.onMouseUp(info);
				}
			);
		}
		if (this.runtime.isAppMobi && !this.runtime.isDirectCanvas)
		{
			AppMobi["accelerometer"]["watchAcceleration"](AppMobiGetAcceleration, { "frequency": 40, "adjustForRotation": true });
		}
		if (this.runtime.isPhoneGap)
		{
			navigator["accelerometer"]["watchAcceleration"](PhoneGapGetAcceleration, null, { "frequency": 40 });
		}
		this.runtime.tick2Me(this);
	};
	instanceProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		var nowtime = cr.performance_now();
		if (i >= 0)
		{
			var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
			var t = this.touches[i];
			if (nowtime - t.time < 2)
				return;
			t.lasttime = t.time;
			t.lastx = t.x;
			t.lasty = t.y;
			t.time = nowtime;
			t.x = info.pageX - offset.left;
			t.y = info.pageY - offset.top;
		}
	};
	instanceProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var touchx = info.pageX - offset.left;
		var touchy = info.pageY - offset.top;
		var nowtime = cr.performance_now();
		this.trigger_index = this.touches.length;
		this.trigger_id = info["pointerId"];
		this.touches.push({ time: nowtime,
							x: touchx,
							y: touchy,
							lasttime: nowtime,
							lastx: touchx,
							lasty: touchy,
							"id": info["pointerId"],
							startindex: this.trigger_index
						});
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
		this.curTouchX = touchx;
		this.curTouchY = touchy;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		this.trigger_index = (i >= 0 ? this.touches[i].startindex : -1);
		this.trigger_id = (i >= 0 ? this.touches[i]["id"] : -1);
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
		this.runtime.isInUserInputEvent = false;
		if (i >= 0)
		{
			this.touches.splice(i, 1);
		}
	};
	instanceProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var nowtime = cr.performance_now();
		var i, len, t, u;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			var j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
				u = this.touches[j];
				if (nowtime - u.time < 2)
					continue;
				u.lasttime = u.time;
				u.lastx = u.x;
				u.lasty = u.y;
				u.time = nowtime;
				u.x = t.pageX - offset.left;
				u.y = t.pageY - offset.top;
			}
		}
	};
	instanceProto.onTouchStart = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var nowtime = cr.performance_now();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j !== -1)
				continue;
			var touchx = t.pageX - offset.left;
			var touchy = t.pageY - offset.top;
			this.trigger_index = this.touches.length;
			this.trigger_id = t["identifier"];
			this.touches.push({ time: nowtime,
								x: touchx,
								y: touchy,
								lasttime: nowtime,
								lastx: touchx,
								lasty: touchy,
								"id": t["identifier"],
								startindex: this.trigger_index
							});
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
			this.curTouchX = touchx;
			this.curTouchY = touchy;
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onTouchEnd = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				this.trigger_index = this.touches[j].startindex;
				this.trigger_id = this.touches[j]["id"];
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
				this.touches.splice(j, 1);
			}
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.getAlpha = function ()
	{
		if (this.runtime.isAppMobi && this.orient_alpha === 0 && appmobi_accz !== 0)
			return appmobi_accz * 90;
		else if (this.runtime.isPhoneGap  && this.orient_alpha === 0 && pg_accz !== 0)
			return pg_accz * 90;
		else
			return this.orient_alpha;
	};
	instanceProto.getBeta = function ()
	{
		if (this.runtime.isAppMobi && this.orient_beta === 0 && appmobi_accy !== 0)
			return appmobi_accy * -90;
		else if (this.runtime.isPhoneGap  && this.orient_beta === 0 && pg_accy !== 0)
			return pg_accy * -90;
		else
			return this.orient_beta;
	};
	instanceProto.getGamma = function ()
	{
		if (this.runtime.isAppMobi && this.orient_gamma === 0 && appmobi_accx !== 0)
			return appmobi_accx * 90;
		else if (this.runtime.isPhoneGap  && this.orient_gamma === 0 && pg_accx !== 0)
			return pg_accx * 90;
		else
			return this.orient_gamma;
	};
	var noop_func = function(){};
	instanceProto.onMouseDown = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click)
			info.preventDefault();
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchStart(fakeinfo);
		this.mouseDown = true;
	};
	instanceProto.onMouseMove = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click)
			info.preventDefault();
		if (!this.mouseDown)
			return;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchMove(fakeinfo);
	};
	instanceProto.onMouseUp = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click)
			info.preventDefault();
		this.runtime.had_a_click = true;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchEnd(fakeinfo);
		this.mouseDown = false;
	};
	instanceProto.tick2 = function()
	{
		var i, len, t;
		var nowtime = cr.performance_now();
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			t = this.touches[i];
			if (t.time <= nowtime - 50)
				t.lasttime = nowtime;
		}
	};
	function Cnds() {};
	Cnds.prototype.OnTouchStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnTouchEnd = function ()
	{
		return true;
	};
	Cnds.prototype.IsInTouch = function ()
	{
		return this.touches.length;
	};
	Cnds.prototype.OnTouchObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	Cnds.prototype.IsTouchingObject = function (type)
	{
		if (!type)
			return false;
		var sol = type.getCurrentSol();
		var instances = sol.getObjects();
		var px, py;
		var touching = [];
		var i, leni, j, lenj;
		for (i = 0, leni = instances.length; i < leni; i++)
		{
			var inst = instances[i];
			inst.update_bbox();
			for (j = 0, lenj = this.touches.length; j < lenj; j++)
			{
				var touch = this.touches[j];
				px = inst.layer.canvasToLayer(touch.x, touch.y, true);
				py = inst.layer.canvasToLayer(touch.x, touch.y, false);
				if (inst.contains_pt(px, py))
				{
					touching.push(inst);
					break;
				}
			}
		}
		if (touching.length)
		{
			sol.select_all = false;
			sol.instances = touching;
			type.applySolToContainer();
			return true;
		}
		else
			return false;
	};
	Cnds.prototype.CompareTouchSpeed = function (index, cmp, s)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
			return false;
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		var speed = 0;
		if (timediff > 0)
			speed = dist / timediff;
		return cr.do_cmp(speed, cmp, s);
	};
	Cnds.prototype.OrientationSupported = function ()
	{
		return typeof window["DeviceOrientationEvent"] !== "undefined";
	};
	Cnds.prototype.MotionSupported = function ()
	{
		return typeof window["DeviceMotionEvent"] !== "undefined";
	};
	Cnds.prototype.CompareOrientation = function (orientation_, cmp_, angle_)
	{
		var v = 0;
		if (orientation_ === 0)
			v = this.getAlpha();
		else if (orientation_ === 1)
			v = this.getBeta();
		else
			v = this.getGamma();
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.CompareAcceleration = function (acceleration_, cmp_, angle_)
	{
		var v = 0;
		if (acceleration_ === 0)
			v = this.acc_g_x;
		else if (acceleration_ === 1)
			v = this.acc_g_y;
		else if (acceleration_ === 2)
			v = this.acc_g_z;
		else if (acceleration_ === 3)
			v = this.acc_x;
		else if (acceleration_ === 4)
			v = this.acc_y;
		else if (acceleration_ === 5)
			v = this.acc_z;
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.OnNthTouchStart = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.OnNthTouchEnd = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.HasNthTouch = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return this.touches.length >= touch_ + 1;
	};
	pluginProto.cnds = new Cnds();
	function Exps() {};
	Exps.prototype.TouchCount = function (ret)
	{
		ret.set_int(this.touches.length);
	};
	Exps.prototype.X = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxX = layer.parallaxX;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxX = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxX = oldParallaxX;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.XAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.XForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.Y = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxY = layer.parallaxY;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxY = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxY = oldParallaxY;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.YAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.YForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.AbsoluteX = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].x);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteXAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].x);
	};
	Exps.prototype.AbsoluteXForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.x);
	};
	Exps.prototype.AbsoluteY = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].y);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteYAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].y);
	};
	Exps.prototype.AbsoluteYForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.y);
	};
	Exps.prototype.SpeedAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.SpeedForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var dist = cr.distanceTo(touch.x, touch.y, touch.lastx, touch.lasty);
		var timediff = (touch.time - touch.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.AngleAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(t.lastx, t.lasty, t.x, t.y)));
	};
	Exps.prototype.AngleForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(touch.lastx, touch.lasty, touch.x, touch.y)));
	};
	Exps.prototype.Alpha = function (ret)
	{
		ret.set_float(this.getAlpha());
	};
	Exps.prototype.Beta = function (ret)
	{
		ret.set_float(this.getBeta());
	};
	Exps.prototype.Gamma = function (ret)
	{
		ret.set_float(this.getGamma());
	};
	Exps.prototype.AccelerationXWithG = function (ret)
	{
		ret.set_float(this.acc_g_x);
	};
	Exps.prototype.AccelerationYWithG = function (ret)
	{
		ret.set_float(this.acc_g_y);
	};
	Exps.prototype.AccelerationZWithG = function (ret)
	{
		ret.set_float(this.acc_g_z);
	};
	Exps.prototype.AccelerationX = function (ret)
	{
		ret.set_float(this.acc_x);
	};
	Exps.prototype.AccelerationY = function (ret)
	{
		ret.set_float(this.acc_y);
	};
	Exps.prototype.AccelerationZ = function (ret)
	{
		ret.set_float(this.acc_z);
	};
	Exps.prototype.TouchIndex = function (ret)
	{
		ret.set_int(this.trigger_index);
	};
	Exps.prototype.TouchID = function (ret)
	{
		ret.set_float(this.trigger_id);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.WebStorage = function(runtime)
{
	this.runtime = runtime;
};
(function()
{
	var pluginProto = cr.plugins_.WebStorage.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var prefix = "";
	var is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	if (is_arcade)
		prefix = "arcade" + window["scirra_arcade_id"];
	var logged_sessionnotsupported = false;
	function LogSessionNotSupported()
	{
		if (logged_sessionnotsupported)
			return;
		cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead.");
		logged_sessionnotsupported = true;
	};
	instanceProto.onCreate = function()
	{
	};
	function Cnds() {};
	Cnds.prototype.LocalStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.SessionStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.LocalStorageExists = function(key)
	{
		return localStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.SessionStorageExists = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return false;
		}
		return sessionStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.OnQuotaExceeded = function ()
	{
		return true;
	};
	Cnds.prototype.CompareKeyText = function (key, text_to_compare, case_sensitive)
	{
		var value = localStorage.getItem(prefix + key) || "";
		if (case_sensitive)
			return value == text_to_compare;
		else
			return cr.equals_nocase(value, text_to_compare);
	};
	Cnds.prototype.CompareKeyNumber = function (key, cmp, x)
	{
		var value = localStorage.getItem(prefix + key) || "";
		return cr.do_cmp(parseFloat(value), cmp, x);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StoreLocal = function(key, data)
	{
		try {
			localStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.StoreSession = function(key,data)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		try {
			sessionStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.RemoveLocal = function(key)
	{
		localStorage.removeItem(prefix + key);
	};
	Acts.prototype.RemoveSession = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		sessionStorage.removeItem(prefix + key);
	};
	Acts.prototype.ClearLocal = function()
	{
		if (!is_arcade)
			localStorage.clear();
	};
	Acts.prototype.ClearSession = function()
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		if (!is_arcade)
			sessionStorage.clear();
	};
	Acts.prototype.JSONLoad = function (json_, mode_)
	{
		var d;
		try {
			d = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!d["c2dictionary"])			// presumably not a c2dictionary object
			return;
		var o = d["data"];
		if (mode_ === 0 && !is_arcade)	// 'set' mode: must clear webstorage first
			localStorage.clear();
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
			{
				try {
					localStorage.setItem(prefix + p, o[p]);
				}
				catch (e)
				{
					this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
					return;
				}
			}
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.LocalValue = function(ret,key)
	{
		ret.set_string(localStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.SessionValue = function(ret,key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		ret.set_string(sessionStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.LocalCount = function(ret)
	{
		ret.set_int(is_arcade ? 0 : localStorage.length);
	};
	Exps.prototype.SessionCount = function(ret)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_int(0);
			return;
		}
		ret.set_int(is_arcade ? 0 : sessionStorage.length);
	};
	Exps.prototype.LocalAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.getItem(localStorage.key(n)) || "");
	};
	Exps.prototype.SessionAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.getItem(sessionStorage.key(n)) || "");
	};
	Exps.prototype.LocalKeyAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.key(n) || "");
	};
	Exps.prototype.SessionKeyAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.key(n) || "");
	};
	Exps.prototype.AsJSON = function (ret)
	{
		var o = {}, i, len, k;
		for (i = 0, len = localStorage.length; i < len; i++)
		{
			k = localStorage.key(i);
			if (is_arcade)
			{
				if (k.substr(0, prefix.length) === prefix)
				{
					o[k.substr(prefix.length)] = localStorage.getItem(k);
				}
			}
			else
				o[k] = localStorage.getItem(k);
		}
		ret.set_string(JSON.stringify({
			"c2dictionary": true,
			"data": o
		}));
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.behaviors.Anchor = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Anchor.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.anch_left = this.properties[0];		// 0 = left, 1 = right
		this.anch_top = this.properties[1];			// 0 = top, 1 = bottom
		this.anch_right = this.properties[2];		// 0 = none, 1 = right
		this.anch_bottom = this.properties[3];		// 0 = none, 1 = bottom
		this.inst.update_bbox();
		this.xleft = this.inst.bbox.left;
		this.ytop = this.inst.bbox.top;
		this.xright = this.runtime.original_width - this.inst.bbox.left;
		this.ybottom = this.runtime.original_height - this.inst.bbox.top;
		this.rdiff = this.runtime.original_width - this.inst.bbox.right;
		this.bdiff = this.runtime.original_height - this.inst.bbox.bottom;
		this.enabled = (this.properties[4] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"xleft": this.xleft,
			"ytop": this.ytop,
			"xright": this.xright,
			"ybottom": this.ybottom,
			"rdiff": this.rdiff,
			"bdiff": this.bdiff,
			"enabled": this.enabled
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.xleft = o["xleft"];
		this.ytop = o["ytop"];
		this.xright = o["xright"];
		this.ybottom = o["ybottom"];
		this.rdiff = o["rdiff"];
		this.bdiff = o["bdiff"];
		this.enabled = o["enabled"];
	};
	behinstProto.tick = function ()
	{
		if (!this.enabled)
			return;
		var n;
		var layer = this.inst.layer;
		var inst = this.inst;
		var bbox = this.inst.bbox;
		if (this.anch_left === 0)
		{
			inst.update_bbox();
			n = (layer.viewLeft + this.xleft) - bbox.left;
			if (n !== 0)
			{
				inst.x += n;
				inst.set_bbox_changed();
			}
		}
		else if (this.anch_left === 1)
		{
			inst.update_bbox();
			n = (layer.viewRight - this.xright) - bbox.left;
			if (n !== 0)
			{
				inst.x += n;
				inst.set_bbox_changed();
			}
		}
		if (this.anch_top === 0)
		{
			inst.update_bbox();
			n = (layer.viewTop + this.ytop) - bbox.top;
			if (n !== 0)
			{
				inst.y += n;
				inst.set_bbox_changed();
			}
		}
		else if (this.anch_top === 1)
		{
			inst.update_bbox();
			n = (layer.viewBottom - this.ybottom) - bbox.top;
			if (n !== 0)
			{
				inst.y += n;
				inst.set_bbox_changed();
			}
		}
		if (this.anch_right === 1)
		{
			inst.update_bbox();
			n = (layer.viewRight - this.rdiff) - bbox.right;
			if (n !== 0)
			{
				inst.width += n;
				if (inst.width < 0)
					inst.width = 0;
				inst.set_bbox_changed();
			}
		}
		if (this.anch_bottom === 1)
		{
			inst.update_bbox();
			n = (layer.viewBottom - this.bdiff) - bbox.bottom;
			if (n !== 0)
			{
				inst.height += n;
				if (inst.height < 0)
					inst.height = 0;
				inst.set_bbox_changed();
			}
		}
	};
	function Cnds() {};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEnabled = function (e)
	{
		if (this.enabled && e === 0)
			this.enabled = false;
		else if (!this.enabled && e !== 0)
		{
			this.inst.update_bbox();
			this.xleft = this.inst.bbox.left;
			this.ytop = this.inst.bbox.top;
			this.xright = this.runtime.original_width - this.inst.bbox.left;
			this.ybottom = this.runtime.original_height - this.inst.bbox.top;
			this.rdiff = this.runtime.original_width - this.inst.bbox.right;
			this.bdiff = this.runtime.original_height - this.inst.bbox.bottom;
			this.enabled = true;
		}
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Bullet = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Bullet.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		var speed = this.properties[0];
		this.acc = this.properties[1];
		this.g = this.properties[2];
		this.bounceOffSolid = (this.properties[3] !== 0);
		this.setAngle = (this.properties[4] !== 0);
		this.dx = Math.cos(this.inst.angle) * speed;
		this.dy = Math.sin(this.inst.angle) * speed;
		this.lastx = this.inst.x;
		this.lasty = this.inst.y;
		this.lastKnownAngle = this.inst.angle;
		this.travelled = 0;
		this.enabled = (this.properties[5] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"acc": this.acc,
			"g": this.g,
			"dx": this.dx,
			"dy": this.dy,
			"lx": this.lastx,
			"ly": this.lasty,
			"lka": this.lastKnownAngle,
			"t": this.travelled,
			"e": this.enabled
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.acc = o["acc"];
		this.g = o["g"];
		this.dx = o["dx"];
		this.dy = o["dy"];
		this.lastx = o["lx"];
		this.lasty = o["ly"];
		this.lastKnownAngle = o["lka"];
		this.travelled = o["t"];
		this.enabled = o["e"];
	};
	behinstProto.tick = function ()
	{
		if (!this.enabled)
			return;
		var dt = this.runtime.getDt(this.inst);
		var s, a;
		var bounceSolid, bounceAngle;
		if (this.inst.angle !== this.lastKnownAngle)
		{
			if (this.setAngle)
			{
				s = cr.distanceTo(0, 0, this.dx, this.dy);
				this.dx = Math.cos(this.inst.angle) * s;
				this.dy = Math.sin(this.inst.angle) * s;
			}
			this.lastKnownAngle = this.inst.angle;
		}
		if (this.acc !== 0)
		{
			s = cr.distanceTo(0, 0, this.dx, this.dy);
			if (this.dx === 0 && this.dy === 0)
				a = this.inst.angle;
			else
				a = cr.angleTo(0, 0, this.dx, this.dy);
			s += this.acc * dt;
			if (s < 0)
				s = 0;
			this.dx = Math.cos(a) * s;
			this.dy = Math.sin(a) * s;
		}
		if (this.g !== 0)
			this.dy += this.g * dt;
		this.lastx = this.inst.x;
		this.lasty = this.inst.y;
		if (this.dx !== 0 || this.dy !== 0)
		{
			this.inst.x += this.dx * dt;
			this.inst.y += this.dy * dt;
			this.travelled += cr.distanceTo(0, 0, this.dx * dt, this.dy * dt)
			if (this.setAngle)
			{
				this.inst.angle = cr.angleTo(0, 0, this.dx, this.dy);
				this.inst.set_bbox_changed();
				this.lastKnownAngle = this.inst.angle;
			}
			this.inst.set_bbox_changed();
			if (this.bounceOffSolid)
			{
				bounceSolid = this.runtime.testOverlapSolid(this.inst);
				if (bounceSolid)
				{
					this.runtime.registerCollision(this.inst, bounceSolid);
					s = cr.distanceTo(0, 0, this.dx, this.dy);
					bounceAngle = this.runtime.calculateSolidBounceAngle(this.inst, this.lastx, this.lasty);
					this.dx = Math.cos(bounceAngle) * s;
					this.dy = Math.sin(bounceAngle) * s;
					this.inst.x += this.dx * dt;			// move out for one tick since the object can't have spent a tick in the solid
					this.inst.y += this.dy * dt;
					this.inst.set_bbox_changed();
					if (this.setAngle)
					{
						this.inst.angle = bounceAngle;
						this.lastKnownAngle = bounceAngle;
						this.inst.set_bbox_changed();
					}
					if (!this.runtime.pushOutSolid(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30)))
						this.runtime.pushOutSolidNearest(this.inst, 100);
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.CompareSpeed = function (cmp, s)
	{
		return cr.do_cmp(cr.distanceTo(0, 0, this.dx, this.dy), cmp, s);
	};
	Cnds.prototype.CompareTravelled = function (cmp, d)
	{
		return cr.do_cmp(this.travelled, cmp, d);
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpeed = function (s)
	{
		var a = cr.angleTo(0, 0, this.dx, this.dy);
		this.dx = Math.cos(a) * s;
		this.dy = Math.sin(a) * s;
	};
	Acts.prototype.SetAcceleration = function (a)
	{
		this.acc = a;
	};
	Acts.prototype.SetGravity = function (g)
	{
		this.g = g;
	};
	Acts.prototype.SetAngleOfMotion = function (a)
	{
		a = cr.to_radians(a);
		var s = cr.distanceTo(0, 0, this.dx, this.dy)
		this.dx = Math.cos(a) * s;
		this.dy = Math.sin(a) * s;
	};
	Acts.prototype.Bounce = function (objtype)
	{
		if (!objtype)
			return;
		var otherinst = objtype.getFirstPicked(this.inst);
		if (!otherinst)
			return;
		var dt = this.runtime.getDt(this.inst);
		var s = cr.distanceTo(0, 0, this.dx, this.dy);
		var bounceAngle = this.runtime.calculateSolidBounceAngle(this.inst, this.lastx, this.lasty, otherinst);
		this.dx = Math.cos(bounceAngle) * s;
		this.dy = Math.sin(bounceAngle) * s;
		this.inst.x += this.dx * dt;			// move out for one tick since the object can't have spent a tick in the solid
		this.inst.y += this.dy * dt;
		this.inst.set_bbox_changed();
		if (this.setAngle)
		{
			this.inst.angle = bounceAngle;
			this.lastKnownAngle = bounceAngle;
			this.inst.set_bbox_changed();
		}
		if (this.bounceOffSolid)
		{
			if (!this.runtime.pushOutSolid(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30)))
				this.runtime.pushOutSolidNearest(this.inst, 100);
		}
		else
		{
			this.runtime.pushOut(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30), otherinst)
		}
	};
	Acts.prototype.SetEnabled = function (en)
	{
		this.enabled = (en === 1);
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Speed = function (ret)
	{
		var s = cr.distanceTo(0, 0, this.dx, this.dy);
		s = cr.round6dp(s);
		ret.set_float(s);
	};
	Exps.prototype.Acceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.AngleOfMotion = function (ret)
	{
		ret.set_float(cr.to_degrees(cr.angleTo(0, 0, this.dx, this.dy)));
	};
	Exps.prototype.DistanceTravelled = function (ret)
	{
		ret.set_float(this.travelled);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.DragnDrop = function(runtime)
{
	this.runtime = runtime;
	var self = this;
	if (!this.runtime.isDomFree)
	{
		jQuery(document).mousemove(
			function(info) {
				self.onMouseMove(info);
			}
		);
		jQuery(document).mousedown(
			function(info) {
				self.onMouseDown(info);
			}
		);
		jQuery(document).mouseup(
			function(info) {
				self.onMouseUp(info);
			}
		);
	}
	var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
	if (this.runtime.isDirectCanvas)
		elem = window["Canvas"];
	else if (this.runtime.isCocoonJs)
		elem = window;
	if (window.navigator["pointerEnabled"])
	{
		elem.addEventListener("pointerdown",
			function(info) {
				self.onPointerStart(info);
			},
			false
		);
		elem.addEventListener("pointermove",
			function(info) {
				self.onPointerMove(info);
			},
			false
		);
		elem.addEventListener("pointerup",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
		elem.addEventListener("pointercancel",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
	}
	else if (window.navigator["msPointerEnabled"])
	{
		elem.addEventListener("MSPointerDown",
			function(info) {
				self.onPointerStart(info);
			},
			false
		);
		elem.addEventListener("MSPointerMove",
			function(info) {
				self.onPointerMove(info);
			},
			false
		);
		elem.addEventListener("MSPointerUp",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
		elem.addEventListener("MSPointerCancel",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
	}
	else
	{
		elem.addEventListener("touchstart",
			function(info) {
				self.onTouchStart(info);
			},
			false
		);
		elem.addEventListener("touchmove",
			function(info) {
				self.onTouchMove(info);
			},
			false
		);
		elem.addEventListener("touchend",
			function(info) {
				self.onTouchEnd(info);
			},
			false
		);
		elem.addEventListener("touchcancel",
			function(info) {
				self.onTouchEnd(info);
			},
			false
		);
	}
};
(function ()
{
	var behaviorProto = cr.behaviors.DragnDrop.prototype;
	var dummyoffset = {left: 0, top: 0};
	function GetDragDropBehavior(inst)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i] instanceof behaviorProto.Instance)
				return inst.behavior_insts[i];
		}
		return null;
	};
	behaviorProto.onMouseDown = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputDown("leftmouse", info.pageX, info.pageY);
	};
	behaviorProto.onMouseMove = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputMove("leftmouse", info.pageX, info.pageY);
	};
	behaviorProto.onMouseUp = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputUp("leftmouse");
	};
	behaviorProto.onTouchStart = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputDown(id ? id.toString() : "<none>", t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputMove(id ? id.toString() : "<none>", t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchEnd = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputUp(id ? id.toString() : "<none>");
		}
	};
	behaviorProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputDown(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputMove(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputUp(info["pointerId"].toString());
	};
	behaviorProto.onInputDown = function (src, pageX, pageY)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var lx, ly, topx, topy;
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst, topmost = null;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (!b.enabled || b.dragging)
				continue;		// don't consider disabled or already-dragging instances
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			inst.update_bbox();
			if (!inst.contains_pt(lx, ly))
				continue;		// don't consider instances not over this point
			if (!topmost)
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
			if (inst.layer.index > topmost.layer.index)
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
			if (inst.layer.index === topmost.layer.index && inst.get_zindex() > topmost.get_zindex())
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
		}
		if (topmost)
			GetDragDropBehavior(topmost).onDown(src, topx, topy);
	};
	behaviorProto.onInputMove = function (src, pageX, pageY)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var lx, ly;
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (!b.enabled || !b.dragging || (b.dragging && b.dragsource !== src))
				continue;		// don't consider disabled, not-dragging, or dragging by other sources
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			b.onMove(lx, ly);
		}
	};
	behaviorProto.onInputUp = function (src)
	{
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (b.dragging && b.dragsource === src)
				b.onUp();
		}
	};
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.dragging = false;
		this.dx = 0;
		this.dy = 0;
		this.dragsource = "<none>";
		this.axes = this.properties[0];
		this.enabled = (this.properties[1] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return { "enabled": this.enabled };
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.enabled = o["enabled"];
		this.dragging = false;
	};
	behinstProto.onDown = function(src, x, y)
	{
		this.dx = x - this.inst.x;
		this.dy = y - this.inst.y;
		this.dragging = true;
		this.dragsource = src;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDragStart, this.inst);
		this.runtime.isInUserInputEvent = false;
	};
	behinstProto.onMove = function(x, y)
	{
		var newx = x - this.dx;
		var newy = y - this.dy;
		if (this.axes === 0)		// both
		{
			if (this.inst.x !== newx || this.inst.y !== newy)
			{
				this.inst.x = newx;
				this.inst.y = newy;
				this.inst.set_bbox_changed();
			}
		}
		else if (this.axes === 1)	// horizontal
		{
			if (this.inst.x !== newx)
			{
				this.inst.x = newx;
				this.inst.set_bbox_changed();
			}
		}
		else if (this.axes === 2)	// vertical
		{
			if (this.inst.y !== newy)
			{
				this.inst.y = newy;
				this.inst.set_bbox_changed();
			}
		}
	};
	behinstProto.onUp = function()
	{
		this.dragging = false;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDrop, this.inst);
		this.runtime.isInUserInputEvent = false;
	};
	behinstProto.tick = function ()
	{
	};
	function Cnds() {};
	Cnds.prototype.IsDragging = function ()
	{
		return this.dragging;
	};
	Cnds.prototype.OnDragStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnDrop = function ()
	{
		return true;
	};
	Cnds.prototype.IsEnabled = function ()
	{
		return !!this.enabled;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEnabled = function (s)
	{
		this.enabled = (s !== 0);
		if (!this.enabled)
			this.dragging = false;
	};
	Acts.prototype.Drop = function ()
	{
		if (this.dragging)
			this.onUp();
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.EightDir = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.EightDir.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.upkey = false;
		this.downkey = false;
		this.leftkey = false;
		this.rightkey = false;
		this.ignoreInput = false;
		this.simup = false;
		this.simdown = false;
		this.simleft = false;
		this.simright = false;
		this.lastuptick = -1;
		this.lastdowntick = -1;
		this.lastlefttick = -1;
		this.lastrighttick = -1;
		this.dx = 0;
		this.dy = 0;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.maxspeed = this.properties[0];
		this.acc = this.properties[1];
		this.dec = this.properties[2];
		this.directions = this.properties[3];	// 0=Up & down, 1=Left & right, 2=4 directions, 3=8 directions"
		this.angleMode = this.properties[4];	// 0=No,1=90-degree intervals, 2=45-degree intervals, 3=360 degree (smooth)
		this.defaultControls = (this.properties[5] === 1);	// 0=no, 1=yes
		this.enabled = (this.properties[6] !== 0);
		if (this.defaultControls && !this.runtime.isDomFree)
		{
			jQuery(document).keydown(
				(function (self) {
					return function(info) {
						self.onKeyDown(info);
					};
				})(this)
			);
			jQuery(document).keyup(
				(function (self) {
					return function(info) {
						self.onKeyUp(info);
					};
				})(this)
			);
		}
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"dx": this.dx,
			"dy": this.dy,
			"enabled": this.enabled,
			"maxspeed": this.maxspeed,
			"acc": this.acc,
			"dec": this.dec,
			"ignoreInput": this.ignoreInput
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.dx = o["dx"];
		this.dy = o["dy"];
		this.enabled = o["enabled"];
		this.maxspeed = o["maxspeed"];
		this.acc = o["acc"];
		this.dec = o["dec"];
		this.ignoreInput = o["ignoreInput"];
		this.upkey = false;
		this.downkey = false;
		this.leftkey = false;
		this.rightkey = false;
		this.simup = false;
		this.simdown = false;
		this.simleft = false;
		this.simright = false;
		this.lastuptick = -1;
		this.lastdowntick = -1;
		this.lastlefttick = -1;
		this.lastrighttick = -1;
	};
	behinstProto.onKeyDown = function (info)
	{
		var tickcount = this.runtime.tickcount;
		switch (info.which) {
		case 37:	// left
			info.preventDefault();
			if (this.lastlefttick < tickcount)
				this.leftkey = true;
			break;
		case 38:	// up
			info.preventDefault();
			if (this.lastuptick < tickcount)
				this.upkey = true;
			break;
		case 39:	// right
			info.preventDefault();
			if (this.lastrighttick < tickcount)
				this.rightkey = true;
			break;
		case 40:	// down
			info.preventDefault();
			if (this.lastdowntick < tickcount)
				this.downkey = true;
			break;
		}
	};
	behinstProto.onKeyUp = function (info)
	{
		var tickcount = this.runtime.tickcount;
		switch (info.which) {
		case 37:	// left
			info.preventDefault();
			this.leftkey = false;
			this.lastlefttick = tickcount;
			break;
		case 38:	// up
			info.preventDefault();
			this.upkey = false;
			this.lastuptick = tickcount;
			break;
		case 39:	// right
			info.preventDefault();
			this.rightkey = false;
			this.lastrighttick = tickcount;
			break;
		case 40:	// down
			info.preventDefault();
			this.downkey = false;
			this.lastdowntick = tickcount;
			break;
		}
	};
	behinstProto.tick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		var left = this.leftkey || this.simleft;
		var right = this.rightkey || this.simright;
		var up = this.upkey || this.simup;
		var down = this.downkey || this.simdown;
		this.simleft = false;
		this.simright = false;
		this.simup = false;
		this.simdown = false;
		if (!this.enabled)
			return;
		var collobj = this.runtime.testOverlapSolid(this.inst);
		if (collobj)
		{
			this.runtime.registerCollision(this.inst, collobj);
			if (!this.runtime.pushOutSolidNearest(this.inst))
				return;		// must be stuck in solid
		}
		if (this.ignoreInput)
		{
			left = false;
			right = false;
			up = false;
			down = false;
		}
		if (this.directions === 0)
		{
			left = false;
			right = false;
		}
		else if (this.directions === 1)
		{
			up = false;
			down = false;
		}
		if (this.directions === 2 && (up || down))
		{
			left = false;
			right = false;
		}
		if (left == right)	// both up or both down
		{
			if (this.dx < 0)
			{
				this.dx += this.dec * dt;
				if (this.dx > 0)
					this.dx = 0;
			}
			else if (this.dx > 0)
			{
				this.dx -= this.dec * dt;
				if (this.dx < 0)
					this.dx = 0;
			}
		}
		if (up == down)
		{
			if (this.dy < 0)
			{
				this.dy += this.dec * dt;
				if (this.dy > 0)
					this.dy = 0;
			}
			else if (this.dy > 0)
			{
				this.dy -= this.dec * dt;
				if (this.dy < 0)
					this.dy = 0;
			}
		}
		if (left && !right)
		{
			if (this.dx > 0)
				this.dx -= (this.acc + this.dec) * dt;
			else
				this.dx -= this.acc * dt;
		}
		if (right && !left)
		{
			if (this.dx < 0)
				this.dx += (this.acc + this.dec) * dt;
			else
				this.dx += this.acc * dt;
		}
		if (up && !down)
		{
			if (this.dy > 0)
				this.dy -= (this.acc + this.dec) * dt;
			else
				this.dy -= this.acc * dt;
		}
		if (down && !up)
		{
			if (this.dy < 0)
				this.dy += (this.acc + this.dec) * dt;
			else
				this.dy += this.acc * dt;
		}
		var ax, ay;
		if (this.dx !== 0 || this.dy !== 0)
		{
			var speed = Math.sqrt(this.dx * this.dx + this.dy * this.dy);
			if (speed > this.maxspeed)
			{
				var a = Math.atan2(this.dy, this.dx);
				this.dx = this.maxspeed * Math.cos(a);
				this.dy = this.maxspeed * Math.sin(a);
			}
			var oldx = this.inst.x;
			var oldy = this.inst.y;
			var oldangle = this.inst.angle;
			this.inst.x += this.dx * dt;
			this.inst.set_bbox_changed();
			collobj = this.runtime.testOverlapSolid(this.inst);
			if (collobj)
			{
				this.inst.x = oldx;
				this.dx = 0;
				this.inst.set_bbox_changed();
				this.runtime.registerCollision(this.inst, collobj);
			}
			this.inst.y += this.dy * dt;
			this.inst.set_bbox_changed();
			collobj = this.runtime.testOverlapSolid(this.inst);
			if (collobj)
			{
				this.inst.y = oldy;
				this.dy = 0;
				this.inst.set_bbox_changed();
				this.runtime.registerCollision(this.inst, collobj);
			}
			ax = cr.round6dp(this.dx);
			ay = cr.round6dp(this.dy);
			if (ax !== 0 || ay !== 0)
			{
				if (this.angleMode === 1)	// 90 degree intervals
					this.inst.angle = cr.to_clamped_radians(Math.round(cr.to_degrees(Math.atan2(ay, ax)) / 90.0) * 90.0);
				else if (this.angleMode === 2)	// 45 degree intervals
					this.inst.angle = cr.to_clamped_radians(Math.round(cr.to_degrees(Math.atan2(ay, ax)) / 45.0) * 45.0);
				else if (this.angleMode === 3)	// 360 degree
					this.inst.angle = Math.atan2(ay, ax);
			}
			this.inst.set_bbox_changed();
			if (this.inst.angle != oldangle)
			{
				collobj = this.runtime.testOverlapSolid(this.inst);
				if (collobj)
				{
					this.inst.angle = oldangle;
					this.inst.set_bbox_changed();
					this.runtime.registerCollision(this.inst, collobj);
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.IsMoving = function ()
	{
		return this.dx !== 0 || this.dy !== 0;
	};
	Cnds.prototype.CompareSpeed = function (cmp, s)
	{
		var speed = Math.sqrt(this.dx * this.dx + this.dy * this.dy);
		return cr.do_cmp(speed, cmp, s);
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Stop = function ()
	{
		this.dx = 0;
		this.dy = 0;
	};
	Acts.prototype.Reverse = function ()
	{
		this.dx *= -1;
		this.dy *= -1;
	};
	Acts.prototype.SetIgnoreInput = function (ignoring)
	{
		this.ignoreInput = ignoring;
	};
	Acts.prototype.SetSpeed = function (speed)
	{
		if (speed < 0)
			speed = 0;
		if (speed > this.maxspeed)
			speed = this.maxspeed;
		var a = Math.atan2(this.dy, this.dx);
		this.dx = speed * Math.cos(a);
		this.dy = speed * Math.sin(a);
	};
	Acts.prototype.SetMaxSpeed = function (maxspeed)
	{
		this.maxspeed = maxspeed;
		if (this.maxspeed < 0)
			this.maxspeed = 0;
	};
	Acts.prototype.SetAcceleration = function (acc)
	{
		this.acc = acc;
		if (this.acc < 0)
			this.acc = 0;
	};
	Acts.prototype.SetDeceleration = function (dec)
	{
		this.dec = dec;
		if (this.dec < 0)
			this.dec = 0;
	};
	Acts.prototype.SimulateControl = function (ctrl)
	{
		switch (ctrl) {
		case 0:		this.simleft = true;	break;
		case 1:		this.simright = true;	break;
		case 2:		this.simup = true;		break;
		case 3:		this.simdown = true;	break;
		}
	};
	Acts.prototype.SetEnabled = function (en)
	{
		this.enabled = (en === 1);
	};
	Acts.prototype.SetVectorX = function (x_)
	{
		this.dx = x_;
	};
	Acts.prototype.SetVectorY = function (y_)
	{
		this.dy = y_;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Speed = function (ret)
	{
		ret.set_float(Math.sqrt(this.dx * this.dx + this.dy * this.dy));
	};
	Exps.prototype.MaxSpeed = function (ret)
	{
		ret.set_float(this.maxspeed);
	};
	Exps.prototype.Acceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.Deceleration = function (ret)
	{
		ret.set_float(this.dec);
	};
	Exps.prototype.MovingAngle = function (ret)
	{
		ret.set_float(cr.to_degrees(Math.atan2(this.dy, this.dx)));
	};
	Exps.prototype.VectorX = function (ret)
	{
		ret.set_float(this.dx);
	};
	Exps.prototype.VectorY = function (ret)
	{
		ret.set_float(this.dy);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Fade = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Fade.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		var active_at_start = this.properties[0] === 1;
		this.fadeInTime = this.properties[1];
		this.waitTime = this.properties[2];
		this.fadeOutTime = this.properties[3];
		this.destroy = this.properties[4];			// 0 = no, 1 = after fade out
		this.stage = active_at_start ? 0 : 3;		// 0 = fade in, 1 = wait, 2 = fade out, 3 = done
		if (this.recycled)
			this.stageTime.reset();
		else
			this.stageTime = new cr.KahanAdder();
		this.maxOpacity = (this.inst.opacity ? this.inst.opacity : 1.0);
		if (active_at_start)
		{
			if (this.fadeInTime === 0)
			{
				this.stage = 1;
				if (this.waitTime === 0)
					this.stage = 2;
			}
			else
			{
				this.inst.opacity = 0;
				this.runtime.redraw = true;
			}
		}
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"fit": this.fadeInTime,
			"wt": this.waitTime,
			"fot": this.fadeOutTime,
			"s": this.stage,
			"st": this.stageTime.sum,
			"mo": this.maxOpacity,
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.fadeInTime = o["fit"];
		this.waitTime = o["wt"];
		this.fadeOutTime = o["fot"];
		this.stage = o["s"];
		this.stageTime.reset();
		this.stageTime.sum = o["st"];
		this.maxOpacity = o["mo"];
	};
	behinstProto.tick = function ()
	{
		this.stageTime.add(this.runtime.getDt(this.inst));
		if (this.stage === 0)
		{
			this.inst.opacity = (this.stageTime.sum / this.fadeInTime) * this.maxOpacity;
			this.runtime.redraw = true;
			if (this.inst.opacity >= this.maxOpacity)
			{
				this.inst.opacity = this.maxOpacity;
				this.stage = 1;	// wait stage
				this.stageTime.reset();
			}
		}
		if (this.stage === 1)
		{
			if (this.stageTime.sum >= this.waitTime)
			{
				this.stage = 2;	// fade out stage
				this.stageTime.reset();
			}
		}
		if (this.stage === 2)
		{
			if (this.fadeOutTime !== 0)
			{
				this.inst.opacity = this.maxOpacity - ((this.stageTime.sum / this.fadeOutTime) * this.maxOpacity);
				this.runtime.redraw = true;
				if (this.inst.opacity < 0)
				{
					this.inst.opacity = 0;
					this.stage = 3;	// done
					this.stageTime.reset();
					this.runtime.trigger(cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd, this.inst);
					if (this.destroy === 1)
						this.runtime.DestroyInstance(this.inst);
				}
			}
		}
	};
	behinstProto.doStart = function ()
	{
		this.stage = 0;
		this.stageTime.reset();
		if (this.fadeInTime === 0)
		{
			this.stage = 1;
			if (this.waitTime === 0)
				this.stage = 2;
		}
		else
		{
			this.inst.opacity = 0;
			this.runtime.redraw = true;
		}
	};
	function Cnds() {};
	Cnds.prototype.OnFadeOutEnd = function ()
	{
		return true;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StartFade = function ()
	{
		if (this.stage === 3)
			this.doStart();
	};
	Acts.prototype.RestartFade = function ()
	{
		this.doStart();
	};
	behaviorProto.acts = new Acts();
}());
;
;
cr.behaviors.Pin = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Pin.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.pinObject = null;
		this.pinObjectUid = -1;		// for loading
		this.pinAngle = 0;
		this.pinDist = 0;
		this.myStartAngle = 0;
		this.theirStartAngle = 0;
		this.lastKnownAngle = 0;
		this.mode = 0;				// 0 = position & angle; 1 = position; 2 = angle; 3 = rope; 4 = bar
		var self = this;
		if (!this.recycled)
		{
			this.myDestroyCallback = (function(inst) {
													self.onInstanceDestroyed(inst);
												});
		}
		this.runtime.addDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"uid": this.pinObject ? this.pinObject.uid : -1,
			"pa": this.pinAngle,
			"pd": this.pinDist,
			"msa": this.myStartAngle,
			"tsa": this.theirStartAngle,
			"lka": this.lastKnownAngle,
			"m": this.mode
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.pinObjectUid = o["uid"];		// wait until afterLoad to look up
		this.pinAngle = o["pa"];
		this.pinDist = o["pd"];
		this.myStartAngle = o["msa"];
		this.theirStartAngle = o["tsa"];
		this.lastKnownAngle = o["lka"];
		this.mode = o["m"];
	};
	behinstProto.afterLoad = function ()
	{
		if (this.pinObjectUid === -1)
			this.pinObject = null;
		else
		{
			this.pinObject = this.runtime.getObjectByUID(this.pinObjectUid);
;
		}
		this.pinObjectUid = -1;
	};
	behinstProto.onInstanceDestroyed = function (inst)
	{
		if (this.pinObject == inst)
			this.pinObject = null;
	};
	behinstProto.onDestroy = function()
	{
		this.pinObject = null;
		this.runtime.removeDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.tick2 = function ()
	{
		if (!this.pinObject)
			return;
		if (this.lastKnownAngle !== this.inst.angle)
			this.myStartAngle = cr.clamp_angle(this.myStartAngle + (this.inst.angle - this.lastKnownAngle));
		var newx = this.inst.x;
		var newy = this.inst.y;
		if (this.mode === 3 || this.mode === 4)		// rope mode or bar mode
		{
			var dist = cr.distanceTo(this.inst.x, this.inst.y, this.pinObject.x, this.pinObject.y);
			if ((dist > this.pinDist) || (this.mode === 4 && dist < this.pinDist))
			{
				var a = cr.angleTo(this.pinObject.x, this.pinObject.y, this.inst.x, this.inst.y);
				newx = this.pinObject.x + Math.cos(a) * this.pinDist;
				newy = this.pinObject.y + Math.sin(a) * this.pinDist;
			}
		}
		else
		{
			newx = this.pinObject.x + Math.cos(this.pinObject.angle + this.pinAngle) * this.pinDist;
			newy = this.pinObject.y + Math.sin(this.pinObject.angle + this.pinAngle) * this.pinDist;
		}
		var newangle = cr.clamp_angle(this.myStartAngle + (this.pinObject.angle - this.theirStartAngle));
		this.lastKnownAngle = newangle;
		if ((this.mode === 0 || this.mode === 1 || this.mode === 3 || this.mode === 4)
			&& (this.inst.x !== newx || this.inst.y !== newy))
		{
			this.inst.x = newx;
			this.inst.y = newy;
			this.inst.set_bbox_changed();
		}
		if ((this.mode === 0 || this.mode === 2) && (this.inst.angle !== newangle))
		{
			this.inst.angle = newangle;
			this.inst.set_bbox_changed();
		}
	};
	function Cnds() {};
	Cnds.prototype.IsPinned = function ()
	{
		return !!this.pinObject;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Pin = function (obj, mode_)
	{
		if (!obj)
			return;
		var otherinst = obj.getFirstPicked(this.inst);
		if (!otherinst)
			return;
		this.pinObject = otherinst;
		this.pinAngle = cr.angleTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y) - otherinst.angle;
		this.pinDist = cr.distanceTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y);
		this.myStartAngle = this.inst.angle;
		this.lastKnownAngle = this.inst.angle;
		this.theirStartAngle = otherinst.angle;
		this.mode = mode_;
	};
	Acts.prototype.Unpin = function ()
	{
		this.pinObject = null;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.PinnedUID = function (ret)
	{
		ret.set_int(this.pinObject ? this.pinObject.uid : -1);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Sin = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Sin.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.i = 0;		// period offset (radians)
	};
	var behinstProto = behaviorProto.Instance.prototype;
	var _2pi = 2 * Math.PI;
	var _pi_2 = Math.PI / 2;
	var _3pi_2 = (3 * Math.PI) / 2;
	behinstProto.onCreate = function()
	{
		this.active = (this.properties[0] === 1);
		this.movement = this.properties[1]; // 0=Horizontal|1=Vertical|2=Size|3=Width|4=Height|5=Angle|6=Opacity|7=Value only
		this.wave = this.properties[2];		// 0=Sine|1=Triangle|2=Sawtooth|3=Reverse sawtooth|4=Square
		this.period = this.properties[3];
		this.period += Math.random() * this.properties[4];								// period random
		if (this.period === 0)
			this.i = 0;
		else
		{
			this.i = (this.properties[5] / this.period) * _2pi;								// period offset
			this.i += ((Math.random() * this.properties[6]) / this.period) * _2pi;			// period offset random
		}
		this.mag = this.properties[7];													// magnitude
		this.mag += Math.random() * this.properties[8];									// magnitude random
		this.initialValue = 0;
		this.initialValue2 = 0;
		this.ratio = 0;
		this.init();
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"i": this.i,
			"a": this.active,
			"mv": this.movement,
			"w": this.wave,
			"p": this.period,
			"mag": this.mag,
			"iv": this.initialValue,
			"iv2": this.initialValue2,
			"r": this.ratio,
			"lkv": this.lastKnownValue,
			"lkv2": this.lastKnownValue2
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.i = o["i"];
		this.active = o["a"];
		this.movement = o["mv"];
		this.wave = o["w"];
		this.period = o["p"];
		this.mag = o["mag"];
		this.initialValue = o["iv"];
		this.initialValue2 = o["iv2"] || 0;
		this.ratio = o["r"];
		this.lastKnownValue = o["lkv"];
		this.lastKnownValue2 = o["lkv2"] || 0;
	};
	behinstProto.init = function ()
	{
		switch (this.movement) {
		case 0:		// horizontal
			this.initialValue = this.inst.x;
			break;
		case 1:		// vertical
			this.initialValue = this.inst.y;
			break;
		case 2:		// size
			this.initialValue = this.inst.width;
			this.ratio = this.inst.height / this.inst.width;
			break;
		case 3:		// width
			this.initialValue = this.inst.width;
			break;
		case 4:		// height
			this.initialValue = this.inst.height;
			break;
		case 5:		// angle
			this.initialValue = this.inst.angle;
			this.mag = cr.to_radians(this.mag);		// convert magnitude from degrees to radians
			break;
		case 6:		// opacity
			this.initialValue = this.inst.opacity;
			break;
		case 7:
			this.initialValue = 0;
			break;
		case 8:		// forwards/backwards
			this.initialValue = this.inst.x;
			this.initialValue2 = this.inst.y;
			break;
		default:
;
		}
		this.lastKnownValue = this.initialValue;
		this.lastKnownValue2 = this.initialValue2;
	};
	behinstProto.waveFunc = function (x)
	{
		x = x % _2pi;
		switch (this.wave) {
		case 0:		// sine
			return Math.sin(x);
		case 1:		// triangle
			if (x <= _pi_2)
				return x / _pi_2;
			else if (x <= _3pi_2)
				return 1 - (2 * (x - _pi_2) / Math.PI);
			else
				return (x - _3pi_2) / _pi_2 - 1;
		case 2:		// sawtooth
			return 2 * x / _2pi - 1;
		case 3:		// reverse sawtooth
			return -2 * x / _2pi + 1;
		case 4:		// square
			return x < Math.PI ? -1 : 1;
		};
		return 0;
	};
	behinstProto.tick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		if (!this.active || dt === 0)
			return;
		if (this.period === 0)
			this.i = 0;
		else
		{
			this.i += (dt / this.period) * _2pi;
			this.i = this.i % _2pi;
		}
		switch (this.movement) {
		case 0:		// horizontal
			if (this.inst.x !== this.lastKnownValue)
				this.initialValue += this.inst.x - this.lastKnownValue;
			this.inst.x = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.x;
			break;
		case 1:		// vertical
			if (this.inst.y !== this.lastKnownValue)
				this.initialValue += this.inst.y - this.lastKnownValue;
			this.inst.y = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.y;
			break;
		case 2:		// size
			this.inst.width = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.inst.height = this.inst.width * this.ratio;
			break;
		case 3:		// width
			this.inst.width = this.initialValue + this.waveFunc(this.i) * this.mag;
			break;
		case 4:		// height
			this.inst.height = this.initialValue + this.waveFunc(this.i) * this.mag;
			break;
		case 5:		// angle
			if (this.inst.angle !== this.lastKnownValue)
				this.initialValue = cr.clamp_angle(this.initialValue + (this.inst.angle - this.lastKnownValue));
			this.inst.angle = cr.clamp_angle(this.initialValue + this.waveFunc(this.i) * this.mag);
			this.lastKnownValue = this.inst.angle;
			break;
		case 6:		// opacity
			this.inst.opacity = this.initialValue + (this.waveFunc(this.i) * this.mag) / 100;
			if (this.inst.opacity < 0)
				this.inst.opacity = 0;
			else if (this.inst.opacity > 1)
				this.inst.opacity = 1;
			break;
		case 8:		// forwards/backwards
			if (this.inst.x !== this.lastKnownValue)
				this.initialValue += this.inst.x - this.lastKnownValue;
			if (this.inst.y !== this.lastKnownValue2)
				this.initialValue2 += this.inst.y - this.lastKnownValue2;
			this.inst.x = this.initialValue + Math.cos(this.inst.angle) * this.waveFunc(this.i) * this.mag;
			this.inst.y = this.initialValue2 + Math.sin(this.inst.angle) * this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.x;
			this.lastKnownValue2 = this.inst.y;
			break;
		}
		this.inst.set_bbox_changed();
	};
	behinstProto.onSpriteFrameChanged = function (prev_frame, next_frame)
	{
		switch (this.movement) {
		case 2:	// size
			this.initialValue *= (next_frame.width / prev_frame.width);
			this.ratio = next_frame.height / next_frame.width;
			break;
		case 3:	// width
			this.initialValue *= (next_frame.width / prev_frame.width);
			break;
		case 4:	// height
			this.initialValue *= (next_frame.height / prev_frame.height);
			break;
		}
	};
	function Cnds() {};
	Cnds.prototype.IsActive = function ()
	{
		return this.active;
	};
	Cnds.prototype.CompareMovement = function (m)
	{
		return this.movement === m;
	};
	Cnds.prototype.ComparePeriod = function (cmp, v)
	{
		return cr.do_cmp(this.period, cmp, v);
	};
	Cnds.prototype.CompareMagnitude = function (cmp, v)
	{
		if (this.movement === 5)
			return cr.do_cmp(this.mag, cmp, cr.to_radians(v));
		else
			return cr.do_cmp(this.mag, cmp, v);
	};
	Cnds.prototype.CompareWave = function (w)
	{
		return this.wave === w;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetActive = function (a)
	{
		this.active = (a === 1);
	};
	Acts.prototype.SetPeriod = function (x)
	{
		this.period = x;
	};
	Acts.prototype.SetMagnitude = function (x)
	{
		this.mag = x;
		if (this.movement === 5)	// angle
			this.mag = cr.to_radians(this.mag);
	};
	Acts.prototype.SetMovement = function (m)
	{
		if (this.movement === 5)
			this.mag = cr.to_degrees(this.mag);
		this.movement = m;
		this.init();
	};
	Acts.prototype.SetWave = function (w)
	{
		this.wave = w;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.CyclePosition = function (ret)
	{
		ret.set_float(this.i / _2pi);
	};
	Exps.prototype.Period = function (ret)
	{
		ret.set_float(this.period);
	};
	Exps.prototype.Magnitude = function (ret)
	{
		if (this.movement === 5)	// angle
			ret.set_float(cr.to_degrees(this.mag));
		else
			ret.set_float(this.mag);
	};
	Exps.prototype.Value = function (ret)
	{
		ret.set_float(this.waveFunc(this.i) * this.mag);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.bound = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.bound.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.mode = 0;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.mode = this.properties[0];	// 0 = origin, 1 = edge
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.tick2 = function ()
	{
		this.inst.update_bbox();
		var bbox = this.inst.bbox;
		var layout = this.inst.layer.layout;
		var changed = false;
		if (this.mode === 0)	// origin
		{
			if (this.inst.x < 0)
			{
				this.inst.x = 0;
				changed = true;
			}
			if (this.inst.y < 0)
			{
				this.inst.y = 0;
				changed = true;
			}
			if (this.inst.x > layout.width)
			{
				this.inst.x = layout.width;
				changed = true;
			}
			if (this.inst.y > layout.height)
			{
				this.inst.y = layout.height;
				changed = true;
			}
		}
		else
		{
			if (bbox.left < 0)
			{
				this.inst.x -= bbox.left;
				changed = true;
			}
			if (bbox.top < 0)
			{
				this.inst.y -= bbox.top;
				changed = true;
			}
			if (bbox.right > layout.width)
			{
				this.inst.x -= (bbox.right - layout.width);
				changed = true;
			}
			if (bbox.bottom > layout.height)
			{
				this.inst.y -= (bbox.bottom - layout.height);
				changed = true;
			}
		}
		if (changed)
			this.inst.set_bbox_changed();
	};
}());
cr.getProjectModel = function() { return [
	null,
	"Start",
	[
	[
		cr.plugins_.Audio,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Browser,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.CJSAds,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Sprite,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.Spritefont2,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Text,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.Touch,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.WebStorage,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
	],
	[
	[
		"t0",
		cr.plugins_.WebStorage,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		4272294279818047,
		[],
		null
		,[]
	]
,	[
		"t1",
		cr.plugins_.Touch,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		7957724995719279,
		[],
		null
		,[1]
	]
,	[
		"t2",
		cr.plugins_.Browser,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		248673054341691,
		[],
		null
		,[]
	]
,	[
		"t3",
		cr.plugins_.Audio,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		9651285368500657,
		[],
		null
		,[0,0,1,1,600,600,10000,1,5000,1]
	]
,	[
		"t4",
		cr.plugins_.CJSAds,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		2789722332527007,
		[],
		null
		,[0,1]
	]
,	[
		"t5",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			15,
			true,
			1,
			0,
			false,
			5015922059034625,
			[
				["sprite-sheet0.png", 4539569, 1, 1, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 452, 1, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 903, 1, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1354, 1, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1, 302, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 452, 302, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 903, 302, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1354, 302, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1, 603, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 452, 603, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 903, 603, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1354, 603, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1, 904, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 452, 904, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 903, 904, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1354, 904, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1, 1205, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 452, 1205, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 903, 1205, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1354, 1205, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 1, 1506, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0],
				["sprite-sheet0.png", 4539569, 452, 1506, 450, 300, 1, 0, 1,[],[0,-0.7566660046577454,1,-0.7566670179367065,1,0,0,0],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			8542099872083246
		]
		],
		false,
		false,
		4761268823165182,
		[],
		null
	]
,	[
		"t6",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5002198510124688,
			[
				["sprite2-sheet0.png", 155, 0, 0, 250, 250, 1, 0, 1,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		1588825619325511,
		[],
		null
	]
,	[
		"t7",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1103154719046307,
			[
				["sprite3-sheet0.png", 409733, 0, 0, 850, 262, 1, 0, 0,[],[0.0847058966755867,0.2748090028762817,0.5,0.3625949919223785,0.9976469874382019,0.007633590139448643,1,0.5,0.9235290288925171,0.751908004283905,0.5,0.7404580116271973,0.07058820128440857,0.7709919810295105,0,0.5],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			4602514961326798
		]
		],
		false,
		false,
		9306859202087049,
		[],
		null
	]
,	[
		"t8",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1563966914041755,
			[
				["sprite4-sheet0.png", 101429, 0, 0, 850, 279, 1, 0.3082352876663208, 0.5089605450630188,[],[0.6917647123336792,-0.5089605450630188,0.6917647123336792,0.4910394549369812,-0.3082352876663208,0.4910394549369812],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			2507581399505843
		]
		],
		false,
		false,
		3878733085625096,
		[],
		null
	]
,	[
		"t9",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			436271627756846,
			[
				["sprite5-sheet0.png", 5284, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			1903575364213888
		]
,		[
			"DragDrop",
			cr.behaviors.DragnDrop,
			7390712688631628
		]
		],
		false,
		false,
		7890163215577567,
		[],
		null
	]
,	[
		"t10",
		cr.plugins_.Sprite,
		false,
		[7997506013411484],
		6,
		0,
		null,
		[
			[
			"Passiv",
			5,
			false,
			1,
			0,
			false,
			8718914953375232,
			[
				["pooplavok-sheet0.png", 187558, 1, 1, 100, 160, 0, 0.4900000095367432, 0.7562500238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5099999904632568,0.2437499761581421,-0.4900000095367432,0.2437499761581421,-0.4900000095367432,-0.7562500238418579,0.5099999904632568,-0.7562500238418579],0]
			]
			]
,			[
			"Based",
			1000,
			false,
			1,
			0,
			false,
			8738955685421775,
			[
				["pooplavok-sheet0.png", 187558, 102, 1, 100, 160, 0, 0.4900000095367432, 0.7562500238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5099999904632568,0.2437499761581421,-0.4900000095367432,0.2437499761581421,-0.4900000095367432,-0.7562500238418579,0.5099999904632568,-0.7562500238418579],0],
				["pooplavok-sheet0.png", 187558, 203, 1, 100, 160, 1, 0.4900000095367432, 0.7562500238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5099999904632568,0.2437499761581421,-0.4900000095367432,0.2437499761581421,-0.4900000095367432,-0.7562500238418579,0.5099999904632568,-0.7562500238418579],0]
			]
			]
,			[
			"Yes1",
			120,
			false,
			1,
			0,
			false,
			6016019928691016,
			[
				["pooplavok-sheet0.png", 187558, 304, 1, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 405, 1, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 506, 1, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 607, 1, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 708, 1, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 809, 1, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 910, 1, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 1, 162, 100, 160, 1, 0.5, 0.706250011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.293749988079071,-0.5,0.293749988079071,-0.5,-0.706250011920929,0.5,-0.706250011920929],0],
				["pooplavok-sheet0.png", 187558, 102, 162, 100, 160, 1, 0.5099999904632568, 0.6625000238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.3374999761581421,-0.5099999904632568,0.3374999761581421,-0.5099999904632568,-0.6625000238418579,0.4900000095367432,-0.6625000238418579],0],
				["pooplavok-sheet0.png", 187558, 203, 162, 100, 160, 1, 0.5, 0.625,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.375,-0.5,0.375,-0.5,-0.625,0.5,-0.625],0],
				["pooplavok-sheet0.png", 187558, 304, 162, 100, 160, 1, 0.5099999904632568, 0.6625000238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.3374999761581421,-0.5099999904632568,0.3374999761581421,-0.5099999904632568,-0.6625000238418579,0.4900000095367432,-0.6625000238418579],0],
				["pooplavok-sheet0.png", 187558, 405, 162, 100, 160, 1, 0.5, 0.706250011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.293749988079071,-0.5,0.293749988079071,-0.5,-0.706250011920929,0.5,-0.706250011920929],0],
				["pooplavok-sheet0.png", 187558, 506, 162, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 607, 162, 100, 160, 1, 0.5, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.231249988079071,-0.5,0.231249988079071,-0.5,-0.768750011920929,0.5,-0.768750011920929],0]
			]
			]
,			[
			"Yes2",
			19,
			false,
			1,
			0,
			false,
			119003999168791,
			[
				["pooplavok-sheet0.png", 187558, 708, 162, 100, 160, 1, 0.5099999904632568, 0.7749999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.2250000238418579,-0.5099999904632568,0.2250000238418579,-0.5099999904632568,-0.7749999761581421,0.4900000095367432,-0.7749999761581421],0],
				["pooplavok-sheet0.png", 187558, 809, 162, 100, 160, 1, 0.5099999904632568, 0.7749999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.2250000238418579,-0.5099999904632568,0.2250000238418579,-0.5099999904632568,-0.7749999761581421,0.4900000095367432,-0.7749999761581421],0],
				["pooplavok-sheet0.png", 187558, 910, 162, 100, 160, 1, 0.5099999904632568, 0.7749999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.2250000238418579,-0.5099999904632568,0.2250000238418579,-0.5099999904632568,-0.7749999761581421,0.4900000095367432,-0.7749999761581421],0],
				["pooplavok-sheet0.png", 187558, 1, 323, 100, 160, 1, 0.5099999904632568, 0.7749999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.2250000238418579,-0.5099999904632568,0.2250000238418579,-0.5099999904632568,-0.7749999761581421,0.4900000095367432,-0.7749999761581421],0],
				["pooplavok-sheet0.png", 187558, 102, 323, 100, 160, 1, 0.5099999904632568, 0.7749999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.2250000238418579,-0.5099999904632568,0.2250000238418579,-0.5099999904632568,-0.7749999761581421,0.4900000095367432,-0.7749999761581421],0],
				["pooplavok-sheet0.png", 187558, 203, 323, 100, 160, 1, 0.5099999904632568, 0.7749999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.2250000238418579,-0.5099999904632568,0.2250000238418579,-0.5099999904632568,-0.7749999761581421,0.4900000095367432,-0.7749999761581421],0],
				["pooplavok-sheet0.png", 187558, 304, 323, 100, 160, 1, 0.5099999904632568, 0.7749999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.2250000238418579,-0.5099999904632568,0.2250000238418579,-0.5099999904632568,-0.7749999761581421,0.4900000095367432,-0.7749999761581421],0],
				["pooplavok-sheet0.png", 187558, 405, 323, 100, 160, 1, 0.5, 0.7124999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.2875000238418579,-0.5,0.2875000238418579,-0.5,-0.7124999761581421,0.5,-0.7124999761581421],0],
				["pooplavok-sheet0.png", 187558, 506, 323, 100, 160, 1, 0.5, 0.668749988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.331250011920929,-0.5,0.331250011920929,-0.5,-0.668749988079071,0.5,-0.668749988079071],0],
				["pooplavok-sheet0.png", 187558, 607, 323, 100, 160, 1, 0.5099999904632568, 0.625,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.375,-0.5099999904632568,0.375,-0.5099999904632568,-0.625,0.4900000095367432,-0.625],0],
				["pooplavok-sheet0.png", 187558, 708, 323, 100, 160, 1, 0.5, 0.5874999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4125000238418579,-0.5,0.4125000238418579,-0.5,-0.5874999761581421,0.5,-0.5874999761581421],0],
				["pooplavok-sheet0.png", 187558, 809, 323, 100, 160, 1, 0.5, 0.5375000238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4624999761581421,-0.5,0.4624999761581421,-0.5,-0.5375000238418579,0.5,-0.5375000238418579],0],
				["pooplavok-sheet0.png", 187558, 910, 323, 100, 160, 1, 0.5, 0.487500011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.512499988079071,-0.5,0.512499988079071,-0.5,-0.487500011920929,0.5,-0.487500011920929],0],
				["pooplavok-sheet0.png", 187558, 1, 484, 100, 160, 1, 0.5, 0.5375000238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4624999761581421,-0.5,0.4624999761581421,-0.5,-0.5375000238418579,0.5,-0.5375000238418579],0],
				["pooplavok-sheet0.png", 187558, 102, 484, 100, 160, 1, 0.5, 0.5874999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4125000238418579,-0.5,0.4125000238418579,-0.5,-0.5874999761581421,0.5,-0.5874999761581421],0],
				["pooplavok-sheet0.png", 187558, 203, 484, 100, 160, 1, 0.5099999904632568, 0.625,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.375,-0.5099999904632568,0.375,-0.5099999904632568,-0.625,0.4900000095367432,-0.625],0],
				["pooplavok-sheet0.png", 187558, 304, 484, 100, 160, 1, 0.5, 0.668749988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.331250011920929,-0.5,0.331250011920929,-0.5,-0.668749988079071,0.5,-0.668749988079071],0],
				["pooplavok-sheet0.png", 187558, 405, 484, 100, 160, 1, 0.5, 0.7124999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.2875000238418579,-0.5,0.2875000238418579,-0.5,-0.7124999761581421,0.5,-0.7124999761581421],0]
			]
			]
,			[
			"Yes3",
			22,
			false,
			1,
			0,
			false,
			8108594847165853,
			[
				["pooplavok-sheet0.png", 187558, 506, 484, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 607, 484, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 708, 484, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 809, 484, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 910, 484, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 1, 645, 100, 160, 1, 0.5199999809265137, 0.71875,[["Imagepoint 1", 0.5, 0.4375]],[0.4800000190734863,0.28125,-0.5199999809265137,0.28125,-0.5199999809265137,-0.71875,0.4800000190734863,-0.71875],0],
				["pooplavok-sheet0.png", 187558, 102, 645, 100, 160, 1, 0.5199999809265137, 0.668749988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.4800000190734863,0.331250011920929,-0.5199999809265137,0.331250011920929,-0.5199999809265137,-0.668749988079071,0.4800000190734863,-0.668749988079071],0],
				["pooplavok-sheet0.png", 187558, 203, 645, 100, 160, 1, 0.5099999904632568, 0.637499988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.362500011920929,-0.5099999904632568,0.362500011920929,-0.5099999904632568,-0.637499988079071,0.4900000095367432,-0.637499988079071],0],
				["pooplavok-sheet0.png", 187558, 304, 645, 100, 160, 1, 0.5, 0.5874999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4125000238418579,-0.5,0.4125000238418579,-0.5,-0.5874999761581421,0.5,-0.5874999761581421],0],
				["pooplavok-sheet0.png", 187558, 405, 645, 100, 160, 1, 0.5, 0.5375000238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4624999761581421,-0.5,0.4624999761581421,-0.5,-0.5375000238418579,0.5,-0.5375000238418579],0],
				["pooplavok-sheet0.png", 187558, 506, 645, 100, 160, 1, 0.5099999904632568, 0.4937500059604645,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.5062500238418579,-0.5099999904632568,0.5062500238418579,-0.5099999904632568,-0.4937500059604645,0.4900000095367432,-0.4937500059604645],0],
				["pooplavok-sheet0.png", 187558, 607, 645, 100, 160, 1, 0.5, 0.449999988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.550000011920929,-0.5,0.550000011920929,-0.5,-0.449999988079071,0.5,-0.449999988079071],0],
				["pooplavok-sheet0.png", 187558, 708, 645, 100, 160, 1, 0.5099999904632568, 0.393750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.606249988079071,-0.5099999904632568,0.606249988079071,-0.5099999904632568,-0.393750011920929,0.4900000095367432,-0.393750011920929],0],
				["pooplavok-sheet0.png", 187558, 809, 645, 100, 160, 1, 0.5, 0.362500011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.637499988079071,-0.5,0.637499988079071,-0.5,-0.362500011920929,0.5,-0.362500011920929],0],
				["pooplavok-sheet0.png", 187558, 910, 645, 100, 160, 1, 0.5099999904632568, 0.393750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.606249988079071,-0.5099999904632568,0.606249988079071,-0.5099999904632568,-0.393750011920929,0.4900000095367432,-0.393750011920929],0],
				["pooplavok-sheet0.png", 187558, 1, 806, 100, 160, 1, 0.5, 0.449999988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.550000011920929,-0.5,0.550000011920929,-0.5,-0.449999988079071,0.5,-0.449999988079071],0],
				["pooplavok-sheet0.png", 187558, 102, 806, 100, 160, 1, 0.5099999904632568, 0.4937500059604645,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.5062500238418579,-0.5099999904632568,0.5062500238418579,-0.5099999904632568,-0.4937500059604645,0.4900000095367432,-0.4937500059604645],0],
				["pooplavok-sheet0.png", 187558, 203, 806, 100, 160, 1, 0.5, 0.5375000238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4624999761581421,-0.5,0.4624999761581421,-0.5,-0.5375000238418579,0.5,-0.5375000238418579],0],
				["pooplavok-sheet0.png", 187558, 304, 806, 100, 160, 1, 0.5, 0.5874999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4125000238418579,-0.5,0.4125000238418579,-0.5,-0.5874999761581421,0.5,-0.5874999761581421],0],
				["pooplavok-sheet0.png", 187558, 405, 806, 100, 160, 1, 0.5099999904632568, 0.637499988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.362500011920929,-0.5099999904632568,0.362500011920929,-0.5099999904632568,-0.637499988079071,0.4900000095367432,-0.637499988079071],0],
				["pooplavok-sheet0.png", 187558, 506, 806, 100, 160, 1, 0.5199999809265137, 0.668749988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.4800000190734863,0.331250011920929,-0.5199999809265137,0.331250011920929,-0.5199999809265137,-0.668749988079071,0.4800000190734863,-0.668749988079071],0],
				["pooplavok-sheet0.png", 187558, 607, 806, 100, 160, 1, 0.5199999809265137, 0.71875,[["Imagepoint 1", 0.5, 0.4375]],[0.4800000190734863,0.28125,-0.5199999809265137,0.28125,-0.5199999809265137,-0.71875,0.4800000190734863,-0.71875],0],
				["pooplavok-sheet0.png", 187558, 708, 806, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 809, 806, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet0.png", 187558, 910, 806, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet1.png", 61003, 1, 1, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0],
				["pooplavok-sheet1.png", 61003, 102, 1, 100, 160, 1, 0.5099999904632568, 0.768750011920929,[["Imagepoint 1", 0.5, 0.4375]],[0.4900000095367432,0.231249988079071,-0.5099999904632568,0.231249988079071,-0.5099999904632568,-0.768750011920929,0.4900000095367432,-0.768750011920929],0]
			]
			]
,			[
			"Yes4",
			25,
			true,
			1,
			0,
			true,
			7179122548236609,
			[
				["pooplavok-sheet1.png", 61003, 203, 1, 100, 160, 0, 0.4900000095367432, 0.7562500238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5099999904632568,0.2437499761581421,-0.4900000095367432,0.2437499761581421,-0.4900000095367432,-0.7562500238418579,0.5099999904632568,-0.7562500238418579],0],
				["pooplavok-sheet1.png", 61003, 304, 1, 100, 160, 1, 0.5, 0.7124999761581421,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.2875000238418579,-0.5,0.2875000238418579,-0.5,-0.7124999761581421,0.5,-0.7124999761581421],0],
				["pooplavok-sheet1.png", 61003, 405, 1, 100, 160, 1, 0.5, 0.668749988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.331250011920929,-0.5,0.331250011920929,-0.5,-0.668749988079071,0.5,-0.668749988079071],0],
				["pooplavok-sheet1.png", 61003, 1, 162, 100, 160, 1, 0.5, 0.625,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.375,-0.5,0.375,-0.5,-0.625,0.5,-0.625],0],
				["pooplavok-sheet1.png", 61003, 102, 162, 100, 160, 1, 0.5, 0.574999988079071,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.425000011920929,-0.5,0.425000011920929,-0.5,-0.574999988079071,0.5,-0.574999988079071],0],
				["pooplavok-sheet1.png", 61003, 203, 162, 100, 160, 1, 0.5, 0.5375000238418579,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.4624999761581421,-0.5,0.4624999761581421,-0.5,-0.5375000238418579,0.5,-0.5375000238418579],0],
				["pooplavok-sheet1.png", 61003, 304, 162, 100, 160, 1, 0.4900000095367432, 0.4937500059604645,[["Imagepoint 1", 0.5, 0.4375]],[0.5099999904632568,0.5062500238418579,-0.4900000095367432,0.5062500238418579,-0.4900000095367432,-0.4937500059604645,0.5099999904632568,-0.4937500059604645],0],
				["pooplavok-sheet1.png", 61003, 405, 162, 100, 160, 1, 0.5, 0.4375,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.5625,-0.5,0.5625,-0.5,-0.4375,0.5,-0.4375],0],
				["pooplavok-sheet1.png", 61003, 1, 323, 100, 160, 1, 0.5, 0.3812499940395355,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.6187499761581421,-0.5,0.6187499761581421,-0.5,-0.3812499940395355,0.5,-0.3812499940395355],0],
				["pooplavok-sheet1.png", 61003, 102, 323, 100, 160, 1, 0.5, 0.34375,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.65625,-0.5,0.65625,-0.5,-0.34375,0.5,-0.34375],0],
				["pooplavok-sheet1.png", 61003, 203, 323, 100, 160, 1, 0.5, 0.28125,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.71875,-0.5,0.71875,-0.5,-0.28125,0.5,-0.28125],0],
				["pooplavok-sheet1.png", 61003, 304, 323, 100, 160, 1, 0.5, 0.2374999970197678,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.762499988079071,-0.5,0.762499988079071,-0.5,-0.2374999970197678,0.5,-0.2374999970197678],0],
				["pooplavok-sheet1.png", 61003, 405, 323, 100, 160, 1, 0.5, 0.2062499970197678,[["Imagepoint 1", 0.5, 0.4375]],[0.5,0.793749988079071,-0.5,0.793749988079071,-0.5,-0.2062499970197678,0.5,-0.2062499970197678],0]
			]
			]
		],
		[
		[
			"8Direction",
			cr.behaviors.EightDir,
			6738893225513602
		]
,		[
			"BoundToLayout",
			cr.behaviors.bound,
			8407748160971603
		]
,		[
			"Sine",
			cr.behaviors.Sin,
			7195113735506417
		]
,		[
			"Sine2",
			cr.behaviors.Sin,
			3326488442061929
		]
,		[
			"Sine3",
			cr.behaviors.Sin,
			1843133637515727
		]
,		[
			"Sine4",
			cr.behaviors.Sin,
			8678819963911654
		]
		],
		false,
		false,
		7516501672445657,
		[],
		null
	]
,	[
		"t11",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4008975374780146,
			[
				["sprite6-sheet0.png", 24696, 0, 0, 850, 191, 1, 0, 0,[],[],1]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			2091686923833702
		]
		],
		false,
		false,
		3131479904123285,
		[],
		null
	]
,	[
		"t12",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			2,
			true,
			1,
			0,
			true,
			7150524494252621,
			[
				["sprite7-sheet0.png", 20784, 1, 1, 290, 70, 1, 0.5, 0.5,[],[],0],
				["sprite7-sheet0.png", 20784, 1, 72, 290, 70, 1, 0.5, 0.5,[],[],0],
				["sprite7-sheet0.png", 20784, 1, 143, 290, 70, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			7920870857396843
		]
		],
		false,
		false,
		1846151838734734,
		[],
		null
	]
,	[
		"t13",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			3445806040741408,
			[
				["sprite8-sheet0.png", 262324, 1, 1, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.1044776141643524, 0.03750000149011612]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 136, 1, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.08955223858356476, 0.05000000074505806]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 271, 1, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.08208955079317093, 0.0625]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 406, 1, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.08208955079317093, 0.078125]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 541, 1, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.05970149114727974, 0.09375]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 676, 1, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.04477611929178238, 0.109375]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 811, 1, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.02985074557363987, 0.1312499940395355]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 1, 322, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.03731343150138855, 0.1500000059604645]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 136, 322, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.01492537278681994, 0.1656250059604645]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 271, 322, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0, 0.1781249940395355]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 406, 322, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0, 0.1906249970197678]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 541, 322, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0, 0.1968750059604645]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 676, 322, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0, 0.2062499970197678]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0],
				["sprite8-sheet0.png", 262324, 811, 322, 134, 320, 1, 0.6791045069694519, 0.574999988079071,[["Imagepoint 1", 0.007462686393409967, 0.2093749940395355]],[-0.6791045069694519,-0.574999988079071,0.3208954930305481,-0.574999988079071,0.313432514667511,0.421875,-0.6791045069694519,0.425000011920929],0]
			]
			]
		],
		[
		],
		false,
		false,
		6268454729151587,
		[],
		null
	]
,	[
		"t14",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			475577770745909,
			[
				["sprite9-sheet0.png", 103, 0, 0, 1, 1, 1, 0, 1,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		5245129033145795,
		[],
		null
	]
,	[
		"t15",
		cr.plugins_.Sprite,
		false,
		[],
		3,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			true,
			962980312802953,
			[
				["sprite10-sheet0.png", 38781, 1, 1, 150, 80, 1, 0.119999997317791, 0.5249999761581421,[],[],0],
				["sprite10-sheet0.png", 38781, 1, 82, 150, 80, 1, 0.119999997317791, 0.5249999761581421,[],[],0],
				["sprite10-sheet0.png", 38781, 1, 163, 150, 80, 1, 0.119999997317791, 0.5249999761581421,[],[],0],
				["sprite10-sheet1.png", 41779, 1, 1, 150, 80, 1, 0.119999997317791, 0.5249999761581421,[],[],0],
				["sprite10-sheet1.png", 41779, 1, 82, 150, 80, 1, 0.119999997317791, 0.5249999761581421,[],[],0],
				["sprite10-sheet1.png", 41779, 1, 163, 150, 80, 1, 0.119999997317791, 0.5249999761581421,[],[],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			7228325395614856
		]
,		[
			"Sine2",
			cr.behaviors.Sin,
			1830332467026428
		]
,		[
			"Sine3",
			cr.behaviors.Sin,
			7030191841276772
		]
		],
		false,
		false,
		7927433338528317,
		[],
		null
	]
,	[
		"t16",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			15,
			true,
			1,
			0,
			true,
			7342132940512283,
			[
				["sprite11-sheet0.png", 170339, 1, 1, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 1, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 81, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 81, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 161, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 161, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 241, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 241, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 321, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 321, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 401, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0]
			]
			]
		],
		[
		[
			"DragDrop",
			cr.behaviors.DragnDrop,
			6811967588241975
		]
		],
		false,
		false,
		3569682826649569,
		[],
		null
	]
,	[
		"t17",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			9,
			false,
			1,
			0,
			false,
			3358427141286982,
			[
				["sprite12-sheet0.png", 54070, 1, 1, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet0.png", 54070, 212, 1, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet0.png", 54070, 1, 156, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet0.png", 54070, 212, 156, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet0.png", 54070, 1, 311, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet0.png", 54070, 212, 311, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet1.png", 29526, 1, 1, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet1.png", 29526, 212, 1, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0],
				["sprite12-sheet1.png", 29526, 1, 156, 210, 154, 1, 0.4285714328289032, 0.7077922224998474,[["Imagepoint 1", 0.9523809552192688, 0.3961038887500763],["Imagepoint 2", 0.3190476298332214, 0.5844155550003052],["Imagepoint 3", 0.2047619074583054, 0.3831168711185455],["Imagepoint 4", 0.523809552192688, 0.4155844151973724],["Imagepoint 5", 0.6190476417541504, 0.8246753215789795],["Imagepoint 6", 0.02380952425301075, 0.8246753215789795]],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			9932428521163323
		]
		],
		false,
		false,
		3721218873427721,
		[],
		null
	]
,	[
		"t18",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			9,
			false,
			1,
			0,
			false,
			2529080163132474,
			[
				["sprite13-sheet0.png", 54233, 1, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 212, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 1, 156, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 212, 156, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 1, 311, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 212, 311, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet1.png", 29618, 1, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet1.png", 29618, 212, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet1.png", 29618, 1, 156, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			1612352285870153
		]
		],
		false,
		false,
		7591381613749078,
		[],
		null
	]
,	[
		"t19",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			9,
			false,
			1,
			0,
			false,
			8771247191549889,
			[
				["sprite13-sheet0.png", 54233, 1, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 212, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 1, 156, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 212, 156, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 1, 311, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet0.png", 54233, 212, 311, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet1.png", 29618, 1, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet1.png", 29618, 212, 1, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["sprite13-sheet1.png", 29618, 1, 156, 210, 154, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			434765950505402
		]
		],
		false,
		false,
		4839630435064274,
		[],
		null
	]
,	[
		"t20",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8397501447765725,
			[
				["tap-sheet0.png", 689, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			3523946101297118
		]
		],
		false,
		false,
		237432789223237,
		[],
		null
	]
,	[
		"t21",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			12,
			false,
			1,
			0,
			false,
			2067486612369722,
			[
				["sprite15-sheet0.png", 2225, 0, 0, 126, 77, 1, 0.5079365372657776, 0.8701298832893372,[],[-0.02480155229568481,-0.009739875793457031,0.04464244842529297,-0.0616878867149353,0.04662644863128662,0.04220813512802124,-0.01785755157470703,0.08116912841796875],0],
				["sprite15-sheet1.png", 3012, 0, 0, 126, 77, 1, 0.5079365372657776, 0.8701298832893372,[],[-0.02480155229568481,-0.009739875793457031,0.04464244842529297,-0.0616878867149353,0.04662644863128662,0.04220813512802124,-0.01785755157470703,0.08116912841796875],0],
				["sprite15-sheet2.png", 3232, 0, 0, 126, 77, 1, 0.5079365372657776, 0.8701298832893372,[],[-0.02480155229568481,-0.009739875793457031,0.04464244842529297,-0.0616878867149353,0.04662644863128662,0.04220813512802124,-0.01785755157470703,0.08116912841796875],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			6312497266202459
		]
		],
		false,
		false,
		9017624653867873,
		[],
		null
	]
,	[
		"t22",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2086474622326355,
			[
				["tap2-sheet0.png", 689, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			4851850945585939
		]
		],
		false,
		false,
		5428729312425058,
		[],
		null
	]
,	[
		"t23",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3585845411911171,
			[
				["tap3-sheet0.png", 728, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			4860578189082264
		]
		],
		false,
		false,
		2883986020430017,
		[],
		null
	]
,	[
		"t24",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6822618816626306,
			[
				["tap4-sheet0.png", 766, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			9998919395633521
		]
		],
		false,
		false,
		4828442009480473,
		[],
		null
	]
,	[
		"t25",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1220501669683553,
			[
				["tap5-sheet0.png", 924, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			1010968132144749
		]
		],
		false,
		false,
		9857569846300061,
		[],
		null
	]
,	[
		"t26",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			790534432533839,
			[
				["tap6-sheet0.png", 925, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			2735424338951775
		]
		],
		false,
		false,
		1269784781880645,
		[],
		null
	]
,	[
		"t27",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4831338462809866,
			[
				["tap7-sheet0.png", 1030, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			8360136029273841
		]
		],
		false,
		false,
		3458161179846734,
		[],
		null
	]
,	[
		"t28",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2644842872526557,
			[
				["tap8-sheet0.png", 1045, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			6298772255760258
		]
		],
		false,
		false,
		5647243468541695,
		[],
		null
	]
,	[
		"t29",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9013056285249035,
			[
				["tap9-sheet0.png", 1055, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			8206534318333357
		]
		],
		false,
		false,
		3490556764156961,
		[],
		null
	]
,	[
		"t30",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1063812078838797,
			[
				["tap10-sheet0.png", 991, 0, 0, 300, 300, 1, 0.5, 0.5,[],[-0.386667013168335,-0.3600000143051148,0,-0.5,0.3700000047683716,-0.3700000047683716,0.5,0,0.3799999952316284,0.3566669821739197,0,0.5,-0.3466669917106628,0.3833330273628235,-0.5,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			838902759592336
		]
		],
		false,
		false,
		4872508782155767,
		[],
		null
	]
,	[
		"t31",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4951018053095668,
			[
				["sprite16-sheet0.png", 75139, 0, 0, 208, 204, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			4861046228054876
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			5855228377383112
		]
		],
		false,
		false,
		9473938616292786,
		[],
		null
	]
,	[
		"t32",
		cr.plugins_.Text,
		false,
		[],
		1,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			480533092714554
		]
		],
		false,
		false,
		6776893165047698,
		[],
		null
	]
,	[
		"t33",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5704978910894986,
			[
				["sprite17-sheet0.png", 19111, 0, 0, 123, 123, 1, 1, 1,[],[],0]
			]
			]
		],
		[
		[
			"Anchor",
			cr.behaviors.Anchor,
			5356971875296693
		]
		],
		false,
		false,
		4385659394031995,
		[],
		null
	]
,	[
		"t34",
		cr.plugins_.Text,
		false,
		[],
		1,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			851102238300251
		]
		],
		false,
		false,
		1570252489844642,
		[],
		null
	]
,	[
		"t35",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2448894258894631,
			[
				["sprite18-sheet0.png", 144935, 0, 0, 271, 402, 1, 0.5018450021743774, 0.5,[],[-0.2878230214118958,-0.3557209968566895,0.4575650095939636,0.4726369976997376,-0.4428043961524963,0.4601989984512329],0]
			]
			]
		],
		[
		],
		false,
		false,
		378224386403804,
		[],
		null
	]
,	[
		"t36",
		cr.plugins_.Sprite,
		false,
		[],
		3,
		0,
		null,
		[
			[
			"Hook",
			5,
			false,
			1,
			0,
			false,
			9976041718599633,
			[
				["fish1-sheet0.png", 831849, 454, 938, 150, 65, 1, 0.2066666632890701, 0.4153846204280853,[],[-0.2066666632890701,0.5846153497695923,-0.2066666632890701,-0.4153846204280853,0.7933333516120911,-0.4153846204280853,0.7933333516120911,0.5846153497695923],0]
			]
			]
,			[
			"Fish1",
			10,
			true,
			1,
			0,
			true,
			7495845121630251,
			[
				["fish1-sheet0.png", 831849, 874, 445, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[0.09692307561635971,-0.09047585725784302,0.6919230818748474,-0.1488098502159119,0.5569230914115906,0.04285714030265808,0.5669230818748474,0.0261901319026947,0.3769230842590332,0.2011901438236237,0.07192306965589523,0.217857152223587,-0.08307692408561707,0.04285714030265808],0],
				["fish1-sheet0.png", 831849, 874, 516, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet0.png", 831849, 874, 587, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet0.png", 831849, 605, 938, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet0.png", 831849, 736, 938, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet0.png", 831849, 867, 938, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet1.png", 804570, 403, 727, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet1.png", 804570, 534, 727, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet1.png", 804570, 665, 727, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet1.png", 804570, 796, 727, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0],
				["fish1-sheet1.png", 804570, 403, 798, 130, 70, 1, 0.1230769231915474, 0.4571428596973419,[],[],0]
			]
			]
,			[
			"Fish2",
			10,
			true,
			1,
			0,
			true,
			2260828713700731,
			[
				["sprite10-sheet0.png", 38781, 1, 1, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["fish1-sheet0.png", 831849, 814, 364, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["sprite10-sheet0.png", 38781, 1, 82, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["fish1-sheet0.png", 831849, 1, 605, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["sprite10-sheet0.png", 38781, 1, 163, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["fish1-sheet0.png", 831849, 1, 938, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["sprite10-sheet1.png", 41779, 1, 1, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["fish1-sheet0.png", 831849, 152, 938, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["sprite10-sheet1.png", 41779, 1, 82, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["fish1-sheet0.png", 831849, 303, 938, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0],
				["sprite10-sheet1.png", 41779, 1, 163, 150, 80, 1, 0.1066666692495346, 0.6000000238418579,[],[],0]
			]
			]
,			[
			"Fish3",
			12,
			true,
			1,
			0,
			true,
			8960707942334947,
			[
				["fish1-sheet0.png", 831849, 814, 1, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet0.png", 831849, 814, 122, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet0.png", 831849, 814, 243, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 302, 1, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 503, 1, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 704, 1, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 1, 122, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 202, 122, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 403, 122, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 604, 122, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0],
				["fish1-sheet1.png", 804570, 805, 122, 200, 120, 1, 0.07000000029802322, 0.5583333373069763,[],[],0]
			]
			]
,			[
			"Fish4",
			16,
			true,
			1,
			0,
			true,
			9565619822540505,
			[
				["fish1-sheet1.png", 804570, 1, 243, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 202, 243, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 403, 243, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 604, 243, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 805, 243, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 1, 364, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 202, 364, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 403, 364, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 604, 364, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 805, 364, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0],
				["fish1-sheet1.png", 804570, 1, 485, 200, 120, 1, 0.09000000357627869, 0.5333333611488342,[],[],0]
			]
			]
,			[
			"Fish5",
			9,
			true,
			1,
			0,
			true,
			3638981618366624,
			[
				["fish1-sheet1.png", 804570, 202, 485, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 403, 485, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 604, 485, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 805, 485, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 1, 606, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 202, 606, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 403, 606, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 604, 606, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 805, 606, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 1, 727, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 202, 727, 200, 120, 1, 0.1049999967217445, 0.4833333194255829,[],[],0]
			]
			]
,			[
			"Fish6",
			7,
			true,
			1,
			0,
			true,
			6303284669251521,
			[
				["fish1-sheet0.png", 831849, 272, 454, 300, 120, 1, 0.1000000014901161, 0.6916666626930237,[],[],0],
				["fish1-sheet0.png", 831849, 573, 454, 300, 120, 1, 0.09333333373069763, 0.6916666626930237,[],[],0],
				["fish1-sheet0.png", 831849, 272, 575, 300, 120, 1, 0.0833333358168602, 0.675000011920929,[],[],0],
				["fish1-sheet0.png", 831849, 573, 575, 300, 120, 1, 0.07333333045244217, 0.6499999761581421,[],[],0],
				["fish1-sheet0.png", 831849, 1, 696, 300, 120, 1, 0.06666667014360428, 0.625,[],[],0],
				["fish1-sheet0.png", 831849, 302, 696, 300, 120, 1, 0.07000000029802322, 0.6000000238418579,[],[],0],
				["fish1-sheet0.png", 831849, 603, 696, 300, 120, 1, 0.06333333253860474, 0.5583333373069763,[],[],0],
				["fish1-sheet0.png", 831849, 1, 817, 300, 120, 1, 0.07000000029802322, 0.5333333611488342,[],[],0],
				["fish1-sheet0.png", 831849, 302, 817, 300, 120, 1, 0.0833333358168602, 0.5166666507720947,[],[],0],
				["fish1-sheet0.png", 831849, 603, 817, 300, 120, 1, 0.09000000357627869, 0.4833333194255829,[],[],0],
				["fish1-sheet1.png", 804570, 1, 1, 300, 120, 1, 0.1000000014901161, 0.4833333194255829,[],[],0]
			]
			]
,			[
			"Fish7",
			17,
			true,
			1,
			0,
			true,
			293103573790438,
			[
				["fish1-sheet0.png", 831849, 1, 1, 270, 150, 1, 0.2185185253620148, 0.5266666412353516,[],[0.7814815044403076,0.4733333587646484,-0.2185185253620148,0.4733333587646484,-0.2185185253620148,-0.5266666412353516,0.7814815044403076,-0.5266666412353516],0],
				["fish1-sheet0.png", 831849, 272, 1, 270, 150, 1, 0.2148148119449616, 0.5266666412353516,[],[0.7851852178573608,0.4733333587646484,-0.2148148119449616,0.4733333587646484,-0.2148148119449616,-0.5266666412353516,0.7851852178573608,-0.5266666412353516],0],
				["fish1-sheet0.png", 831849, 543, 1, 270, 150, 1, 0.2111111134290695, 0.5400000214576721,[],[0.7888888716697693,0.4599999785423279,-0.2111111134290695,0.4599999785423279,-0.2111111134290695,-0.5400000214576721,0.7888888716697693,-0.5400000214576721],0],
				["fish1-sheet0.png", 831849, 1, 152, 270, 150, 1, 0.2074074000120163, 0.54666668176651,[],[0.7925925850868225,0.45333331823349,-0.2074074000120163,0.45333331823349,-0.2074074000120163,-0.54666668176651,0.7925925850868225,-0.54666668176651],0],
				["fish1-sheet0.png", 831849, 272, 152, 270, 150, 1, 0.196296289563179, 0.5600000023841858,[],[0.8037037253379822,0.4399999976158142,-0.196296289563179,0.4399999976158142,-0.196296289563179,-0.5600000023841858,0.8037037253379822,-0.5600000023841858],0],
				["fish1-sheet0.png", 831849, 543, 152, 270, 150, 1, 0.192592591047287, 0.5666666626930237,[],[0.8074073791503906,0.4333333373069763,-0.192592591047287,0.4333333373069763,-0.192592591047287,-0.5666666626930237,0.8074073791503906,-0.5666666626930237],0],
				["fish1-sheet0.png", 831849, 1, 303, 270, 150, 1, 0.192592591047287, 0.5799999833106995,[],[0.8074073791503906,0.4200000166893005,-0.192592591047287,0.4200000166893005,-0.192592591047287,-0.5799999833106995,0.8074073791503906,-0.5799999833106995],0],
				["fish1-sheet0.png", 831849, 272, 303, 270, 150, 1, 0.192592591047287, 0.5733333230018616,[],[0.8074073791503906,0.4266666769981384,-0.192592591047287,0.4266666769981384,-0.192592591047287,-0.5733333230018616,0.8074073791503906,-0.5733333230018616],0],
				["fish1-sheet0.png", 831849, 543, 303, 270, 150, 1, 0.192592591047287, 0.5733333230018616,[],[0.8074073791503906,0.4266666769981384,-0.192592591047287,0.4266666769981384,-0.192592591047287,-0.5733333230018616,0.8074073791503906,-0.5733333230018616],0],
				["fish1-sheet0.png", 831849, 1, 454, 270, 150, 1, 0.192592591047287, 0.5733333230018616,[],[0.8074073791503906,0.4266666769981384,-0.192592591047287,0.4266666769981384,-0.192592591047287,-0.5733333230018616,0.8074073791503906,-0.5733333230018616],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			9877756143130039
		]
,		[
			"Sine2",
			cr.behaviors.Sin,
			2629005174136195
		]
,		[
			"Sine3",
			cr.behaviors.Sin,
			1751742969985551
		]
		],
		false,
		false,
		8685859978637708,
		[],
		null
	]
,	[
		"t37",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6672683661510306,
			[
				["ok-sheet0.png", 10445, 0, 0, 116, 65, 1, 0.5, 0.5076923370361328,[],[0.5,-0.5076923370361328,0.5,0.4923076629638672,-0.5,0.4923076629638672,-0.5,-0.5076923370361328],0]
			]
			]
		],
		[
		],
		false,
		false,
		5196768843323105,
		[],
		null
	]
,	[
		"t38",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		3230404528950172,
		[],
		null
	]
,	[
		"t39",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		4079730075840603,
		[],
		null
	]
,	[
		"t40",
		cr.plugins_.Sprite,
		false,
		[],
		4,
		0,
		null,
		[
			[
			"Default",
			15,
			true,
			1,
			0,
			true,
			62709608150259,
			[
				["sprite11-sheet0.png", 170339, 1, 1, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 1, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 81, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 81, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 161, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 161, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 241, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 241, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 321, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 200, 321, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0],
				["sprite11-sheet0.png", 170339, 1, 401, 198, 79, 1, 0.5, 0.5063291192054749,[],[],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			3534379089760573
		]
,		[
			"Sine",
			cr.behaviors.Sin,
			7597261387107894
		]
,		[
			"Sine2",
			cr.behaviors.Sin,
			5848870627920227
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			7167378460751992
		]
		],
		false,
		false,
		4235233355734599,
		[],
		null
	]
,	[
		"t41",
		cr.plugins_.Sprite,
		false,
		[],
		4,
		0,
		null,
		[
			[
			"Default",
			15,
			true,
			1,
			0,
			true,
			7020046631969569,
			[
				["decorfish2-sheet0.png", 170353, 1, 1, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 200, 1, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 1, 81, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 200, 81, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 1, 161, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 200, 161, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 1, 241, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 200, 241, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 1, 321, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 200, 321, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0],
				["decorfish2-sheet0.png", 170353, 1, 401, 198, 79, 1, 0.5, 0.5063291192054749,[],[0.5,0.4936708807945252,-0.5,0.4936708807945252,-0.5,-0.5063291192054749,0.5,-0.5063291192054749],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			6370362589689031
		]
,		[
			"Sine",
			cr.behaviors.Sin,
			6794743694661276
		]
,		[
			"Sine2",
			cr.behaviors.Sin,
			3566513001442854
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			592033080463939
		]
		],
		false,
		false,
		2911901072207294,
		[],
		null
	]
,	[
		"t42",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Poklev",
			10,
			true,
			1,
			0,
			true,
			6965097520936363,
			[
				["poklev-sheet0.png", 436, 0, 0, 80, 150, 1, 0.4749999940395355, 0.119999997317791,[],[0.5249999761581421,-0.119999997317791,0.5249999761581421,0.8799999952316284,-0.4749999940395355,0.8799999952316284,-0.4749999940395355,-0.119999997317791],1]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4344983409514569
		]
		],
		false,
		false,
		4438537157118546,
		[],
		null
	]
,	[
		"t43",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Default",
			2,
			false,
			1,
			0,
			false,
			5070919429320658,
			[
				["getready-sheet0.png", 19413, 1, 1, 235, 37, 1, 0.5021276473999023, 0.5135135054588318,[],[-0.4893616437911987,-0.4324324131011963,0.485106348991394,-0.4324324131011963,0.485106348991394,0.4054055213928223,-0.4893616437911987,0.4054055213928223],0],
				["getready-sheet0.png", 19413, 1, 39, 111, 71, 1, 0.5045045018196106, 0.5070422291755676,[],[],0]
			]
			]
		],
		[
		[
			"Sine",
			cr.behaviors.Sin,
			4687359028840747
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			7534469174688205
		]
		],
		false,
		false,
		9123638796094165,
		[],
		null
	]
,	[
		"t44",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"No",
			0,
			false,
			1,
			0,
			false,
			6171098870386878,
			[
				["sprite20-sheet0.png", 17701, 0, 0, 123, 123, 1, 0, 1,[["Imagepoint 1", 0.4227642416954041, 0.5691056847572327]],[],0]
			]
			]
,			[
			"Yes",
			0,
			false,
			1,
			0,
			false,
			793329481703727,
			[
				["sprite20-sheet1.png", 18521, 0, 0, 123, 123, 1, 0, 1,[["Imagepoint 1", 0.4227642416954041, 0.5691056847572327]],[],0]
			]
			]
		],
		[
		[
			"Anchor",
			cr.behaviors.Anchor,
			9276885016171832
		]
		],
		false,
		false,
		8821762423615608,
		[],
		null
	]
,	[
		"t45",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6882901539860044,
			[
				["dark-sheet0.png", 94, 0, 0, 50, 50, 1, 0.5, 0.5,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		7134247188632839,
		[],
		null
	]
,	[
		"t46",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5399047560610058,
			[
				["sprite21-sheet0.png", 276179, 0, 0, 572, 348, 1, 0.4965035021305084, 0,[["Imagepoint 1", 0.190559446811676, 0.2816092073917389],["Imagepoint 2", 0.5069929957389832, 0.252873569726944],["Imagepoint 3", 0.809440553188324, 0.25],["Imagepoint 4", 0.188811182975769, 0.6120689511299133],["Imagepoint 5", 0.5, 0.6120689511299133],["Imagepoint 6", 0.8181818127632141, 0.6149425506591797],["Imagepoint 7", 0.9527971744537354, 0.9683908224105835],["Imagepoint 8", 0.1031468510627747, 1.091953992843628]],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		3864428152725993,
		[],
		null
	]
,	[
		"t47",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7559512654487695,
			[
				["ok2-sheet0.png", 11992, 0, 0, 152, 58, 1, 0.9934210777282715, -0.1379310339689255,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		5428465048132582,
		[],
		null
	]
,	[
		"t48",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			451176984552301,
			[
				["n1-sheet0.png", 11005, 0, 0, 76, 80, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		1604986564326281,
		[],
		null
	]
,	[
		"t49",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1879961231760169,
			[
				["n2-sheet0.png", 5849, 0, 0, 78, 61, 1, 0.5, 0.5081967115402222,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		3733972096888646,
		[],
		null
	]
,	[
		"t50",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5148615232504912,
			[
				["n3-sheet0.png", 10210, 0, 0, 77, 88, 1, 0.5064935088157654, 0.5,[],[0.4935064911842346,-0.5,0.4935064911842346,0.5,-0.5064935088157654,0.5,-0.5064935088157654,-0.5],0]
			]
			]
		],
		[
		],
		false,
		false,
		3194240867358223,
		[],
		null
	]
,	[
		"t51",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1894708394834067,
			[
				["n4-sheet0.png", 7683, 0, 0, 85, 68, 1, 0.5058823823928833, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		3956736801898354,
		[],
		null
	]
,	[
		"t52",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9635563906839997,
			[
				["n5-sheet0.png", 7599, 0, 0, 80, 76, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		5008920948144345,
		[],
		null
	]
,	[
		"t53",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			705788434818956,
			[
				["n0-sheet0.png", 3117, 0, 0, 53, 51, 1, 0.4905660450458527, 0.4509803950786591,[],[0.5094339847564697,-0.4509803950786591,0.5094339847564697,0.5490195751190186,-0.4905660450458527,0.5490195751190186,-0.4905660450458527,-0.4509803950786591],0]
			]
			]
		],
		[
		],
		false,
		false,
		9130985972727421,
		[],
		null
	]
,	[
		"t54",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7178538752808363,
			[
				["n6-sheet0.png", 10152, 0, 0, 72, 72, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.5,-0.4861111044883728,0.5],0]
			]
			]
		],
		[
		],
		false,
		false,
		5850410663353981,
		[],
		null
	]
,	[
		"t55",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5827194018326806,
			[
				["n1-sheet0.png", 11005, 0, 0, 76, 80, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		4514807479597571,
		[],
		null
	]
,	[
		"t56",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			464284483822227,
			[
				["n2-sheet0.png", 5849, 0, 0, 78, 61, 1, 0.5, 0.5081967115402222,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		5816476205756602,
		[],
		null
	]
,	[
		"t57",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			273900976838992,
			[
				["n3-sheet0.png", 10210, 0, 0, 77, 88, 1, 0.5064935088157654, 0.5,[],[0.4935064911842346,-0.5,0.4935064911842346,0.5,-0.5064935088157654,0.5,-0.5064935088157654,-0.5],0]
			]
			]
		],
		[
		],
		false,
		false,
		4834102500278884,
		[],
		null
	]
,	[
		"t58",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9880521700655204,
			[
				["n4-sheet0.png", 7683, 0, 0, 85, 68, 1, 0.5058823823928833, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7871488794282707,
		[],
		null
	]
,	[
		"t59",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8920902462062095,
			[
				["n5-sheet0.png", 7599, 0, 0, 80, 76, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		1253381408970717,
		[],
		null
	]
,	[
		"t60",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9983074308616172,
			[
				["n6-sheet0.png", 10152, 0, 0, 72, 72, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.5,-0.4861111044883728,0.5],0]
			]
			]
		],
		[
		],
		false,
		false,
		6893427582312564,
		[],
		null
	]
,	[
		"t61",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text1.png", 29928, 0],
		null,
		[
		],
		false,
		false,
		24343731978441,
		[],
		null
	]
,	[
		"t62",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text1.png", 29928, 0],
		null,
		[
		],
		false,
		false,
		943639784613607,
		[],
		null
	]
,	[
		"t63",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text1.png", 29928, 0],
		null,
		[
		],
		false,
		false,
		5633690371779471,
		[],
		null
	]
,	[
		"t64",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text1.png", 29928, 0],
		null,
		[
		],
		false,
		false,
		9760165685923587,
		[],
		null
	]
,	[
		"t65",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text1.png", 29928, 0],
		null,
		[
		],
		false,
		false,
		3285642286687877,
		[],
		null
	]
,	[
		"t66",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text1.png", 29928, 0],
		null,
		[
		],
		false,
		false,
		8445691245868466,
		[],
		null
	]
,	[
		"t67",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text7all.png", 30329, 0],
		null,
		[
		],
		false,
		false,
		3436460280473487,
		[],
		null
	]
,	[
		"t68",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			7,
			true,
			1,
			0,
			false,
			7994535045491669,
			[
				["moneyicon-sheet0.png", 13881, 1, 1, 50, 50, 1, 0.5, 0.5,[],[-0.3199999928474426,-0.3199999928474426,0,-0.4600000083446503,0.3199999928474426,-0.3199999928474426,0.4599999785423279,0,0.3199999928474426,0.3199999928474426,0,0.4599999785423279,-0.3199999928474426,0.3199999928474426,-0.4600000083446503,0],0],
				["moneyicon-sheet0.png", 13881, 52, 1, 50, 50, 1, 0.5, 0.5,[],[],0],
				["moneyicon-sheet0.png", 13881, 1, 52, 50, 50, 1, 0.5, 0.5,[],[],0],
				["moneyicon-sheet0.png", 13881, 52, 52, 50, 50, 1, 0.5, 0.5,[],[],0],
				["moneyicon-sheet1.png", 3570, 0, 0, 50, 50, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6986286379344296,
		[],
		null
	]
,	[
		"t69",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9775665634504909,
			[
				["sprite19-sheet0.png", 471688, 0, 0, 720, 480, 1, 0, 1,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		8372392551776705,
		[],
		null
	]
,	[
		"t70",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3926099055846084,
			[
				["sprite22-sheet0.png", 60341, 0, 0, 299, 383, 1, 0.9632107019424439, 0.5013054609298706,[["Imagepoint 1", 0.5351170301437378, 0.4308094084262848],["Imagepoint 2", 0.5351170301437378, 0.642297625541687],["Imagepoint 3", 0.5351170301437378, 0.8172323703765869]],[-0.7959867119789124,-0.3707574605941773,-0.4648827016353607,-0.4778067469596863,-0.0769227147102356,-0.4125326573848724,-0.07023370265960693,0.4151435494422913,-0.4648827016353607,0.4464755654335022,-0.7959867119789124,0.368146538734436],0]
			]
			]
		],
		[
		],
		false,
		false,
		9129421083108789,
		[],
		null
	]
,	[
		"t71",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5907042630729567,
			[
				["sprite23play-sheet0.png", 46551, 1, 1, 201, 80, 1, 0.5024875402450562, 0.5,[],[-0.4875621497631073,-0.4625000059604645,0.482587456703186,-0.4625000059604645,0.4975124597549439,0.362500011920929,-0.5024875402450562,0.362500011920929],0]
			]
			]
,			[
			"pressed",
			5,
			false,
			1,
			0,
			false,
			3924602564958286,
			[
				["sprite23play-sheet0.png", 46551, 1, 82, 201, 80, 1, 0.5024875402450562, 0.5,[],[-0.4676616489887238,-0.4124999940395355,0.4626864790916443,-0.4124999940395355,0.4278604388237,0.324999988079071,-0.4328358471393585,0.324999988079071],0]
			]
			]
		],
		[
		],
		false,
		false,
		8155473999318647,
		[],
		null
	]
,	[
		"t72",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			253909026078994,
			[
				["sprite24help-sheet0.png", 46833, 1, 1, 201, 80, 1, 0.5024875402450562, 0.5,[],[-0.4875621497631073,-0.4625000059604645,0.482587456703186,-0.4625000059604645,0.4975124597549439,0.300000011920929,-0.5024875402450562,0.324999988079071],0]
			]
			]
,			[
			"Pressed",
			5,
			false,
			1,
			0,
			false,
			8177775415754379,
			[
				["sprite24help-sheet0.png", 46833, 1, 82, 201, 80, 1, 0.5024875402450562, 0.5,[],[-0.4676616489887238,-0.4124999940395355,0.467661440372467,-0.425000011920929,0.4726364612579346,0.3125,-0.4726368486881256,0.300000011920929],0]
			]
			]
		],
		[
		],
		false,
		false,
		265670105195487,
		[],
		null
	]
,	[
		"t73",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2089119884002746,
			[
				["sprite25settings-sheet0.png", 48008, 1, 1, 201, 69, 1, 0.5024875402450562, 0.5072463750839233,[],[-0.4875621497631073,-0.4637680649757385,0.482587456703186,-0.4637680649757385,0.482587456703186,0.4492756128311157,-0.4875621497631073,0.4492756128311157],0]
			]
			]
,			[
			"Pressed",
			5,
			false,
			1,
			0,
			false,
			7026822793111087,
			[
				["sprite25settings-sheet0.png", 48008, 1, 71, 201, 69, 1, 0.5024875402450562, 0.5072463750839233,[],[-0.4676616489887238,-0.4057973623275757,0.467661440372467,-0.4202898740768433,0.4626864790916443,0.391304612159729,-0.4676616489887238,0.391304612159729],0]
			]
			]
		],
		[
		],
		false,
		false,
		6646192803077907,
		[],
		null
	]
,	[
		"t74",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3106860503484042,
			[
				["sprite26-sheet0.png", 143315, 0, 0, 262, 345, 1, 0, 0.5014492869377136,[["Imagepoint 1", -0.2290076315402985, -0.2173912972211838],["Imagepoint 2", -0.1793893128633499, 0.5043478012084961],["Imagepoint 3", 1.160305380821228, 0.4956521689891815],["Name", 0.5, 0.1652173846960068],["Amount", 0.5, 0.4347825944423676],["Award", 0.4961832165718079, 0.6666666865348816],["Image", 0.5, 0.2724637687206268],["Complete", 0.5, 0.9101449251174927]],[0.03816790133714676,-0.4724637866020203,0.9580150246620178,-0.4695651829242706,0.9427480101585388,-0.002898275852203369,0.969465970993042,0.4753627181053162,0.03053439967334271,0.4753627181053162,0.04961830005049706,-0.002898275852203369],0]
			]
			]
		],
		[
		],
		false,
		false,
		481956508572948,
		[],
		null
	]
,	[
		"t75",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2706494418186078,
			[
				["sprite27-sheet0.png", 15840, 0, 0, 216, 84, 1, 0.004629629664123058, 0.3452380895614624,[],[0.004629630595445633,-0.3214285969734192,0.9953703880310059,0.6547619104385376,-0.004629629664123058,0.6547619104385376],0]
			]
			]
		],
		[
		],
		false,
		false,
		7608195261999488,
		[],
		null
	]
,	[
		"t76",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7856891992124545,
			[
				["sprite28left-sheet0.png", 5975, 0, 0, 33, 111, 1, 0.4848484992980957, 0.5045045018196106,[],[0.5151515007019043,0.4954954981803894,-0.4848484992980957,0.4954954981803894,-0.4848484992980957,-0.5045045018196106,0.5151515007019043,-0.5045045018196106],0]
			]
			]
		],
		[
		],
		false,
		false,
		5913746628685625,
		[],
		null
	]
,	[
		"t77",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			444776984234664,
			[
				["sprite29right-sheet0.png", 6097, 0, 0, 33, 111, 1, 0.5151515007019043, 0.5045045018196106,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		1191635874519402,
		[],
		null
	]
,	[
		"t78",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4272438582582168,
			[
				["sprite28-sheet0.png", 4802, 0, 0, 190, 37, 1, 0.5, 0.5135135054588318,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6437678403419107,
		[],
		null
	]
,	[
		"t79",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		6218431568158552,
		[],
		null
	]
,	[
		"t80",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		3946744907130208,
		[],
		null
	]
,	[
		"t81",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		371716569146542,
		[],
		null
	]
,	[
		"t82",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"F1",
			5,
			false,
			1,
			0,
			false,
			1912312165923806,
			[
				["sprite29-sheet1.png", 125488, 1, 219, 150, 73, 1, 0.5, 0.5068492889404297,[],[],0]
			]
			]
,			[
			"F1A",
			5,
			false,
			1,
			0,
			false,
			2572983305116201,
			[
				["sprite29-sheet1.png", 125488, 152, 247, 150, 73, 1, 0.5, 0.5068492889404297,[],[],0]
			]
			]
,			[
			"F2",
			5,
			false,
			1,
			0,
			false,
			2430935741268876,
			[
				["sprite29-sheet0.png", 201986, 306, 126, 159, 92, 1, 0.5031446814537048, 0.5,[],[],0]
			]
			]
,			[
			"F2A",
			5,
			false,
			1,
			0,
			false,
			2529567099624608,
			[
				["sprite29-sheet1.png", 125488, 1, 126, 159, 92, 1, 0.5031446814537048, 0.5,[],[],0]
			]
			]
,			[
			"F3",
			5,
			false,
			1,
			0,
			false,
			9017754358587954,
			[
				["sprite29-sheet1.png", 125488, 202, 1, 196, 122, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"F3A",
			5,
			false,
			1,
			0,
			false,
			8909129744018079,
			[
				["sprite29-sheet1.png", 125488, 202, 124, 196, 122, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"F4",
			5,
			false,
			1,
			0,
			false,
			1531262626273411,
			[
				["sprite29-sheet1.png", 125488, 1, 1, 200, 124, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"F4A",
			5,
			false,
			1,
			0,
			false,
			1043088831519819,
			[
				["sprite29-sheet0.png", 201986, 211, 347, 200, 126, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"F5",
			5,
			false,
			1,
			0,
			false,
			5677791095171675,
			[
				["sprite29-sheet0.png", 201986, 1, 222, 209, 124, 1, 0.5023923516273499, 0.5,[],[],0]
			]
			]
,			[
			"F5A",
			5,
			false,
			1,
			0,
			false,
			9207257496150089,
			[
				["sprite29-sheet0.png", 201986, 306, 1, 204, 124, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"F6",
			5,
			false,
			1,
			0,
			false,
			2231927687293953,
			[
				["sprite29-sheet0.png", 201986, 1, 118, 304, 103, 1, 0.5, 0.5048543810844421,[],[],0]
			]
			]
,			[
			"F6A",
			5,
			false,
			1,
			0,
			false,
			8351257797872778,
			[
				["sprite29-sheet0.png", 201986, 1, 1, 291, 116, 1, 0.5017182230949402, 0.5,[],[],0]
			]
			]
,			[
			"F7",
			5,
			false,
			1,
			0,
			false,
			7009485929108764,
			[
				["sprite29-sheet0.png", 201986, 211, 222, 209, 124, 1, 0.5023923516273499, 0.5,[],[-0.5023923516273499,-0.5,0.4976076483726502,-0.5,0.3875596523284912,0.314516007900238,-0.3827753663063049,0.2983869910240173],0]
			]
			]
,			[
			"F7A",
			5,
			false,
			1,
			0,
			false,
			6463818406785141,
			[
				["sprite29-sheet0.png", 201986, 1, 347, 209, 124, 1, 0.5023923516273499, 0.5,[],[0.4306216239929199,0,-0.4306220412254334,0.1532260179519653,-0.4449760615825653,-0.25],0]
			]
			]
		],
		[
		],
		false,
		false,
		4712924995942275,
		[],
		null
	]
,	[
		"t83",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5376801744074791,
			[
				["sprite30pause-sheet0.png", 3989, 0, 0, 400, 150, 1, 0.5024999976158142, 0.5,[],[-0.2249999940395355,-0.5,0.4975000023841858,-0.5,0.4975000023841858,0.3933330178260803,-0.2274999916553497,0.3933330178260803],0]
			]
			]
		],
		[
		[
			"Anchor",
			cr.behaviors.Anchor,
			3725595540294754
		]
		],
		false,
		false,
		4196735218306602,
		[],
		null
	]
,	[
		"t84",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2033944951355536,
			[
				["sprite30gotomenu-sheet0.png", 47110, 1, 1, 201, 80, 1, 0.5024875402450562, 0.512499988079071,[],[-0.4825870394706726,-0.4624999761581421,0.482587456703186,-0.4749999940395355,0.4975124597549439,0.362500011920929,-0.4825870394706726,0.3500000238418579],0]
			]
			]
,			[
			"Pressed",
			5,
			false,
			1,
			0,
			false,
			6692279123270801,
			[
				["sprite30gotomenu-sheet0.png", 47110, 1, 82, 201, 80, 1, 0.5024875402450562, 0.512499988079071,[],[-0.4726368486881256,-0.4375,0.4626864790916443,-0.4249999821186066,0.467661440372467,0.2749999761581421,-0.4626865386962891,0.300000011920929],0]
			]
			]
		],
		[
		],
		false,
		false,
		7410028452127611,
		[],
		null
	]
,	[
		"t85",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7762548090018444,
			[
				["ok-sheet0.png", 10445, 0, 0, 116, 65, 1, 0.5, 0.5076923370361328,[],[0.5,-0.5076923370361328,0.5,0.4923076629638672,-0.5,0.4923076629638672,-0.5,-0.5076923370361328],0]
			]
			]
		],
		[
		],
		false,
		false,
		1044513296327664,
		[],
		null
	]
,	[
		"t86",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"On",
			5,
			false,
			1,
			0,
			false,
			1539841791859072,
			[
				["soundviz-sheet0.png", 11645, 1, 1, 108, 57, 1, 0.5, 0.5087719559669495,[],[0.3999999761581421,-0.3200929760932922,0.3899999856948853,0.2836810350418091,-0.5,-0.01820597052574158],0]
			]
			]
,			[
			"Off",
			5,
			false,
			1,
			0,
			false,
			2431579927331533,
			[
				["soundviz-sheet0.png", 11645, 1, 59, 100, 53, 1, 0.5, 0.5094339847564697,[],[0.3999999761581421,-0.3207550048828125,0.3899999856948853,0.2830190062522888,-0.5,-0.01886799931526184],0]
			]
			]
		],
		[
		],
		false,
		false,
		715362597478273,
		[],
		null
	]
,	[
		"t87",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"On",
			5,
			false,
			1,
			0,
			false,
			3180473405632144,
			[
				["soundviz-sheet0.png", 11645, 1, 1, 108, 57, 1, 0.5, 0.5087719559669495,[],[0.3981480002403259,-0.3157899379730225,0.3888890147209168,0.2807020545005798,-0.4259259104728699,-0.01754394173622131],0]
			]
			]
,			[
			"Off",
			5,
			false,
			1,
			0,
			false,
			3141363188103982,
			[
				["soundviz-sheet0.png", 11645, 1, 59, 100, 53, 1, 0.5, 0.5094339847564697,[],[0.3981480002403259,-0.3164519667625427,0.3888890147209168,0.2800400257110596,-0.4259259104728699,-0.01820597052574158],0]
			]
			]
		],
		[
		],
		false,
		false,
		8376167361399331,
		[],
		null
	]
,	[
		"t88",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6851064898055309,
			[
				["sprite25-sheet0.png", 31422, 1, 1, 196, 86, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3604649901390076,-0.5,0.3604649901390076],0]
			]
			]
,			[
			"Pressed",
			5,
			false,
			1,
			0,
			false,
			6621311636253151,
			[
				["sprite25-sheet0.png", 31422, 1, 88, 182, 69, 1, 0.5, 0.5072463750839233,[],[-0.4835165143013001,-0.4637680649757385,0.4835159778594971,-0.4637680649757385,0.4835159778594971,0.4492756128311157,-0.4835165143013001,0.4492756128311157],0]
			]
			]
		],
		[
		],
		false,
		false,
		7723752256280337,
		[],
		null
	]
,	[
		"t89",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7742326516747026,
			[
				["sprite30-sheet0.png", 5735, 0, 0, 77, 56, 1, 0.5064935088157654, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		2906508025377763,
		[],
		null
	]
,	[
		"t90",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9404498657748942,
			[
				["sprite31-sheet0.png", 4210, 0, 0, 68, 55, 1, 0.5, 0.5090909004211426,[],[-0.5,-0.5090909004211426,0.5,-0.5090909004211426,0.485293984413147,0.4727271199226379,-0.5,0.4909090995788574],0]
			]
			]
		],
		[
		],
		false,
		false,
		8268788313853135,
		[],
		null
	]
,	[
		"t91",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6208180944591235,
			[
				["sprite32-sheet0.png", 3065, 0, 0, 73, 54, 1, 0.5068492889404297, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		5058619630325681,
		[],
		null
	]
,	[
		"t92",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4560488561677584,
			[
				["sprite33-sheet0.png", 3606, 0, 0, 70, 46, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		2002696360599075,
		[],
		null
	]
,	[
		"t93",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Step1",
			5,
			false,
			1,
			0,
			false,
			9563135703590276,
			[
				["sprite24-sheet0.png", 35620, 137, 1, 78, 77, 1, 0.5, 0.5064935088157654,[],[0,-0.493506520986557,0.4743589758872986,-0.01298749446868897,-0.4487178921699524,0.4415584802627564],0]
			]
			]
,			[
			"Step2",
			5,
			false,
			1,
			0,
			false,
			6467205603410499,
			[
				["sprite24-sheet0.png", 35620, 1, 1, 135, 74, 1, 0.5037037134170532, 0.5,[],[0.4888892769813538,0.48648601770401,-0.5037037134170532,0.5,-0.2370367050170898,-0.5],0]
			]
			]
,			[
			"Step3",
			5,
			false,
			1,
			0,
			false,
			5120311577115112,
			[
				["sprite24-sheet0.png", 35620, 79, 79, 89, 55, 1, 0.5056179761886597, 0.5090909004211426,[],[0.2808990478515625,-0.5090909004211426,0.4943820238113403,0.4909090995788574,-0.5056179761886597,0.4909090995788574],0]
			]
			]
,			[
			"Step4",
			5,
			false,
			1,
			0,
			false,
			8879971564112601,
			[
				["sprite24-sheet0.png", 35620, 1, 76, 77, 77, 1, 0.5064935088157654, 0.5064935088157654,[],[-0.5064935088157654,0.4805194735527039,0.4935064911842346,-0.5064935088157654,0.4935064911842346,0.4935064911842346],0]
			]
			]
		],
		[
		],
		false,
		false,
		3859560627117956,
		[],
		null
	]
,	[
		"t94",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["text1.png", 29928, 0],
		null,
		[
		],
		false,
		false,
		8834567996968072,
		[],
		null
	]
,	[
		"t95",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		3953751090550889,
		[],
		null
	]
,	[
		"t96",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3342577423079437,
			[
				["sprite28left-sheet0.png", 5975, 0, 0, 33, 111, 1, 0.4848484992980957, 0.5045045018196106,[],[0.5151515007019043,0.4954954981803894,-0.4848484992980957,0.4954954981803894,-0.4848484992980957,-0.5045045018196106,0.5151515007019043,-0.5045045018196106],0]
			]
			]
		],
		[
		],
		false,
		false,
		844069400634698,
		[],
		null
	]
,	[
		"t97",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4175493141785582,
			[
				["sprite29right-sheet0.png", 6097, 0, 0, 33, 111, 1, 0.5151515007019043, 0.5045045018196106,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		9597074237857223,
		[],
		null
	]
,	[
		"t98",
		cr.plugins_.Text,
		false,
		[],
		1,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			2732986812688089
		]
		],
		false,
		false,
		3151235977817076,
		[],
		null
	]
	],
	[
	],
	[
	[
		"Game",
		850,
		550,
		false,
		"Game",
		9548905132703771,
		[
		[
			"BG",
			0,
			9842999810685295,
			true,
			[255, 255, 255],
			false,
			0,
			0,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[479, 421.5, 0, 962, 445, 0, 0, 1, 0, 1, 0, 0, []],
				6,
				6,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Layer 0",
			1,
			719602827262566,
			true,
			[255, 255, 255],
			true,
			0,
			0,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-1, 600, 0, 850, 474, 0, 0, 1, 0, 1, 0, 0, []],
				5,
				5,
				[
				],
				[
				[
					1,
					1,
					0,
					10,
					0,
					0,
					0,
					8,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 0, 0, 850, 191, 0, 0, 1, 0, 0, 0, 0, []],
				11,
				14,
				[
				],
				[
				[
					1,
					1,
					0,
					10,
					0,
					0,
					0,
					2,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[153, 84, 0, 850, 272, 0, 0, 1, 0.3082352876663208, 0.5089605450630188, 0, 0, []],
				8,
				9,
				[
				],
				[
				[
					1,
					0,
					0,
					70,
					0,
					0,
					0,
					40,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Layer 1",
			2,
			1972894232007905,
			true,
			[255, 255, 255],
			true,
			0.1000000014901161,
			0,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-1, 93, 0, 959, 262, 0, 0, 1, 0, 0, 0, 0, []],
				7,
				7,
				[
				],
				[
				[
					1,
					1,
					0,
					10,
					0,
					0,
					0,
					4,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Layer 2",
			3,
			9030741400782839,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[433.8681640625, -81.1314697265625, 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, []],
				14,
				19,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[789, 356, 0, 192.4428558349609, 459.5650024414063, 0, 0, 1, 0.6791045069694519, 0.574999988079071, 0, 0, []],
				13,
				18,
				[
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
			],
			[			]
		]
,		[
			"UI",
			4,
			4964565743235559,
			true,
			[255, 255, 255],
			true,
			0,
			0,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[850, 551, 0, 169.9529418945313, 169.9529418945313, 0, 0, 1, 1, 1, 0, 0, []],
				33,
				30,
				[
				],
				[
				[
					1,
					1,
					0,
					0,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[7, 543, 0, 163.9725646972656, 163.9725646972656, 0, 0, 1, 0, 1, 0, 0, []],
				44,
				41,
				[
				],
				[
				[
					0,
					1,
					0,
					0,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[77, 473, 0, 79.43624877929688, 76.43865966796875, 0, 0, 1, 0.4905660450458527, 0.4509803950786591, 0, 0, []],
				53,
				58,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[91, 32, 0, 489.4136047363281, 183.5301361083984, 0, 0, 1, 0.5024999976158142, 0.5, 0, 0, []],
				83,
				81,
				[
				],
				[
				[
					0,
					0,
					0,
					0,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[153, 457, 0, 475, 105, 0, 0, 1, 0, 0, 0, 0, []],
				67,
				82,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"",
					1.5,
					0,
					0,
					1,
					0,
					0,
					-35,
					0
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Elements",
		1708,
		960,
		false,
		null,
		9129613374389139,
		[
		[
			"Layer 0",
			0,
			1417469433491179,
			true,
			[255, 255, 255],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[177, -50, 0, 272.3397521972656, 65.96154022216797, 0, 0, 0.25, 0.5, 0.5, 0, 0, []],
				12,
				8,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[186, -39, 0, 143, 227, 0, 0, 1, 0.4900000095367432, 0.7562500238418579, 0, 0, []],
				10,
				10,
				[
					[150]
				],
				[
				[
					200,
					800,
					350,
					3,
					0,
					0,
					1
				],
				[
					1
				],
				[
					1,
					0,
					0,
					20,
					0,
					0,
					0,
					5,
					0
				],
				[
					1,
					1,
					0,
					20,
					0,
					0,
					0,
					10,
					0
				],
				[
					1,
					1,
					0,
					2,
					0,
					0,
					0,
					3,
					0
				],
				[
					1,
					5,
					0,
					3,
					0,
					0,
					0,
					15,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[233.1985321044922, 343.5455627441406, 0, 214.6402893066406, 157.4028778076172, 0, 0, 1, 0.4285714328289032, 0.7077922224998474, 0, 0, []],
				17,
				11,
				[
				],
				[
				[
					1,
					0,
					3,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[287.6798095703125, 354.2985534667969, 0, 147.4688415527344, 108.1438446044922, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				18,
				12,
				[
				],
				[
				[
					1,
					0,
					3,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[349.6798706054688, 368.2985534667969, 0, 91.75308227539063, 67.28556823730469, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				19,
				13,
				[
				],
				[
				[
					1,
					0,
					3,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-238.8056640625, 29.01014709472656, 0, 493.4328918457031, 302.7341918945313, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				20,
				15,
				[
				],
				[
				[
					1,
					0,
					2.5,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-164, 238, 0, 144.0789489746094, 88.95124053955078, 0, 0, 1, 0.5079365372657776, 0.8701298832893372, 0, 0, []],
				21,
				16,
				[
				],
				[
				[
					1,
					0,
					0.5,
					0.5,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-238.8056640625, 28.01014709472656, 0, 414.4031677246094, 245.1115417480469, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				22,
				17,
				[
				],
				[
				[
					1,
					0,
					2.4,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-238.8056640625, 29.01014709472656, 0, 354.9139404296875, 203.4239654541016, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				23,
				20,
				[
				],
				[
				[
					1,
					0,
					2.3,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-238.7981262207031, 29.01767730712891, 0, 285.2257080078125, 155.0982360839844, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				24,
				21,
				[
				],
				[
				[
					1,
					0,
					2.2,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-238.8056640625, 30.01014709472656, 0, 235.7808837890625, 120.8749389648438, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				25,
				22,
				[
				],
				[
				[
					1,
					0,
					2.1,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-238.8056640625, 30.01014709472656, 0, 193.7151336669922, 90.19429779052734, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				26,
				23,
				[
				],
				[
				[
					1,
					0,
					2,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-239.8056640625, 30.01014709472656, 0, 142.9480285644531, 58.21696472167969, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				27,
				24,
				[
				],
				[
				[
					1,
					0,
					1.98,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-239.8673400878906, 29.94847869873047, 0, 106.4379196166992, 35.84248733520508, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				28,
				25,
				[
				],
				[
				[
					1,
					0,
					1.9,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-239.8056640625, 29.01014709472656, 0, 81.05187225341797, 20.90019607543945, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				29,
				26,
				[
				],
				[
				[
					1,
					0,
					1.75,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-240.74560546875, 29.18095016479492, 0, 40.1948356628418, 12.86234855651856, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				30,
				27,
				[
				],
				[
				[
					1,
					0,
					1.5,
					0.1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-295.3827819824219, 482.3745727539063, 0, 269.5973815917969, 264.4128112792969, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				31,
				28,
				[
				],
				[
				[
					1,
					2,
					0,
					2,
					0,
					0,
					0,
					50,
					0
				],
				[
					1,
					0,
					0.6,
					0.3,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-299, 540, 0, 293, 227, 0, -0.2338331639766693, 1, 0.5, 0.5, 0, 0, []],
				32,
				29,
				[
				],
				[
				[
					1,
					0,
					1,
					0.5,
					1
				]
				],
				[
					"Text",
					0,
					"bold 72pt Axure Handwriting",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[-304, 825, 0, 271, 402, 0, 0, 1, 0.5018450021743774, 0.5, 0, 0, []],
				35,
				32,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[322.0336303710938, -242.7499389648438, 0, 169.2187805175781, 73.32814788818359, 0, 1.570774674415588, 1, 0.2066666632890701, 0.4153846204280853, 0, 0, []],
				36,
				33,
				[
				],
				[
				[
					1,
					5,
					0,
					2,
					0,
					0,
					0,
					15,
					0
				],
				[
					1,
					5,
					0,
					1,
					0,
					0,
					0,
					10,
					0
				],
				[
					1,
					2,
					0,
					2,
					0,
					0,
					0,
					10,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-276, 998, 0, 116, 65, 0, 0, 1, 0.5, 0.5076923370361328, 0, 0, []],
				37,
				34,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-291, 898, 0, 293, 227, 0, -0.2338331639766693, 1, 0.5, 0.5, 0, 0, []],
				34,
				31,
				[
				],
				[
				[
					1,
					0,
					3,
					1,
					1
				]
				],
				[
					"Text",
					0,
					"bold 72pt Axure Handwriting",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[10, 789, 0, 369, 297, 0, -0.04617984220385552, 1, 0.5, 0.5, 0, 0, []],
				38,
				35,
				[
				],
				[
				],
				[
					"Text",
					0,
					"bold 48pt Arial Black",
					"rgb(255,255,255)",
					0,
					1,
					1,
					0,
					0
				]
			]
,			[
				[43, 1006, 0, 369, 297, 0, -0.04617984220385552, 1, 0.5, 0.5, 0, 0, []],
				39,
				36,
				[
				],
				[
				],
				[
					"Text",
					0,
					"bold 72pt Arial Black",
					"rgb(255,255,255)",
					0,
					1,
					1,
					0,
					0
				]
			]
,			[
				[552.70458984375, -148.2236022949219, 0, 115.8615493774414, 46.22758865356445, 0, 0, 0.6000000238418579, 0.5, 0.5063291192054749, 0, 0, []],
				40,
				37,
				[
				],
				[
				[
					-70,
					0,
					0,
					0,
					0,
					1
				],
				[
					1,
					1,
					0,
					3,
					0,
					0,
					0,
					15,
					0
				],
				[
					1,
					0,
					0,
					4,
					0,
					0,
					0,
					20,
					0
				],
				[
					1,
					3,
					4.5,
					5,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[718.7998046875, -126.6546249389648, 0, 140.4004211425781, 56.01834869384766, 0, 0, 0.6000000238418579, 0.5, 0.5063291192054749, 0, 0, []],
				41,
				38,
				[
				],
				[
				[
					80,
					0,
					0,
					0,
					0,
					1
				],
				[
					1,
					1,
					0,
					3,
					0,
					0,
					0,
					15,
					0
				],
				[
					1,
					0,
					0,
					4,
					0,
					0,
					0,
					20,
					0
				],
				[
					1,
					3,
					4.5,
					5,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[957.5647583007813, -203.7641448974609, 0, 77.01849365234375, 99.56049346923828, 0, 0.001907347002997994, 1, 0.4749999940395355, 0.119999997317791, 0, 0, []],
				42,
				40,
				[
				],
				[
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-244, -299, 0, 235, 37, 0, 0, 1, 0.5021276473999023, 0.5135135054588318, 0, 0, []],
				43,
				39,
				[
				],
				[
				[
					1,
					2,
					0,
					3,
					0,
					0,
					0,
					70,
					0
				],
				[
					1,
					0,
					0.65,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[417, 242, 0, 658.6907348632813, 400.7419128417969, 0, 0, 1, 0.4965035021305084, 0, 0, 0, []],
				46,
				43,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-283.7195129394531, 1099.40966796875, 0, 206.5609893798828, 78.81932830810547, 0, 0, 1, 0.9934210777282715, -0.1379310339689255, 0, 0, []],
				47,
				44,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[316, 1051, 0, 76, 80, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				48,
				45,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[446, 1057, 0, 78, 61, 0, 0, 1, 0.5, 0.5081967115402222, 0, 0, []],
				49,
				46,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[553, 1045, 0, 77, 88, 0, 0, 1, 0.5064935088157654, 0.5, 0, 0, []],
				50,
				47,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[677, 1048, 0, 85, 68, 0, 0, 1, 0.5058823823928833, 0.5, 0, 0, []],
				51,
				48,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[817, 1043, 0, 80, 76, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				52,
				49,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[202.0952606201172, 1049.283935546875, 0, 79.43624877929688, 76.43865966796875, 0, 0, 1, 0.4905660450458527, 0.4509803950786591, 0, 0, []],
				53,
				50,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[938, 1043, 0, 72, 72, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				54,
				51,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[322, 1155, 0, 76, 80, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				55,
				52,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[449, 1154, 0, 78, 61, 0, 0, 1, 0.5, 0.5081967115402222, 0, 0, []],
				56,
				53,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[550, 1138, 0, 77, 88, 0, 0, 1, 0.5064935088157654, 0.5, 0, 0, []],
				57,
				54,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[685, 1138, 0, 85, 68, 0, 0, 1, 0.5058823823928833, 0.5, 0, 0, []],
				58,
				55,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[818, 1135, 0, 80, 76, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				59,
				56,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[921, 1132, 0, 72, 72, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				60,
				57,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1010, 65, 0, 148, 64, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				61,
				59,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"0$",
					1.3,
					0,
					1,
					1,
					1,
					0,
					-33,
					0
				]
			]
,			[
				[1037.5, 130, 0, 240, 64, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				62,
				60,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"20$",
					1.3,
					0,
					1,
					1,
					1,
					0,
					-33,
					0
				]
			]
,			[
				[1056, 196, 0, 192, 64, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				63,
				61,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"80$",
					1.3,
					0,
					1,
					1,
					1,
					0,
					-33,
					0
				]
			]
,			[
				[1040, 259, 0, 183, 64, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				64,
				62,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"160$",
					1.3,
					0,
					1,
					1,
					1,
					0,
					-33,
					0
				]
			]
,			[
				[1050, 329, 0, 206, 64, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				65,
				63,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"240$",
					1.3,
					0,
					1,
					1,
					1,
					0,
					-33,
					0
				]
			]
,			[
				[1051, 413, 0, 264, 64, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				66,
				64,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"300$",
					1.3,
					0,
					1,
					1,
					1,
					0,
					-33,
					0
				]
			]
,			[
				[934, 543, 0, 475, 153, 0, 0, 1, 0, 0, 0, 0, []],
				67,
				65,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"",
					1.5,
					0,
					0,
					1,
					0,
					0,
					-35,
					0
				]
			]
,			[
				[484.2645874023438, 819.6370849609375, 0, 58.13776779174805, 58.13776779174805, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				68,
				66,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-72, 1139, 0, 116, 65, 0, 0, 1, 0.5, 0.5076923370361328, 0, 0, []],
				85,
				84,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Layer 1",
			1,
			6675090186915646,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[1218, -117, 0, 3235, 2387, 0, 0, 0.800000011920929, 0.5, 0.5, 0, 0, []],
				45,
				42,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Layer 2",
			2,
			5836442279163215,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[363, 235, 0, 720, 480, 0, 0, 1, 0, 1, 0, 0, []],
				69,
				67,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[756, 275.8960876464844, 0, 416.1653442382813, 533.0813598632813, 0, 0, 1, 0.9632107019424439, 0.5013054609298706, 0, 0, []],
				70,
				68,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[900, 246, 0, 239.0697631835938, 95.15214538574219, 0, 0, 1, 0.5024875402450562, 0.5, 0, 0, []],
				71,
				69,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[899, 331, 0, 239.0697631835938, 95.15214538574219, 0, 0, 1, 0.5024875402450562, 0.5, 0, 0, []],
				72,
				70,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[901, 415, 0, 239.0697631835938, 84.15214538574219, 0, 0, 1, 0.5024875402450562, 0.5072463750839233, 0, 0, []],
				73,
				71,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[57, 296.8108215332031, 0, 286.4066772460938, 377.1385803222656, 0, 0, 1, 0, 0.5014492869377136, 0, 0, []],
				74,
				72,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[401.7862243652344, 602.8001098632813, 0, 240.8556060791016, 93.66606903076172, 0, 0, 1, 0.004629629664123058, 0.3452380895614624, 0, 0, []],
				75,
				73,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[504, 771, 0, 33, 111, 0, 0, 1, 0.4848484992980957, 0.5045045018196106, 0, 0, []],
				76,
				74,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[618, 765, 0, 33, 111, 0, 0, 1, 0.5151515007019043, 0.5045045018196106, 0, 0, []],
				77,
				75,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[246.9340515136719, 595.3928833007813, 0, 337.6958923339844, 65.76182556152344, 0, -0.05982454493641853, 1, 0.5, 0.5135135054588318, 0, 0, []],
				78,
				76,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[143.5, 645, 0, 338, 75, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				79,
				77,
				[
				],
				[
				],
				[
					"Text",
					0,
					"bold 33pt Arial Black",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[97, 713, 0, 745, 102, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				80,
				78,
				[
				],
				[
				],
				[
					"Text",
					0,
					"bold 33pt Arial Black",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[96, 777, 0, 225, 75, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				81,
				79,
				[
				],
				[
				],
				[
					"Text",
					0,
					"bold 33pt Arial Black",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[246, 874, 0, 150, 73, 0, 0, 1, 0.5, 0.5068492889404297, 0, 0, []],
				82,
				80,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[903, 520, 0, 244.607177734375, 97.35609436035156, 0, 0, 1, 0.5024875402450562, 0.512499988079071, 0, 0, []],
				84,
				83,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1022, 671, 0, 155.5377807617188, 82.08938598632813, 0, 0, 1, 0.5, 0.5087719559669495, 0, 0, []],
				86,
				86,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1025, 792, 0, 155.5377807617188, 82.08938598632813, 0, 0, 1, 0.5, 0.5087719559669495, 0, 0, []],
				87,
				85,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1051.903076171875, 960.1717529296875, 0, 309.7855529785156, 135.9263000488281, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				88,
				87,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1190, 668, 0, 106.7520446777344, 77.63785552978516, 0, 0, 1, 0.5064935088157654, 0.5, 0, 0, []],
				89,
				88,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[859, 682, 0, 97.75204467773438, 76.63785552978516, 0, 0, 1, 0.5, 0.5090909004211426, 0, 0, []],
				90,
				89,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[861, 786, 0, 100.2682571411133, 74.17103576660156, 0, 0, 1, 0.5068492889404297, 0.5, 0, 0, []],
				91,
				90,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1191, 801, 0, 97.26825714111328, 66.17103576660156, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				91,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[442.4187927246094, 1054.418701171875, 0, 130.8375701904297, 129.16015625, 0, 0, 1, 0.5, 0.5064935088157654, 0, 0, []],
				93,
				93,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[27, 1105.5, 0, 178, 165, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				94,
				92,
				[
				],
				[
				],
				[
					48,
					48,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"1",
					2,
					0,
					0,
					1,
					1,
					0,
					-33,
					0
				]
			]
,			[
				[562, 988, 0, 345, 452, 0, 0, 1, 0, 0, 0, 0, []],
				95,
				94,
				[
				],
				[
				],
				[
					"text",
					0,
					"bold 33pt Arial Black",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[184, 1224, 0, 33, 111, 0, 0, 1, 0.4848484992980957, 0.5045045018196106, 0, 0, []],
				96,
				95,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[327, 1191, 0, 33, 111, 0, 0, 1, 0.5151515007019043, 0.5045045018196106, 0, 0, []],
				97,
				96,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[717, 1075, 0, 530, 260, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				98,
				97,
				[
				],
				[
				[
					1,
					0,
					1.5,
					2,
					1
				]
				],
				[
					"text",
					0,
					"bold 36pt Arial Black",
					"rgb(0,0,0)",
					1,
					1,
					1,
					0,
					0
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Start",
		850,
		550,
		false,
		"Start",
		6404320609690426,
		[
		[
			"Layer 0",
			0,
			214695905839994,
			true,
			[255, 255, 255],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Help",
		850,
		550,
		false,
		"Help",
		4612592261517998,
		[
		[
			"Layer 0",
			0,
			9034671389081608,
			true,
			[255, 255, 255],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Settings",
		850,
		550,
		false,
		"Settings",
		1291509857337518,
		[
		[
			"Layer 0",
			0,
			3586744734992581,
			true,
			[255, 255, 255],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
		],
		[
		],
		[]
	]
	],
	[
	[
		"Game",
		[
		[
			1,
			"Help2",
			0,
			0,
false,false,6657596282077148,false
		]
,		[
			1,
			"Timer",
			0,
			0,
false,false,6637887949837153,false
		]
,		[
			1,
			"Money",
			0,
			0,
false,false,3804246986247559,false
		]
,		[
			1,
			"accuracyonscreen",
			0,
			0,
false,false,4787192929106813,false
		]
,		[
			0,
			null,
			false,
			null,
			7460961096190256,
			[
			[
				31,
				cr.plugins_.Sprite.prototype.cnds.OnCreated,
				null,
				1,
				false,
				false,
				false,
				4210302539899256,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3867249375931704,
				false
				,[
				[
					11,
					"accuracyonscreen"
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			755915346086441,
			[
			[
				31,
				cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
				null,
				1,
				false,
				false,
				false,
				4835850108106426,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4165003256661287,
				false
				,[
				[
					11,
					"accuracyonscreen"
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
,		[
			1,
			"Setnazivka",
			0,
			0,
false,false,2709117325335168,false
		]
,		[
			1,
			"fishonscreen",
			0,
			0,
false,false,398851455464075,false
		]
,		[
			1,
			"Randomfishvalue",
			0,
			0,
false,false,5119526151777246,false
		]
,		[
			1,
			"Mode",
			0,
			0,
false,false,9950046132870023,false
		]
,		[
			1,
			"VidNazhivki",
			0,
			0,
false,false,8442868134648275,false
		]
,		[
			1,
			"Fail",
			0,
			0,
false,false,1905000040975858,false
		]
,		[
			1,
			"Accuracy",
			0,
			0,
false,false,158433324649566,false
		]
,		[
			1,
			"MoneyCatch",
			0,
			0,
false,false,9753357234418512,false
		]
,		[
			1,
			"FishName",
			1,
			"nothing",
false,false,2341671722775439,false
		]
,		[
			1,
			"Ulov",
			0,
			0,
false,false,7952985438135269,false
		]
,		[
			0,
			null,
			false,
			null,
			9856229614960542,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				536426287961214,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7186701745375565,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9671760995242872,
					false
					,[
					[
						11,
						"Sound"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					3,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					1241089843660013,
					false
					,[
					[
						2,
						["sp0000",true]
					]
,					[
						3,
						1
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							"SP0000"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1550897423706347,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					4543532526356588,
					false
					,[
					[
						11,
						"Sound"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					3,
					cr.plugins_.Audio.prototype.acts.StopAll,
					null,
					1161918702242675,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4017192479198042,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutEnd,
				null,
				1,
				false,
				false,
				false,
				8202980658121844,
				false
			]
			],
			[
			[
				3,
				cr.plugins_.Audio.prototype.acts.StopAll,
				null,
				9214826885063408,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2321121479843447,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				2507676682349228,
				false
			]
			],
			[
			[
				5,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				458843196826696,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportbottom
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				5,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				7267132405407886,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							70
						]
					]
				]
				]
			]
,			[
				5,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				6847494715303836,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				7,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				5088800901987427,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							5,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							540
						]
					]
				]
				]
			]
,			[
				7,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				4675253605784216,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							70
						]
					]
				]
				]
			]
,			[
				7,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				7156384136436392,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				62960638105811,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewporttop
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							2
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				1585967240599677,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							70
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				7480245745669381,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								1
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				6,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				5415233713927547,
				false
				,[
				[
					0,
					[
						19,
						cr.system_object.prototype.exps.viewportbottom
						,[
[
							0,
							0
						]
						]
					]
				]
				]
			]
,			[
				6,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				2543931130373183,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							70
						]
					]
				]
				]
			]
,			[
				6,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				3442995944241388,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				13,
				cr.plugins_.Sprite.prototype.acts.SetPos,
				null,
				4392877341949821,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								4
							]
							]
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportbottom
							,[
[
								0,
								4
							]
							]
						]
						,[
							0,
							200
						]
					]
				]
				]
			]
,			[
				13,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				6243763941079433,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutheight
							]
							,[
								0,
								8
							]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetGroupActive,
				null,
				1904988828795603,
				false
				,[
				[
					1,
					[
						2,
						"Targeting (push poplavok)"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				4,
				cr.plugins_.CJSAds.prototype.acts.ShowBanner,
				null,
				657239128591498,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				14,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				7324398426222213,
				false
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				9859834435069342,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					5889701080808075,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"MoneySave"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					45652384199027,
					false
					,[
					[
						11,
						"Money"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"MoneySave"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					175646232828643,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2015385262461425,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					8353057363403006,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"VidNazivkiS"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							-1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6069528695704539,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"VidNazivkiS"
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6400339396283451,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1260643722149622,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					44,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					2166269426291382,
					false
					,[
					[
						4,
						48
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					482353907451855,
					false
					,[
					[
						1,
						[
							2,
							"Yes"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9029923562858359,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8033694366727148,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1843681019483994,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4922893578907836,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3994186933305881,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6740036853492163,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6318998984368994,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7811265844598698,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				],
				[
				[
					44,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					4283778798770037,
					false
					,[
					[
						4,
						49
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					5241565710849761,
					false
					,[
					[
						1,
						[
							2,
							"Yes"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1381361158089982,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7226913891422711,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					837477159445912,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4444478104108523,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2111460450026849,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2099260203551234,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5690157710563299,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8319885880060992,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					44,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					7689389430630008,
					false
					,[
					[
						4,
						50
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9372261424077191,
					false
					,[
					[
						1,
						[
							2,
							"Yes"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6836838481808387,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6675098844248458,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9554910630219861,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9679841139851431,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7311660134453594,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7149749676086656,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				649056977747011,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7295915617650903,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							4
						]
					]
					]
				]
				],
				[
				[
					44,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					7354644468110084,
					false
					,[
					[
						4,
						51
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6412518437523604,
					false
					,[
					[
						1,
						[
							2,
							"Yes"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3893531485091109,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6778757039731522,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6241310677747979,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					364344545958293,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1705441351482033,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6159424660330767,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				518059528368137,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7552535959559362,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					44,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					1400368841165689,
					false
					,[
					[
						4,
						52
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3876536048278487,
					false
					,[
					[
						1,
						[
							2,
							"Yes"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9929153776820285,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1185808324504756,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2025577323827651,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1859963122643406,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3568972895165282,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9690496810929703,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7743204026227454,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8077144389275834,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							6
						]
					]
					]
				]
				],
				[
				[
					44,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					1323568182494499,
					false
					,[
					[
						4,
						54
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					5048817724213963,
					false
					,[
					[
						1,
						[
							2,
							"Yes"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					340257685767294,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1638217289947162,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8053757289011684,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8023576936243227,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					748070326402489,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1007383721443137,
					false
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Decor"],
			false,
			null,
			7976038636401137,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7976038636401137,
				false
				,[
				[
					1,
					[
						2,
						"Decor"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5228316281861007,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					5232190026343589,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								8
							]
,[
								0,
								19
							]
							]
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					6160036132480602,
					false
					,[
					[
						4,
						40
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								4,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									260
								]
							]
,[
								4,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									500
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8545706336573032,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					8382605540694327,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								8
							]
,[
								0,
								19
							]
							]
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					6619977168389818,
					false
					,[
					[
						4,
						41
					]
,					[
						5,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								4,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									260
								]
							]
,[
								4,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									500
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8521223236770779,
				[
				[
					40,
					cr.plugins_.Sprite.prototype.cnds.OnCreated,
					null,
					1,
					false,
					false,
					false,
					5536301753293075,
					false
				]
				],
				[
				[
					40,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6184599196717683,
					false
					,[
					[
						0,
						[
							5,
							[
								6,
								[
									20,
									40,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									1,
									0.003
								]
							]
							,[
								6,
								[
									5,
									[
										20,
										5,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										370
									]
								]
								,[
									1,
									0.003
								]
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Targeting (push poplavok)"],
			false,
			null,
			9444168380175369,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9444168380175369,
				false
				,[
				[
					1,
					[
						2,
						"Targeting (push poplavok)"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9290144362050913,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					5282288481126632,
					false
					,[
					[
						0,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4982368029139864,
					false
					,[
					[
						4,
						17
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								4,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									50
								]
							]
,[
								5,
								[
									20,
									13,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									100
								]
							]
							]
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								4,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									250
								]
							]
,[
								4,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									370
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6694480353240322,
				[
				[
					17,
					cr.plugins_.Sprite.prototype.cnds.OnCreated,
					null,
					1,
					false,
					false,
					false,
					1334802816795533,
					false
				]
				],
				[
				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					867329781612314,
					false
					,[
					[
						4,
						20
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					304882482727061,
					false
					,[
					[
						4,
						22
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9713571482411914,
					false
					,[
					[
						4,
						23
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6767107206912798,
					false
					,[
					[
						4,
						24
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					4691588488043762,
					false
					,[
					[
						4,
						25
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					4244910644436256,
					false
					,[
					[
						4,
						26
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6935473572648481,
					false
					,[
					[
						4,
						27
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					132015754020223,
					false
					,[
					[
						4,
						28
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6478147756905766,
					false
					,[
					[
						4,
						29
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					4310866546778421,
					false
					,[
					[
						4,
						30
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3266517780158233,
					false
					,[
					[
						0,
						[
							5,
							[
								6,
								[
									20,
									17,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									1,
									0.01
								]
							]
							,[
								6,
								[
									5,
									[
										20,
										5,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										370
									]
								]
								,[
									1,
									0.01
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2902089826854178,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								1,
								0.3
							]
,[
								1,
								0.7
							]
							]
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9893858309805853,
					false
					,[
					[
						4,
						18
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.choose
							,[
[
								0,
								1
							]
,[
								0,
								2
							]
,[
								0,
								3
							]
,[
								0,
								4
							]
							]
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5021216624197568,
					false
					,[
					[
						0,
						[
							5,
							[
								6,
								[
									20,
									18,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									1,
									0.01
								]
							]
							,[
								6,
								[
									5,
									[
										20,
										5,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										370
									]
								]
								,[
									1,
									0.01
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6278097469643861,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								1,
								0.2
							]
,[
								1,
								0.5
							]
							]
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					5517061812868996,
					false
					,[
					[
						4,
						19
					]
,					[
						5,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.choose
							,[
[
								0,
								1
							]
,[
								0,
								2
							]
,[
								0,
								3
							]
,[
								0,
								4
							]
							]
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3996086776889068,
					false
					,[
					[
						0,
						[
							5,
							[
								6,
								[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									1,
									0.01
								]
							]
							,[
								6,
								[
									5,
									[
										20,
										5,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										370
									]
								]
								,[
									1,
									0.01
								]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Accuracy"],
				false,
				null,
				1934925231061415,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1934925231061415,
					false
					,[
					[
						1,
						[
							2,
							"Accuracy"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8480252550155505,
					[
					[
						1,
						cr.plugins_.Touch.prototype.cnds.IsInTouch,
						null,
						0,
						false,
						false,
						false,
						9037129942264537,
						false
					]
,					[
						1,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						true,
						false,
						6493522930473802,
						false
						,[
						[
							4,
							13
						]
						]
					]
,					[
						1,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						true,
						false,
						4784373207433452,
						false
						,[
						[
							4,
							44
						]
						]
					]
,					[
						1,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						true,
						false,
						5127050342052242,
						false
						,[
						[
							4,
							83
						]
						]
					]
,					[
						1,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						true,
						false,
						1492326074039101,
						false
						,[
						[
							4,
							85
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1725470711648734,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							4803244337273615,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6417964719573107,
							false
							,[
							[
								4,
								21
							]
,							[
								5,
								[
									0,
									2
								]
							]
,							[
								0,
								[
									20,
									1,
									cr.plugins_.Touch.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									1,
									cr.plugins_.Touch.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6799446526455841,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							272336289803613,
							false
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9137923220663627,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6249802887015799,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2537618342238749,
							false
							,[
							[
								11,
								"Setnazivka"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						738574022606953,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8521858932436385,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4254354997206916,
							false
							,[
							[
								11,
								"Setnazivka"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											1
										]
,[
											0,
											6
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6059891098134322,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5240802175277095,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4941497553740429,
							false
							,[
							[
								11,
								"Setnazivka"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											3
										]
,[
											0,
											11
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5780573864189636,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							7124336543459583,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7856882909092867,
							false
							,[
							[
								11,
								"Setnazivka"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											7
										]
,[
											0,
											15
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4153351680984691,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6738492995293025,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2124835465533454,
							false
							,[
							[
								11,
								"Setnazivka"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											10
										]
,[
											0,
											19
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8823339676389519,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5645242119397407,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5993861666429496,
							false
							,[
							[
								11,
								"Setnazivka"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											16
										]
,[
											0,
											23
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7111847762168768,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8832595620277145,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									6
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4369102542227873,
							false
							,[
							[
								11,
								"Setnazivka"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											20
										]
,[
											0,
											29
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3931405808733102,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							5396505648312611,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							4887103950960165,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							4014979672811235,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							5366770366510434,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							5212019609053882,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3937309579290388,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							6590718314747423,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2919393603616363,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							9952147592261856,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7623152659012818,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							9193504721533971,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									1
								]
							]
,							[
								0,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							9825199385277427,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							6906217682352188,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8114497505347545,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							4764123508761689,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3028741760300721,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1992640182194634,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8242333679909919,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							785393442489245,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2321962413263732,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							690003096173553,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									5
								]
							]
,							[
								0,
								[
									0,
									8
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8572210637517232,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2787930081132181,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							9788259503311322,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2346502800363157,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							5210901900302993,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2289242271176449,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							9512469581817448,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							6587799124014811,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7235310057129714,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							2985330873163892,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									9
								]
							]
,							[
								0,
								[
									0,
									12
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							4601639303173405,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1157099698224066,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2167132116366891,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3805209782630844,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							7429951259488794,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							7209121489070062,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2754099159803197,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							743423442904047,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7242381987588636,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							7784670275801862,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									13
								]
							]
,							[
								0,
								[
									0,
									16
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1505816327984245,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8708039228796451,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							796907501029358,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3459296980294242,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							9623947359890455,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8978812956021112,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1457084021220836,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3418693133469863,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9277340732298285,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							6282505103821339,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									17
								]
							]
,							[
								0,
								[
									0,
									20
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							6695730499843949,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							5544194507305135,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3333670648106933,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							4566446088764315,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1971170375233856,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2100920589987665,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							9041391562631612,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							2574063250981634,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2953189806245458,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							1228664906917745,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									21
								]
							]
,							[
								0,
								[
									0,
									27
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							921068624599835,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1453448605278835,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							855900436913843,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							4052046886134264,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							6994966457029109,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							6305068506239889,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							345160840216307,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							7880588252222551,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1792065087651071,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareBetween,
							null,
							0,
							false,
							false,
							false,
							5399788288764076,
							false
							,[
							[
								0,
								[
									23,
									"Setnazivka"
								]
							]
,							[
								0,
								[
									0,
									28
								]
							]
,							[
								0,
								[
									0,
									28
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							4402666447810639,
							false
							,[
							[
								1,
								[
									2,
									"Ryba0"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1426928669580089,
							false
							,[
							[
								1,
								[
									2,
									"Ryba1"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8909605518268535,
							false
							,[
							[
								1,
								[
									2,
									"Ryba2"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8105838065920635,
							false
							,[
							[
								1,
								[
									2,
									"Ryba3"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1346755343597195,
							false
							,[
							[
								1,
								[
									2,
									"Ryba4"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8908028499769464,
							false
							,[
							[
								1,
								[
									2,
									"Ryba5"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							8598106935445576,
							false
							,[
							[
								1,
								[
									2,
									"Ryba6"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							826773801787577,
							false
							,[
							[
								1,
								[
									2,
									"Ryba7"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5975383905937922,
						[
						[
							21,
							cr.plugins_.Sprite.prototype.cnds.OnCreated,
							null,
							1,
							false,
							false,
							false,
							4679376286024091,
							false
						]
						],
						[
						[
							21,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							5658599474089115,
							false
							,[
							[
								4,
								10
							]
,							[
								5,
								[
									0,
									2
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							21,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							5072400616904786,
							false
							,[
							[
								4,
								12
							]
,							[
								5,
								[
									0,
									2
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							21,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9282868910678757,
							false
							,[
							[
								4,
								14
							]
,							[
								5,
								[
									0,
									2
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.SetPosToObject,
							null,
							7487085501309953,
							false
							,[
							[
								4,
								10
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							12,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							3258166167930141,
							false
							,[
							[
								4,
								10
							]
,							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7952375148237344,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								5071110169596515,
								false
								,[
								[
									11,
									"Vibro"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Browser.prototype.acts.Vibrate,
								null,
								897569844148262,
								false
								,[
								[
									1,
									[
										2,
										"200,100,200"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							111254161419981,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								716698994144903,
								false
								,[
								[
									4,
									20
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								4891056533658893,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1042995198983524,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								5809358802032961,
								false
								,[
								[
									4,
									22
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								8501427483794037,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2662242421033163,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								6846689746275407,
								false
								,[
								[
									4,
									23
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								3054524943744264,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							13296818405779,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								3696418362120439,
								false
								,[
								[
									4,
									24
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								317882145585071,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7293255864311795,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								9109739323015923,
								false
								,[
								[
									4,
									25
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								394795061893429,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3454024462979699,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								7412123150756738,
								false
								,[
								[
									4,
									26
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								8891692966937533,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5596258118188474,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								4212870815630287,
								false
								,[
								[
									4,
									27
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								1759187311625133,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5044004630102546,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								3423074508695803,
								false
								,[
								[
									4,
									28
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								4504198494333566,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8823303615904318,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								2408305763490581,
								false
								,[
								[
									4,
									29
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								8354389702812427,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							997945565213482,
							[
							[
								21,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								3420295167375024,
								false
								,[
								[
									4,
									30
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								8737844074575158,
								false
								,[
								[
									11,
									"Accuracy"
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9394239707973142,
						[
						[
							21,
							cr.plugins_.Sprite.prototype.cnds.OnCreated,
							null,
							1,
							false,
							false,
							false,
							8049025294629369,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1759898093163041,
							false
							,[
							[
								4,
								31
							]
,							[
								5,
								[
									0,
									4
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4545627611027221,
							false
							,[
							[
								4,
								32
							]
,							[
								5,
								[
									0,
									4
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										31,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										50
									]
								]
							]
							]
						]
,						[
							32,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							3637285461797343,
							false
							,[
							[
								7,
								[
									23,
									"Accuracy"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							3659326243365409,
							false
							,[
							[
								0,
								[
									0,
									2
								]
							]
							]
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5943630577429863,
							false
							,[
							[
								0,
								[
									0,
									25
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Poplavok"],
			false,
			null,
			231230226782782,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				231230226782782,
				false
				,[
				[
					1,
					[
						2,
						"Poplavok"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "AnimationP"],
				false,
				null,
				2743744748824869,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					2743744748824869,
					false
					,[
					[
						1,
						[
							2,
							"AnimationP"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7917452153228265,
					[
					[
						-1,
						cr.system_object.prototype.cnds.EveryTick,
						null,
						0,
						false,
						false,
						false,
						9495599355509343,
						false
					]
					],
					[
					[
						10,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						1794931252895812,
						false
						,[
						[
							0,
							[
								5,
								[
									6,
									[
										20,
										10,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										1,
										0.005
									]
								]
								,[
									6,
									[
										5,
										[
											20,
											5,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											370
										]
									]
									,[
										1,
										0.005
									]
								]
							]
						]
						]
					]
,					[
						12,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						16802976559746,
						false
						,[
						[
							0,
							[
								5,
								[
									6,
									[
										20,
										12,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										1,
										0.005
									]
								]
								,[
									6,
									[
										5,
										[
											20,
											5,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											370
										]
									]
									,[
										1,
										0.005
									]
								]
							]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						6919399352707495,
						false
						,[
						[
							0,
							[
								20,
								13,
								cr.plugins_.Sprite.prototype.exps.ImagePointX,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
,						[
							0,
							[
								20,
								13,
								cr.plugins_.Sprite.prototype.exps.ImagePointY,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetTowardPosition,
						null,
						2291815753249502,
						false
						,[
						[
							0,
							[
								20,
								10,
								cr.plugins_.Sprite.prototype.exps.ImagePointX,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
,						[
							0,
							[
								20,
								10,
								cr.plugins_.Sprite.prototype.exps.ImagePointY,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						1970386336993311,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.distance
								,[
[
									20,
									13,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
,[
									20,
									13,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
,[
									20,
									10,
									cr.plugins_.Sprite.prototype.exps.ImagePointX,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
,[
									20,
									10,
									cr.plugins_.Sprite.prototype.exps.ImagePointY,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					285513706259528,
					[
					[
						98,
						cr.plugins_.Text.prototype.cnds.OnCreated,
						null,
						1,
						false,
						false,
						false,
						8286431863794379,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8015512912986565,
						false
						,[
						[
							11,
							"Help2"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9479537399952835,
					[
					[
						98,
						cr.plugins_.Text.prototype.cnds.OnDestroyed,
						null,
						1,
						false,
						false,
						false,
						8764136092026306,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						5500414106783359,
						false
						,[
						[
							0,
							[
								0,
								4
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8554426763633671,
						false
						,[
						[
							11,
							"Help2"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1046001674020138,
					[
					[
						1,
						cr.plugins_.Touch.prototype.cnds.OnTouchObject,
						null,
						1,
						false,
						false,
						false,
						7764021089032445,
						false
						,[
						[
							4,
							33
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5176201391236741,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2919112999393272,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							673889653356746,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6592364176434427,
							false
							,[
							[
								11,
								"Help2"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							34191842516834,
							false
							,[
							[
								4,
								98
							]
,							[
								5,
								[
									0,
									4
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
,						[
							98,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							1899574757427979,
							false
							,[
							[
								7,
								[
									2,
									"Выберите наживку и опустите ее в воду"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6683114550816905,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2557354635310899,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2832264887787768,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								1
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							4452558805249145,
							false
							,[
							[
								11,
								"Help2"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9537867815583758,
							false
							,[
							[
								4,
								98
							]
,							[
								5,
								[
									0,
									4
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
,						[
							98,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							9059661945675736,
							false
							,[
							[
								7,
								[
									2,
									"Достаньте поплавок из воды и насадите наживку на крючек (Иконка наживки в левом нижнем углу)."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4652387474462413,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1763285554829856,
							false
							,[
							[
								11,
								"VidNazhivki"
							]
,							[
								8,
								1
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8602028148104519,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3180450106315531,
							false
							,[
							[
								11,
								"Help2"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1622465387598679,
							false
							,[
							[
								4,
								98
							]
,							[
								5,
								[
									0,
									4
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
							]
,							[
								0,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutheight
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
,						[
							98,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							3144460834456372,
							false
							,[
							[
								7,
								[
									2,
									"Бросьте поплавок в воду. (Коснитесь экрана)"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2871459494137151,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						9752719307591383,
						false
						,[
						[
							7,
							[
								20,
								10,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								5,
								[
									20,
									5,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									355
								]
							]
						]
						]
					]
					],
					[
					[
						10,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3957329715320993,
						false
						,[
						[
							0,
							[
								20,
								10,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									5,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									355
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Kluet"],
					false,
					null,
					8146456454550142,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						8146456454550142,
						false
						,[
						[
							1,
							[
								2,
								"Kluet"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5630612027796052,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
							null,
							0,
							false,
							false,
							false,
							4153945734107771,
							false
							,[
							[
								4,
								42
							]
							]
						]
						],
						[
						[
							12,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1377154011889912,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							424931492601512,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
								null,
								1,
								false,
								false,
								false,
								8032989873046219,
								false
								,[
								[
									1,
									[
										2,
										"Passiv"
									]
								]
								]
							]
							],
							[
							[
								10,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8477359153424355,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4999735802263405,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
								null,
								1,
								false,
								false,
								false,
								1724814695138605,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								10,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6798080844795605,
								false
								,[
								[
									1,
									[
										2,
										"yes1"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5756890278965396,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
								null,
								1,
								false,
								false,
								false,
								7572262090651104,
								false
								,[
								[
									1,
									[
										2,
										"yes1"
									]
								]
								]
							]
							],
							[
							[
								10,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6410615888018587,
								false
								,[
								[
									1,
									[
										2,
										"yes2"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8701409737682792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
								null,
								1,
								false,
								false,
								false,
								527267235300266,
								false
								,[
								[
									1,
									[
										2,
										"yes2"
									]
								]
								]
							]
							],
							[
							[
								10,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								410454307801314,
								false
								,[
								[
									1,
									[
										2,
										"yes3"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4801274150978472,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
								null,
								1,
								false,
								false,
								false,
								4235048093462679,
								false
								,[
								[
									1,
									[
										2,
										"yes3"
									]
								]
								]
							]
							],
							[
							[
								10,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								814861998056419,
								false
								,[
								[
									1,
									[
										2,
										"yes4"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2747596926931548,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							6671519233370874,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2542177498822485,
							false
							,[
							[
								1,
								[
									2,
									"Based"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							4324004039116311,
							false
							,[
							[
								0,
								[
									0,
									25
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ok button"],
			false,
			null,
			2656347791420923,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2656347791420923,
				false
				,[
				[
					1,
					[
						2,
						"Ok button"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2953743416480264,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					3849326642726227,
					false
					,[
					[
						4,
						37
					]
					]
				]
				],
				[
				[
					39,
					cr.plugins_.Text.prototype.acts.Destroy,
					null,
					6496351245247407,
					false
				]
,				[
					38,
					cr.plugins_.Text.prototype.acts.Destroy,
					null,
					3074260783134486,
					false
				]
,				[
					35,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					779437593126283,
					false
				]
,				[
					36,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3746183334103283,
					false
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7209057420262454,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4740670414276309,
					false
					,[
					[
						11,
						"Money"
					]
,					[
						7,
						[
							23,
							"MoneyCatch"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1568970022425022,
					false
					,[
					[
						4,
						43
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutwidth
							]
							,[
								0,
								2
							]
						]
					]
,					[
						0,
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutheight
							]
							,[
								0,
								2
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5758163953396247,
					false
					,[
					[
						0,
						[
							1,
							1.5
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6171329362693115,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					7982728650547575,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					251114260409814,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2502111721012347,
					false
					,[
					[
						4,
						44
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps.viewportleft
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								6
							]
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportbottom
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								6
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					3352114224063022,
					false
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					2934457439021013,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					1050476039749813,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					1083992331664885,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					5456113561230054,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					556027959246425,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					5106195752706562,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					6001187124897869,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
					null,
					8259190509749437,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4904970793014196,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6709574609954874,
					false
					,[
					[
						11,
						"Accuracy"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4880105651334277,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6562920894424033,
					false
					,[
					[
						11,
						"FishName"
					]
,					[
						7,
						[
							2,
							"nothing"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					735298958810177,
					false
					,[
					[
						11,
						"MoneyCatch"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7373776107533626,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9763080806619826,
					false
					,[
					[
						1,
						[
							2,
							"Timer"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9751014010729883,
					false
					,[
					[
						4,
						83
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							0,
							91
						]
					]
,					[
						0,
						[
							0,
							32
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1265262824959724,
					false
					,[
					[
						7,
						[
							10,
							[
								23,
								"Money"
							]
							,[
								2,
								"$"
							]
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3447183181537994,
					false
					,[
					[
						1,
						[
							2,
							"MoneySave"
						]
					]
,					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2464746248754876,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4462975425366486,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5018950411377785,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5084881889478964,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9891766827752125,
						false
						,[
						[
							11,
							"Ryba1"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						936275759649266,
						false
						,[
						[
							4,
							74
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								5,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
								,[
									0,
									128
								]
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewporttop
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									202
								]
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7968174310488349,
						false
						,[
						[
							4,
							79
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						887030305661752,
						false
						,[
						[
							4,
							80
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						565028461353882,
						false
						,[
						[
							4,
							81
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						2139215956076882,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						1738964080432918,
						false
						,[
						[
							4,
							78
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						9991118046156665,
						false
						,[
						[
							0,
							[
								0,
								-4
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6950792249567616,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						79,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						3105702186766588,
						false
						,[
						[
							7,
							[
								2,
								"Плотва"
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						9761862872589583,
						false
						,[
						[
							7,
							[
								2,
								"x5"
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						78798439720583,
						false
						,[
						[
							7,
							[
								2,
								"50"
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3808996326993029,
						false
						,[
						[
							1,
							[
								2,
								"F1A"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1454774159767758,
						false
						,[
						[
							4,
							85
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								20,
								78,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									55
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6862458753983628,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8192250762373066,
						false
						,[
						[
							11,
							"Ryba2"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7764721579061768,
						false
						,[
						[
							4,
							74
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								5,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
								,[
									0,
									128
								]
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewporttop
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									202
								]
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						1920407052717961,
						false
						,[
						[
							4,
							79
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3391633232847033,
						false
						,[
						[
							4,
							80
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7463740993189515,
						false
						,[
						[
							4,
							81
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						8253745194069864,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7370391563535505,
						false
						,[
						[
							4,
							78
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						4381756278740157,
						false
						,[
						[
							0,
							[
								0,
								-4
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4713457159796729,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						79,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						843151006951587,
						false
						,[
						[
							7,
							[
								2,
								"Карп"
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						9355405013547061,
						false
						,[
						[
							7,
							[
								2,
								"x7"
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						1295034793552374,
						false
						,[
						[
							7,
							[
								2,
								"200"
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						204190424622877,
						false
						,[
						[
							1,
							[
								2,
								"F2A"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						4342674368843879,
						false
						,[
						[
							4,
							85
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								20,
								78,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									55
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2895846995489253,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						597973935988323,
						false
						,[
						[
							11,
							"Ryba3"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								12
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1328601571763725,
						false
						,[
						[
							4,
							74
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								5,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
								,[
									0,
									128
								]
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewporttop
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									202
								]
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3071276275726386,
						false
						,[
						[
							4,
							79
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3930714861630091,
						false
						,[
						[
							4,
							80
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						5488667067265113,
						false
						,[
						[
							4,
							81
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						830607658436651,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						4326836112121822,
						false
						,[
						[
							4,
							78
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						2515938357165719,
						false
						,[
						[
							0,
							[
								0,
								-4
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2076324146034329,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						79,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						4535114559745997,
						false
						,[
						[
							7,
							[
								2,
								"Ёрш"
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						1211725403612805,
						false
						,[
						[
							7,
							[
								2,
								"x12"
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						4643428448818377,
						false
						,[
						[
							7,
							[
								2,
								"300"
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						793547199904553,
						false
						,[
						[
							1,
							[
								2,
								"F3A"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						2157672085260165,
						false
						,[
						[
							4,
							85
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								20,
								78,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									55
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4447513014997799,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4751428538863232,
						false
						,[
						[
							11,
							"Ryba4"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						9317208204250617,
						false
						,[
						[
							4,
							74
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								5,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
								,[
									0,
									128
								]
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewporttop
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									202
								]
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3637837986689525,
						false
						,[
						[
							4,
							79
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3033777962054593,
						false
						,[
						[
							4,
							80
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						6451033520399932,
						false
						,[
						[
							4,
							81
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						2023789264599425,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						1137923003731008,
						false
						,[
						[
							4,
							78
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						3179138250231841,
						false
						,[
						[
							0,
							[
								0,
								-4
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						360489286712727,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						79,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						5458929068429196,
						false
						,[
						[
							7,
							[
								2,
								"Окунь"
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						415377651159094,
						false
						,[
						[
							7,
							[
								2,
								"x20"
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						5638189063282576,
						false
						,[
						[
							7,
							[
								2,
								"600"
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6429573166070908,
						false
						,[
						[
							1,
							[
								2,
								"F4A"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						4616819987276072,
						false
						,[
						[
							4,
							85
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								20,
								78,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									55
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6439636418772906,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						275567790167445,
						false
						,[
						[
							11,
							"Ryba5"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								18
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						9177914422938705,
						false
						,[
						[
							4,
							74
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								5,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
								,[
									0,
									128
								]
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewporttop
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									202
								]
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						374702512880237,
						false
						,[
						[
							4,
							79
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3871254476591121,
						false
						,[
						[
							4,
							80
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						6232320563141207,
						false
						,[
						[
							4,
							81
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						9436691582168594,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						1828346566605464,
						false
						,[
						[
							4,
							78
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						6544772529518761,
						false
						,[
						[
							0,
							[
								0,
								-4
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2784168006493745,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						79,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						2763877346275736,
						false
						,[
						[
							7,
							[
								2,
								"Чебак"
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						5219273279063072,
						false
						,[
						[
							7,
							[
								2,
								"x18"
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						9223604021017473,
						false
						,[
						[
							7,
							[
								2,
								"1200"
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9854383292728334,
						false
						,[
						[
							1,
							[
								2,
								"F5A"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5828987323437651,
						false
						,[
						[
							4,
							85
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								20,
								78,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									55
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					488869885833553,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5704134407753234,
						false
						,[
						[
							11,
							"Ryba6"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								12
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7666906154531366,
						false
						,[
						[
							4,
							74
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								5,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
								,[
									0,
									128
								]
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewporttop
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									202
								]
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						2911248797598361,
						false
						,[
						[
							4,
							79
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						348959521986952,
						false
						,[
						[
							4,
							80
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						5685852889983661,
						false
						,[
						[
							4,
							81
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						196178680290926,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						8825355972143908,
						false
						,[
						[
							4,
							78
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						4258281973600542,
						false
						,[
						[
							0,
							[
								0,
								-4
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2771488366192632,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						79,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						6522659700937154,
						false
						,[
						[
							7,
							[
								2,
								"Щука"
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						6633741979935024,
						false
						,[
						[
							7,
							[
								2,
								"x12"
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						5676314767205867,
						false
						,[
						[
							7,
							[
								2,
								"1400"
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6289327809884857,
						false
						,[
						[
							1,
							[
								2,
								"F6A"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1013346284682043,
						false
						,[
						[
							4,
							85
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								20,
								78,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									55
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1209481417332567,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3780191684020059,
						false
						,[
						[
							11,
							"Ryba7"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6557696092337421,
						false
						,[
						[
							4,
							74
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								5,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.layoutwidth
									]
									,[
										0,
										2
									]
								]
								,[
									0,
									128
								]
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewporttop
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									202
								]
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						1981636611415338,
						false
						,[
						[
							4,
							79
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7945649297837226,
						false
						,[
						[
							4,
							80
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						1883942602742246,
						false
						,[
						[
							4,
							81
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7427170939903927,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						4296998111357462,
						false
						,[
						[
							4,
							78
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						9124957449499366,
						false
						,[
						[
							0,
							[
								0,
								-4
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9965697037948394,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						79,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						2742622083670065,
						false
						,[
						[
							7,
							[
								2,
								"Речной монстр !"
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						2644834090519365,
						false
						,[
						[
							7,
							[
								2,
								"x1"
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						3960875191252378,
						false
						,[
						[
							7,
							[
								2,
								"2400"
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2359478412321639,
						false
						,[
						[
							1,
							[
								2,
								"F7A"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						3326618178679079,
						false
						,[
						[
							4,
							85
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								20,
								78,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									55
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				439121454406655,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					7053659234726489,
					false
					,[
					[
						4,
						85
					]
					]
				]
				],
				[
				[
					74,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5524465527726236,
					false
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.Destroy,
					null,
					4841632431084687,
					false
				]
,				[
					81,
					cr.plugins_.Text.prototype.acts.Destroy,
					null,
					8686193977282559,
					false
				]
,				[
					79,
					cr.plugins_.Text.prototype.acts.Destroy,
					null,
					7016895208010592,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7118201312894932,
					false
				]
,				[
					78,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1731285635878878,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9016547232643602,
					false
					,[
					[
						0,
						[
							1,
							0.5
						]
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1272596035160459,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6547744310777344,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7844761450982031,
						false
						,[
						[
							11,
							"Ryba1"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						5362263259662963,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								50
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						7162743066681243,
						false
						,[
						[
							7,
							[
								10,
								[
									23,
									"Money"
								]
								,[
									2,
									" $"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9424609511148747,
						false
						,[
						[
							11,
							"Ryba1"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2927932339404751,
						false
						,[
						[
							1,
							[
								2,
								"MoneySave"
							]
						]
,						[
							7,
							[
								23,
								"Money"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5472791688328379,
						false
						,[
						[
							1,
							[
								2,
								"Ryba1S"
							]
						]
,						[
							7,
							[
								23,
								"Ryba1"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6207798792403455,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5764158309040833,
						false
						,[
						[
							11,
							"Ryba2"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6961831237261076,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								200
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3399033858163661,
						false
						,[
						[
							7,
							[
								10,
								[
									23,
									"Money"
								]
								,[
									2,
									" $"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						1292083787392212,
						false
						,[
						[
							11,
							"Ryba2"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						998809552245026,
						false
						,[
						[
							1,
							[
								2,
								"MoneySave"
							]
						]
,						[
							7,
							[
								23,
								"Money"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5636437050327017,
						false
						,[
						[
							1,
							[
								2,
								"Ryba2S"
							]
						]
,						[
							7,
							[
								23,
								"Ryba2"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3182644666039887,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2550655460939573,
						false
						,[
						[
							11,
							"Ryba3"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								12
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						3695832025641243,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								300
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1827257601240762,
						false
						,[
						[
							7,
							[
								10,
								[
									23,
									"Money"
								]
								,[
									2,
									" $"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						3388632458824355,
						false
						,[
						[
							11,
							"Ryba3"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9855128950112824,
						false
						,[
						[
							1,
							[
								2,
								"MoneySave"
							]
						]
,						[
							7,
							[
								23,
								"Money"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3599164571368738,
						false
						,[
						[
							1,
							[
								2,
								"Ryba3S"
							]
						]
,						[
							7,
							[
								23,
								"Ryba3"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4613000353855494,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5275388819368993,
						false
						,[
						[
							11,
							"Ryba4"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						2295699155859279,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								600
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3777311346108776,
						false
						,[
						[
							7,
							[
								10,
								[
									23,
									"Money"
								]
								,[
									2,
									" $"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						8873018418072798,
						false
						,[
						[
							11,
							"Ryba4"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						830166251925321,
						false
						,[
						[
							1,
							[
								2,
								"MoneySave"
							]
						]
,						[
							7,
							[
								23,
								"Money"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8457002479030974,
						false
						,[
						[
							1,
							[
								2,
								"Ryba4S"
							]
						]
,						[
							7,
							[
								23,
								"Ryba4"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2940934969444605,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2786509101249302,
						false
						,[
						[
							11,
							"Ryba5"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								18
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9881386635711541,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								1200
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						5736106866090758,
						false
						,[
						[
							7,
							[
								10,
								[
									23,
									"Money"
								]
								,[
									2,
									" $"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9842746621831349,
						false
						,[
						[
							11,
							"Ryba5"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9283520792399278,
						false
						,[
						[
							1,
							[
								2,
								"MoneySave"
							]
						]
,						[
							7,
							[
								23,
								"Money"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						856782969150619,
						false
						,[
						[
							1,
							[
								2,
								"Ryba5S"
							]
						]
,						[
							7,
							[
								23,
								"Ryba5"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1123781123502826,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6290868981184663,
						false
						,[
						[
							11,
							"Ryba6"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								12
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6234503261112303,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								1400
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1734178745088284,
						false
						,[
						[
							7,
							[
								10,
								[
									23,
									"Money"
								]
								,[
									2,
									" $"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						4279735086252932,
						false
						,[
						[
							11,
							"Ryba6"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6061457396075602,
						false
						,[
						[
							1,
							[
								2,
								"MoneySave"
							]
						]
,						[
							7,
							[
								23,
								"Money"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						50203399228747,
						false
						,[
						[
							1,
							[
								2,
								"Ryba6S"
							]
						]
,						[
							7,
							[
								23,
								"Ryba6"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2832416947323233,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9686307174528688,
						false
						,[
						[
							11,
							"Ryba7"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						124482459386357,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								2400
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1193516892212035,
						false
						,[
						[
							7,
							[
								10,
								[
									23,
									"Money"
								]
								,[
									2,
									" $"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						3517738641272045,
						false
						,[
						[
							11,
							"Ryba7"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						151519105142176,
						false
						,[
						[
							1,
							[
								2,
								"MoneySave"
							]
						]
,						[
							7,
							[
								23,
								"Money"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5718307937753508,
						false
						,[
						[
							1,
							[
								2,
								"Ryba7S"
							]
						]
,						[
							7,
							[
								23,
								"Ryba7"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba0"],
			false,
			null,
			5450530084679968,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5450530084679968,
				false
				,[
				[
					1,
					[
						2,
						"Ryba0"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)8"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)8"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev8"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev8"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													5
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													7
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													9
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													11
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													13
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													15
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													17
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													19
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													21
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													23
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull8"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull8"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							7582154351288541,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							4908568626174108,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Karas ebaniy"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8297587623663723,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										0,
										55
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish1"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba1"],
			false,
			null,
			9178796863036201,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9178796863036201,
				false
				,[
				[
					1,
					[
						2,
						"Ryba1"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3549093675491664,
							false
							,[
							[
								11,
								"accuracyonscreen"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													5
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													7
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													9
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													11
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													13
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													15
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													17
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													19
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													21
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													23
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9071219560582323,
							false
							,[
							[
								4,
								42
							]
,							[
								5,
								[
									0,
									0
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1065648232180835,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							1202406192740118,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							316527638959266,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9699707515039952,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4417945871250869,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3845072587818307,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6456224185793239,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2326295613419589,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6539146712325265,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1170777552934625,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2429569523198691,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								775574594744243,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2480477198340822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6357687901566137,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									42,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1252663421086527,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									4695173181090956,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3212635328546623,
									false
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8271458765984497,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1437982154498837,
									false
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3677849602934717,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7948294646030368,
									false
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									519728362681704,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7674484532087941,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8544226927257097,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6452586166879104,
									false
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7563412844923586,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									4399870525539274,
									false
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7413518047012404,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9803863863265885,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							513716811661922,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							1589544168427495,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Плотва"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8297587623663723,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												1
											]
,[
												0,
												7
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish1"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											80
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								580010895219754,
								false
								,[
								[
									11,
									"Ryba1"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								6586772677888154,
								false
								,[
								[
									1,
									[
										2,
										"Ryba1S"
									]
								]
,								[
									7,
									[
										23,
										"Ryba1"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3731009730276416,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							8519657154477092,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							5936045304349833,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6004801646164516,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5628512099022705,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1723403052291283,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3113760492719211,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								4796801095919675,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2360032301999263,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5759815422353543,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7127123768807209,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9723451282369792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6768980482224279,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								991547926087356,
								[
								[
									10,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									7876838382065539,
									false
									,[
									[
										4,
										42
									]
									]
								]
								],
								[
								[
									44,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3611132123101552,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									44,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1269621956392506,
									false
									,[
									[
										1,
										[
											2,
											"No"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									7469508271362414,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba2"],
			false,
			null,
			8631324695358861,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8631324695358861,
				false
				,[
				[
					1,
					[
						2,
						"Ryba2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)2"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)2"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev2"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev2"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5670348981850058,
							false
							,[
							[
								11,
								"accuracyonscreen"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													9
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													11
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													13
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													15
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													17
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													19
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													21
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													23
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													25
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													27
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9071219560582323,
							false
							,[
							[
								4,
								42
							]
,							[
								5,
								[
									0,
									0
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1065648232180835,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							1202406192740118,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							316527638959266,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9699707515039952,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4417945871250869,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6456224185793239,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3845072587818307,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2326295613419589,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6539146712325265,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1170777552934625,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2429569523198691,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								445093434389352,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2480477198340822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6357687901566137,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									42,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1252663421086527,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									4695173181090956,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3212635328546623,
									false
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8271458765984497,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1437982154498837,
									false
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3677849602934717,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7948294646030368,
									false
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									519728362681704,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7674484532087941,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8544226927257097,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6452586166879104,
									false
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7563412844923586,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									4399870525539274,
									false
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7413518047012404,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9803863863265885,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull2"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull2"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6777490604078144,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							6459253847452675,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Карп"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3533577870469123,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												3
											]
,[
												0,
												10
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish2"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								9956035475661146,
								false
								,[
								[
									11,
									"Ryba2"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								319729850983032,
								false
								,[
								[
									1,
									[
										2,
										"Ryba2S"
									]
								]
,								[
									7,
									[
										23,
										"Ryba2"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3731009730276416,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							8519657154477092,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							5936045304349833,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6004801646164516,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5628512099022705,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1723403052291283,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3113760492719211,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								4796801095919675,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2360032301999263,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5759815422353543,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7127123768807209,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9723451282369792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6768980482224279,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								991547926087356,
								[
								[
									10,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									7876838382065539,
									false
									,[
									[
										4,
										42
									]
									]
								]
								],
								[
								[
									44,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3611132123101552,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									44,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1269621956392506,
									false
									,[
									[
										1,
										[
											2,
											"No"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									7469508271362414,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba3"],
			false,
			null,
			8121143227596866,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8121143227596866,
				false
				,[
				[
					1,
					[
						2,
						"Ryba3"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)3"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)3"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev3"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev3"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1617797134894135,
							false
							,[
							[
								11,
								"accuracyonscreen"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													11
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													13
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													15
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													17
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													19
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													21
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													23
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													25
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													27
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													29
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9071219560582323,
							false
							,[
							[
								4,
								42
							]
,							[
								5,
								[
									0,
									0
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1065648232180835,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							1202406192740118,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							316527638959266,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9699707515039952,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4417945871250869,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6456224185793239,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3845072587818307,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2326295613419589,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6539146712325265,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1170777552934625,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2429569523198691,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4601346961675911,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2480477198340822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6357687901566137,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									42,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1252663421086527,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									4695173181090956,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3212635328546623,
									false
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8271458765984497,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1437982154498837,
									false
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3677849602934717,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7948294646030368,
									false
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									519728362681704,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7674484532087941,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8544226927257097,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6452586166879104,
									false
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7563412844923586,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									4399870525539274,
									false
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7413518047012404,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9803863863265885,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull3"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull3"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							828965645769254,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							2195910767695275,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Ёрш"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8297587623663723,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												17
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish3"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								9669343584839067,
								false
								,[
								[
									11,
									"Ryba3"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								5377834832938392,
								false
								,[
								[
									1,
									[
										2,
										"Ryba3S"
									]
								]
,								[
									7,
									[
										23,
										"Ryba3"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3731009730276416,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							8519657154477092,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							5936045304349833,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6004801646164516,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5628512099022705,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1723403052291283,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3113760492719211,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								4796801095919675,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2360032301999263,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5759815422353543,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7127123768807209,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9723451282369792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6768980482224279,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								991547926087356,
								[
								[
									10,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									7876838382065539,
									false
									,[
									[
										4,
										42
									]
									]
								]
								],
								[
								[
									44,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3611132123101552,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									44,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1269621956392506,
									false
									,[
									[
										1,
										[
											2,
											"No"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									7469508271362414,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba4"],
			false,
			null,
			8357504243746307,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8357504243746307,
				false
				,[
				[
					1,
					[
						2,
						"Ryba4"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)4"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)4"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev4"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev4"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8991908540610811,
							false
							,[
							[
								11,
								"accuracyonscreen"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													13
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													15
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													17
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													19
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													21
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													23
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													25
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													27
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													29
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													31
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9071219560582323,
							false
							,[
							[
								4,
								42
							]
,							[
								5,
								[
									0,
									0
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1065648232180835,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							1202406192740118,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							316527638959266,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9699707515039952,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4417945871250869,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6456224185793239,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3845072587818307,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2326295613419589,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6539146712325265,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1170777552934625,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2429569523198691,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4398164952615339,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2480477198340822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6357687901566137,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									42,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1252663421086527,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									4695173181090956,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3212635328546623,
									false
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8271458765984497,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1437982154498837,
									false
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3677849602934717,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7948294646030368,
									false
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									519728362681704,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7674484532087941,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8544226927257097,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6452586166879104,
									false
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7563412844923586,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									4399870525539274,
									false
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7413518047012404,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9803863863265885,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull4"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull4"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							873139383001281,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							187074685562375,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Окунь"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8297587623663723,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												10
											]
,[
												0,
												40
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish4"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								8906544720619789,
								false
								,[
								[
									11,
									"Ryba4"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								587780524420984,
								false
								,[
								[
									1,
									[
										2,
										"Ryba4S"
									]
								]
,								[
									7,
									[
										23,
										"Ryba4"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3731009730276416,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							8519657154477092,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							5936045304349833,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6004801646164516,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5628512099022705,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1723403052291283,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3113760492719211,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								4796801095919675,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2360032301999263,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5759815422353543,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7127123768807209,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9723451282369792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6768980482224279,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								991547926087356,
								[
								[
									10,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									7876838382065539,
									false
									,[
									[
										4,
										42
									]
									]
								]
								],
								[
								[
									44,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3611132123101552,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									44,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1269621956392506,
									false
									,[
									[
										1,
										[
											2,
											"No"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									7469508271362414,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba5"],
			false,
			null,
			2982444124315829,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2982444124315829,
				false
				,[
				[
					1,
					[
						2,
						"Ryba5"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)5"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)5"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev5"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev5"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3508926037971952,
							false
							,[
							[
								11,
								"accuracyonscreen"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													15
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													17
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													19
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													21
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													23
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													25
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													27
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													27
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													29
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													31
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9071219560582323,
							false
							,[
							[
								4,
								42
							]
,							[
								5,
								[
									0,
									0
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1065648232180835,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							1202406192740118,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							316527638959266,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9699707515039952,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4417945871250869,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6456224185793239,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3845072587818307,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2326295613419589,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6539146712325265,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1170777552934625,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2429569523198691,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								8205665912430874,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2480477198340822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6357687901566137,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									42,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1252663421086527,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									4695173181090956,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3212635328546623,
									false
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8271458765984497,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1437982154498837,
									false
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3677849602934717,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7948294646030368,
									false
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									519728362681704,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7674484532087941,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8544226927257097,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6452586166879104,
									false
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7563412844923586,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									4399870525539274,
									false
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7413518047012404,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9803863863265885,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull5"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull5"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							7140951648195981,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							6748068990582335,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Чебак"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8297587623663723,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												20
											]
,[
												0,
												50
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish5"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								4548472181581834,
								false
								,[
								[
									11,
									"Ryba5"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								1897953858313578,
								false
								,[
								[
									1,
									[
										2,
										"Ryba5S"
									]
								]
,								[
									7,
									[
										23,
										"Ryba5"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3731009730276416,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							8519657154477092,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							5936045304349833,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6004801646164516,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5628512099022705,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1723403052291283,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3113760492719211,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								4796801095919675,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2360032301999263,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5759815422353543,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7127123768807209,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9723451282369792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6768980482224279,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								991547926087356,
								[
								[
									10,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									7876838382065539,
									false
									,[
									[
										4,
										42
									]
									]
								]
								],
								[
								[
									44,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3611132123101552,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									44,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1269621956392506,
									false
									,[
									[
										1,
										[
											2,
											"No"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									7469508271362414,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba6"],
			false,
			null,
			6047284765297247,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6047284765297247,
				false
				,[
				[
					1,
					[
						2,
						"Ryba6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)6"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)6"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev6"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev6"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3508926037971952,
							false
							,[
							[
								11,
								"accuracyonscreen"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													25
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													27
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													29
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													31
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													33
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													35
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													37
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													37
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													39
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													41
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9071219560582323,
							false
							,[
							[
								4,
								42
							]
,							[
								5,
								[
									0,
									0
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1065648232180835,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							1202406192740118,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							316527638959266,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9699707515039952,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4417945871250869,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3845072587818307,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6456224185793239,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2326295613419589,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6539146712325265,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1170777552934625,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2429569523198691,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								8205665912430874,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2480477198340822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6357687901566137,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									42,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1252663421086527,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									4695173181090956,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3212635328546623,
									false
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8271458765984497,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1437982154498837,
									false
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3677849602934717,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7948294646030368,
									false
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									519728362681704,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7674484532087941,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8544226927257097,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6452586166879104,
									false
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7563412844923586,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									4399870525539274,
									false
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7413518047012404,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9803863863265885,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull6"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull6"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							7140951648195981,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							6748068990582335,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Щука"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8297587623663723,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												40
											]
,[
												0,
												70
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish6"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								4548472181581834,
								false
								,[
								[
									11,
									"Ryba6"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								1897953858313578,
								false
								,[
								[
									1,
									[
										2,
										"Ryba6S"
									]
								]
,								[
									7,
									[
										23,
										"Ryba6"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3731009730276416,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							8519657154477092,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							5936045304349833,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6004801646164516,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5628512099022705,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1723403052291283,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3113760492719211,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								4796801095919675,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2360032301999263,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5759815422353543,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7127123768807209,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9723451282369792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6768980482224279,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								991547926087356,
								[
								[
									10,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									7876838382065539,
									false
									,[
									[
										4,
										42
									]
									]
								]
								],
								[
								[
									44,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3611132123101552,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									44,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1269621956392506,
									false
									,[
									[
										1,
										[
											2,
											"No"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									7469508271362414,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Ryba7"],
			false,
			null,
			1921551433577342,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1921551433577342,
				false
				,[
				[
					1,
					[
						2,
						"Ryba7"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Katushka (poimal ne poimal)7"],
				false,
				null,
				3100918284784316,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3100918284784316,
					false
					,[
					[
						1,
						[
							2,
							"Katushka (poimal ne poimal)7"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					[true, "Poklev7"],
					false,
					null,
					2252678665855271,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						2252678665855271,
						false
						,[
						[
							1,
							[
								2,
								"Poklev7"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6161747489170552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9391195845135548,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3508926037971952,
							false
							,[
							[
								11,
								"accuracyonscreen"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7588060731547541,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2343169617905008,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										90
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								90004334585728,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6263019243250785,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									431114352290716,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													29
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9840261777873681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								2034124348082235,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										80
									]
								]
,								[
									0,
									[
										0,
										89
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								4191688308188619,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7291401411853831,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2682135851122912,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													31
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9424872572920646,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								4798612307719104,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										70
									]
								]
,								[
									0,
									[
										0,
										79
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7242495227371457,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5428622536575905,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9735476032839362,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													33
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7811381049403784,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								104450301221956,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										60
									]
								]
,								[
									0,
									[
										0,
										69
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2054339384711834,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7699746351609945,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									8870005897462823,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													35
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7678222009790221,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3426195039171714,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										50
									]
								]
,								[
									0,
									[
										0,
										59
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3324833775464742,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									7002831173853127,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5513261512428641,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													37
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							923118265567011,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3562655440335433,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										49
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3720318517071801,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									5301066170038471,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									6834772163583831,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													39
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7624340805583801,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								7513759487615895,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										30
									]
								]
,								[
									0,
									[
										0,
										39
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								7555980735841706,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									6294482181526781,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9609220475107328,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													41
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2083945939146803,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3873871079044246,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										20
									]
								]
,								[
									0,
									[
										0,
										29
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3210391708748668,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									1270840258227139,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5646340646523701,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													43
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4963972277774766,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								1082711966231634,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3096682729155722,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									3611300151855347,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									5465477292340417,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													45
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8606676318401428,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareBetween,
								null,
								0,
								false,
								false,
								false,
								3553391578941337,
								false
								,[
								[
									0,
									[
										23,
										"Accuracy"
									]
								]
,								[
									0,
									[
										0,
										-100
									]
								]
,								[
									0,
									[
										0,
										9
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								9734197086994214,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Every,
									null,
									0,
									false,
									false,
									false,
									2282104521655278,
									false
									,[
									[
										0,
										[
											1,
											0.25
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									2192450116683093,
									false
									,[
									[
										11,
										"Randomfishvalue"
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													0
												]
,[
													0,
													47
												]
												]
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885908315880333,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1918350377757051,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							436357272934333,
							false
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9071219560582323,
							false
							,[
							[
								4,
								42
							]
,							[
								5,
								[
									0,
									0
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5827416323882749,
							false
							,[
							[
								11,
								"Mode"
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7233007685299773,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
							null,
							1,
							false,
							false,
							false,
							3367421795357738,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4915557102004636,
							false
							,[
							[
								11,
								"fishonscreen"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1065648232180835,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							1202406192740118,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							316527638959266,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9699707515039952,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4417945871250869,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3845072587818307,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6456224185793239,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2326295613419589,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6539146712325265,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1170777552934625,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2429569523198691,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								8205665912430874,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2480477198340822,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6357687901566137,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									42,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1252663421086527,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									4695173181090956,
									false
									,[
									[
										11,
										"Mode"
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3212635328546623,
									false
								]
,								[
									48,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8271458765984497,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									1437982154498837,
									false
								]
,								[
									49,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3677849602934717,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7948294646030368,
									false
								]
,								[
									50,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									519728362681704,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									7674484532087941,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8544226927257097,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6452586166879104,
									false
								]
,								[
									52,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7563412844923586,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									4399870525539274,
									false
								]
,								[
									54,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7413518047012404,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									9803863863265885,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Pull7"],
					false,
					null,
					5228451756673705,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						5228451756673705,
						false
						,[
						[
							1,
							[
								2,
								"Pull7"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7239084014179087,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							6585086627476445,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							1628559183694963,
							false
							,[
							[
								11,
								"Accuracy"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorX,
							"8Direction",
							5564876912034826,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetVectorY,
							"8Direction",
							7237896589627884,
							false
							,[
							[
								0,
								[
									20,
									33,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							10,
							cr.behaviors.EightDir.prototype.acts.SetSpeed,
							"8Direction",
							2083752612636607,
							false
							,[
							[
								0,
								[
									0,
									2000
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5149397145439612,
							false
							,[
							[
								0,
								[
									4,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateCounterclockwise,
							null,
							2860101268597922,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							779201780786794,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6089153052939916,
							false
							,[
							[
								0,
								[
									5,
									[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.AnimationFrame,
										false,
										null
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							13,
							cr.plugins_.Sprite.prototype.acts.RotateClockwise,
							null,
							3285642709490009,
							false
							,[
							[
								0,
								[
									1,
									0.35
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2514870009049415,
						[
						[
							10,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							3762807719891483,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						[
							10,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8164122852795838,
							false
						]
,						[
							12,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6142852231830942,
							false
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5033111414501544,
							false
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							7140951648195981,
							false
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1793971777063533,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							44,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							9096611270808991,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6360995530576789,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							48,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5636150842410151,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6765904518194535,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							50,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7685339285090269,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							51,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7548576692481839,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							1633773013782627,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							54,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							5147801355423498,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Spritefont2.prototype.acts.SetOpacity,
							null,
							6748068990582335,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							504228348893025,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							402778988958888,
							false
							,[
							[
								11,
								"Randomfishvalue"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5577702859435212,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6466060177362653,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3786014009577501,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3998903958767781,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4631571364115179,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6838245759474246,
								false
								,[
								[
									1,
									[
										2,
										"Hook"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1956316747962156,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9069470987685165,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6687854317021853,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3848098729155909,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6438770844898572,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							157058949593746,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								485801517304956,
								false
								,[
								[
									11,
									"Ulov"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1627543629786276,
								false
								,[
								[
									11,
									"Mode"
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3832233809158981,
								false
								,[
								[
									11,
									"FishName"
								]
,								[
									7,
									[
										2,
										"Речной монстр !!!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8297587623663723,
								false
								,[
								[
									11,
									"MoneyCatch"
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												70
											]
,[
												0,
												100
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2630017974597183,
								false
								,[
								[
									4,
									35
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutheight
										]
										,[
											1,
											2.5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8012842985207573,
								false
								,[
								[
									4,
									36
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											4
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								36,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4124837847952826,
								false
								,[
								[
									1,
									[
										2,
										"Fish7"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2522195251141183,
								false
								,[
								[
									4,
									37
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
,								[
									0,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps.viewportbottom
											,[
[
												0,
												4
											]
											]
										]
										,[
											0,
											55
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3214916344304961,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											15
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7220643648184429,
								false
								,[
								[
									4,
									39
								]
,								[
									5,
									[
										0,
										4
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											37,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											122
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											35,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								39,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								153740987340436,
								false
								,[
								[
									7,
									[
										10,
										[
											23,
											"MoneyCatch"
										]
										,[
											2,
											" $"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7883406533147552,
								false
								,[
								[
									7,
									[
										23,
										"FishName"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								4548472181581834,
								false
								,[
								[
									11,
									"Ryba7"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								1897953858313578,
								false
								,[
								[
									1,
									[
										2,
										"Ryba7S"
									]
								]
,								[
									7,
									[
										23,
										"Ryba7"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3731009730276416,
						[
						[
							1,
							cr.plugins_.Touch.prototype.cnds.OnTouchObject,
							null,
							1,
							false,
							false,
							false,
							8519657154477092,
							false
							,[
							[
								4,
								33
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							true,
							null,
							5936045304349833,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6004801646164516,
								false
								,[
								[
									1,
									[
										2,
										"Yes2"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5628512099022705,
								false
								,[
								[
									1,
									[
										2,
										"Yes3"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1723403052291283,
								false
								,[
								[
									1,
									[
										2,
										"Yes4"
									]
								]
								]
							]
,							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								3113760492719211,
								false
								,[
								[
									1,
									[
										2,
										"Yes1"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								4796801095919675,
								false
								,[
								[
									4,
									10
								]
,								[
									3,
									3
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2360032301999263,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5759815422353543,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							[
								42,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7127123768807209,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9723451282369792,
							[
							[
								10,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								6768980482224279,
								false
								,[
								[
									1,
									[
										2,
										"Based"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								991547926087356,
								[
								[
									10,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									7876838382065539,
									false
									,[
									[
										4,
										42
									]
									]
								]
								],
								[
								[
									44,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									3611132123101552,
									false
									,[
									[
										4,
										53
									]
,									[
										5,
										[
											0,
											4
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									44,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1269621956392506,
									false
									,[
									[
										1,
										[
											2,
											"No"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									7469508271362414,
									false
									,[
									[
										11,
										"VidNazhivki"
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Bait"],
			false,
			null,
			598252451762901,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				598252451762901,
				false
				,[
				[
					1,
					[
						2,
						"Bait"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6540054556164785,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1633724421576146,
					false
					,[
					[
						4,
						44
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6159133246848627,
					false
					,[
					[
						1,
						[
							2,
							"Targeting (push poplavok)"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					6656493449097882,
					false
					,[
					[
						4,
						45
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					709029574018727,
					false
					,[
					[
						4,
						46
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutwidth
							]
							,[
								0,
								2
							]
						]
					]
,					[
						0,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps.viewporttop
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								25
							]
						]
					]
					]
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6004966962910574,
					false
					,[
					[
						4,
						55
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2049384687867073,
					false
					,[
					[
						4,
						61
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							55,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								55,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6438697840178548,
					false
					,[
					[
						4,
						56
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4595468390822678,
					false
					,[
					[
						4,
						62
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							56,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								56,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6725667752555126,
					false
					,[
					[
						4,
						57
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					4351457395785609,
					false
					,[
					[
						4,
						63
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							57,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								57,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8770488899254602,
					false
					,[
					[
						4,
						58
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							4
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					7278047491450427,
					false
					,[
					[
						4,
						64
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							58,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								58,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8828509766260849,
					false
					,[
					[
						4,
						59
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					5688886226053469,
					false
					,[
					[
						4,
						65
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							59,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								59,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					5727924538657432,
					false
					,[
					[
						4,
						60
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							6
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					39242598742515,
					false
					,[
					[
						4,
						66
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							60,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								60,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					3592068077330456,
					false
					,[
					[
						4,
						47
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							46,
							cr.plugins_.Sprite.prototype.exps.ImagePointX,
							false,
							null
							,[
[
								0,
								7
							]
							]
						]
					]
,					[
						0,
						[
							20,
							46,
							cr.plugins_.Sprite.prototype.exps.ImagePointY,
							false,
							null
							,[
[
								0,
								7
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					69272209542753,
					false
					,[
					[
						4,
						68
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							20,
							46,
							cr.plugins_.Sprite.prototype.exps.ImagePointX,
							false,
							null
							,[
[
								0,
								8
							]
							]
						]
					]
,					[
						0,
						[
							20,
							46,
							cr.plugins_.Sprite.prototype.exps.ImagePointY,
							false,
							null
							,[
[
								0,
								8
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9967007077990862,
					false
					,[
					[
						4,
						67
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							4,
							[
								20,
								68,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								0,
								45
							]
						]
					]
,					[
						0,
						[
							5,
							[
								20,
								68,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								0,
								48
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6310666549710831,
					false
					,[
					[
						7,
						[
							10,
							[
								23,
								"Money"
							]
							,[
								2,
								"$"
							]
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6216139037239771,
					false
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4838364699396139,
					false
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8413027844733479,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5883068289075091,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8789008631051481,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3571663301233418,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9110458917436672,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9447910673879781,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1065941701382511,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5837734727630042,
					false
				]
,				[
					4,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					4980608020704902,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				282436238605703,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					241923812231283,
					false
					,[
					[
						4,
						55
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7550015973403518,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					462159432382084,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4629334369519494,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1649608637845046,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						4489540308362412,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1475217763610105,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6989201776564228,
					false
					,[
					[
						4,
						56
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8275325684717708,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3458223927254005,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4902248990500897,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5558228440252243,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8045865261159205,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						9965653929803429,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1043585870626041,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6832673125495071,
					false
					,[
					[
						4,
						57
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1023553137701043,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8707802861849558,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1175287879608732,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						633003276513611,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								80
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1818456463918789,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						7696216353156088,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								80
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2861179867792615,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					3417416658382735,
					false
					,[
					[
						4,
						58
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9469617483623919,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5030224711753306,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						559786630157921,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5627928776990488,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								160
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3612871160536643,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						6980909672434446,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								160
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8774798654268844,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6639564676795574,
					false
					,[
					[
						4,
						59
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1132207833731633,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1270767773879003,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4026900508838312,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6139553260952933,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								240
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5988854214918016,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						4729535900789527,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								240
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1577132906960661,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					7805279648449457,
					false
					,[
					[
						4,
						60
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6220578626666729,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3978340606763186,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1744398514572955,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6787223313245791,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								300
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8956985220745377,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						7788881759374792,
						false
						,[
						[
							11,
							"Money"
						]
,						[
							7,
							[
								0,
								300
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7166819953298682,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					9468239686755619,
					false
					,[
					[
						4,
						47
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5993872259763537,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1845689520487843,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8339944682682628,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
					],
					[
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6315327084655174,
				[
				[
					45,
					cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
					null,
					1,
					false,
					false,
					false,
					2744263620767727,
					false
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8615113419981098,
					false
				]
,				[
					47,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1856891157173523,
					false
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1056531472902417,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2258385051810698,
					false
					,[
					[
						4,
						33
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportright
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								1
							]
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportbottom
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								1
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1394854788226134,
					false
					,[
					[
						4,
						44
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps.viewportleft
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								6
							]
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportbottom
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								6
							]
						]
					]
					]
				]
,				[
					55,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2933706492102434,
					false
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2924397367180564,
					false
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8096543992727353,
					false
				]
,				[
					58,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6834487154672858,
					false
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					196628797523159,
					false
				]
,				[
					60,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					34897752887906,
					false
				]
,				[
					61,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					7988070541877305,
					false
				]
,				[
					62,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					5329559816599821,
					false
				]
,				[
					63,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					4721613138855813,
					false
				]
,				[
					64,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					2862350344908639,
					false
				]
,				[
					65,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					6531590541878707,
					false
				]
,				[
					66,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					6959798769687053,
					false
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					812319273517469,
					false
				]
,				[
					68,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3059733012950996,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					968375200045805,
					false
					,[
					[
						0,
						[
							1,
							0.5
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9332460881865505,
					false
					,[
					[
						1,
						[
							2,
							"Targeting (push poplavok)"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2716335071736392,
					false
					,[
					[
						4,
						83
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							0,
							91
						]
					]
,					[
						0,
						[
							0,
							32
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2060511125176482,
					false
					,[
					[
						4,
						67
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							0,
							153
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportbottom
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								93
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1057892753352394,
					false
					,[
					[
						7,
						[
							10,
							[
								23,
								"Money"
							]
							,[
								2,
								"$"
							]
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					8995665732177444,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1969593221481983,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2546088450621708,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						319520187612406,
						false
						,[
						[
							4,
							53
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1699379383043581,
						false
						,[
						[
							1,
							[
								2,
								"No"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5913017840006484,
						false
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7644017554626368,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						605808208398561,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1415048254509048,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6546380073948968,
						false
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1809962164581902,
						false
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3022905341154804,
						false
						,[
						[
							1,
							[
								2,
								"VidNazivkiS"
							]
						]
,						[
							7,
							[
								23,
								"VidNazhivki"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3262325030483366,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5310167106716359,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3047968659024049,
						false
						,[
						[
							4,
							48
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3210240859294751,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						3468814321927242,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						219449430186507,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						4127325738968222,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1948151927323192,
						false
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5706016623817268,
						false
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7105620713020421,
						false
						,[
						[
							1,
							[
								2,
								"VidNazivkiS"
							]
						]
,						[
							7,
							[
								23,
								"VidNazhivki"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2109612738165357,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						354370936725557,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7732756886159602,
						false
						,[
						[
							4,
							49
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						839171108083018,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7749608523053821,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5649262442687125,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9829958328231908,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8974972881136573,
						false
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1434893667286786,
						false
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7451949641716049,
						false
						,[
						[
							1,
							[
								2,
								"VidNazivkiS"
							]
						]
,						[
							7,
							[
								23,
								"VidNazhivki"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9536140144359718,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8820934720636093,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						1518822718717324,
						false
						,[
						[
							4,
							50
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3684900113675294,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1901055114072262,
						false
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8623266880540975,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						932689031703777,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7271678689799989,
						false
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9185169456520244,
						false
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1542601184613987,
						false
						,[
						[
							1,
							[
								2,
								"VidNazivkiS"
							]
						]
,						[
							7,
							[
								23,
								"VidNazhivki"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9233866768425634,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						669209437220719,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3342071130996918,
						false
						,[
						[
							4,
							51
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						7927845164484481,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6391367029183326,
						false
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						3265359780733764,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5802748095720213,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9829625648558111,
						false
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6673616800885462,
						false
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8100000370300115,
						false
						,[
						[
							1,
							[
								2,
								"VidNazivkiS"
							]
						]
,						[
							7,
							[
								23,
								"VidNazhivki"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1932735740713034,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6736431941155127,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						8481866061995969,
						false
						,[
						[
							4,
							52
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5331215552541554,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7614127962852272,
						false
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5570638172554367,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						599438654685629,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5935748975429913,
						false
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						4325312391326261,
						false
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						453662687974627,
						false
						,[
						[
							1,
							[
								2,
								"VidNazivkiS"
							]
						]
,						[
							7,
							[
								23,
								"VidNazhivki"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9122562405635049,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9024075955133992,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						4674373251813287,
						false
						,[
						[
							4,
							54
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						317954818455732,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						48,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5713354099707545,
						false
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6396170409686457,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7662073984542468,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5933211259201092,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5823587027439253,
						false
					]
,					[
						0,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2427800433051665,
						false
						,[
						[
							1,
							[
								2,
								"VidNazivkiS"
							]
						]
,						[
							7,
							[
								23,
								"VidNazhivki"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Dengy"],
			false,
			null,
			8088086467496266,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8088086467496266,
				false
				,[
				[
					1,
					[
						2,
						"Dengy"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9419299025131783,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					3400614334051443,
					false
				]
				],
				[
				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4154777881290703,
					false
					,[
					[
						7,
						[
							10,
							[
								23,
								"Money"
							]
							,[
								2,
								"$"
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Timer"],
			false,
			null,
			2975460049709563,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2975460049709563,
				false
				,[
				[
					1,
					[
						2,
						"Timer"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3896922900628498,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					3437952923856154,
					false
					,[
					[
						0,
						[
							1,
							0.0625
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
					null,
					0,
					false,
					false,
					false,
					2604398399519778,
					false
					,[
					[
						4,
						10
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1176046621757075,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						7,
						[
							1,
							0.0625
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Time"],
			false,
			null,
			4951524182045621,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4951524182045621,
				false
				,[
				[
					1,
					[
						2,
						"Time"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				1520687292128189,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					9328267644945307,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8980792584491152,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5244618700238066,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							7
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2658698125960823,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9187579248317322,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9128959417836272,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					185701639410535,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8899962088832588,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					7403304894515143,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3044424305945883,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8834617555472547,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4181541531605372,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					3989595503485537,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9120142596043148,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					3714213054186116,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7523144647925745,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					4424568203909027,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1474813533232763,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3849252512213858,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					706080882160521,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2735459054740021,
					false
					,[
					[
						1,
						[
							2,
							"VidNazivkiS"
						]
					]
,					[
						7,
						[
							23,
							"VidNazhivki"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9879149251686387,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9654855131881128,
						false
						,[
						[
							11,
							"Vibro"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Browser.prototype.acts.Vibrate,
						null,
						1732220929323566,
						false
						,[
						[
							1,
							[
								2,
								"200,100,200"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2023897337437715,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5162658600047443,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7815771287281815,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					407703688078899,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2237406003254305,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4857971384323923,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					550773992265071,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8561038995715835,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5191812459407075,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					3762227824255442,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1564797610352438,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					1420409519103616,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7155979281195494,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8066776805405742,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4160115241895317,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8345542793124945,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5362140913293663,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6640769341394469,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9020141748158494,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8700015064480225,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4838979579275872,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					718386373542931,
					false
					,[
					[
						1,
						[
							2,
							"VidNazivkiS"
						]
					]
,					[
						7,
						[
							23,
							"VidNazhivki"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4802727812262187,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7292068042784947,
						false
						,[
						[
							11,
							"Vibro"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Browser.prototype.acts.Vibrate,
						null,
						1013204746868266,
						false
						,[
						[
							1,
							[
								2,
								"200,100,200"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5186988979829452,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5122942101734471,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6782203735482854,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2221950575700158,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2145058332510511,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7468022180456304,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4252300199439014,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9325616214626161,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1899625036615541,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					7944678814110881,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4373499480811492,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6755834993984519,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2211018041880471,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					2312468712614053,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3519735682794876,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					590263867686792,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					288414332775465,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8118915343163063,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3076774254780282,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8850220002805882,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6511383990340947,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6663814172906519,
					false
					,[
					[
						1,
						[
							2,
							"VidNazivkiS"
						]
					]
,					[
						7,
						[
							23,
							"VidNazhivki"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					342998261311646,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2024779537227873,
						false
						,[
						[
							11,
							"Vibro"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Browser.prototype.acts.Vibrate,
						null,
						3317745904996742,
						false
						,[
						[
							1,
							[
								2,
								"200,100,200"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				580381966357406,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					863379996920556,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6222501378265977,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							4
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6518760901938915,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							1,
							0.75
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1019141234271922,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					815989704516394,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4580369712561996,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					2576009664657908,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2525086583910409,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					1444699937574733,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7174069630906975,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					1904623373351648,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4415193594357573,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8489393948987957,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7484148799570151,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6744620683766916,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8437299218312981,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					5783484947481573,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					910620197570533,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9328673360397834,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6968397300960566,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5186865644779264,
					false
					,[
					[
						1,
						[
							2,
							"VidNazivkiS"
						]
					]
,					[
						7,
						[
							23,
							"VidNazhivki"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8889913591949633,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6640036710494342,
						false
						,[
						[
							11,
							"Vibro"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Browser.prototype.acts.Vibrate,
						null,
						296816312500948,
						false
						,[
						[
							1,
							[
								2,
								"200,100,200"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3682997813527958,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2185469610125014,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7818215594391301,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8200295262048194,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							1,
							0.625
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					663255711035667,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7155136268982664,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7933358186639287,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8846983988440914,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7199849475135259,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					8233026732607855,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9794279078644611,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					3540331416770402,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5604026210599328,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					4868081476995024,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8745178566116839,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					7354850824957667,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4599527283599545,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6587431001915138,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5967874538217407,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2366216691737718,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5927230084775646,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					9668510919025043,
					false
					,[
					[
						1,
						[
							2,
							"VidNazivkiS"
						]
					]
,					[
						7,
						[
							23,
							"VidNazhivki"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3751625306074094,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2342934312643109,
						false
						,[
						[
							11,
							"Vibro"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Browser.prototype.acts.Vibrate,
						null,
						8770048843654328,
						false
						,[
						[
							1,
							[
								2,
								"200,100,200"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7703295913448331,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6999715237684335,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					375078736414395,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							6
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5150331865528084,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							1,
							0.5625
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5810138863455901,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					457692710363559,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					669053836074781,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					57436821776419,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6541341939364064,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9629370923248431,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3619867456118945,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					5631173080936411,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8567597636719777,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					4822246568677023,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8188928070738466,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					183392452141652,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8511766518491168,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					1123678412616477,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6555327394132441,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8396861316044399,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9715616357903807,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5467937980863044,
					false
					,[
					[
						1,
						[
							2,
							"VidNazivkiS"
						]
					]
,					[
						7,
						[
							23,
							"VidNazhivki"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5015321150540612,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3243985117164783,
						false
						,[
						[
							11,
							"Vibro"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Browser.prototype.acts.Vibrate,
						null,
						311275961217657,
						false
						,[
						[
							1,
							[
								2,
								"200,100,200"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8371930840815699,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4917345452529498,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1870558875229402,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						8,
						1
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1808963943860721,
					false
					,[
					[
						11,
						"Timer"
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							1,
							0.1875
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1688083478112272,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3325589556579347,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					37274515930519,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9286743084545532,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6783072004025559,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9845403984673642,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					382612268273671,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9450995686764861,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6050804303793179,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9702284786587332,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8837180087145257,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					6723050186804211,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5463483600192645,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					279091818854783,
					false
					,[
					[
						4,
						53
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5141535188940875,
					false
					,[
					[
						11,
						"Mode"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1654885961402058,
					false
					,[
					[
						11,
						"Ulov"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8248020201105661,
					false
					,[
					[
						11,
						"VidNazhivki"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6207588054185532,
					false
					,[
					[
						1,
						[
							2,
							"VidNazivkiS"
						]
					]
,					[
						7,
						[
							23,
							"VidNazhivki"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1847896207210343,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1311427224055316,
						false
						,[
						[
							11,
							"Vibro"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Browser.prototype.acts.Vibrate,
						null,
						4155353954043145,
						false
						,[
						[
							1,
							[
								2,
								"200,100,200"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5375530369659616,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4136095025822561,
					false
					,[
					[
						4,
						33
					]
					]
				]
,				[
					10,
					cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
					null,
					0,
					false,
					false,
					false,
					3793735014688035,
					false
					,[
					[
						4,
						42
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8019781513721089,
					false
					,[
					[
						1,
						[
							2,
							"Timer"
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Pause"],
			false,
			null,
			4038483984029094,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4038483984029094,
				false
				,[
				[
					1,
					[
						2,
						"Pause"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3689534112824375,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					8833782166199093,
					false
					,[
					[
						4,
						83
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					4506597183237686,
					false
					,[
					[
						1,
						[
							2,
							"Targeting (push poplavok)"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1571229415884544,
					false
					,[
					[
						4,
						70
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							4,
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
								,[
									0,
									2
								]
							]
							,[
								0,
								183
							]
						]
					]
,					[
						0,
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutheight
							]
							,[
								0,
								2
							]
						]
					]
					]
				]
,				[
					70,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					1680354389854576,
					false
					,[
					[
						4,
						71
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					70,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					7462326484222126,
					false
					,[
					[
						4,
						84
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
,				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7441178564911601,
					false
					,[
					[
						1,
						[
							2,
							"Default"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					84,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7565121284658731,
					false
					,[
					[
						1,
						[
							2,
							"Default"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1581319361559417,
					false
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4029478932833432,
					false
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.Destroy,
					null,
					5549613472172237,
					false
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6483848857274511,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					3904345537566631,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					1886575330374145,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					883727226144317,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					7834004297538171,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					6065428466663375,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					2644664005442874,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					2391047626047717,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					6613571133044925,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2793677958585403,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					8611210533356688,
					false
					,[
					[
						4,
						71
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					4000278547715808,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7453635780354531,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9022752222725183,
					false
					,[
					[
						0,
						[
							1,
							0.6
						]
					]
					]
				]
,				[
					71,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4484185001477578,
					false
				]
,				[
					84,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4171948256617961,
					false
				]
,				[
					70,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3367665343966663,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1306629392264857,
					false
					,[
					[
						4,
						33
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportright
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								1
							]
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportbottom
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								1
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4991968158066393,
					false
					,[
					[
						0,
						[
							1,
							0.5
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					3306638081134813,
					false
					,[
					[
						1,
						[
							2,
							"Targeting (push poplavok)"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1332451959004474,
					false
					,[
					[
						4,
						83
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							0,
							91
						]
					]
,					[
						0,
						[
							0,
							32
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1505850011246709,
					false
					,[
					[
						4,
						67
					]
,					[
						5,
						[
							0,
							4
						]
					]
,					[
						0,
						[
							0,
							153
						]
					]
,					[
						0,
						[
							5,
							[
								19,
								cr.system_object.prototype.exps.viewportbottom
								,[
[
									0,
									4
								]
								]
							]
							,[
								0,
								93
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					2595414935110016,
					false
					,[
					[
						7,
						[
							10,
							[
								23,
								"Money"
							]
							,[
								2,
								"$"
							]
						]
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					1964584857397313,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					6509010210159347,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					4102838112205262,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					1816598129394741,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					3615254582647787,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					5726498497864539,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetOpacity,
					null,
					4688815513632501,
					false
					,[
					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					8054880889921855,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					2142650936681814,
					false
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					4120556898415326,
					false
				]
,				[
					50,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					5160486173483366,
					false
				]
,				[
					51,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					2528998341084582,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					4588117536031869,
					false
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					6647986954395686,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9296836964131458,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3926339077585938,
						false
						,[
						[
							11,
							"Mode"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8936808875864467,
						false
						,[
						[
							4,
							44
						]
,						[
							5,
							[
								0,
								4
							]
						]
,						[
							0,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.viewportleft
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.viewportbottom
									,[
[
										0,
										4
									]
									]
								]
								,[
									0,
									6
								]
							]
						]
						]
					]
,					[
						53,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						647024675811592,
						false
					]
,					[
						48,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						9303770755844525,
						false
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						6609947650967903,
						false
					]
,					[
						50,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						1784042715526602,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						2990748128571863,
						false
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						2173174441056743,
						false
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						3218995892116012,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4122137086031193,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					3803876011271336,
					false
					,[
					[
						4,
						84
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					4793485974465455,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					84,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					8466538698253671,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6822109641952205,
					false
					,[
					[
						0,
						[
							1,
							0.7
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					1856068757408878,
					false
					,[
					[
						6,
						"Start"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5848557508412424,
				[
				[
					44,
					cr.plugins_.Sprite.prototype.cnds.OnCreated,
					null,
					1,
					false,
					false,
					false,
					8111123526986745,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5404828036477882,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						538541794356631,
						false
						,[
						[
							11,
							"VidNazhivki"
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9183670797371461,
						false
						,[
						[
							1,
							[
								2,
								"Yes"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Start",
		[
		[
			1,
			"Achivment",
			0,
			1,
false,false,5951110774711795,false
		]
,		[
			1,
			"Ryba1",
			0,
			0,
false,false,2324760830065596,false
		]
,		[
			1,
			"Ryba2",
			0,
			0,
false,false,2249232831736807,false
		]
,		[
			1,
			"Ryba3",
			0,
			0,
false,false,1239306083084863,false
		]
,		[
			1,
			"Ryba4",
			0,
			0,
false,false,767233873704187,false
		]
,		[
			1,
			"Ryba5",
			0,
			0,
false,false,6399565191014597,false
		]
,		[
			1,
			"Ryba6",
			0,
			0,
false,false,8627520193035277,false
		]
,		[
			1,
			"Ryba7",
			0,
			0,
false,false,8920587403305796,false
		]
,		[
			0,
			null,
			false,
			null,
			6092229367095721,
			[
			[
				4,
				cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,
				null,
				1,
				false,
				false,
				false,
				5527847203612596,
				false
			]
			],
			[
			[
				4,
				cr.plugins_.CJSAds.prototype.acts.HideBanner,
				null,
				3033754117954564,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8308571410516066,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				5537956936752786,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7465973805563931,
				false
				,[
				[
					4,
					69
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
						,[
							0,
							2
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							2
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				7006339459372971,
				false
				,[
				[
					0,
					[
						19,
						cr.system_object.prototype.exps.viewportbottom
						,[
[
							0,
							0
						]
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				6068757847247239,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				6249969424110081,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							16
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				22534204060581,
				false
				,[
				[
					0,
					[
						19,
						cr.system_object.prototype.exps.viewportbottom
						,[
[
							0,
							0
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				931131825727753,
				false
				,[
				[
					4,
					70
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							50
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							3
						]
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetPos,
				null,
				496529650348905,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							5
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							2
						]
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				3639609245632772,
				false
				,[
				[
					4,
					71
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				9105729429299275,
				false
				,[
				[
					4,
					72
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						2
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				8614440108014744,
				false
				,[
				[
					4,
					73
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				2856284699605712,
				false
				,[
				[
					4,
					74
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							110
						]
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							45
						]
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				3321383710654452,
				false
				,[
				[
					4,
					75
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				4494814789722358,
				false
				,[
				[
					4,
					76
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						2
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				1856023180029914,
				false
				,[
				[
					4,
					77
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				8933713084328554,
				false
				,[
				[
					4,
					79
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						4
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				7389543833615382,
				false
				,[
				[
					4,
					80
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						5
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				5607765300487576,
				false
				,[
				[
					4,
					81
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						6
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				7841253075106245,
				false
				,[
				[
					4,
					82
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						7
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				6411698830291023,
				false
				,[
				[
					4,
					78
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						8
					]
				]
				]
			]
,			[
				78,
				cr.plugins_.Sprite.prototype.acts.SetAngle,
				null,
				7280924713192781,
				false
				,[
				[
					0,
					[
						0,
						-4
					]
				]
				]
			]
,			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				3665366646183755,
				false
				,[
				[
					1,
					[
						2,
						"Default"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				8894786053301727,
				false
				,[
				[
					1,
					[
						2,
						"Default"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				2593929983673263,
				false
				,[
				[
					1,
					[
						2,
						"Default"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				8702020132339534,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					8759372807013117,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba1S"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8767569254846109,
					false
					,[
					[
						11,
						"Ryba1"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba1S"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					867506783336234,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4964623338378224,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					8103424984277396,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba2S"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3140507508667321,
					false
					,[
					[
						11,
						"Ryba2"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba2S"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					3523555245101885,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5518523149130726,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					8340510781306266,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba3S"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2430846349329812,
					false
					,[
					[
						11,
						"Ryba3"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba3S"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9948414484916159,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1872030591803729,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					5249576880636333,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba4S"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2099573448700829,
					false
					,[
					[
						11,
						"Ryba4"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba4S"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					8206062493967893,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4872148775054425,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					5569390904783152,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba5S"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3433673138932696,
					false
					,[
					[
						11,
						"Ryba5"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba5S"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6219871364692701,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				301563659383182,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					8407295605807763,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba6S"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					212770348669077,
					false
					,[
					[
						11,
						"Ryba6"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba6S"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6926674585039312,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2348260550277352,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1281421988790927,
					false
					,[
					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba7S"
							]
							]
						]
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3286827806105945,
					false
					,[
					[
						11,
						"Ryba7"
					]
,					[
						7,
						[
							20,
							0,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"Ryba7S"
							]
							]
						]
					]
					]
				]
,				[
					67,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					8135505953979483,
					false
					,[
					[
						7,
						[
							23,
							"Money"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9991341772709575,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				7149921873734711,
				false
				,[
				[
					11,
					"Achivment"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				2029806617100195,
				false
				,[
				[
					7,
					[
						2,
						"Плотва"
					]
				]
				]
			]
,			[
				80,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				7128876002398719,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Осталось: x"
						]
						,[
							5,
							[
								0,
								5
							]
							,[
								23,
								"Ryba1"
							]
						]
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				2928957279255748,
				false
				,[
				[
					7,
					[
						2,
						"50"
					]
				]
				]
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				1300023184477726,
				false
				,[
				[
					1,
					[
						2,
						"F1"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				539898923282369,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9330080518197746,
					false
					,[
					[
						11,
						"Ryba1"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9945434744168134,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6452076499766669,
					false
					,[
					[
						1,
						[
							2,
							"F1A"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					6853370888615173,
					false
					,[
					[
						7,
						[
							2,
							"5"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7628527137180794,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					3967117108005101,
					false
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6126724258052476,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4591076649587583,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				9542640692717403,
				false
				,[
				[
					11,
					"Achivment"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						2
					]
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				3497533817245506,
				false
				,[
				[
					7,
					[
						2,
						"Карп"
					]
				]
				]
			]
,			[
				80,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				8996887905584712,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Осталось: x"
						]
						,[
							5,
							[
								0,
								7
							]
							,[
								23,
								"Ryba2"
							]
						]
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				2669701842684748,
				false
				,[
				[
					7,
					[
						2,
						"200"
					]
				]
				]
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				1254225574910826,
				false
				,[
				[
					1,
					[
						2,
						"F2"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				6151797750496154,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					3257826141557371,
					false
					,[
					[
						11,
						"Ryba2"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							7
						]
					]
					]
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9174374002633456,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1153440034938499,
					false
					,[
					[
						1,
						[
							2,
							"F2A"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					917444333863788,
					false
					,[
					[
						7,
						[
							2,
							"7"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1580553008594868,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					2634888254384783,
					false
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9224954408374804,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1275596507767226,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				9982176212360608,
				false
				,[
				[
					11,
					"Achivment"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				1610086544644969,
				false
				,[
				[
					7,
					[
						2,
						"Ёрш"
					]
				]
				]
			]
,			[
				80,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				6964925183309551,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Осталось: x"
						]
						,[
							5,
							[
								0,
								12
							]
							,[
								23,
								"Ryba3"
							]
						]
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				4703702686786432,
				false
				,[
				[
					7,
					[
						2,
						"300"
					]
				]
				]
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				5702532192580061,
				false
				,[
				[
					1,
					[
						2,
						"F3"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				56776156456839,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					3939506025688906,
					false
					,[
					[
						11,
						"Ryba3"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							12
						]
					]
					]
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7973275196016606,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9854933640822127,
					false
					,[
					[
						1,
						[
							2,
							"F3A"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					8060074530794797,
					false
					,[
					[
						7,
						[
							2,
							"12"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7976206810734247,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					2039922966675493,
					false
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7419262250946963,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3471012149624689,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				1906544323422612,
				false
				,[
				[
					11,
					"Achivment"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						4
					]
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				5268946437013933,
				false
				,[
				[
					7,
					[
						2,
						"Окунь"
					]
				]
				]
			]
,			[
				80,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				259725349073577,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Осталось: x"
						]
						,[
							5,
							[
								0,
								20
							]
							,[
								23,
								"Ryba4"
							]
						]
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				1145705153486415,
				false
				,[
				[
					7,
					[
						2,
						"600"
					]
				]
				]
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				4949854520728584,
				false
				,[
				[
					1,
					[
						2,
						"F4"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				4409685354745164,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6320171842057909,
					false
					,[
					[
						11,
						"Ryba4"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					435964813902378,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					4000322909708571,
					false
					,[
					[
						1,
						[
							2,
							"F4A"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					9084564295552322,
					false
					,[
					[
						7,
						[
							2,
							"20"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5001651889296304,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					4121420574119616,
					false
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6560251162294901,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8007208816733673,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				9205958443402881,
				false
				,[
				[
					11,
					"Achivment"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						5
					]
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				6242687311076984,
				false
				,[
				[
					7,
					[
						2,
						"Чебак"
					]
				]
				]
			]
,			[
				80,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				8259142279066153,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Осталось: x"
						]
						,[
							5,
							[
								0,
								18
							]
							,[
								23,
								"Ryba5"
							]
						]
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				6931145526154192,
				false
				,[
				[
					7,
					[
						2,
						"1200"
					]
				]
				]
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				8079362830920123,
				false
				,[
				[
					1,
					[
						2,
						"F5"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				614121148381663,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7797629374823868,
					false
					,[
					[
						11,
						"Ryba5"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							18
						]
					]
					]
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7836177558613417,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					5844951795849701,
					false
					,[
					[
						1,
						[
							2,
							"F5A"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					9815921378114437,
					false
					,[
					[
						7,
						[
							2,
							"18"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9235337296342549,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					7957295118516386,
					false
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2636862923815476,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7858460006374486,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				4276963056121857,
				false
				,[
				[
					11,
					"Achivment"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						6
					]
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				4555339007496902,
				false
				,[
				[
					7,
					[
						2,
						"Щука"
					]
				]
				]
			]
,			[
				80,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				4798331911433616,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Осталось: x"
						]
						,[
							5,
							[
								0,
								12
							]
							,[
								23,
								"Ryba6"
							]
						]
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				4656181288646068,
				false
				,[
				[
					7,
					[
						2,
						"1400"
					]
				]
				]
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				3878621868787613,
				false
				,[
				[
					1,
					[
						2,
						"F6"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				9221399501304154,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2424894733632973,
					false
					,[
					[
						11,
						"Ryba6"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							10
						]
					]
					]
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7264153334048121,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					4004273931827036,
					false
					,[
					[
						1,
						[
							2,
							"F6A"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					9471316594038393,
					false
					,[
					[
						7,
						[
							2,
							"10"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5868916223115845,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					5262909557875247,
					false
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5070906353095217,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8355628531346117,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				3380853469045173,
				false
				,[
				[
					11,
					"Achivment"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						7
					]
				]
				]
			]
			],
			[
			[
				79,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				5551815405990904,
				false
				,[
				[
					7,
					[
						2,
						"Речной монстр"
					]
				]
				]
			]
,			[
				80,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				2346869335237701,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Осталось: x"
						]
						,[
							5,
							[
								0,
								1
							]
							,[
								23,
								"Ryba7"
							]
						]
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				7016836775885996,
				false
				,[
				[
					7,
					[
						2,
						"2400"
					]
				]
				]
			]
,			[
				82,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				4341718455378759,
				false
				,[
				[
					1,
					[
						2,
						"F7"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				6932206333182326,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5692398681588614,
					false
					,[
					[
						11,
						"Ryba7"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8781760573472636,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1899419563678088,
					false
					,[
					[
						1,
						[
							2,
							"F7A"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					80,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					5470833835977953,
					false
					,[
					[
						7,
						[
							2,
							"1"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				975534964891732,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					4139967835590324,
					false
				]
				],
				[
				[
					78,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5309214571397627,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "levopravo"],
			false,
			null,
			6486985991982442,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6486985991982442,
				false
				,[
				[
					1,
					[
						2,
						"levopravo"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				566981012606291,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					392090508892336,
					false
					,[
					[
						4,
						77
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1234562686078064,
					false
					,[
					[
						11,
						"Achivment"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8272564635523438,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8108910938039592,
						false
						,[
						[
							11,
							"Achivment"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9688238606744937,
						false
						,[
						[
							11,
							"Achivment"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2436488866009698,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4467208465290691,
					false
					,[
					[
						4,
						76
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					2834991859361058,
					false
					,[
					[
						11,
						"Achivment"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7795610224816198,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7562437902897067,
						false
						,[
						[
							11,
							"Achivment"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1105205902412193,
						false
						,[
						[
							11,
							"Achivment"
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Pressed"],
			false,
			null,
			1803788981238132,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1803788981238132,
				false
				,[
				[
					1,
					[
						2,
						"Pressed"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8887191911431504,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5541443936753242,
					false
					,[
					[
						4,
						71
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1690397025300329,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4652593219413924,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					2332488856799832,
					false
					,[
					[
						6,
						"Game"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9196742919520734,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					8600802758874923,
					false
					,[
					[
						4,
						72
					]
					]
				]
				],
				[
				[
					72,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7411857245948759,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5196501094058811,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					1105621190681045,
					false
					,[
					[
						6,
						"Help"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8552391677875126,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					544748034812645,
					false
					,[
					[
						4,
						73
					]
					]
				]
				],
				[
				[
					72,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9320902547693388,
					false
					,[
					[
						1,
						[
							2,
							"Default"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					73,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3142251753062596,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6487335010323756,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					9946500304755772,
					false
					,[
					[
						6,
						"Settings"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4935374956882287,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2256986634152222,
					false
					,[
					[
						4,
						73
					]
					]
				]
				],
				[
				[
					73,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6782397366967278,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Help",
		[
		[
			1,
			"Help",
			0,
			1,
false,false,9107212949871937,false
		]
,		[
			0,
			null,
			false,
			null,
			6069623709695624,
			[
			[
				4,
				cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,
				null,
				1,
				false,
				false,
				false,
				1214763858663938,
				false
			]
			],
			[
			[
				4,
				cr.plugins_.CJSAds.prototype.acts.HideBanner,
				null,
				5381810525699102,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3417741450121797,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				9795669917775728,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5492042502745832,
				false
				,[
				[
					4,
					69
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
						,[
							0,
							2
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							2
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				5856431278822749,
				false
				,[
				[
					0,
					[
						19,
						cr.system_object.prototype.exps.viewportbottom
						,[
[
							0,
							0
						]
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				5225281202018066,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				5409823651008673,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							16
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				8421181961379808,
				false
				,[
				[
					0,
					[
						19,
						cr.system_object.prototype.exps.viewportbottom
						,[
[
							0,
							0
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8637355115153859,
				false
				,[
				[
					4,
					70
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							50
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							3
						]
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetPos,
				null,
				2523383782255641,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							5
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							2
						]
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				2300707998716628,
				false
				,[
				[
					4,
					71
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				3746084136135528,
				false
				,[
				[
					4,
					72
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						2
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				500568120708959,
				false
				,[
				[
					4,
					73
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
,			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				641710720082179,
				false
				,[
				[
					1,
					[
						2,
						"Default"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				7190698058887771,
				false
				,[
				[
					1,
					[
						2,
						"Pressed"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				7148501067630596,
				false
				,[
				[
					1,
					[
						2,
						"Default"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				1179908944989572,
				false
				,[
				[
					4,
					93
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							200
						]
					]
				]
,				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewporttop
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							90
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				9474044271691046,
				false
				,[
				[
					4,
					94
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							93,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							0,
							60
						]
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							93,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6239466324403609,
				false
				,[
				[
					4,
					95
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							93,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							0,
							100
						]
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							93,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							90
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				4122472153428125,
				false
				,[
				[
					4,
					97
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							0,
							380
						]
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				2130243663247242,
				false
				,[
				[
					4,
					96
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							50
						]
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							30
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6574208479989009,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				1193385321783951,
				false
				,[
				[
					11,
					"Help"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				95,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				9065087875044653,
				false
				,[
				[
					7,
					[
						2,
						"Купите приманку. Убедитесь, что приманка на крючке. (После выбора - приманка отображается в левом нижнем углу)"
					]
				]
				]
			]
,			[
				93,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				8407263993751944,
				false
				,[
				[
					1,
					[
						2,
						"Step1"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				94,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				1571742743212145,
				false
				,[
				[
					7,
					[
						2,
						"1"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8659814987187229,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				2735777105355244,
				false
				,[
				[
					11,
					"Help"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						2
					]
				]
				]
			]
			],
			[
			[
				95,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				9443359753357421,
				false
				,[
				[
					7,
					[
						2,
						" Бросьте поплавок в скопление рыб на экране. Чем точнее бросок - Тем быстрее рыба окажется на крючке"
					]
				]
				]
			]
,			[
				93,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				5050983987004157,
				false
				,[
				[
					1,
					[
						2,
						"Step2"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				94,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8157652722386136,
				false
				,[
				[
					7,
					[
						2,
						"2"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7277082259236487,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				5140984167557125,
				false
				,[
				[
					11,
					"Help"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
			],
			[
			[
				95,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				1480094352865958,
				false
				,[
				[
					7,
					[
						2,
						"Следите за поплавком. Когда поплавок начинает двигаться, подсекайте рыбу и вынимайте ее из воды."
					]
				]
				]
			]
,			[
				93,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				7887260591482462,
				false
				,[
				[
					1,
					[
						2,
						"Step3"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				94,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8922501944052536,
				false
				,[
				[
					7,
					[
						2,
						"3"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7288908895883999,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				8790231018081956,
				false
				,[
				[
					11,
					"Help"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						4
					]
				]
				]
			]
			],
			[
			[
				95,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				8987381831914552,
				false
				,[
				[
					7,
					[
						2,
						"Отлично - рыба на крючке! Нажмайте кнопку катушки в правом нижнем углу до тех пор, пока не вытащите рыбу из воды"
					]
				]
				]
			]
,			[
				93,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				5287838709758739,
				false
				,[
				[
					1,
					[
						2,
						"Step4"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				94,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8364243623581166,
				false
				,[
				[
					7,
					[
						2,
						"4"
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "levopravo2"],
			false,
			null,
			5551876628317893,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5551876628317893,
				false
				,[
				[
					1,
					[
						2,
						"levopravo2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				566981012606291,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					392090508892336,
					false
					,[
					[
						4,
						97
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1234562686078064,
					false
					,[
					[
						11,
						"Help"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8272564635523438,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8108910938039592,
						false
						,[
						[
							11,
							"Help"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9688238606744937,
						false
						,[
						[
							11,
							"Help"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2436488866009698,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4467208465290691,
					false
					,[
					[
						4,
						96
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					2834991859361058,
					false
					,[
					[
						11,
						"Help"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7795610224816198,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7562437902897067,
						false
						,[
						[
							11,
							"Help"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1105205902412193,
						false
						,[
						[
							11,
							"Help"
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Pressed2"],
			false,
			null,
			2239656791893817,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2239656791893817,
				false
				,[
				[
					1,
					[
						2,
						"Pressed2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8687334544230525,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1666784866078701,
					false
					,[
					[
						4,
						70
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2073771528220946,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					9279742546197717,
					false
					,[
					[
						6,
						"Start"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8887191911431504,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5541443936753242,
					false
					,[
					[
						4,
						71
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1690397025300329,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4652593219413924,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					2332488856799832,
					false
					,[
					[
						6,
						"Game"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4935374956882287,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2256986634152222,
					false
					,[
					[
						4,
						73
					]
					]
				]
				],
				[
				[
					72,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					434983909490094,
					false
					,[
					[
						1,
						[
							2,
							"Default"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					73,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6782397366967278,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9697856071462425,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					8821358737233973,
					false
					,[
					[
						6,
						"Settings"
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Settings",
		[
		[
			1,
			"Sound",
			0,
			0,
false,false,2016045922310506,false
		]
,		[
			1,
			"Vibro",
			0,
			1,
false,false,8991360762286978,false
		]
,		[
			0,
			null,
			false,
			null,
			5796481862909023,
			[
			[
				4,
				cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,
				null,
				1,
				false,
				false,
				false,
				4953125292304513,
				false
			]
			],
			[
			[
				4,
				cr.plugins_.CJSAds.prototype.acts.HideBanner,
				null,
				5313289254164401,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1606237388162302,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				9800936165551895,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				6494735929804913,
				false
				,[
				[
					4,
					69
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutwidth
						]
						,[
							0,
							2
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							2
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetY,
				null,
				3300155896917547,
				false
				,[
				[
					0,
					[
						19,
						cr.system_object.prototype.exps.viewportbottom
						,[
[
							0,
							0
						]
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetX,
				null,
				6592749151387695,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							8
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				5771720658225842,
				false
				,[
				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							16
						]
					]
				]
				]
			]
,			[
				69,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				1033411412424578,
				false
				,[
				[
					0,
					[
						19,
						cr.system_object.prototype.exps.viewportbottom
						,[
[
							0,
							0
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7474396891867866,
				false
				,[
				[
					4,
					70
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							50
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							3
						]
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetPos,
				null,
				4586000696703025,
				false
				,[
				[
					0,
					[
						5,
						[
							19,
							cr.system_object.prototype.exps.viewportright
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							5
						]
					]
				]
,				[
					0,
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
						,[
							0,
							2
						]
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				3100128676268619,
				false
				,[
				[
					4,
					71
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				9274109921490972,
				false
				,[
				[
					4,
					72
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						2
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.Spawn,
				null,
				1796099035065143,
				false
				,[
				[
					4,
					73
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
,			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				5438680586466453,
				false
				,[
				[
					1,
					[
						2,
						"Default"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				3386600962481626,
				false
				,[
				[
					1,
					[
						2,
						"Default"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				5253914538269512,
				false
				,[
				[
					1,
					[
						2,
						"Pressed"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				882484034738444,
				false
				,[
				[
					4,
					86
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							240
						]
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							150
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8714791518275284,
				false
				,[
				[
					4,
					90
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							86,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							0,
							140
						]
					]
				]
,				[
					0,
					[
						20,
						86,
						cr.plugins_.Sprite.prototype.exps.Y,
						false,
						null
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				5238495397678446,
				false
				,[
				[
					4,
					89
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							86,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							0,
							140
						]
					]
				]
,				[
					0,
					[
						20,
						86,
						cr.plugins_.Sprite.prototype.exps.Y,
						false,
						null
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				7766503201907503,
				false
				,[
				[
					4,
					87
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							240
						]
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							20
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				336546542636937,
				false
				,[
				[
					4,
					92
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							87,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							0,
							140
						]
					]
				]
,				[
					0,
					[
						20,
						87,
						cr.plugins_.Sprite.prototype.exps.Y,
						false,
						null
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				8594396747287159,
				false
				,[
				[
					4,
					91
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						5,
						[
							20,
							87,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
						,[
							0,
							140
						]
					]
				]
,				[
					0,
					[
						20,
						87,
						cr.plugins_.Sprite.prototype.exps.Y,
						false,
						null
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				3603144824829001,
				false
				,[
				[
					4,
					88
				]
,				[
					5,
					[
						0,
						0
					]
				]
,				[
					0,
					[
						4,
						[
							19,
							cr.system_object.prototype.exps.viewportleft
							,[
[
								0,
								0
							]
							]
						]
						,[
							0,
							240
						]
					]
				]
,				[
					0,
					[
						4,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
						,[
							0,
							155
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Pressed3"],
			false,
			null,
			321591565575811,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				321591565575811,
				false
				,[
				[
					1,
					[
						2,
						"Pressed3"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8687334544230525,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1666784866078701,
					false
					,[
					[
						4,
						70
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2073771528220946,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					9279742546197717,
					false
					,[
					[
						6,
						"Start"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8887191911431504,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5541443936753242,
					false
					,[
					[
						4,
						71
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1690397025300329,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4652593219413924,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					2332488856799832,
					false
					,[
					[
						6,
						"Game"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4935374956882287,
				[
				[
					1,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2256986634152222,
					false
					,[
					[
						4,
						72
					]
					]
				]
				],
				[
				[
					72,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					434983909490094,
					false
					,[
					[
						1,
						[
							2,
							"Pressed"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					73,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6782397366967278,
					false
					,[
					[
						1,
						[
							2,
							"Default"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6205802849666162,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					3841575662218799,
					false
					,[
					[
						6,
						"Help"
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7798788006048259,
			[
			[
				1,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				6925302144415585,
				false
				,[
				[
					4,
					90
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6341068874968037,
				false
				,[
				[
					11,
					"Sound"
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4201153797456345,
			[
			[
				1,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				7005264187850426,
				false
				,[
				[
					4,
					89
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4443074602057903,
				false
				,[
				[
					11,
					"Sound"
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4865081631036745,
			[
			[
				1,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				5762643901230303,
				false
				,[
				[
					4,
					91
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				595939917988129,
				false
				,[
				[
					11,
					"Vibro"
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6418866859416107,
			[
			[
				1,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				5476666358028586,
				false
				,[
				[
					4,
					92
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7729574309165842,
				false
				,[
				[
					11,
					"Vibro"
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3716693835621297,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				5952123337182557,
				false
				,[
				[
					11,
					"Sound"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				86,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				1944504588491677,
				false
				,[
				[
					1,
					[
						2,
						"On"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7400054753834987,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				3129868664762918,
				false
				,[
				[
					11,
					"Sound"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			],
			[
			[
				86,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				8974511863554221,
				false
				,[
				[
					1,
					[
						2,
						"Off"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6112284937178759,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				5706466841799652,
				false
				,[
				[
					11,
					"Vibro"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
			],
			[
			[
				87,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				9545174534095511,
				false
				,[
				[
					1,
					[
						2,
						"On"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5717457356019067,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				7408236488665903,
				false
				,[
				[
					11,
					"Vibro"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			],
			[
			[
				87,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				9883509475201963,
				false
				,[
				[
					1,
					[
						2,
						"Off"
					]
				]
,				[
					3,
					1
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4051386826331139,
			[
			[
				1,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				2781564392138505,
				false
				,[
				[
					4,
					88
				]
				]
			]
			],
			[
			[
				88,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				3543624738739102,
				false
				,[
				[
					1,
					[
						2,
						"Pressed"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.ResetGlobals,
				null,
				2634873098358987,
				false
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				2377283692587724,
				false
				,[
				[
					1,
					[
						2,
						"VidNazivkiS"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				3347542938650573,
				false
				,[
				[
					1,
					[
						2,
						"MoneySave"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7452646515650705,
				false
				,[
				[
					1,
					[
						2,
						"Ryba1S"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1016439121529408,
				false
				,[
				[
					1,
					[
						2,
						"Ryba2S"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1201565717569242,
				false
				,[
				[
					1,
					[
						2,
						"Ryba3S"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4618758806519302,
				false
				,[
				[
					1,
					[
						2,
						"Ryba4S"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5235078116068536,
				false
				,[
				[
					1,
					[
						2,
						"Ryba5S"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1220628800295428,
				false
				,[
				[
					1,
					[
						2,
						"Ryba6S"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				8986804894697084,
				false
				,[
				[
					1,
					[
						2,
						"Ryba7S"
					]
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
		]
	]
	],
	"",
	false,
	850,
	550,
	4,
	true,
	true,
	false,
	"1.0",
	true,
	false,
	0,
	0,
	98,
	false,
	true,
	[
	]
];};


createCocoonJSRuntime();

})();
